/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
(function(){
var e,t=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/uri","vs/platform/environment/common/environment","vs/base/common/async","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/arrays","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/types","vs/base/common/objects","vs/base/common/errors","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/platform/telemetry/common/telemetry","vs/platform/configuration/common/configuration","vs/base/common/network","vs/base/common/cancellation","vs/base/common/json","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/amd","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/map","fs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/product/common/productService","vs/base/common/jsonEdit","vs/base/common/extpath","os","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","child_process","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/process","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/content","vs/base/common/stream","util","vs/base/common/date","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/iterator","vs/base/common/glob","vs/base/common/normalization","vs/base/common/labels","vs/base/node/decoder","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/extensions/common/extensions","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/electron/electron-sandbox/electron","vs/platform/localizations/common/localizations","semver-umd","vs/platform/log/node/spdlogService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/storageKeys","vs/base/common/assert","vs/base/common/decorators","vs/base/common/linkedList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/paths","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/base/parts/request/browser/request","vs/base/parts/ipc/electron-sandbox/ipc.electron-sandbox","vs/base/parts/storage/common/storage","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspaces/common/workspaces","vs/platform/credentials/node/credentialsService","vs/platform/diagnostics/common/diagnostics","vs/platform/diagnostics/node/diagnosticsIpc","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherIpc","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/credentials/common/credentials","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","crypto","vs/platform/log/common/bufferLog","vs/platform/log/common/fileLogService","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/environment/node/environmentService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/storage/node/storageIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/commonProperties","vs/platform/telemetry/node/telemetryIpc","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-browser/userDataAutoSyncService","vs/platform/workspaces/common/workspaces","vs/platform/storage/node/storageService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","net","applicationinsights","vs/base/common/performance","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],i=function(e){
for(var i=[],n=0,r=e.length;n<r;n++)i[n]=t[e[n]];return i};function n(e){e.MonacoPerformanceMarks=e.MonacoPerformanceMarks||[];const t=2,i="function"==typeof console.timeStamp?console.timeStamp.bind(console):()=>{};return{mark:function(t){e.MonacoPerformanceMarks.push(t,Date.now()),i(t)},getEntries:function(){const i=[],n=e.MonacoPerformanceMarks;for(let e=0;e<n.length;e+=t)i.push({name:n[e],startTime:n[e+1]});return i},getDuration:function(i,n){const r=e.MonacoPerformanceMarks;let s=n,o=0;for(let e=r.length-t;e>=0;e-=t)if(r[e]===s){if(s!==n)return r[o+1]-r[e+1];o=e,s=i}return 0},importEntries:function(t){e.MonacoPerformanceMarks.splice(0,0,...t)},exportEntries:function(){return e.MonacoPerformanceMarks.slice(0)}}}define(t[81],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0,t.ok=function(e,t){if(!e)throw new Error(t?`Assertion failed (${t})`:"Assertion Failed")}})),define(t[57],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0
}),t.SetMap=t.fromMap=t.groupBy=t.forEach=t.values=void 0;const i=Object.prototype.hasOwnProperty;t.values=function(e){const t=[];for(let n in e)i.call(e,n)&&t.push(e[n]);return t},t.forEach=function(e,t){for(let n in e)if(i.call(e,n)){if(!1===t({key:n,value:e[n]},(function(){delete e[n]})))return}},t.groupBy=function(e,t){const i=Object.create(null);for(const n of e){const e=t(n);let r=i[e];r||(r=i[e]=[]),r.push(n)}return i},t.fromMap=function(e){const t=Object.create(null);return e&&e.forEach((e,i)=>{t[i]=e}),t};t.SetMap=class{constructor(){this.map=new Map}add(e,t){let i=this.map.get(e);i||(i=new Set,this.map.set(e,i)),i.add(t)}delete(e,t){const i=this.map.get(e);i&&(i.delete(t),0===i.size&&this.map.delete(e))}forEach(e,t){const i=this.map.get(e);i&&i.forEach(t)}}})),define(t[82],i([0,1]),(function(e,t){"use strict";function i(e){return(t,i,n)=>{let r=null,s=null;if("function"==typeof n.value?(r="value",s=n.value):"function"==typeof n.get&&(r="get",s=n.get),!s)throw new Error("not supported");n[r]=e(s,i)}}
Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0,t.createDecorator=i;let n=0;function r(){const e=`$memoize${n++}`;let t=void 0;const i=function(i,n,r){let s=null,o=null;if("function"==typeof r.value?(s="value",0!==(o=r.value).length&&console.warn("Memoize should only be used in functions with zero parameters")):"function"==typeof r.get&&(s="get",o=r.get),!o)throw new Error("not supported");const a=`${e}:${n}`;r[s]=function(...e){return t=this,this.hasOwnProperty(a)||Object.defineProperty(this,a,{configurable:!0,enumerable:!1,writable:!0,value:o.apply(this,e)}),this[a]}};return i.clear=()=>{void 0!==t&&Object.getOwnPropertyNames(t).forEach(i=>{0===i.indexOf(e)&&delete t[i]})},i}t.createMemoizer=r,t.memoize=function(e,t,i){return r()(e,t,i)},t.debounce=function(e,t,n){return i((i,r)=>{const s=`$debounce$${r}`,o=`$debounce$result$${r}`;return function(...r){this[o]||(this[o]=n?n():void 0),clearTimeout(this[s]),t&&(this[o]=t(this[o],...r),
r=[this[o]]),this[s]=setTimeout(()=>{i.apply(this,r),this[o]=n?n():void 0},e)}})},t.throttle=function(e,t,n){return i((i,r)=>{const s=`$throttle$timer$${r}`,o=`$throttle$result$${r}`,a=`$throttle$lastRun$${r}`,c=`$throttle$pending$${r}`;return function(...r){if(this[o]||(this[o]=n?n():void 0),null!==this[a]&&void 0!==this[a]||(this[a]=-Number.MAX_VALUE),t&&(this[o]=t(this[o],...r)),this[c])return;const l=this[a]+e;l<=Date.now()?(this[a]=Date.now(),i.apply(this,[this[o]]),this[o]=n?n():void 0):(this[c]=!0,this[s]=setTimeout(()=>{this[c]=!1,this[a]=Date.now(),i.apply(this,[this[o]]),this[o]=n?n():void 0},l-Date.now()))}})}})),define(t[20],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(e){setTimeout(()=>{if(e.stack)throw new Error(e.message+"\n\n"+e.stack);throw e},0)}}addListener(e){return this.listeners.push(e),()=>{this._removeListener(e)}}emit(e){this.listeners.forEach(t=>{t(e)})}_removeListener(e){this.listeners.splice(this.listeners.indexOf(e),1)}setUnexpectedErrorHandler(e){this.unexpectedErrorHandler=e}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(e){this.unexpectedErrorHandler(e),this.emit(e)}onUnexpectedExternalError(e){this.unexpectedErrorHandler(e)}}t.ErrorHandler=i,t.errorHandler=new i,t.setUnexpectedErrorHandler=function(e){t.errorHandler.setUnexpectedErrorHandler(e)},
t.onUnexpectedError=function(e){r(e)||t.errorHandler.onUnexpectedError(e)},t.onUnexpectedExternalError=function(e){r(e)||t.errorHandler.onUnexpectedExternalError(e)},t.transformErrorForSerialization=function(e){if(e instanceof Error){let{name:t,message:i}=e;return{$isError:!0,name:t,message:i,stack:e.stacktrace||e.stack}}return e};const n="Canceled";function r(e){return e instanceof Error&&e.name===n&&e.message===n}t.isPromiseCanceledError=r,t.canceled=function(){const e=new Error(n);return e.name=e.message,e},t.illegalArgument=function(e){return e?new Error(`Illegal argument: ${e}`):new Error("Illegal argument")},t.illegalState=function(e){return e?new Error(`Illegal state: ${e}`):new Error("Illegal state")},t.readonly=function(e){return e?new Error(`readonly property '${e} cannot be changed'`):new Error("readonly property cannot be changed")},t.disposed=function(e){const t=new Error(`${e} has been disposed`);return t.name="DISPOSED",t},t.getErrorMessage=function(e){
return e?e.message?e.message:e.stack?e.stack.split("\n")[0]:String(e):"Error"};class s extends Error{constructor(e){super("NotImplemented"),e&&(this.message=e)}}t.NotImplementedError=s;class o extends Error{constructor(e){super("NotSupported"),e&&(this.message=e)}}t.NotSupportedError=o})),define(t[15],i([0,1,20]),(function(e,t,i){"use strict";function n(e,t){let i=0,n=e.length;if(0===n)return 0;for(;i<n;){const r=Math.floor((i+n)/2);t(e[r])?n=r:i=r+1}return i}function r(e,t){return function e(t,i,n,r,s){if(r<=n)return;const o=n+(r-n)/2|0;e(t,i,n,o,s);e(t,i,o+1,r,s);if(i(t[o],t[o+1])<=0)return;!function(e,t,i,n,r,s){let o=i,a=n+1;for(let t=i;t<=r;t++)s[t]=e[t];for(let c=i;c<=r;c++)o>n?e[c]=s[a++]:a>r?e[c]=s[o++]:t(s[a],s[o])<0?e[c]=s[a++]:e[c]=s[o++]}(t,i,n,o,r,s)}(e,t,0,e.length-1,[]),e}function s(e,t,i){const n=[];function r(e,t,i){if(0===t&&0===i.length)return;const r=n[n.length-1];r&&r.start+r.deleteCount===e?(r.deleteCount+=t,r.toInsert.push(...i)):n.push({start:e,deleteCount:t,toInsert:i})}let s=0,o=0
;for(;;){if(s===e.length){r(s,0,t.slice(o));break}if(o===t.length){r(s,e.length-s,[]);break}const n=e[s],a=t[o],c=i(n,a);0===c?(s+=1,o+=1):c<0?(r(s,1,[]),s+=1):c>0&&(r(s,0,[a]),o+=1)}return n}function o(e,t,i,r,s){for(const o=i.length;r<s;r++){const s=e[r];if(t(s,i[o-1])<0){i.pop();const e=n(i,e=>t(s,e)<0);i.splice(e,0,s)}}}function a(e,t){for(let i=0;i<e.length;i++){if(t(e[i]))return i}return-1}function c(e,t){const i=e.indexOf(t);if(i>-1)return e.splice(i,1),t}Object.defineProperty(t,"__esModule",{value:!0}),t.getRandomElement=t.asArray=t.mapArrayOrNot=t.find=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.first=t.firstIndex=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.mergeSort=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0,t.tail=function(e,t=0){return e[e.length-(1+t)]},
t.tail2=function(e){if(0===e.length)throw new Error("Invalid tail call");return[e.slice(0,e.length-1),e[e.length-1]]},t.equals=function(e,t,i=((e,t)=>e===t)){if(e===t)return!0;if(!e||!t)return!1;if(e.length!==t.length)return!1;for(let n=0,r=e.length;n<r;n++)if(!i(e[n],t[n]))return!1;return!0},t.binarySearch=function(e,t,i){let n=0,r=e.length-1;for(;n<=r;){const s=(n+r)/2|0,o=i(e[s],t);if(o<0)n=s+1;else{if(!(o>0))return s;r=s-1}}return-(n+1)},t.findFirstInSorted=n,t.mergeSort=r,t.groupBy=function(e,t){const i=[];let n=void 0;for(const s of r(e.slice(0),t))n&&0===t(n[0],s)?n.push(s):(n=[s],i.push(n));return i},t.sortedDiff=s,t.delta=function(e,t,i){const n=s(e,t,i),r=[],o=[];for(const t of n)r.push(...e.slice(t.start,t.start+t.deleteCount)),o.push(...t.toInsert);return{removed:r,added:o}},t.top=function(e,t,i){if(0===i)return[];const n=e.slice(0,i).sort(t);return o(e,t,n,i,e.length),n},t.topAsync=function(e,t,n,r,s){return 0===n?Promise.resolve([]):new Promise((a,c)=>{(async()=>{
const a=e.length,c=e.slice(0,n).sort(t);for(let l=n,u=Math.min(n+r,a);l<a;l=u,u=Math.min(u+r,a)){if(l>n&&await new Promise(e=>setTimeout(e)),s&&s.isCancellationRequested)throw i.canceled();o(e,t,c,l,u)}return c})().then(a,c)})},t.coalesce=function(e){return e.filter(e=>!!e)},t.coalesceInPlace=function(e){let t=0;for(let i=0;i<e.length;i++)e[i]&&(e[t]=e[i],t+=1);e.length=t},t.move=function(e,t,i){e.splice(i,0,e.splice(t,1)[0])},t.isFalsyOrEmpty=function(e){return!Array.isArray(e)||0===e.length},t.isNonEmptyArray=function(e){return Array.isArray(e)&&e.length>0},t.distinct=function(e,t){if(!t)return e.filter((t,i)=>e.indexOf(t)===i);const i=Object.create(null);return e.filter(e=>{const n=t(e);return!i[n]&&(i[n]=!0,!0)})},t.distinctES6=function(e){const t=new Set;return e.filter(e=>!t.has(e)&&(t.add(e),!0))},t.uniqueFilter=function(e){const t=Object.create(null);return i=>{const n=e(i);return!t[n]&&(t[n]=!0,!0)}},t.lastIndex=function(e,t){for(let i=e.length-1;i>=0;i--){if(t(e[i]))return i}return-1},
t.firstIndex=a,t.first=function(e,t,i){const n=a(e,t);return n<0?i:e[n]},t.firstOrDefault=function(e,t){return e.length>0?e[0]:t},t.commonPrefixLength=function(e,t,i=((e,t)=>e===t)){let n=0;for(let r=0,s=Math.min(e.length,t.length);r<s&&i(e[r],t[r]);r++)n++;return n},t.flatten=function(e){return[].concat(...e)},t.range=function(e,t){let i="number"==typeof t?e:0;"number"==typeof t?i=e:(i=0,t=e);const n=[];if(i<=t)for(let e=i;e<t;e++)n.push(e);else for(let e=i;e>t;e--)n.push(e);return n},t.index=function(e,t,i){return e.reduce((e,n)=>(e[t(n)]=i?i(n):n,e),Object.create(null))},t.insert=function(e,t){return e.push(t),()=>c(e,t)},t.remove=c,t.arrayInsert=function(e,t,i){const n=e.slice(0,t),r=e.slice(t);return n.concat(i,r)},t.shuffle=function(e,t){let i;if("number"==typeof t){let e=t;i=()=>{const t=179426549*Math.sin(e++);return t-Math.floor(t)}}else i=Math.random;for(let t=e.length-1;t>0;t-=1){const n=Math.floor(i()*(t+1)),r=e[t];e[t]=e[n],e[n]=r}},t.pushToStart=function(e,t){const i=e.indexOf(t)
;i>-1&&(e.splice(i,1),e.unshift(t))},t.pushToEnd=function(e,t){const i=e.indexOf(t);i>-1&&(e.splice(i,1),e.push(t))},t.find=function(e,t){for(let i=0;i<e.length;i++){const n=e[i];if(t(n,i,e))return n}},t.mapArrayOrNot=function(e,t){return Array.isArray(e)?e.map(t):t(e)},t.asArray=function(e){return Array.isArray(e)?e:[e]},t.getRandomElement=function(e){return e[Math.floor(Math.random()*e.length)]}})),define(t[58],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0,t.once=function(e){const t=this;let i,n=!1;return function(){return n?i:(n=!0,i=e.apply(t,arguments))}}})),define(t[59],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0,function(e){e.is=function(e){return e&&"object"==typeof e&&"function"==typeof e[Symbol.iterator]};const t=Object.freeze([]);e.empty=function(){return t},e.single=function*(e){yield e},e.from=function(e){return e||t},e.first=function(e){return e[Symbol.iterator]().next().value},
e.some=function(e,t){for(const i of e)if(t(i))return!0;return!1},e.filter=function*(e,t){for(const i of e)t(i)&&(yield i)},e.map=function*(e,t){for(const i of e)yield t(i)},e.concat=function*(...e){for(const t of e)for(const e of t)yield e},e.consume=function(t,i=Number.POSITIVE_INFINITY){const n=[];if(0===i)return[n,t];const r=t[Symbol.iterator]();for(let t=0;t<i;t++){const t=r.next();if(t.done)return[n,e.empty()];n.push(t.value)}return[n,{[Symbol.iterator]:()=>r}]}}(t.Iterable||(t.Iterable={}))})),define(t[28],i([0,1]),(function(e,t){"use strict";var i,n;function r(e,t=!1){let i=0,n=e.length,r="",c=0,l=16,u=0;function h(t){let n=0,r=0;for(;n<t;){const t=e.charCodeAt(i);if(t>=48&&t<=57)r=16*r+t-48;else if(t>=65&&t<=70)r=16*r+t-65+10;else{if(!(t>=97&&t<=102))break;r=16*r+t-97+10}i++,n++}return n<t&&(r=-1),r}function d(){if(r="",u=0,c=i,i>=n)return c=n,l=17;let t=e.charCodeAt(i);if(s(t)){do{i++,r+=String.fromCharCode(t),t=e.charCodeAt(i)}while(s(t));return l=15}if(o(t))return i++,r+=String.fromCharCode(t),
13===t&&10===e.charCodeAt(i)&&(i++,r+="\n"),l=14;switch(t){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,r=function(){let t="",r=i;for(;;){if(i>=n){t+=e.substring(r,i),u=2;break}const s=e.charCodeAt(i);if(34===s){t+=e.substring(r,i),i++;break}if(92!==s){if(s>=0&&s<=31){if(o(s)){t+=e.substring(r,i),u=2;break}u=6}i++}else{if(t+=e.substring(r,i),++i>=n){u=2;break}switch(e.charCodeAt(i++)){case 34:t+='"';break;case 92:t+="\\";break;case 47:t+="/";break;case 98:t+="\b";break;case 102:t+="\f";break;case 110:t+="\n";break;case 114:t+="\r";break;case 116:t+="\t";break;case 117:const e=h(4);e>=0?t+=String.fromCharCode(e):u=4;break;default:u=5}r=i}}return t}(),l=10;case 47:const s=i-1;if(47===e.charCodeAt(i+1)){for(i+=2;i<n&&!o(e.charCodeAt(i));)i++;return r=e.substring(s,i),l=12}if(42===e.charCodeAt(i+1)){i+=2;const t=n-1;let o=!1;for(;i<t;){if(42===e.charCodeAt(i)&&47===e.charCodeAt(i+1)){i+=2,o=!0;break}
i++}return o||(i++,u=1),r=e.substring(s,i),l=13}return r+=String.fromCharCode(t),i++,l=16;case 45:if(r+=String.fromCharCode(t),++i===n||!a(e.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=function(){const t=i;if(48===e.charCodeAt(i))i++;else for(i++;i<e.length&&a(e.charCodeAt(i));)i++;if(i<e.length&&46===e.charCodeAt(i)){if(!(++i<e.length&&a(e.charCodeAt(i))))return u=3,e.substring(t,i);for(i++;i<e.length&&a(e.charCodeAt(i));)i++}let n=i;if(i<e.length&&(69===e.charCodeAt(i)||101===e.charCodeAt(i)))if((++i<e.length&&43===e.charCodeAt(i)||45===e.charCodeAt(i))&&i++,i<e.length&&a(e.charCodeAt(i))){for(i++;i<e.length&&a(e.charCodeAt(i));)i++;n=i}else u=3;return e.substring(t,n)}(),l=11;default:for(;i<n&&f(t);)i++,t=e.charCodeAt(i);if(c!==i){switch(r=e.substring(c,i)){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return r+=String.fromCharCode(t),i++,l=16}}function f(e){if(s(e)||o(e))return!1;switch(e){case 125:
case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}return{setPosition:function(e){i=e,r="",c=0,l=16,u=0},getPosition:()=>i,scan:t?function(){let e;do{e=d()}while(e>=12&&e<=15);return e}:d,getToken:()=>l,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>u}}function s(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&e<=8203||8239===e||8287===e||12288===e||65279===e}function o(e){return 10===e||13===e||8232===e||8233===e}function a(e){return e>=48&&e<=57}function c(e,t,i=!1){return t>=e.offset&&t<e.offset+e.length||i&&t===e.offset+e.length}function l(e,t,n=i.DEFAULT){const s=r(e,!1);function o(e){return e?()=>e(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(e){return e?t=>e(t,s.getTokenOffset(),s.getTokenLength()):()=>!0}
const c=o(t.onObjectBegin),l=a(t.onObjectProperty),u=o(t.onObjectEnd),h=o(t.onArrayBegin),d=o(t.onArrayEnd),f=a(t.onLiteralValue),g=a(t.onSeparator),p=o(t.onComment),m=a(t.onError),v=n&&n.disallowComments,y=n&&n.allowTrailingComma;function S(){for(;;){const e=s.scan();switch(s.getTokenError()){case 4:w(14);break;case 5:w(15);break;case 3:w(13);break;case 1:v||w(11);break;case 2:w(12);break;case 6:w(16)}switch(e){case 12:case 13:v?w(10):p();break;case 16:w(1);break;case 15:case 14:break;default:return e}}}function w(e,t=[],i=[]){if(m(e),t.length+i.length>0){let e=s.getToken();for(;17!==e;){if(-1!==t.indexOf(e)){S();break}if(-1!==i.indexOf(e))break;e=S()}}}function E(e){const t=s.getTokenValue();return e?f(t):l(t),S(),!0}function C(){switch(s.getToken()){case 3:return function(){h(),S();let e=!1;for(;4!==s.getToken()&&17!==s.getToken();){if(5===s.getToken()){if(e||w(4,[],[]),g(","),S(),4===s.getToken()&&y)break}else e&&w(6,[],[]);C()||w(4,[],[4,5]),e=!0}return d(),4!==s.getToken()?w(8,[4],[]):S(),!0}();case 1:
return function(){c(),S();let e=!1;for(;2!==s.getToken()&&17!==s.getToken();){if(5===s.getToken()){if(e||w(4,[],[]),g(","),S(),2===s.getToken()&&y)break}else e&&w(6,[],[]);(10!==s.getToken()?(w(3,[],[2,5]),0):(E(!1),6===s.getToken()?(g(":"),S(),C()||w(4,[],[2,5])):w(5,[],[2,5]),1))||w(4,[],[2,5]),e=!0}return u(),2!==s.getToken()?w(7,[2],[]):S(),!0}();case 10:return E(!0);default:return function(){switch(s.getToken()){case 11:let e=0;try{"number"!=typeof(e=JSON.parse(s.getTokenValue()))&&(w(2),e=0)}catch(e){w(2)}f(e);break;case 7:f(null);break;case 8:f(!0);break;case 9:f(!1);break;default:return!1}return S(),!0}()}}return S(),17===s.getToken()?!!n.allowEmptyContent||(w(4,[],[]),!1):C()?(17!==s.getToken()&&w(9,[],[]),!0):(w(4,[],[]),!1)}function u(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":return e?Array.isArray(e)?"array":"object":"null";default:return"null"}}Object.defineProperty(t,"__esModule",{value:!0}),
t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"}(t.ScanError||(t.ScanError={})),function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",
e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"}(t.SyntaxKind||(t.SyntaxKind={})),function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"
}(t.ParseErrorCode||(t.ParseErrorCode={})),function(e){e.DEFAULT={allowTrailingComma:!0}}(i=t.ParseOptions||(t.ParseOptions={})),t.createScanner=r,function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",
e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",
e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"}(n||(n={})),t.getLocation=function(e,t){const i=[],n=new Object;let r=void 0;const s={value:{},offset:0,length:0,
type:"object",parent:void 0};let o=!1;function a(e,t,i,n){s.value=e,s.offset=t,s.length=i,s.type=n,s.colonOffset=void 0,r=s}try{l(e,{onObjectBegin:(e,s)=>{if(t<=e)throw n;r=void 0,o=t>e,i.push("")},onObjectProperty:(e,r,s)=>{if(t<r)throw n;if(a(e,r,s,"property"),i[i.length-1]=e,t<=r+s)throw n},onObjectEnd:(e,s)=>{if(t<=e)throw n;r=void 0,i.pop()},onArrayBegin:(e,s)=>{if(t<=e)throw n;r=void 0,i.push(0)},onArrayEnd:(e,s)=>{if(t<=e)throw n;r=void 0,i.pop()},onLiteralValue:(e,i,r)=>{if(t<i)throw n;if(a(e,i,r,u(e)),t<=i+r)throw n},onSeparator:(e,s,a)=>{if(t<=s)throw n;if(":"===e&&r&&"property"===r.type)r.colonOffset=s,o=!1,r=void 0;else if(","===e){const e=i[i.length-1];"number"==typeof e?i[i.length-1]=e+1:(o=!0,i[i.length-1]=""),r=void 0}}})}catch(e){if(e!==n)throw e}return{path:i,previousNode:r,isAtPropertyKey:o,matches:e=>{let t=0;for(let n=0;t<e.length&&n<i.length;n++)if(e[t]===i[n]||"*"===e[t])t++;else if("**"!==e[t])return!1;return t===e.length}}},t.parse=function(e,t=[],n=i.DEFAULT){let r=null,s=[]
;const o=[];function a(e){Array.isArray(s)?s.push(e):null!==r&&(s[r]=e)}return l(e,{onObjectBegin:()=>{const e={};a(e),o.push(s),s=e,r=null},onObjectProperty:e=>{r=e},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const e=[];a(e),o.push(s),s=e,r=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:a,onError:(e,i,n)=>{t.push({error:e,offset:i,length:n})}},n),s[0]},t.parseTree=function(e,t=[],n=i.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(e){"property"===r.type&&(r.length=e-r.offset,r=r.parent)}function o(e){return r.children.push(e),e}l(e,{onObjectBegin:e=>{r=o({type:"object",offset:e,length:-1,parent:r,children:[]})},onObjectProperty:(e,t,i)=>{(r=o({type:"property",offset:t,length:-1,parent:r,children:[]})).children.push({type:"string",value:e,offset:t,length:i,parent:r})},onObjectEnd:(e,t)=>{r.length=e+t-r.offset,r=r.parent,s(e+t)},onArrayBegin:(e,t)=>{r=o({type:"array",offset:e,length:-1,parent:r,children:[]})},onArrayEnd:(e,t)=>{r.length=e+t-r.offset,r=r.parent,s(e+t)
},onLiteralValue:(e,t,i)=>{o({type:u(e),offset:t,length:i,parent:r,value:e}),s(t+i)},onSeparator:(e,t,i)=>{"property"===r.type&&(":"===e?r.colonOffset=t:","===e&&s(t))},onError:(e,i,n)=>{t.push({error:e,offset:i,length:n})}},n);const a=r.children[0];return a&&delete a.parent,a},t.findNodeAtLocation=function(e,t){if(!e)return;let i=e;for(let e of t)if("string"==typeof e){if("object"!==i.type||!Array.isArray(i.children))return;let t=!1;for(const n of i.children)if(Array.isArray(n.children)&&n.children[0].value===e){i=n.children[1],t=!0;break}if(!t)return}else{const t=e;if("array"!==i.type||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i},t.getNodePath=function e(t){if(!t.parent||!t.parent.children)return[];const i=e(t.parent);if("property"===t.parent.type){const e=t.parent.children[0].value;i.push(e)}else if("array"===t.parent.type){const e=t.parent.children.indexOf(t);-1!==e&&i.push(e)}return i},t.getNodeValue=function e(t){switch(t.type){case"array":
return t.children.map(e);case"object":const i=Object.create(null);for(let n of t.children){const t=n.children[1];t&&(i[n.children[0].value]=e(t))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}},t.contains=c,t.findNodeAtOffset=function e(t,i,n=!1){if(c(t,i,n)){const r=t.children;if(Array.isArray(r))for(let t=0;t<r.length&&r[t].offset<=i;t++){const s=e(r[t],i,n);if(s)return s}return t}},t.visit=l,t.stripComments=function(e,t){let i,n,s=r(e),o=[],a=0;do{switch(n=s.getPosition(),i=s.scan()){case 12:case 13:case 17:a!==n&&o.push(e.substring(a,n)),void 0!==t&&o.push(s.getTokenValue().replace(/[^\r\n]/g,t)),a=s.getPosition()}}while(17!==i);return o.join("")},t.getNodeType=u})),define(t[46],i([0,1,28]),(function(e,t,i){"use strict";function n(e,t){let i="";for(let n=0;n<t;n++)i+=e;return i}function r(e,t){for(let e=0;e<t.length;e++){const i=t.charAt(e);if("\r"===i)return e+1<t.length&&"\n"===t.charAt(e+1)?"\r\n":"\r";if("\n"===i)return"\n"}return e&&e.eol||"\n"}
function s(e,t){return-1!=="\r\n".indexOf(e.charAt(t))}Object.defineProperty(t,"__esModule",{value:!0}),t.isEOL=t.getEOL=t.format=void 0,t.format=function(e,t,o){let a,c,l,u,h;if(t){for(u=t.offset,h=u+t.length,l=u;l>0&&!s(e,l-1);)l--;let i=h;for(;i<e.length&&!s(e,i);)i++;c=e.substring(l,i),a=function(e,t){let i=0,n=0;const r=t.tabSize||4;for(;i<e.length;){const t=e.charAt(i);if(" "===t)n++;else{if("\t"!==t)break;n+=r}i++}return Math.floor(n/r)}(c,o)}else c=e,a=0,l=0,u=0,h=e.length;const d=r(o,e);let f,g=!1,p=0;f=o.insertSpaces?n(" ",o.tabSize||4):"\t";const m=i.createScanner(c,!1);let v=!1;function y(){return d+n(f,a+p)}function S(){let e=m.scan();for(g=!1;15===e||14===e;)g=g||14===e,e=m.scan();return v=16===e||0!==m.getTokenError(),e}const w=[];function E(t,i,n){!v&&i<h&&n>u&&e.substring(i,n)!==t&&w.push({offset:i,length:n-i,content:t})}let C=S();if(17!==C){const e=m.getTokenOffset()+l;E(n(f,a),l,e)}for(;17!==C;){let e=m.getTokenOffset()+m.getTokenLength()+l,t=S(),i="";for(;!g&&(12===t||13===t);){
E(" ",e,m.getTokenOffset()+l),e=m.getTokenOffset()+m.getTokenLength()+l,i=12===t?y():"",t=S()}if(2===t)1!==C&&(p--,i=y());else if(4===t)3!==C&&(p--,i=y());else{switch(C){case 3:case 1:p++,i=y();break;case 5:case 12:i=y();break;case 13:i=g?y():" ";break;case 6:i=" ";break;case 10:if(6===t){i="";break}case 7:case 8:case 9:case 11:case 2:case 4:12===t||13===t?i=" ":5!==t&&17!==t&&(v=!0);break;case 16:v=!0}!g||12!==t&&13!==t||(i=y())}E(i,e,m.getTokenOffset()+l),C=t}return w},t.getEOL=r,t.isEOL=s})),define(t[38],i([0,1,28,46,15]),(function(e,t,i,n,r){"use strict";function s(e,t,n,r,s){const a=t.slice(),c=i.parseTree(e,[]);let l=void 0,u=void 0;for(;a.length>0&&(u=a.pop(),void 0===(l=i.findNodeAtLocation(c,a))&&void 0!==n);)n="string"==typeof u?{[u]:n}:[n];if(l){if("object"===l.type&&"string"==typeof u&&Array.isArray(l.children)){const t=i.findNodeAtLocation(l,[u]);if(void 0!==t){if(void 0===n){if(!t.parent)throw new Error("Malformed AST");const i=l.children.indexOf(t.parent);let n,s=t.parent.offset+t.parent.length
;if(i>0){const e=l.children[i-1];n=e.offset+e.length}else if(n=l.offset+1,l.children.length>1){s=l.children[1].offset}return o(e,{offset:n,length:s-n,content:""},r)}return o(e,{offset:t.offset,length:t.length,content:JSON.stringify(n)},r)}{if(void 0===n)return[];const t=`${JSON.stringify(u)}: ${JSON.stringify(n)}`,i=s?s(l.children.map(e=>e.children[0].value)):l.children.length;let a;if(i>0){const e=l.children[i-1];a={offset:e.offset+e.length,length:0,content:","+t}}else a=0===l.children.length?{offset:l.offset+1,length:0,content:t}:{offset:l.offset+1,length:0,content:t+","};return o(e,a,r)}}if("array"===l.type&&"number"==typeof u&&Array.isArray(l.children)){if(void 0!==n){const t=`${JSON.stringify(n)}`;let i;if(0===l.children.length||0===u)i={offset:l.offset+1,length:0,content:0===l.children.length?t:t+","};else{const e=-1===u||u>l.children.length?l.children.length:u,n=l.children[e-1];i={offset:n.offset+n.length,length:0,content:","+t}}return o(e,i,r)}{const t=u,i=l.children[t];let n
;if(1===l.children.length)n={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===t){const e=l.children[t-1],i=e.offset+e.length;n={offset:i,length:l.offset+l.length-2-i,content:""}}else n={offset:i.offset,length:l.children[t+1].offset-i.offset,content:""};return o(e,n,r)}}throw new Error(`Can not add ${"number"!=typeof u?"index":"property"} to parent of type ${l.type}`)}if(void 0===n)throw new Error("Can not delete in empty document");return o(e,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(n)},r)}function o(e,t,i){let r=a(e,t),s=t.offset,o=t.offset+t.content.length;if(0===t.length||0===t.content.length){for(;s>0&&!n.isEOL(r,s-1);)s--;for(;o<r.length&&!n.isEOL(r,o);)o++}const c=n.format(r,{offset:s,length:o-s},i);for(let e=c.length-1;e>=0;e--){const t=c[e];r=a(r,t),s=Math.min(s,t.offset),o=Math.max(o,t.offset+t.length),o+=t.content.length-t.length}return[{offset:s,length:e.length-(r.length-o)-s,content:r.substring(s,o)}]}function a(e,t){
return e.substring(0,t.offset)+t.content+e.substring(t.offset+t.length)}Object.defineProperty(t,"__esModule",{value:!0}),t.applyEdits=t.applyEdit=t.withFormatting=t.setProperty=t.removeProperty=void 0,t.removeProperty=function(e,t,i){return s(e,t,void 0,i)},t.setProperty=s,t.withFormatting=o,t.applyEdit=a,t.applyEdits=function(e,t){let i=r.mergeSort(t,(e,t)=>{const i=e.offset-t.offset;return 0===i?e.length-t.length:i}),n=e.length;for(let t=i.length-1;t>=0;t--){let r=i[t];if(!(r.offset+r.length<=n))throw new Error("Overlapping edit");e=a(e,r),n=r.offset}return e}})),define(t[2],i([0,1,58,59]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.ReferenceCollection=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=void 0;const r=!1,s="__is_disposable_tracked__";function o(e){if(r&&e&&e!==h.None)try{e[s]=!0}catch(e){}}function a(e){if(!r)return e
;const t=new Error("Potentially leaked disposable").stack;return setTimeout(()=>{e[s]||console.log(t)},3e3),e}class c extends Error{constructor(e){super(`Encounter errors while disposing of store. Errors: [${e.join(", ")}]`),this.errors=e}}function l(e){if(n.Iterable.is(e)){let t=[];for(const i of e)if(i){o(i);try{i.dispose()}catch(e){t.push(e)}}if(1===t.length)throw t[0];if(t.length>1)throw new c(t);return Array.isArray(e)?[]:e}if(e)return o(e),e.dispose(),e}t.MultiDisposeError=c,t.isDisposable=function(e){return"function"==typeof e.dispose&&0===e.dispose.length},t.dispose=l,t.combinedDisposable=function(...e){return e.forEach(o),a({dispose:()=>l(e)})},t.toDisposable=function(e){const t=a({dispose:()=>{o(t),e()}});return t};class u{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(e){if(!e)return e
;if(e===this)throw new Error("Cannot register a disposable on itself!");return o(e),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(e),e}}t.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new u,a(this)}dispose(){o(this),this._store.dispose()}_register(e){if(e===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(e)}}t.Disposable=h,h.None=Object.freeze({dispose(){}});t.MutableDisposable=class{constructor(){this._isDisposed=!1,a(this)}get value(){return this._isDisposed?void 0:this._value}set value(e){this._isDisposed||e===this._value||(this._value&&this._value.dispose(),e&&o(e),this._value=e)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,o(this),this._value&&this._value.dispose(),this._value=void 0}};t.ReferenceCollection=class{constructor(){this.references=new Map}
acquire(e,...t){let n=this.references.get(e);n||(n={counter:0,object:this.createReferencedObject(e,...t)},this.references.set(e,n));const{object:r}=n,s=i.once(()=>{0==--n.counter&&(this.destroyReferencedObject(e,n.object),this.references.delete(e))});return n.counter++,{object:r,dispose:s}}};t.ImmortalReference=class{constructor(e){this.object=e}dispose(){}}})),define(t[83],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class i{constructor(e){this.element=e,this.next=i.Undefined,this.prev=i.Undefined}}i.Undefined=new i(void 0);t.LinkedList=class{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(e){return this._insert(e,!1)}push(e){return this._insert(e,!0)}_insert(e,t){const n=new i(e);if(this._first===i.Undefined)this._first=n,this._last=n;else if(t){const e=this._last
;this._last=n,n.prev=e,e.next=n}else{const e=this._first;this._first=n,n.next=e,e.prev=n}this._size+=1;let r=!1;return()=>{r||(r=!0,this._remove(n))}}shift(){if(this._first!==i.Undefined){const e=this._first.element;return this._remove(this._first),e}}pop(){if(this._last!==i.Undefined){const e=this._last.element;return this._remove(this._last),e}}_remove(e){if(e.prev!==i.Undefined&&e.next!==i.Undefined){const t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===i.Undefined&&e.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):e.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):e.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let e=this._first;for(;e!==i.Undefined;)yield e.element,e=e.next}toArray(){const e=[];for(let t=this._first;t!==i.Undefined;t=t.next)e.push(t.element);return e}}})),define(t[3],i([0,1,20,58,2,83]),(function(e,t,i,n,r,s){"use strict";var o;Object.defineProperty(t,"__esModule",{
value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.AsyncEmitter=t.PauseableEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0,function(e){function t(e){return(t,i=null,n)=>{let r,s=!1;return r=e(e=>{if(!s)return r?r.dispose():s=!0,t.call(i,e)},null,n),s&&r.dispose(),r}}function i(e,t){return a((i,n=null,r)=>e(e=>i.call(n,t(e)),null,r))}function n(e,t){return a((i,n=null,r)=>e(e=>{t(e),i.call(n,e)},null,r))}function s(e,t){return a((i,n=null,r)=>e(e=>t(e)&&i.call(n,e),null,r))}function o(e,t,n){let r=n;return i(e,e=>r=t(r,e))}function a(e){let t;const i=new l({onFirstListenerAdd(){t=e(i.fire,i)},onLastListenerRemove(){t.dispose()}});return i.event}function c(e,t,i=100,n=!1,r){let s,o=void 0,a=void 0,c=0;const u=new l({leakWarningThreshold:r,onFirstListenerAdd(){s=e(e=>{c++,o=t(o,e),n&&!a&&(u.fire(o),o=void 0),clearTimeout(a),a=setTimeout(()=>{const e=o;o=void 0,a=void 0,(!n||c>1)&&u.fire(e),c=0},i)})},onLastListenerRemove(){s.dispose()}});return u.event}function u(e){let t,i=!0
;return s(e,e=>{const n=i||e!==t;return i=!1,t=e,n})}e.None=()=>r.Disposable.None,e.once=t,e.map=i,e.forEach=n,e.filter=s,e.signal=function(e){return e},e.any=function(...e){return(t,i=null,n)=>r.combinedDisposable(...e.map(e=>e(e=>t.call(i,e),null,n)))},e.reduce=o,e.snapshot=a,e.debounce=c,e.stopwatch=function(e){const n=(new Date).getTime();return i(t(e),e=>(new Date).getTime()-n)},e.latch=u,e.buffer=function(e,t=!1,i=[]){let n=i.slice(),r=e(e=>{n?n.push(e):o.fire(e)});const s=()=>{n&&n.forEach(e=>o.fire(e)),n=null},o=new l({onFirstListenerAdd(){r||(r=e(e=>o.fire(e)))},onFirstListenerDidAdd(){n&&(t?setTimeout(s):s())},onLastListenerRemove(){r&&r.dispose(),r=null}});return o.event};class h{constructor(e){this.event=e}map(e){return new h(i(this.event,e))}forEach(e){return new h(n(this.event,e))}filter(e){return new h(s(this.event,e))}reduce(e,t){return new h(o(this.event,e,t))}latch(){return new h(u(this.event))}debounce(e,t=100,i=!1,n){return new h(c(this.event,e,t,i,n))}on(e,t,i){return this.event(e,t,i)}
once(e,i,n){return t(this.event)(e,i,n)}}e.chain=function(e){return new h(e)},e.fromNodeEventEmitter=function(e,t,i=(e=>e)){const n=(...e)=>r.fire(i(...e)),r=new l({onFirstListenerAdd:()=>e.on(t,n),onLastListenerRemove:()=>e.removeListener(t,n)});return r.event},e.fromDOMEventEmitter=function(e,t,i=(e=>e)){const n=(...e)=>r.fire(i(...e)),r=new l({onFirstListenerAdd:()=>e.addEventListener(t,n),onLastListenerRemove:()=>e.removeEventListener(t,n)});return r.event},e.fromPromise=function(e){const t=new l;let i=!1;return e.then(void 0,()=>null).then(()=>{i?t.fire(void 0):setTimeout(()=>t.fire(void 0),0)}),i=!0,t.event},e.toPromise=function(e){return new Promise(i=>t(e)(i))}}(o=t.Event||(t.Event={}));let a=-1;t.setGlobalLeakWarningThreshold=function(e){const t=a;return a=e,{dispose(){a=t}}};class c{constructor(e,t=Math.random().toString(18).slice(2,5)){this.customThreshold=e,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(e){let t=a
;if("number"==typeof this.customThreshold&&(t=this.customThreshold),t<=0||e<t)return;this._stacks||(this._stacks=new Map);const i=(new Error).stack.split("\n").slice(3).join("\n"),n=this._stacks.get(i)||0;if(this._stacks.set(i,n+1),this._warnCountdown-=1,this._warnCountdown<=0){let i;this._warnCountdown=.5*t;let n=0;for(const[e,t]of this._stacks)(!i||n<t)&&(i=e,n=t);console.warn(`[${this.name}] potential listener LEAK detected, having ${e} listeners already. MOST frequent listener (${n}):`),console.warn(i)}return()=>{const e=this._stacks.get(i)||0;this._stacks.set(i,e-1)}}}class l{constructor(e){this._disposed=!1,this._options=e,this._leakageMon=a>0?new c(this._options&&this._options.leakWarningThreshold):void 0}get event(){return this._event||(this._event=(e,t,i)=>{this._listeners||(this._listeners=new s.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(t?[e,t]:e);let a,c
;return n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,e,t),this._leakageMon&&(a=this._leakageMon.check(this._listeners.size)),c={dispose:()=>{if(a&&a(),c.dispose=l._noop,!this._disposed&&(o(),this._options&&this._options.onLastListenerRemove)){this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)}}},i instanceof r.DisposableStore?i.add(c):Array.isArray(i)&&i.push(c),c}),this._event}fire(e){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,e]);for(;this._deliveryQueue.size>0;){const[e,t]=this._deliveryQueue.shift();try{"function"==typeof e?e.call(void 0,t):e[0].call(e[1],t)}catch(e){i.onUnexpectedError(e)}}}}dispose(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),
this._disposed=!0}}t.Emitter=l,l._noop=function(){};t.PauseableEmitter=class extends l{constructor(e){super(e),this._isPaused=0,this._eventQueue=new s.LinkedList,this._mergeFn=e&&e.merge}pause(){this._isPaused++}resume(){if(0!==this._isPaused&&0==--this._isPaused)if(this._mergeFn){const e=this._eventQueue.toArray();this._eventQueue.clear(),super.fire(this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)super.fire(this._eventQueue.shift())}fire(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):super.fire(e))}};t.AsyncEmitter=class extends l{async fireAsync(e,t,n){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new s.LinkedList);for(const t of this._listeners)this._asyncDeliveryQueue.push([t,e]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[e,t]=this._asyncDeliveryQueue.shift(),r=[],s=Object.assign(Object.assign({},t),{waitUntil:t=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous")
;n&&(t=n(t,"function"==typeof e?e:e[0])),r.push(t)}});try{"function"==typeof e?e.call(void 0,s):e[0].call(e[1],s)}catch(e){i.onUnexpectedError(e);continue}Object.freeze(r),await Promise.all(r).catch(e=>i.onUnexpectedError(e))}}}};t.EventMultiplexer=class{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(e){const t={event:e,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);return r.toDisposable(n.once(()=>{this.hasListeners&&this.unhook(t);const e=this.events.indexOf(t);this.events.splice(e,1)}))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(e=>this.hook(e))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(e=>this.unhook(e))}hook(e){e.listener=e.event(e=>this.emitter.fire(e))}unhook(e){e.listener&&e.listener.dispose(),e.listener=null}dispose(){this.emitter.dispose()}};t.EventBufferer=class{
constructor(){this.buffers=[]}wrapEvent(e){return(t,i,n)=>e(e=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>t.call(i,e)):t.call(i,e)},void 0,n)}bufferEvents(e){const t=[];this.buffers.push(t);const i=e();return this.buffers.pop(),t.forEach(e=>e()),i}};t.Relay=class{constructor(){this.listening=!1,this.inputEvent=o.None,this.inputEventListener=r.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(e){this.inputEvent=e,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=e(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}})),define(t[27],i([0,1,3]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0
;const n=Object.freeze((function(e,t){const i=setTimeout(e.bind(t),0);return{dispose(){clearTimeout(i)}}}));var r;!function(e){e.isCancellationToken=function(t){return t===e.None||t===e.Cancelled||(t instanceof s||!(!t||"object"!=typeof t)&&("boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested))},e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})}(r=t.CancellationToken||(t.CancellationToken={}));class s{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}t.CancellationTokenSource=class{constructor(e){
this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new s),this._token}cancel(){this._token?this._token instanceof s&&this._token.cancel():this._token=r.Cancelled}dispose(e=!1){e&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof s&&this._token.dispose():this._token=r.None}}})),define(t[9],i([0,1,27,20,3,2]),(function(e,t,i,n,r,s){"use strict";function o(e){return e&&"function"==typeof e.then}function a(e){const t=new i.CancellationTokenSource,r=e(t.token),s=new Promise((e,i)=>{t.token.onCancellationRequested(()=>{i(n.canceled())}),Promise.resolve(r).then(i=>{t.dispose(),e(i)},e=>{t.dispose(),i(e)})});return new class{cancel(){t.cancel()}then(e,t){return s.then(e,t)}catch(e){return this.then(void 0,e)}finally(e){return s.finally(e)}}}Object.defineProperty(t,"__esModule",{value:!0}),
t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.RunOnceWorker=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.first=t.sequence=t.ignoreErrors=t.disposableTimeout=t.timeout=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0,t.isThenable=o,t.createCancelablePromise=a,t.raceCancellation=function(e,t,i){return Promise.race([e,new Promise(e=>t.onCancellationRequested(()=>e(i)))])},t.raceTimeout=function(e,t,i){let n=void 0;const r=setTimeout(()=>{null==n||n(),null==i||i()},t);return Promise.race([e.finally(()=>clearTimeout(r)),new Promise(e=>n=e)])},t.asPromise=function(e){return new Promise((t,i)=>{const n=e();o(n)?n.then(t,i):t(n)})};class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(e){if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){const e=()=>{
this.queuedPromise=null;const e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,e};this.queuedPromise=new Promise(t=>{this.activePromise.then(e,e).then(t)})}return new Promise((e,t)=>{this.queuedPromise.then(e,t)})}return this.activePromise=e(),new Promise((e,t)=>{this.activePromise.then(t=>{this.activePromise=null,e(t)},e=>{this.activePromise=null,t(e)})})}}t.Throttler=c;t.Sequencer=class{constructor(){this.current=Promise.resolve(null)}queue(e){return this.current=this.current.then(()=>e())}};t.SequencerByKey=class{constructor(){this.promiseMap=new Map}queue(e,t){var i;const n=(null!==(i=this.promiseMap.get(e))&&void 0!==i?i:Promise.resolve()).catch(()=>{}).then(t).finally(()=>{this.promiseMap.get(e)===n&&this.promiseMap.delete(e)});return this.promiseMap.set(e,n),n}};class l{constructor(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(e,t=this.defaultDelay){return this.task=e,this.cancelTimeout(),
this.completionPromise||(this.completionPromise=new Promise((e,t)=>{this.doResolve=e,this.doReject=t}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const e=this.task;return this.task=null,e()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},t),this.completionPromise}isTriggered(){return null!==this.timeout}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(n.canceled()),this.completionPromise=null)}cancelTimeout(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}t.Delayer=l;t.ThrottledDelayer=class{constructor(e){this.delayer=new l(e),this.throttler=new c}trigger(e,t){return this.delayer.trigger(()=>this.throttler.queue(e),t)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}};function u(e,t){return t?new Promise((i,r)=>{const s=setTimeout(i,e);t.onCancellationRequested(()=>{clearTimeout(s),
r(n.canceled())})}):a(t=>u(e,t))}t.Barrier=class{constructor(){this._isOpen=!1,this._promise=new Promise((e,t)=>{this._completePromise=e})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}},t.timeout=u,t.disposableTimeout=function(e,t=0){const i=setTimeout(e,t);return s.toDisposable(()=>clearTimeout(i))},t.ignoreErrors=function(e){return e.then(void 0,e=>void 0)},t.sequence=function(e){const t=[];let i=0;const n=e.length;return Promise.resolve(null).then((function r(s){null!=s&&t.push(s);const o=i<n?e[i++]():null;return o?o.then(r):Promise.resolve(t)}))},t.first=function(e,t=(e=>!!e),i=null){let n=0;const r=e.length,s=()=>{if(n>=r)return Promise.resolve(i);const o=e[n++];return Promise.resolve(o()).then(e=>t(e)?Promise.resolve(e):s())};return s()};class h{constructor(e){this._size=0,this.maxDegreeOfParalellism=e,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new r.Emitter}get onFinished(){return this._onFinished.event}get size(){
return this._size}queue(e){return this._size++,new Promise((t,i)=>{this.outstandingPromises.push({factory:e,c:t,e:i}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const e=this.outstandingPromises.shift();this.runningPromises++;const t=e.factory();t.then(e.c,e.e),t.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}t.Limiter=h;class d extends h{constructor(){super(1)}}t.Queue=d;t.ResourceQueue=class{constructor(){this.queues=new Map}queueFor(e){const t=e.toString();if(!this.queues.has(t)){const e=new d;e.onFinished(()=>{e.dispose(),this.queues.delete(t)}),this.queues.set(t,e)}return this.queues.get(t)}dispose(){this.queues.forEach(e=>e.dispose()),this.queues.clear()}};t.TimeoutTimer=class{constructor(e,t){this._token=-1,"function"==typeof e&&"number"==typeof t&&this.setIfNotSet(e,t)}
dispose(){this.cancel()}cancel(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setTimeout(()=>{this._token=-1,e()},t)}setIfNotSet(e,t){-1===this._token&&(this._token=setTimeout(()=>{this._token=-1,e()},t))}};t.IntervalTimer=class{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearInterval(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setInterval(()=>{e()},t)}};class f{constructor(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(e=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,e)}isScheduled(){return-1!==this.timeoutToken}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}t.RunOnceScheduler=f;t.RunOnceWorker=class extends f{
constructor(e,t){super(e,t),this.units=[]}work(e){this.units.push(e),this.isScheduled()||this.schedule()}doRun(){const e=this.units;this.units=[],this.runner&&this.runner(e)}dispose(){this.units=[],super.dispose()}},function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){const e=Object.freeze({didTimeout:!0,timeRemaining:()=>15});t.runWhenIdle=t=>{const i=setTimeout(()=>t(e));let n=!1;return{dispose(){n||(n=!0,clearTimeout(i))}}}}else t.runWhenIdle=(e,t)=>{const i=requestIdleCallback(e,"number"==typeof t?{timeout:t}:void 0);let n=!1;return{dispose(){n||(n=!0,cancelIdleCallback(i))}}}}();t.IdleValue=class{constructor(e){this._didRun=!1,this._executor=()=>{try{this._value=e()}catch(e){this._error=e}finally{this._didRun=!0}},this._handle=t.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}},t.retry=async function(e,t,i){let n
;for(let r=0;r<i;r++)try{return await e()}catch(e){n=e,await u(t)}throw n};t.TaskSequentializer=class{hasPending(e){return!!this._pending&&("number"==typeof e?this._pending.taskId===e:!!this._pending)}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var e;null===(e=this._pending)||void 0===e||e.cancel()}setPending(e,t,i){return this._pending={taskId:e,cancel:()=>null==i?void 0:i(),promise:t},t.then(()=>this.donePending(e),()=>this.donePending(e)),t}donePending(e){this._pending&&e===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const e=this._next;this._next=void 0,e.run().then(e.promiseResolve,e.promiseReject)}}setNext(e){if(this._next)this._next.run=e;else{let t,i;const n=new Promise((e,n)=>{t=e,i=n});this._next={run:e,promise:n,promiseResolve:t,promiseReject:i}}return this._next.promise}}})),e="object"==typeof global?global:"object"==typeof self?self:{},"function"==typeof define?define("vs/base/common/performance",[],(function(){
return n(e)})):"object"==typeof module&&"object"==typeof module.exports?module.exports=n(e):e.perf=n(e),define(t[6],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.globals=t.translationsConfigFile=t.locale=t.Language=t.language=t.isRootUser=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=void 0;let i=!1,n=!1,r=!1,s=!1,o=!1,a=!1,c=void 0,l="en",u=void 0,h=void 0;const d="undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.electron&&"renderer"===process.type;if("object"!=typeof navigator||d){if("object"==typeof process){i="win32"===process.platform,n="darwin"===process.platform,r="linux"===process.platform,c="en",l="en";const e=process.env.VSCODE_NLS_CONFIG;if(e)try{const t=JSON.parse(e),i=t.availableLanguages["*"];c=t.locale,l=i||"en",u=t._translationsConfigFile}catch(e){}s=!0}}else h=navigator.userAgent,
i=h.indexOf("Windows")>=0,n=h.indexOf("Macintosh")>=0,a=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,r=h.indexOf("Linux")>=0,o=!0,l=c=navigator.language;!function(e){e[e.Web=0]="Web",e[e.Mac=1]="Mac",e[e.Linux=2]="Linux",e[e.Windows=3]="Windows"}(t.Platform||(t.Platform={})),t.PlatformToString=function(e){switch(e){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}};let f=0;n?f=1:i?f=3:r&&(f=2),t.isWindows=i,t.isMacintosh=n,t.isLinux=r,t.isNative=s,t.isWeb=o,t.isIOS=a,t.platform=f,t.userAgent=h,t.isRootUser=function(){return s&&!i&&0===process.getuid()},t.language=l,function(e){e.value=function(){return t.language},e.isDefaultVariant=function(){return 2===t.language.length?"en"===t.language:t.language.length>=3&&("e"===t.language[0]&&"n"===t.language[1]&&"-"===t.language[2])},e.isDefault=function(){return"en"===t.language}}(t.Language||(t.Language={})),t.locale=c,t.translationsConfigFile=u
;const g="object"==typeof self?self:"object"==typeof global?global:{};t.globals=g,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if("function"==typeof t.globals.postMessage&&!t.globals.importScripts){let e=[];t.globals.addEventListener("message",t=>{if(t.data&&t.data.vscodeSetImmediateId)for(let i=0,n=e.length;i<n;i++){const n=e[i];if(n.id===t.data.vscodeSetImmediateId)return e.splice(i,1),void n.callback()}});let i=0;return n=>{const r=++i;e.push({id:r,callback:n}),t.globals.postMessage({vscodeSetImmediateId:r},"*")}}if("undefined"!=typeof process&&"function"==typeof process.nextTick)return process.nextTick.bind(process);const e=Promise.resolve();return t=>e.then(t)}(),function(e){e[e.Windows=1]="Windows",e[e.Macintosh=2]="Macintosh",e[e.Linux=3]="Linux"}(t.OperatingSystem||(t.OperatingSystem={})),t.OS=n||a?2:i?1:3;let p=!0,m=!1;t.isLittleEndian=function(){if(!m){m=!0;const e=new Uint8Array(2);e[0]=1,e[1]=2;const t=new Uint16Array(e.buffer);p=513===t[0]}
return p}})),define(t[47],i([0,1,6]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.nextTick=t.platform=t.env=t.cwd=void 0;const n="undefined"==typeof process?{cwd:()=>"/",env:Object.create(null),get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},nextTick:e=>i.setImmediate(e)}:process;t.cwd=n.cwd,t.env=n.env,t.platform=n.platform,t.nextTick=n.nextTick})),define(t[4],i([0,1,47]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const n=65,r=97,s=90,o=122,a=46,c=47,l=92;class u extends Error{constructor(e,t,i){let n;"string"==typeof t&&0===t.indexOf("not ")?(n="must not be",t=t.replace(/^not /,"")):n="must be";const r=-1!==e.indexOf(".")?"property":"argument";let s=`The "${e}" ${r} ${n} of type ${t}`;super(s+=`. Received type ${typeof i}`),
this.code="ERR_INVALID_ARG_TYPE"}}function h(e,t){if("string"!=typeof e)throw new u(t,"string",e)}function d(e){return e===c||e===l}function f(e){return e===c}function g(e){return e>=n&&e<=s||e>=r&&e<=o}function p(e,t,i,n){let r="",s=0,o=-1,l=0,u=0;for(let h=0;h<=e.length;++h){if(h<e.length)u=e.charCodeAt(h);else{if(n(u))break;u=c}if(n(u)){if(o===h-1||1===l);else if(2===l){if(r.length<2||2!==s||r.charCodeAt(r.length-1)!==a||r.charCodeAt(r.length-2)!==a){if(r.length>2){const e=r.lastIndexOf(i);-1===e?(r="",s=0):s=(r=r.slice(0,e)).length-1-r.lastIndexOf(i),o=h,l=0;continue}if(0!==r.length){r="",s=0,o=h,l=0;continue}}t&&(r+=r.length>0?`${i}..`:"..",s=2)}else r.length>0?r+=`${i}${e.slice(o+1,h)}`:r=e.slice(o+1,h),s=h-o-1;o=h,l=0}else u===a&&-1!==l?++l:l=-1}return r}function m(e,t){if(null===t||"object"!=typeof t)throw new u("pathObject","Object",t);const i=t.dir||t.root,n=t.base||`${t.name||""}${t.ext||""}`;return i?i===t.root?`${i}${n}`:`${i}${e}${n}`:n}t.win32={resolve(...e){let t="",n="",r=!1
;for(let s=e.length-1;s>=-1;s--){let o;if(s>=0){if(h(o=e[s],"path"),0===o.length)continue}else 0===t.length?o=i.cwd():(void 0===(o=i.env[`=${t}`]||i.cwd())||o.slice(0,2).toLowerCase()!==t.toLowerCase()&&o.charCodeAt(2)===l)&&(o=`${t}\\`);const a=o.length;let c=0,u="",f=!1;const p=o.charCodeAt(0);if(1===a)d(p)&&(c=1,f=!0);else if(d(p))if(f=!0,d(o.charCodeAt(1))){let e=2,t=e;for(;e<a&&!d(o.charCodeAt(e));)e++;if(e<a&&e!==t){const i=o.slice(t,e);for(t=e;e<a&&d(o.charCodeAt(e));)e++;if(e<a&&e!==t){for(t=e;e<a&&!d(o.charCodeAt(e));)e++;e!==a&&e===t||(u=`\\\\${i}\\${o.slice(t,e)}`,c=e)}}}else c=1;else g(p)&&58===o.charCodeAt(1)&&(u=o.slice(0,2),c=2,a>2&&d(o.charCodeAt(2))&&(f=!0,c=3));if(u.length>0)if(t.length>0){if(u.toLowerCase()!==t.toLowerCase())continue}else t=u;if(r){if(t.length>0)break}else if(n=`${o.slice(c)}\\${n}`,r=f,f&&t.length>0)break}return n=p(n,!r,"\\",d),r?`${t}\\${n}`:`${t}${n}`||"."},normalize(e){h(e,"path");const t=e.length;if(0===t)return".";let i,n=0,r=!1;const s=e.charCodeAt(0)
;if(1===t)return f(s)?"\\":e;if(d(s))if(r=!0,d(e.charCodeAt(1))){let r=2,s=r;for(;r<t&&!d(e.charCodeAt(r));)r++;if(r<t&&r!==s){const o=e.slice(s,r);for(s=r;r<t&&d(e.charCodeAt(r));)r++;if(r<t&&r!==s){for(s=r;r<t&&!d(e.charCodeAt(r));)r++;if(r===t)return`\\\\${o}\\${e.slice(s)}\\`;r!==s&&(i=`\\\\${o}\\${e.slice(s,r)}`,n=r)}}}else n=1;else g(s)&&58===e.charCodeAt(1)&&(i=e.slice(0,2),n=2,t>2&&d(e.charCodeAt(2))&&(r=!0,n=3));let o=n<t?p(e.slice(n),!r,"\\",d):"";return 0!==o.length||r||(o="."),o.length>0&&d(e.charCodeAt(t-1))&&(o+="\\"),void 0===i?r?`\\${o}`:o:r?`${i}\\${o}`:`${i}${o}`},isAbsolute(e){h(e,"path");const t=e.length;if(0===t)return!1;const i=e.charCodeAt(0);return d(i)||t>2&&g(i)&&58===e.charCodeAt(1)&&d(e.charCodeAt(2))},join(...e){if(0===e.length)return".";let i,n;for(let t=0;t<e.length;++t){const r=e[t];h(r,"path"),r.length>0&&(void 0===i?i=n=r:i+=`\\${r}`)}if(void 0===i)return".";let r=!0,s=0;if("string"==typeof n&&d(n.charCodeAt(0))){++s;const e=n.length;e>1&&d(n.charCodeAt(1))&&(++s,
e>2&&(d(n.charCodeAt(2))?++s:r=!1))}if(r){for(;s<i.length&&d(i.charCodeAt(s));)s++;s>=2&&(i=`\\${i.slice(s)}`)}return t.win32.normalize(i)},relative(e,i){if(h(e,"from"),h(i,"to"),e===i)return"";const n=t.win32.resolve(e),r=t.win32.resolve(i);if(n===r)return"";if((e=n.toLowerCase())===(i=r.toLowerCase()))return"";let s=0;for(;s<e.length&&e.charCodeAt(s)===l;)s++;let o=e.length;for(;o-1>s&&e.charCodeAt(o-1)===l;)o--;const a=o-s;let c=0;for(;c<i.length&&i.charCodeAt(c)===l;)c++;let u=i.length;for(;u-1>c&&i.charCodeAt(u-1)===l;)u--;const d=u-c,f=a<d?a:d;let g=-1,p=0;for(;p<f;p++){const t=e.charCodeAt(s+p);if(t!==i.charCodeAt(c+p))break;t===l&&(g=p)}if(p!==f){if(-1===g)return r}else{if(d>f){if(i.charCodeAt(c+p)===l)return r.slice(c+p+1);if(2===p)return r.slice(c+p)}a>f&&(e.charCodeAt(s+p)===l?g=p:2===p&&(g=3)),-1===g&&(g=0)}let m="";for(p=s+g+1;p<=o;++p)p!==o&&e.charCodeAt(p)!==l||(m+=0===m.length?"..":"\\..");return c+=g,m.length>0?`${m}${r.slice(c,u)}`:(r.charCodeAt(c)===l&&++c,r.slice(c,u))},
toNamespacedPath(e){if("string"!=typeof e)return e;if(0===e.length)return"";const i=t.win32.resolve(e);if(i.length<=2)return e;if(i.charCodeAt(0)===l){if(i.charCodeAt(1)===l){const e=i.charCodeAt(2);if(63!==e&&e!==a)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(g(i.charCodeAt(0))&&58===i.charCodeAt(1)&&i.charCodeAt(2)===l)return`\\\\?\\${i}`;return e},dirname(e){h(e,"path");const t=e.length;if(0===t)return".";let i=-1,n=0;const r=e.charCodeAt(0);if(1===t)return d(r)?e:".";if(d(r)){if(i=n=1,d(e.charCodeAt(1))){let r=2,s=r;for(;r<t&&!d(e.charCodeAt(r));)r++;if(r<t&&r!==s){for(s=r;r<t&&d(e.charCodeAt(r));)r++;if(r<t&&r!==s){for(s=r;r<t&&!d(e.charCodeAt(r));)r++;if(r===t)return e;r!==s&&(i=n=r+1)}}}}else g(r)&&58===e.charCodeAt(1)&&(n=i=t>2&&d(e.charCodeAt(2))?3:2);let s=-1,o=!0;for(let i=t-1;i>=n;--i)if(d(e.charCodeAt(i))){if(!o){s=i;break}}else o=!1;if(-1===s){if(-1===i)return".";s=i}return e.slice(0,s)},basename(e,t){void 0!==t&&h(t,"ext"),h(e,"path");let i,n=0,r=-1,s=!0
;if(e.length>=2&&g(e.charCodeAt(0))&&58===e.charCodeAt(1)&&(n=2),void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let o=t.length-1,a=-1;for(i=e.length-1;i>=n;--i){const c=e.charCodeAt(i);if(d(c)){if(!s){n=i+1;break}}else-1===a&&(s=!1,a=i+1),o>=0&&(c===t.charCodeAt(o)?-1==--o&&(r=i):(o=-1,r=a))}return n===r?r=a:-1===r&&(r=e.length),e.slice(n,r)}for(i=e.length-1;i>=n;--i)if(d(e.charCodeAt(i))){if(!s){n=i+1;break}}else-1===r&&(s=!1,r=i+1);return-1===r?"":e.slice(n,r)},extname(e){h(e,"path");let t=0,i=-1,n=0,r=-1,s=!0,o=0;e.length>=2&&58===e.charCodeAt(1)&&g(e.charCodeAt(0))&&(t=n=2);for(let c=e.length-1;c>=t;--c){const t=e.charCodeAt(c);if(d(t)){if(!s){n=c+1;break}}else-1===r&&(s=!1,r=c+1),t===a?-1===i?i=c:1!==o&&(o=1):-1!==i&&(o=-1)}return-1===i||-1===r||0===o||1===o&&i===r-1&&i===n+1?"":e.slice(i,r)},format:m.bind(null,"\\"),parse(e){h(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const i=e.length;let n=0,r=e.charCodeAt(0);if(1===i)return d(r)?(t.root=t.dir=e,
t):(t.base=t.name=e,t);if(d(r)){if(n=1,d(e.charCodeAt(1))){let t=2,r=t;for(;t<i&&!d(e.charCodeAt(t));)t++;if(t<i&&t!==r){for(r=t;t<i&&d(e.charCodeAt(t));)t++;if(t<i&&t!==r){for(r=t;t<i&&!d(e.charCodeAt(t));)t++;t===i?n=t:t!==r&&(n=t+1)}}}}else if(g(r)&&58===e.charCodeAt(1)){if(i<=2)return t.root=t.dir=e,t;if(n=2,d(e.charCodeAt(2))){if(3===i)return t.root=t.dir=e,t;n=3}}n>0&&(t.root=e.slice(0,n));let s=-1,o=n,c=-1,l=!0,u=e.length-1,f=0;for(;u>=n;--u)if(d(r=e.charCodeAt(u))){if(!l){o=u+1;break}}else-1===c&&(l=!1,c=u+1),r===a?-1===s?s=u:1!==f&&(f=1):-1!==s&&(f=-1);return-1!==c&&(-1===s||0===f||1===f&&s===c-1&&s===o+1?t.base=t.name=e.slice(o,c):(t.name=e.slice(o,s),t.base=e.slice(o,c),t.ext=e.slice(s,c))),t.dir=o>0&&o!==n?e.slice(0,o-1):t.root,t},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...e){let t="",n=!1;for(let r=e.length-1;r>=-1&&!n;r--){const s=r>=0?e[r]:i.cwd();h(s,"path"),0!==s.length&&(t=`${s}/${t}`,n=s.charCodeAt(0)===c)}return t=p(t,!n,"/",f),n?`/${t}`:t.length>0?t:"."},
normalize(e){if(h(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===c,i=e.charCodeAt(e.length-1)===c;return 0===(e=p(e,!t,"/",f)).length?t?"/":i?"./":".":(i&&(e+="/"),t?`/${e}`:e)},isAbsolute:e=>(h(e,"path"),e.length>0&&e.charCodeAt(0)===c),join(...e){if(0===e.length)return".";let i;for(let t=0;t<e.length;++t){const n=e[t];h(n,"path"),n.length>0&&(void 0===i?i=n:i+=`/${n}`)}return void 0===i?".":t.posix.normalize(i)},relative(e,i){if(h(e,"from"),h(i,"to"),e===i)return"";if((e=t.posix.resolve(e))===(i=t.posix.resolve(i)))return"";const n=e.length,r=n-1,s=i.length-1,o=r<s?r:s;let a=-1,l=0;for(;l<o;l++){const t=e.charCodeAt(1+l);if(t!==i.charCodeAt(1+l))break;t===c&&(a=l)}if(l===o)if(s>o){if(i.charCodeAt(1+l)===c)return i.slice(1+l+1);if(0===l)return i.slice(1+l)}else r>o&&(e.charCodeAt(1+l)===c?a=l:0===l&&(a=0));let u="";for(l=1+a+1;l<=n;++l)l!==n&&e.charCodeAt(l)!==c||(u+=0===u.length?"..":"/..");return`${u}${i.slice(1+a)}`},toNamespacedPath:e=>e,dirname(e){if(h(e,"path"),0===e.length)return"."
;const t=e.charCodeAt(0)===c;let i=-1,n=!0;for(let t=e.length-1;t>=1;--t)if(e.charCodeAt(t)===c){if(!n){i=t;break}}else n=!1;return-1===i?t?"/":".":t&&1===i?"//":e.slice(0,i)},basename(e,t){void 0!==t&&h(t,"ext"),h(e,"path");let i,n=0,r=-1,s=!0;if(void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let o=t.length-1,a=-1;for(i=e.length-1;i>=0;--i){const l=e.charCodeAt(i);if(l===c){if(!s){n=i+1;break}}else-1===a&&(s=!1,a=i+1),o>=0&&(l===t.charCodeAt(o)?-1==--o&&(r=i):(o=-1,r=a))}return n===r?r=a:-1===r&&(r=e.length),e.slice(n,r)}for(i=e.length-1;i>=0;--i)if(e.charCodeAt(i)===c){if(!s){n=i+1;break}}else-1===r&&(s=!1,r=i+1);return-1===r?"":e.slice(n,r)},extname(e){h(e,"path");let t=-1,i=0,n=-1,r=!0,s=0;for(let o=e.length-1;o>=0;--o){const l=e.charCodeAt(o);if(l!==c)-1===n&&(r=!1,n=o+1),l===a?-1===t?t=o:1!==s&&(s=1):-1!==t&&(s=-1);else if(!r){i=o+1;break}}return-1===t||-1===n||0===s||1===s&&t===n-1&&t===i+1?"":e.slice(t,n)},format:m.bind(null,"/"),parse(e){h(e,"path");const t={root:"",dir:"",base:"",
ext:"",name:""};if(0===e.length)return t;const i=e.charCodeAt(0)===c;let n;i?(t.root="/",n=1):n=0;let r=-1,s=0,o=-1,l=!0,u=e.length-1,d=0;for(;u>=n;--u){const t=e.charCodeAt(u);if(t!==c)-1===o&&(l=!1,o=u+1),t===a?-1===r?r=u:1!==d&&(d=1):-1!==r&&(d=-1);else if(!l){s=u+1;break}}if(-1!==o){const n=0===s&&i?1:s;-1===r||0===d||1===d&&r===o-1&&r===s+1?t.base=t.name=e.slice(n,o):(t.name=e.slice(n,r),t.base=e.slice(n,o),t.ext=e.slice(r,o))}return s>0?t.dir=e.slice(0,s-1):i&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize="win32"===i.platform?t.win32.normalize:t.posix.normalize,t.isAbsolute="win32"===i.platform?t.win32.isAbsolute:t.posix.isAbsolute,t.join="win32"===i.platform?t.win32.join:t.posix.join,t.resolve="win32"===i.platform?t.win32.resolve:t.posix.resolve,t.relative="win32"===i.platform?t.win32.relative:t.posix.relative,t.dirname="win32"===i.platform?t.win32.dirname:t.posix.dirname,
t.basename="win32"===i.platform?t.win32.basename:t.posix.basename,t.extname="win32"===i.platform?t.win32.extname:t.posix.extname,t.format="win32"===i.platform?t.win32.format:t.posix.format,t.parse="win32"===i.platform?t.win32.parse:t.posix.parse,t.toNamespacedPath="win32"===i.platform?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep="win32"===i.platform?t.win32.sep:t.posix.sep,t.delimiter="win32"===i.platform?t.win32.delimiter:t.posix.delimiter})),define(t[51],i([0,1,2]),(function(e,t,i){"use strict";function n(e){const t=e;return t&&[t.on,t.pause,t.resume,t.destroy].every(e=>"function"==typeof e)}function r(e,t){return new s(e,t)}Object.defineProperty(t,"__esModule",{value:!0}),t.transform=t.toReadable=t.toStream=t.peekStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0,t.isReadableStream=n,t.isReadableBufferedStream=function(e){const t=e;return t&&n(t.stream)&&Array.isArray(t.buffer)&&"boolean"==typeof t.ended},
t.newWriteableStream=r;class s{constructor(e,t){this.reducer=e,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(e){var t;if(!this.state.destroyed)if(this.state.flowing)this.listeners.data.forEach(t=>t(e));else if(this.buffer.data.push(e),"number"==typeof(null===(t=this.options)||void 0===t?void 0:t.highWaterMark)&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}error(e){this.state.destroyed||(this.state.flowing?this.listeners.error.forEach(t=>t(e)):this.buffer.error.push(e))}end(e){this.state.destroyed||(e instanceof Error?this.error(e):e&&this.write(e),this.state.flowing?(this.listeners.end.forEach(e=>e()),this.destroy()):this.state.ended=!0)}on(e,t){
if(!this.state.destroyed)switch(e){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors()}}removeListener(e,t){if(this.state.destroyed)return;let i=void 0;switch(e){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error}if(i){const e=i.indexOf(t);e>=0&&i.splice(e,1)}}flowData(){if(this.buffer.data.length>0){const e=this.reducer(this.buffer.data);this.listeners.data.forEach(t=>t(e)),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const e of this.buffer.error)this.listeners.error.forEach(t=>t(e));this.buffer.error.length=0}}flowEnd(){return!!this.state.ended&&(this.listeners.end.forEach(e=>e()),this.listeners.end.length>0)}destroy(){
this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}t.consumeReadable=function(e,t){const i=[];let n;for(;null!==(n=e.read());)i.push(n);return t(i)},t.peekReadable=function(e,t,i){const n=[];let r=void 0;for(;null!==(r=e.read())&&n.length<i;)n.push(r);return null===r&&n.length>0?t(n):{read:()=>{if(n.length>0)return n.shift();if(void 0!==r){const e=r;return r=void 0,e}return e.read()}}},t.consumeStream=function(e,t){return new Promise((i,n)=>{const r=[];e.on("data",e=>r.push(e)),e.on("error",e=>n(e)),e.on("end",()=>i(t(r)))})},t.peekStream=function(e,t){return new Promise((n,r)=>{const s=new i.DisposableStore,o=[],a=i=>{if(o.push(i),o.length>t)return s.dispose(),e.pause(),n({stream:e,buffer:o,ended:!1})};s.add(i.toDisposable(()=>e.removeListener("data",a))),e.on("data",a);const c=e=>r(e)
;s.add(i.toDisposable(()=>e.removeListener("error",c))),e.on("error",c);const l=()=>n({stream:e,buffer:o,ended:!0});s.add(i.toDisposable(()=>e.removeListener("end",l))),e.on("end",l)})},t.toStream=function(e,t){const i=r(t);return i.end(e),i},t.toReadable=function(e){let t=!1;return{read:()=>t?null:(t=!0,e)}},t.transform=function(e,t,i){const n=r(i);return e.on("data",e=>n.write(t.data(e))),e.on("end",()=>n.end()),e.on("error",e=>n.error(t.error?t.error(e):e)),n}})),define(t[14],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.repeat=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.encodeUTF8=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.endsWith=t.startsWith=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.escapeRegExpCharacters=t.escape=t.format=t.pad=t.isFalsyOrWhitespace=void 0,
t.isFalsyOrWhitespace=function(e){return!e||"string"!=typeof e||0===e.trim().length},t.pad=function(e,t,i="0"){const n=""+e,r=[n];for(let e=n.length;e<t;e++)r.push(i);return r.reverse().join("")};const i=/{(\d+)}/g;function n(e){return e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function r(e,t){if(!e||!t)return e;const i=t.length;if(0===i||0===e.length)return e;let n=0;for(;e.indexOf(t,n)===n;)n+=i;return e.substring(n)}function s(e,t){if(!e||!t)return e;const i=t.length,n=e.length;if(0===i||0===n)return e;let r=n,s=-1;for(;-1!==(s=e.lastIndexOf(t,r-1))&&s+i===r;){if(0===s)return"";r=s}return e.substring(0,r)}function o(e,t,i=0,n=e.length,r=0,s=t.length){for(;i<n&&r<s;i++,r++){let n=e.charCodeAt(i),s=t.charCodeAt(r);if(n<s)return-1;if(n>s)return 1}const o=n-i,a=s-r;return o<a?-1:o>a?1:0}function a(e,t,i=0,n=e.length,r=0,s=t.length){for(;i<n&&r<s;i++,r++){let a=e.charCodeAt(i),u=t.charCodeAt(r);if(a===u)continue;const h=a-u
;if((32!==h||!l(u))&&(-32!==h||!l(a)))return c(a)&&c(u)?h:o(e.toLowerCase(),t.toLowerCase(),i,n,r,s)}const a=n-i,u=s-r;return a<u?-1:a>u?1:0}function c(e){return e>=97&&e<=122}function l(e){return e>=65&&e<=90}function u(e){return c(e)||l(e)}function h(e,t,i=e.length){for(let n=0;n<i;n++){const i=e.charCodeAt(n),r=t.charCodeAt(n);if(i!==r)if(u(i)&&u(r)){const e=Math.abs(i-r);if(0!==e&&32!==e)return!1}else if(String.fromCharCode(i).toLowerCase()!==String.fromCharCode(r).toLowerCase())return!1}return!0}function d(e){return 55296<=e&&e<=56319}function f(e){return 56320<=e&&e<=57343}function g(e,t){return t-56320+(e-55296<<10)+65536}function p(e,t,i){const n=e.charCodeAt(i);if(d(n)&&i+1<t){const t=e.charCodeAt(i+1);if(f(t))return g(n,t)}return n}function m(e,t){const i=e.charCodeAt(t-1);if(f(i)&&t>1){const n=e.charCodeAt(t-2);if(d(n))return g(n,i)}return i}function v(e,t){const i=I.getInstance(),n=e.length,r=t,s=p(e,n,t),o=i.getGraphemeBreakType(s);t+=s>=65536?2:1;let a=o;for(;t<n;){
const r=p(e,n,t),s=i.getGraphemeBreakType(r);if(x(a,s))break;t+=r>=65536?2:1,a=s}const c=t;for(t=r,a=o;t>0;){const n=m(e,t),r=i.getGraphemeBreakType(n);if(x(r,a))break;t-=n>=65536?2:1,a=r}return[t,c]}t.format=function(e,...t){return 0===t.length?e:e.replace(i,(function(e,i){const n=parseInt(i,10);return isNaN(n)||n<0||n>=t.length?e:t[n]}))},t.escape=function(e){return e.replace(/[<>&]/g,(function(e){switch(e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return e}}))},t.escapeRegExpCharacters=n,t.trim=function(e,t=" "){return s(r(e,t),t)},t.ltrim=r,t.rtrim=s,t.convertSimple2RegExpPattern=function(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},t.stripWildcards=function(e){return e.replace(/\*/g,"")},t.startsWith=function(e,t){if(e.length<t.length)return!1;if(e===t)return!0;for(let i=0;i<t.length;i++)if(e[i]!==t[i])return!1;return!0},t.endsWith=function(e,t){const i=e.length-t.length;return i>0?e.indexOf(t,i)===i:0===i&&e===t},
t.createRegExp=function(e,t,i={}){if(!e)throw new Error("Cannot create regex from empty string");t||(e=n(e)),i.wholeWord&&(/\B/.test(e.charAt(0))||(e="\\b"+e),/\B/.test(e.charAt(e.length-1))||(e+="\\b"));let r="";return i.global&&(r+="g"),i.matchCase||(r+="i"),i.multiline&&(r+="m"),i.unicode&&(r+="u"),new RegExp(e,r)},t.regExpLeadsToEndlessLoop=function(e){return"^"!==e.source&&"^$"!==e.source&&"$"!==e.source&&"^\\s*$"!==e.source&&!(!e.exec("")||0!==e.lastIndex)},t.regExpContainsBackreference=function(e){return!!e.match(/([^\\]|^)(\\\\)*\\\d+/)},t.regExpFlags=function(e){return(e.global?"g":"")+(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")},t.firstNonWhitespaceIndex=function(e){for(let t=0,i=e.length;t<i;t++){const i=e.charCodeAt(t);if(32!==i&&9!==i)return t}return-1},t.getLeadingWhitespace=function(e,t=0,i=e.length){for(let n=t;n<i;n++){const i=e.charCodeAt(n);if(32!==i&&9!==i)return e.substring(t,n)}return e.substring(t,i)},t.lastNonWhitespaceIndex=function(e,t=e.length-1){
for(let i=t;i>=0;i--){const t=e.charCodeAt(i);if(32!==t&&9!==t)return i}return-1},t.compare=function(e,t){return e<t?-1:e>t?1:0},t.compareSubstring=o,t.compareIgnoreCase=function(e,t){return a(e,t,0,e.length,0,t.length)},t.compareSubstringIgnoreCase=a,t.isLowerAsciiLetter=c,t.isUpperAsciiLetter=l,t.equalsIgnoreCase=function(e,t){return e.length===t.length&&h(e,t)},t.startsWithIgnoreCase=function(e,t){const i=t.length;return!(t.length>e.length)&&h(e,t,i)},t.commonPrefixLength=function(e,t){let i,n=Math.min(e.length,t.length);for(i=0;i<n;i++)if(e.charCodeAt(i)!==t.charCodeAt(i))return i;return n},t.commonSuffixLength=function(e,t){let i,n=Math.min(e.length,t.length);const r=e.length-1,s=t.length-1;for(i=0;i<n;i++)if(e.charCodeAt(r-i)!==t.charCodeAt(s-i))return i;return n},t.isHighSurrogate=d,t.isLowSurrogate=f,t.computeCodePoint=g,t.getNextCodePoint=p,t.nextCharLength=function(e,t){const i=I.getInstance(),n=t,r=e.length,s=p(e,r,t);t+=s>=65536?2:1;let o=i.getGraphemeBreakType(s);for(;t<r;){
const n=p(e,r,t),s=i.getGraphemeBreakType(n);if(x(o,s))break;t+=n>=65536?2:1,o=s}return t-n},t.prevCharLength=function(e,t){const i=I.getInstance(),n=t,r=m(e,t);t-=r>=65536?2:1;let s=i.getGraphemeBreakType(r);for(;t>0;){const n=m(e,t),r=i.getGraphemeBreakType(n);if(x(r,s))break;t-=n>=65536?2:1,s=r}return n-t},t.getCharContainingOffset=function(e,t){return t>0&&f(e.charCodeAt(t))?v(e,t-1):v(e,t)},t.encodeUTF8=function(e){const t=e.length;let i=0,n=0;for(;n<t;){const r=p(e,t,n);n+=r>=65536?2:1,i+=r<128?1:r<2048?2:r<65536?3:4}const r=new Uint8Array(i);n=0;let s=0;for(;n<t;){const i=p(e,t,n);n+=i>=65536?2:1,i<128?r[s++]=i:i<2048?(r[s++]=192|(1984&i)>>>6,r[s++]=128|(63&i)>>>0):i<65536?(r[s++]=224|(61440&i)>>>12,r[s++]=128|(4032&i)>>>6,r[s++]=128|(63&i)>>>0):(r[s++]=240|(1835008&i)>>>18,r[s++]=128|(258048&i)>>>12,r[s++]=128|(4032&i)>>>6,r[s++]=128|(63&i)>>>0)}return r},t.decodeUTF8=function(e){const t=e.byteLength,i=[];let n=0;for(;n<t;){const r=e[n];let s
;if((s=r>=240&&n+3<t?(7&e[n++])<<18>>>0|(63&e[n++])<<12>>>0|(63&e[n++])<<6>>>0|(63&e[n++])<<0>>>0:r>=224&&n+2<t?(15&e[n++])<<12>>>0|(63&e[n++])<<6>>>0|(63&e[n++])<<0>>>0:r>=192&&n+1<t?(31&e[n++])<<6>>>0|(63&e[n++])<<0>>>0:e[n++])>=0&&s<=55295||s>=57344&&s<=65535)i.push(String.fromCharCode(s));else if(s>=65536&&s<=1114111){const e=s-65536,t=55296+((1047552&e)>>>10),n=56320+((1023&e)>>>0);i.push(String.fromCharCode(t)),i.push(String.fromCharCode(n))}else i.push(String.fromCharCode(65533))}return i.join("")};const y=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/
;t.containsRTL=function(e){return y.test(e)};const S=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;t.containsEmoji=function(e){return S.test(e)};const w=/^[\t\n\r\x20-\x7E]*$/;function E(e){return(e=+e)>=11904&&e<=55215||e>=63744&&e<=64255||e>=65281&&e<=65374}t.isBasicASCII=function(e){return w.test(e)},t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/,t.containsUnusualLineTerminators=function(e){return t.UNUSUAL_LINE_TERMINATORS.test(e)},t.containsFullWidthCharacter=function(e){for(let t=0,i=e.length;t<i;t++)if(E(e.charCodeAt(t)))return!0;return!1},t.isFullWidthCharacter=E,t.isEmojiImprecise=function(e){return e>=127462&&e<=127487||e>=9728&&e<=10175||e>=127744&&e<=128591||e>=128640&&e<=128764||e>=128992&&e<=129003||e>=129280&&e<=129535||e>=129648&&e<=129651||e>=129656&&e<=129666||e>=129680&&e<=129685},t.lcut=function(e,t){if(e.length<t)return e;const i=/\b/g
;let n=0;for(;i.test(e)&&!(e.length-i.lastIndex<t);)n=i.lastIndex,i.lastIndex+=1;return e.substring(n).replace(/^\s/,"")};const C=/\x1B\x5B[12]?K/g,_=/\x1b\[\d+m/g,b=/\x1b\[0?m/g;function D(e){return!!(e&&e.length>0&&65279===e.charCodeAt(0))}function x(e,t){return 0===e?5!==t&&7!==t:(2!==e||3!==t)&&(4===e||2===e||3===e||(4===t||2===t||3===t||(8!==e||8!==t&&9!==t&&11!==t&&12!==t)&&((11!==e&&9!==e||9!==t&&10!==t)&&((12!==e&&10!==e||10!==t)&&(5!==t&&13!==t&&(7!==t&&(1!==e&&((13!==e||14!==t)&&(6!==e||6!==t)))))))))}t.removeAnsiEscapeCodes=function(e){return e&&(e=(e=(e=e.replace(C,"")).replace(_,"")).replace(b,"")),e},t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=D,t.stripUTF8BOM=function(e){return D(e)?e.substr(1):e},t.repeat=function(e,t){let i="";for(let n=0;n<t;n++)i+=e;return i},t.fuzzyContains=function(e,t){if(!e||!t)return!1;if(e.length<t.length)return!1;const i=t.length,n=e.toLowerCase();let r=0,s=-1;for(;r<i;){const e=n.indexOf(t[r],s+1);if(e<0)return!1;s=e,r++}return!0},
t.containsUppercaseCharacter=function(e,t=!1){return!!e&&(t&&(e=e.replace(/\\./g,"")),e.toLowerCase()!==e)},t.uppercaseFirstLetter=function(e){return e.charAt(0).toUpperCase()+e.slice(1)},t.getNLines=function(e,t=1){if(0===t)return"";let i=-1;do{i=e.indexOf("\n",i+1),t--}while(t>0&&i>=0);return i>=0?e.substr(0,i):e},t.singleLetterHash=function(e){return(e%=52)<26?String.fromCharCode(97+e):String.fromCharCode(65+e-26)},t.getGraphemeBreakType=function(e){return I.getInstance().getGraphemeBreakType(e)},t.breakBetweenGraphemeBreakType=x,function(e){e[e.Other=0]="Other",e[e.Prepend=1]="Prepend",e[e.CR=2]="CR",e[e.LF=3]="LF",e[e.Control=4]="Control",e[e.Extend=5]="Extend",e[e.Regional_Indicator=6]="Regional_Indicator",e[e.SpacingMark=7]="SpacingMark",e[e.L=8]="L",e[e.V=9]="V",e[e.T=10]="T",e[e.LV=11]="LV",e[e.LVT=12]="LVT",e[e.ZWJ=13]="ZWJ",e[e.Extended_Pictographic=14]="Extended_Pictographic"}(t.GraphemeBreakType||(t.GraphemeBreakType={}));class I{constructor(){
this._data=JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")
}static getInstance(){return I._INSTANCE||(I._INSTANCE=new I),I._INSTANCE}getGraphemeBreakType(e){if(e<32)return 10===e?3:13===e?2:4;if(e<127)return 0;const t=this._data,i=t.length/3;let n=1;for(;n<=i;)if(e<t[3*n])n*=2;else{if(!(e>t[3*n+1]))return t[3*n+2];n=2*n+1}return 0}}I._INSTANCE=null})),define(t[17],i([0,1,14,51]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const r="undefined"!=typeof Buffer,s="undefined"!=typeof TextEncoder,o="undefined"!=typeof TextDecoder;let a,c;class l{constructor(e){this.buffer=e,this.byteLength=this.buffer.byteLength}static alloc(e){return new l(r?Buffer.allocUnsafe(e):new Uint8Array(e))}static wrap(e){
return r&&!Buffer.isBuffer(e)&&(e=Buffer.from(e.buffer,e.byteOffset,e.byteLength)),new l(e)}static fromString(e){return r?new l(Buffer.from(e)):s?(a||(a=new TextEncoder),new l(a.encode(e))):new l(i.encodeUTF8(e))}static concat(e,t){if(void 0===t){t=0;for(let i=0,n=e.length;i<n;i++)t+=e[i].byteLength}const i=l.alloc(t);let n=0;for(let t=0,r=e.length;t<r;t++){const r=e[t];i.set(r,n),n+=r.byteLength}return i}toString(){return r?this.buffer.toString():o?(c||(c=new TextDecoder),c.decode(this.buffer)):i.decodeUTF8(this.buffer)}slice(e,t){return new l(this.buffer.subarray(e,t))}set(e,t){e instanceof l?this.buffer.set(e.buffer,t):this.buffer.set(e,t)}readUInt32BE(e){return u(this.buffer,e)}writeUInt32BE(e,t){h(this.buffer,e,t)}readUInt32LE(e){return d(this.buffer,e)}writeUInt32LE(e,t){f(this.buffer,e,t)}readUInt8(e){return g(this.buffer,e)}writeUInt8(e,t){p(this.buffer,e,t)}}function u(e,t){return e[t]*2**24+65536*e[t+1]+256*e[t+2]+e[t+3]}function h(e,t,i){e[i+3]=t,t>>>=8,e[i+2]=t,t>>>=8,e[i+1]=t,t>>>=8,e[i]=t}
function d(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0|e[t+2]<<16>>>0|e[t+3]<<24>>>0}function f(e,t,i){e[i+0]=255&t,t>>>=8,e[i+1]=255&t,t>>>=8,e[i+2]=255&t,t>>>=8,e[i+3]=255&t}function g(e,t){return e[t]}function p(e,t,i){e[i]=t}function m(e){return n.consumeStream(e,e=>l.concat(e))}t.VSBuffer=l,t.readUInt16LE=function(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0},t.writeUInt16LE=function(e,t,i){e[i+0]=255&t,t>>>=8,e[i+1]=255&t},t.readUInt32BE=u,t.writeUInt32BE=h,t.readUInt32LE=d,t.writeUInt32LE=f,t.readUInt8=g,t.writeUInt8=p,t.readableToBuffer=function(e){return n.consumeReadable(e,e=>l.concat(e))},t.bufferToReadable=function(e){return n.toReadable(e)},t.streamToBuffer=m,t.bufferedStreamToBuffer=async function(e){return e.ended?l.concat(e.buffer):l.concat([...e.buffer,await m(e.stream)])},t.bufferToStream=function(e){return n.toStream(e,e=>l.concat(e))},t.streamToBufferReadableStream=function(e){return n.transform(e,{data:e=>"string"==typeof e?l.fromString(e):l.wrap(e)},e=>l.concat(e))},
t.newWriteableBufferStream=function(e){return n.newWriteableStream(e=>l.concat(e),e)}})),define(t[18],i([0,1]),(function(e,t){"use strict";function i(e){return"string"==typeof e}function n(e){return!("object"!=typeof e||null===e||Array.isArray(e)||e instanceof RegExp||e instanceof Date)}function r(e){return void 0===e}function s(e){return r(e)||null===e}Object.defineProperty(t,"__esModule",{value:!0}),t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0,t.isArray=function(e){return Array.isArray(e)},t.isString=i,t.isStringArray=function(e){return Array.isArray(e)&&e.every(e=>i(e))},t.isObject=n,t.isNumber=function(e){return"number"==typeof e&&!isNaN(e)},t.isBoolean=function(e){
return!0===e||!1===e},t.isUndefined=r,t.isDefined=function(e){return!s(e)},t.isUndefinedOrNull=s,t.assertType=function(e,t){if(!e)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")},t.assertIsDefined=function(e){if(s(e))throw new Error("Assertion Failed: argument is undefined or null");return e},t.assertAllDefined=function(...e){const t=[];for(let i=0;i<e.length;i++){const n=e[i];if(s(n))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(n)}return t};const o=Object.prototype.hasOwnProperty;function a(e){return"function"==typeof e}function c(e,t){if(i(t)){if(typeof e!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(e instanceof t)return}catch(e){}if(!s(e)&&e.constructor===t)return;if(1===t.length&&!0===t.call(void 0,e))return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function l(e){
let t=[],i=Object.getPrototypeOf(e);for(;Object.prototype!==i;)t=t.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return t}t.isEmptyObject=function(e){if(!n(e))return!1;for(let t in e)if(o.call(e,t))return!1;return!0},t.isFunction=a,t.areFunctions=function(...e){return e.length>0&&e.every(a)},t.validateConstraints=function(e,t){const i=Math.min(e.length,t.length);for(let n=0;n<i;n++)c(e[n],t[n])},t.validateConstraint=c,t.getAllPropertyNames=l,t.getAllMethodNames=function(e){const t=[];for(const i of l(e))"function"==typeof e[i]&&t.push(i);return t},t.createProxyObject=function(e,t){const i=e=>(function(){const i=Array.prototype.slice.call(arguments,0);return t(e,i)});let n={};for(const t of e)n[t]=i(t);return n},t.withNullAsUndefined=function(e){return null===e?void 0:e},t.withUndefinedAsNull=function(e){return void 0===e?null:e},t.NotImplementedProxy=function(e){return class{constructor(){return new Proxy({},{get(t,i){if(t[i])return t[i]
;throw new Error(`Not Implemented: ${e}->${String(i)}`)}})}}}})),define(t[39],i([0,1,6,14,4,18]),(function(e,t,i,n,r,s){"use strict";function o(e){return 47===e||92===e}Object.defineProperty(t,"__esModule",{value:!0}),t.parseLineAndColumnAware=t.indexOfPath=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toSlashes=t.isPathSeparator=void 0,t.isPathSeparator=o,t.toSlashes=function(e){return e.replace(/[\\/]/g,r.posix.sep)},t.getRoot=function(e,t=r.posix.sep){if(!e)return"";const i=e.length,n=e.charCodeAt(0);if(o(n)){if(o(e.charCodeAt(1))&&!o(e.charCodeAt(2))){let n=3;const r=n;for(;n<i&&!o(e.charCodeAt(n));n++);if(r!==n&&!o(e.charCodeAt(n+1)))for(n+=1;n<i;n++)if(o(e.charCodeAt(n)))return e.slice(0,n+1).replace(/[\\/]/g,t)}return t}if(u(n)&&58===e.charCodeAt(1))return o(e.charCodeAt(2))?e.slice(0,2)+t:e.slice(0,2);let s=e.indexOf("://");if(-1!==s)for(s+=3;s<i;s++)if(o(e.charCodeAt(s)))return e.slice(0,s+1);return""},
t.isUNC=function(e){if(!i.isWindows)return!1;if(!e||e.length<5)return!1;let t=e.charCodeAt(0);if(92!==t)return!1;if(92!==(t=e.charCodeAt(1)))return!1;let n=2;const r=n;for(;n<e.length&&92!==(t=e.charCodeAt(n));n++);return r!==n&&(t=e.charCodeAt(n+1),!isNaN(t)&&92!==t)};const a=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(e){return e>=65&&e<=90||e>=97&&e<=122}t.isValidBasename=function(e,t=i.isWindows){const n=t?a:c;return!(!e||0===e.length||/^\s+$/.test(e))&&(n.lastIndex=0,!n.test(e)&&((!t||!l.test(e))&&("."!==e&&".."!==e&&((!t||"."!==e[e.length-1])&&((!t||e.length===e.trim().length)&&!(e.length>255))))))},t.isEqual=function(e,t,i){const r=e===t;return!i||r?r:!(!e||!t)&&n.equalsIgnoreCase(e,t)},t.isEqualOrParent=function(e,t,i,s=r.sep){if(e===t)return!0;if(!e||!t)return!1;if(t.length>e.length)return!1;if(i){if(!n.startsWithIgnoreCase(e,t))return!1;if(t.length===e.length)return!0;let i=t.length;return t.charAt(t.length-1)===s&&i--,e.charAt(i)===s}
return t.charAt(t.length-1)!==s&&(t+=s),0===e.indexOf(t)},t.isWindowsDriveLetter=u,t.sanitizeFilePath=function(e,t){return i.isWindows&&e.endsWith(":")&&(e+=r.sep),r.isAbsolute(e)||(e=r.join(t,e)),e=r.normalize(e),i.isWindows?(e=n.rtrim(e,r.sep)).endsWith(":")&&(e+=r.sep):(e=n.rtrim(e,r.sep))||(e=r.sep),e},t.isRootOrDriveLetter=function(e){const t=r.normalize(e);return i.isWindows?!(e.length>3)&&(u(t.charCodeAt(0))&&58===t.charCodeAt(1)&&(2===e.length||92===t.charCodeAt(2))):t===r.posix.sep},t.indexOfPath=function(e,t,i){return t.length>e.length?-1:e===t?0:(i&&(e=e.toLowerCase(),t=t.toLowerCase()),e.indexOf(t))},t.parseLineAndColumnAware=function(e){const t=e.split(":");let i=void 0,n=void 0,r=void 0;if(t.forEach(e=>{const t=Number(e);s.isNumber(t)?void 0===n?n=t:void 0===r&&(r=t):i=i?[i,e].join(":"):e}),!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:void 0!==n?n:void 0,column:void 0!==r?r:void 0!==n?1:void 0}}})),define(t[19],i([0,1,18]),(function(e,t,i){
"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.assign=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0,t.deepClone=function e(t){if(!t||"object"!=typeof t)return t;if(t instanceof RegExp)return t;const i=Array.isArray(t)?[]:{};return Object.keys(t).forEach(n=>{t[n]&&"object"==typeof t[n]?i[n]=e(t[n]):i[n]=t[n]}),i},t.deepFreeze=function(e){if(!e||"object"!=typeof e)return e;const t=[e];for(;t.length>0;){const e=t.shift();Object.freeze(e);for(const i in e)if(n.call(e,i)){const n=e[i];"object"!=typeof n||Object.isFrozen(n)||t.push(n)}}return e};const n=Object.prototype.hasOwnProperty;function r(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(typeof e!=typeof t)return!1;if("object"!=typeof e)return!1;if(Array.isArray(e)!==Array.isArray(t))return!1;let i,n;if(Array.isArray(e)){if(e.length!==t.length)return!1;for(i=0;i<e.length;i++)if(!r(e[i],t[i]))return!1}else{const s=[];for(n in e)s.push(n);s.sort();const o=[]
;for(n in t)o.push(n);if(o.sort(),!r(s,o))return!1;for(i=0;i<s.length;i++)if(!r(e[s[i]],t[s[i]]))return!1}return!0}t.cloneAndChange=function(e,t){return function e(t,r,s){if(i.isUndefinedOrNull(t))return t;const o=r(t);if(void 0!==o)return o;if(i.isArray(t)){const i=[];for(const n of t)i.push(e(n,r,s));return i}if(i.isObject(t)){if(s.has(t))throw new Error("Cannot clone recursive data-structure");s.add(t);const i={};for(let o in t)n.call(t,o)&&(i[o]=e(t[o],r,s));return s.delete(t),i}return t}(e,t,new Set)},t.mixin=function e(t,n,r=!0){return i.isObject(t)?(i.isObject(n)&&Object.keys(n).forEach(s=>{s in t?r&&(i.isObject(t[s])&&i.isObject(n[s])?e(t[s],n[s],r):t[s]=n[s]):t[s]=n[s]}),t):n},t.assign=function(e,...t){return t.forEach(t=>Object.keys(t).forEach(i=>e[i]=t[i])),e},t.equals=r,t.safeStringify=function(e){const t=[];return JSON.stringify(e,(e,n)=>{if(i.isObject(n)||Array.isArray(n)){if(-1!==t.indexOf(n))return"[Circular]";t.push(n)}return n})},t.getOrDefault=function(e,t,i){const n=t(e)
;return void 0===n?i:n},t.distinct=function(e,t){const i=Object.create(null);return e&&t?(Object.keys(t).forEach(n=>{const s=e[n],o=t[n];r(s,o)||(i[n]=o)}),i):i}})),define(t[7],i([0,1,6,4]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,s=/^\//,o=/^\/\//;const a="",c="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{constructor(e,t,i,n,l,u=!1){"object"==typeof e?(this.scheme=e.scheme||a,this.authority=e.authority||a,this.path=e.path||a,this.query=e.query||a,this.fragment=e.fragment||a):(this.scheme=function(e,t){return e||t?e:"file"}(e,u),this.authority=t||a,this.path=function(e,t){switch(e){case"https":case"http":case"file":t?t[0]!==c&&(t=c+t):t=c}return t}(this.scheme,i||a),this.query=n||a,this.fragment=l||a,function(e,t){if(!e.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${e.authority}", path: "${e.path}", query: "${e.query}", fragment: "${e.fragment}"}`)
;if(e.scheme&&!r.test(e.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(e.path)if(e.authority){if(!s.test(e.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(o.test(e.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}(this,u))}static isUri(e){return e instanceof u||!!e&&("string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme&&"function"==typeof e.fsPath&&"function"==typeof e.with&&"function"==typeof e.toString)}get fsPath(){return m(this,!1)}with(e){if(!e)return this;let{scheme:t,authority:i,path:n,query:r,fragment:s}=e;return void 0===t?t=this.scheme:null===t&&(t=a),void 0===i?i=this.authority:null===i&&(i=a),void 0===n?n=this.path:null===n&&(n=a),
void 0===r?r=this.query:null===r&&(r=a),void 0===s?s=this.fragment:null===s&&(s=a),t===this.scheme&&i===this.authority&&n===this.path&&r===this.query&&s===this.fragment?this:new d(t,i,n,r,s)}static parse(e,t=!1){const i=l.exec(e);return i?new d(i[2]||a,S(i[4]||a),S(i[5]||a),S(i[7]||a),S(i[9]||a),t):new d(a,a,a,a,a)}static file(e){let t=a;if(i.isWindows&&(e=e.replace(/\\/g,c)),e[0]===c&&e[1]===c){const i=e.indexOf(c,2);-1===i?(t=e.substring(2),e=c):(t=e.substring(2,i),e=e.substring(i)||c)}return new d("file",t,e,a,a)}static from(e){return new d(e.scheme,e.authority,e.path,e.query,e.fragment)}static joinPath(e,...t){if(!e.path)throw new Error("[UriError]: cannot call joinPaths on URI without path");let r;return r=i.isWindows&&"file"===e.scheme?u.file(n.win32.join(m(e,!0),...t)).path:n.posix.join(e.path,...t),e.with({path:r})}toString(e=!1){return v(this,e)}toJSON(){return this}static revive(e){if(e){if(e instanceof u)return e;{const t=new d(e);return t._formatted=e.external,t._fsPath=e._sep===h?e.fsPath:null,t}
}return e}}t.URI=u;const h=i.isWindows?1:void 0;class d extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(e=!1){return e?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const e={$mid:1};return this._fsPath&&(e.fsPath=this._fsPath,e._sep=h),this._formatted&&(e.external=this._formatted),this.path&&(e.path=this.path),this.scheme&&(e.scheme=this.scheme),this.authority&&(e.authority=this.authority),this.query&&(e.query=this.query),this.fragment&&(e.fragment=this.fragment),e}}const f={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function g(e,t){let i=void 0,n=-1;for(let r=0;r<e.length;r++){const s=e.charCodeAt(r)
;if(s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57||45===s||46===s||95===s||126===s||t&&47===s)-1!==n&&(i+=encodeURIComponent(e.substring(n,r)),n=-1),void 0!==i&&(i+=e.charAt(r));else{void 0===i&&(i=e.substr(0,r));const t=f[s];void 0!==t?(-1!==n&&(i+=encodeURIComponent(e.substring(n,r)),n=-1),i+=t):-1===n&&(n=r)}}return-1!==n&&(i+=encodeURIComponent(e.substring(n))),void 0!==i?i:e}function p(e){let t=void 0;for(let i=0;i<e.length;i++){const n=e.charCodeAt(i);35===n||63===n?(void 0===t&&(t=e.substr(0,i)),t+=f[n]):void 0!==t&&(t+=e[i])}return void 0!==t?t:e}function m(e,t){let n;return n=e.authority&&e.path.length>1&&"file"===e.scheme?`//${e.authority}${e.path}`:47===e.path.charCodeAt(0)&&(e.path.charCodeAt(1)>=65&&e.path.charCodeAt(1)<=90||e.path.charCodeAt(1)>=97&&e.path.charCodeAt(1)<=122)&&58===e.path.charCodeAt(2)?t?e.path.substr(1):e.path[1].toLowerCase()+e.path.substr(2):e.path,i.isWindows&&(n=n.replace(/\//g,"\\")),n}function v(e,t){const i=t?p:g;let n="",{scheme:r,authority:s,path:o,query:a,fragment:l}=e
;if(r&&(n+=r,n+=":"),(s||"file"===r)&&(n+=c,n+=c),s){let e=s.indexOf("@");if(-1!==e){const t=s.substr(0,e);s=s.substr(e+1),-1===(e=t.indexOf(":"))?n+=i(t,!1):(n+=i(t.substr(0,e),!1),n+=":",n+=i(t.substr(e+1),!1)),n+="@"}-1===(e=(s=s.toLowerCase()).indexOf(":"))?n+=i(s,!1):(n+=i(s.substr(0,e),!1),n+=s.substr(e))}if(o){if(o.length>=3&&47===o.charCodeAt(0)&&58===o.charCodeAt(2)){const e=o.charCodeAt(1);e>=65&&e<=90&&(o=`/${String.fromCharCode(e+32)}:${o.substr(3)}`)}else if(o.length>=2&&58===o.charCodeAt(1)){const e=o.charCodeAt(0);e>=65&&e<=90&&(o=`${String.fromCharCode(e+32)}:${o.substr(2)}`)}n+=i(o,!0)}return a&&(n+="?",n+=i(a,!1)),l&&(n+="#",n+=t?l:g(l,!1)),n}t.uriToFsPath=m;const y=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(e){return e.match(y)?e.replace(y,e=>(function e(t){try{return decodeURIComponent(t)}catch(i){return t.length>3?t.substr(0,3)+e(t.substr(3)):t}})(e)):e}})),define(t[31],i([0,1,7]),(function(e,t,i){"use strict";function n(e,t){return i.URI.parse(e.toUrl(t))}
Object.defineProperty(t,"__esModule",{value:!0}),t.getUriFromAmdModule=t.getPathFromAmdModule=void 0,t.getPathFromAmdModule=function(e,t){return n(e,t).fsPath},t.getUriFromAmdModule=n})),define(t[84],i([0,1,7]),(function(e,t,i){"use strict";function n(e){const t=[];let i;try{const n=JSON.parse(e.arguments),r=n[n.length-1];r&&r.__$stack&&(n.pop(),i=r.__$stack),t.push(...n)}catch(i){t.push("Unable to log remote console arguments",e.arguments)}return{args:t,stack:i}}function r(e){if(!e)return e;const t=e.indexOf("\n");return-1===t?e:e.substring(0,t)}function s(e){return`color: ${e}`}Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0,t.isRemoteConsoleLog=function(e){const t=e;return t&&"string"==typeof t.type&&"string"==typeof t.severity},t.parse=n,t.getFirstFrame=function e(t){if("string"!=typeof t)return e(n(t).stack);if(t){const e=r(t),n=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(e||"");if(n&&4===n.length)return{
uri:i.URI.file(n[1]),line:Number(n[2]),column:Number(n[3])}}},t.log=function(e,t){const{args:i,stack:o}=n(e),a="string"==typeof i[0]&&1===i.length;let c=r(o);c&&(c=`(${c.trim()})`);let l=[];if(l="string"==typeof i[0]?c&&a?[`%c[${t}] %c${i[0]} %c${c}`,s("blue"),s(""),s("grey")]:[`%c[${t}] %c${i[0]}`,s("blue"),s(""),...i.slice(1)]:[`%c[${t}]%`,s("blue"),...i],c&&!a&&l.push(c),"function"!=typeof console[e.severity])throw new Error("Unknown console method");console[e.severity].apply(console,l)}})),define(t[85],i([0,1,17,14,7]),(function(e,t,i,n,r){"use strict";function s(e,t){return t instanceof RegExp?{$mid:2,source:t.source,flags:n.regExpFlags(t)}:t}function o(e,t=0){if(!e||t>200)return e;if("object"==typeof e){switch(e.$mid){case 1:return r.URI.revive(e);case 2:return new RegExp(e.source,e.flags)}if(e instanceof i.VSBuffer||e instanceof Uint8Array)return e;if(Array.isArray(e))for(let i=0;i<e.length;++i)e[i]=o(e[i],t+1);else for(const i in e)Object.hasOwnProperty.call(e,i)&&(e[i]=o(e[i],t+1))}return e}
Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0,t.stringify=function(e){return JSON.stringify(e,s)},t.parse=function(e){let t=JSON.parse(e);return t=o(t)},t.revive=o})),define(t[26],i([0,1,7,6]),(function(e,t,i,n){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteAuthorities=t.Schemas=void 0,function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.userData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebook="vscode-notebook",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeSettings="vscode-settings",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.vscodeWebviewResource="vscode-webview-resource",e.extension="extension"
}(r=t.Schemas||(t.Schemas={}));t.RemoteAuthorities=new class{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(e){this._preferredWebSchema=e}setDelegate(e){this._delegate=e}set(e,t,i){this._hosts[e]=t,this._ports[e]=i}setConnectionToken(e,t){this._connectionTokens[e]=t}rewrite(e){if(this._delegate)return this._delegate(e);const t=e.authority;let s=this._hosts[t];s&&-1!==s.indexOf(":")&&(s=`[${s}]`);const o=this._ports[t],a=this._connectionTokens[t];let c=`path=${encodeURIComponent(e.path)}`;return"string"==typeof a&&(c+=`&tkn=${encodeURIComponent(a)}`),i.URI.from({scheme:n.isWeb?this._preferredWebSchema:r.vscodeRemoteResource,authority:`${s}:${o}`,path:"/vscode-remote-resource",query:c})}}})),define(t[34],i([0,1,7,14,26,6]),(function(e,t,i,n,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.LRUCache=t.LinkedMap=t.Touch=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0,t.getOrSet=function(e,t,i){let n=e.get(t);return void 0===n&&(n=i,e.set(t,n)),n},t.mapToString=function(e){const t=[];return e.forEach((e,i)=>{t.push(`${i} => ${e}`)}),`Map(${e.size}) {${t.join(", ")}}`},t.setToString=function(e){const t=[];return e.forEach(e=>{t.push(e)}),`Set(${e.size}) {${t.join(", ")}}`};class o{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(e){return e.charCodeAt(0)-this._value.charCodeAt(this._pos)}value(){return this._value[this._pos]}}t.StringIterator=o;class a{constructor(e=!0,t=!0){this._splitOnBackslash=e,this._caseSensitive=t}reset(e){return this._value=e.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0
;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(47===t||this._splitOnBackslash&&92===t){if(!e)break;this._from++}else e=!1}return this}cmp(e){return this._caseSensitive?n.compareSubstring(e,this._value,0,e.length,this._from,this._to):n.compareSubstringIgnoreCase(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}var c;t.PathIterator=a,function(e){e[e.Scheme=1]="Scheme",e[e.Authority=2]="Authority",e[e.Path=3]="Path",e[e.Query=4]="Query",e[e.Fragment=5]="Fragment"}(c||(c={}));class l{constructor(){this._states=[],this._stateIdx=0}reset(e){if(this._value=e,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path){const t=e.scheme===r.Schemas.file&&s.isLinux;this._pathIterator=new a(!1,t),this._pathIterator.reset(e.path),this._pathIterator.value()&&this._states.push(3)}return this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),
this._stateIdx=0,this}next(){return 3===this._states[this._stateIdx]&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return 3===this._states[this._stateIdx]&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(e){if(1===this._states[this._stateIdx])return n.compare(e,this._value.scheme);if(2===this._states[this._stateIdx])return n.compareSubstringIgnoreCase(e,this._value.authority);if(3===this._states[this._stateIdx])return this._pathIterator.cmp(e);if(4===this._states[this._stateIdx])return n.compare(e,this._value.query);if(5===this._states[this._stateIdx])return n.compare(e,this._value.fragment);throw new Error}value(){if(1===this._states[this._stateIdx])return this._value.scheme;if(2===this._states[this._stateIdx])return this._value.authority;if(3===this._states[this._stateIdx])return this._pathIterator.value();if(4===this._states[this._stateIdx])return this._value.query;if(5===this._states[this._stateIdx])return this._value.fragment
;throw new Error}}t.UriIterator=l;class u{isEmpty(){return!(this.left||this.mid||this.right||this.value)}}class h{constructor(e){this._iter=e}static forUris(){return new h(new l)}static forPaths(){return new h(new a)}static forStrings(){return new h(new o)}clear(){this._root=void 0}set(e,t){const i=this._iter.reset(e);let n;for(this._root||(this._root=new u,this._root.segment=i.value()),n=this._root;;){const e=i.cmp(n.segment);if(e>0)n.left||(n.left=new u,n.left.segment=i.value()),n=n.left;else if(e<0)n.right||(n.right=new u,n.right.segment=i.value()),n=n.right;else{if(!i.hasNext())break;i.next(),n.mid||(n.mid=new u,n.mid.segment=i.value()),n=n.mid}}const r=n.value;return n.value=t,n.key=e,r}get(e){const t=this._iter.reset(e);let i=this._root;for(;i;){const e=t.cmp(i.segment);if(e>0)i=i.left;else if(e<0)i=i.right;else{if(!t.hasNext())break;t.next(),i=i.mid}}return i?i.value:void 0}delete(e){const t=this._iter.reset(e),i=[];let n=this._root;for(;n;){const e=t.cmp(n.segment);if(e>0)i.push([1,n]),
n=n.left;else if(e<0)i.push([-1,n]),n=n.right;else{if(!t.hasNext()){for(n.value=void 0;i.length>0&&n.isEmpty();){let[e,t]=i.pop();switch(e){case 1:t.left=void 0;break;case 0:t.mid=void 0;break;case-1:t.right=void 0}n=t}break}t.next(),i.push([0,n]),n=n.mid}}}findSubstr(e){const t=this._iter.reset(e);let i=this._root,n=void 0;for(;i;){const e=t.cmp(i.segment);if(e>0)i=i.left;else if(e<0)i=i.right;else{if(!t.hasNext())break;t.next(),n=i.value||n,i=i.mid}}return i&&i.value||n}findSuperstr(e){const t=this._iter.reset(e);let i=this._root;for(;i;){const e=t.cmp(i.segment);if(e>0)i=i.left;else if(e<0)i=i.right;else{if(!t.hasNext())return i.mid?this._nodeIterator(i.mid):void 0;t.next(),i=i.mid}}}_nodeIterator(e){let t,i,n;return{next:()=>(n||(n=[],i=0,this._forEach(e,e=>n.push(e))),i>=n.length?{done:!0,value:void 0}:(t?t.value=n[i++]:t={done:!1,value:n[i++]},t))}}forEach(e){this._forEach(this._root,e)}_forEach(e,t){e&&(this._forEach(e.left,t),e.value&&t(e.value,e.key),this._forEach(e.mid,t),this._forEach(e.right,t))}}
t.TernarySearchTree=h;class d{constructor(e,t){this[Symbol.toStringTag]="ResourceMap",e instanceof d?(this.map=new Map(e.map),this.toKey=null!=t?t:d.defaultToKey):(this.map=new Map,this.toKey=null!=e?e:d.defaultToKey)}set(e,t){return this.map.set(this.toKey(e),t),this}get(e){return this.map.get(this.toKey(e))}has(e){return this.map.has(this.toKey(e))}get size(){return this.map.size}clear(){this.map.clear()}delete(e){return this.map.delete(this.toKey(e))}forEach(e,t){void 0!==t&&(e=e.bind(t));for(let[t,n]of this.map)e(n,i.URI.parse(t),this)}values(){return this.map.values()}*keys(){for(let e of this.map.keys())yield i.URI.parse(e)}*entries(){for(let e of this.map.entries())yield[i.URI.parse(e[0]),e[1]]}*[Symbol.iterator](){for(let e of this.map)yield[i.URI.parse(e[0]),e[1]]}}t.ResourceMap=d,d.defaultToKey=e=>e.toString(),function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"}(t.Touch||(t.Touch={}));class f{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,
this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var e;return null===(e=this._head)||void 0===e?void 0:e.value}get last(){var e;return null===(e=this._tail)||void 0===e?void 0:e.value}has(e){return this._map.has(e)}get(e,t=0){const i=this._map.get(e);if(i)return 0!==t&&this.touch(i,t),i.value}set(e,t,i=0){let n=this._map.get(e);if(n)n.value=t,0!==i&&this.touch(n,i);else{switch(n={key:e,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(n);break;case 1:this.addItemFirst(n);break;case 2:default:this.addItemLast(n)}this._map.set(e,n),this._size++}return this}delete(e){return!!this.remove(e)}remove(e){const t=this._map.get(e);if(t)return this._map.delete(e),this.removeItem(t),this._size--,t.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const e=this._head
;return this._map.delete(e.key),this.removeItem(e),this._size--,e.value}forEach(e,t){const i=this._state;let n=this._head;for(;n;){if(t?e.bind(t)(n.value,n.key,this):e(n.value,n.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const e=this,t=this._state;let i=this._head;const n={[Symbol.iterator]:()=>n,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const e={value:i.key,done:!1};return i=i.next,e}return{value:void 0,done:!0}}};return n}values(){const e=this,t=this._state;let i=this._head;const n={[Symbol.iterator]:()=>n,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const e={value:i.value,done:!1};return i=i.next,e}return{value:void 0,done:!0}}};return n}entries(){const e=this,t=this._state;let i=this._head;const n={[Symbol.iterator]:()=>n,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const e={value:[i.key,i.value],done:!1}
;return i=i.next,e}return{value:void 0,done:!0}}};return n}[Symbol.iterator](){return this.entries()}trimOld(e){if(e>=this.size)return;if(0===e)return void this.clear();let t=this._head,i=this.size;for(;t&&i>e;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}addItemFirst(e){if(this._head||this._tail){if(!this._head)throw new Error("Invalid list");e.next=this._head,this._head.previous=e}else this._tail=e;this._head=e,this._state++}addItemLast(e){if(this._head||this._tail){if(!this._tail)throw new Error("Invalid list");e.previous=this._tail,this._tail.next=e}else this._head=e;this._tail=e,this._state++}removeItem(e){if(e===this._head&&e===this._tail)this._head=void 0,this._tail=void 0;else if(e===this._head){if(!e.next)throw new Error("Invalid list");e.next.previous=void 0,this._head=e.next}else if(e===this._tail){if(!e.previous)throw new Error("Invalid list");e.previous.next=void 0,this._tail=e.previous}else{const t=e.next,i=e.previous
;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}e.next=void 0,e.previous=void 0,this._state++}touch(e,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(1===t||2===t)if(1===t){if(e===this._head)return;const t=e.next,i=e.previous;e===this._tail?(i.next=void 0,this._tail=i):(t.previous=i,i.next=t),e.previous=void 0,e.next=this._head,this._head.previous=e,this._head=e,this._state++}else if(2===t){if(e===this._tail)return;const t=e.next,i=e.previous;e===this._head?(t.previous=void 0,this._head=t):(t.previous=i,i.next=t),e.next=void 0,e.previous=this._tail,this._tail.next=e,this._tail=e,this._state++}}toJSON(){const e=[];return this.forEach((t,i)=>{e.push([i,t])}),e}fromJSON(e){this.clear();for(const[t,i]of e)this.set(t,i)}}t.LinkedMap=f;t.LRUCache=class extends f{constructor(e,t=1){super(),this._limit=e,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(e){this._limit=e,this.checkTrim()}get ratio(){return this._ratio}set ratio(e){
this._ratio=Math.min(Math.max(0,e),1),this.checkTrim()}get(e,t=2){return super.get(e,t)}peek(e){return super.get(e,0)}set(e,t){return super.set(e,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}})),define(t[60],i([0,1,15,14,39,4,34,9]),(function(e,t,i,n,r,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0,t.getEmptyExpression=function(){return Object.create(null)};const c="**",l="/",u="[/\\\\]",h="[^/\\\\]",d=/\//g;function f(e){switch(e){case 0:return"";case 1:return`${h}*?`;default:return`(?:${u}|${h}+${u}|${u}${h}+)*?`}}function g(e,t){if(!e)return[];const i=[];let n=!1,r=!1,s="";for(const o of e){switch(o){case t:if(!n&&!r){i.push(s),s="";continue}break;case"{":n=!0;break;case"}":n=!1;break;case"[":r=!0;break;case"]":r=!1}s+=o}return s&&i.push(s),i}t.splitGlobAware=g
;const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,y=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,E=new o.LRUCache(1e4),C=function(){return!1},_=function(){return null};function b(e,t){if(!e)return _;let r;const s=`${r=(r="string"!=typeof e?e.pattern:e).trim()}_${!!t.trimForExclusions}`;let o,a=E.get(s);if(a)return D(a,e);if(p.test(r)){const e=r.substr(4);a=function(t,i){return"string"==typeof t&&t.endsWith(e)?r:null}}else a=(o=m.exec(x(r,t)))?function(e,t){const i=`/${e}`,n=`\\${e}`,r=function(r,s){return"string"!=typeof r?null:s?s===e?t:null:r===e||r.endsWith(i)||r.endsWith(n)?t:null},s=[e];return r.basenames=s,r.patterns=[t],r.allBasenames=s,r}(o[1],r):(t.trimForExclusions?y:v).test(r)?function(e,t){const n=L(e.slice(1,-1).split(",").map(e=>b(e,t)).filter(e=>e!==_),e),r=n.length;if(!r)return _;if(1===r)return n[0];const s=function(t,i){
for(let r=0,s=n.length;r<s;r++)if(n[r](t,i))return e;return null},o=i.first(n,e=>!!e.allBasenames);o&&(s.allBasenames=o.allBasenames);const a=n.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);a.length&&(s.allPaths=a);return s}(r,t):(o=S.exec(x(r,t)))?I(o[1].substr(1),r,!0):(o=w.exec(x(r,t)))?I(o[1],r,!1):function(e){try{const t=new RegExp(`^${function e(t){if(!t)return"";let i="";const r=g(t,l);if(r.every(e=>e===c))i=".*";else{let t=!1;r.forEach((s,o)=>{if(s===c)return void(t||(i+=f(2),t=!0));let a=!1,d="",p=!1,m="";for(const t of s)if("}"!==t&&a)d+=t;else if(!p||"]"===t&&m)switch(t){case"{":a=!0;continue;case"[":p=!0;continue;case"}":const r=`(?:${g(d,",").map(t=>e(t)).join("|")})`;i+=r,a=!1,d="";break;case"]":i+="["+m+"]",p=!1,m="";break;case"?":i+=h;continue;case"*":i+=f(1);continue;default:i+=n.escapeRegExpCharacters(t)}else{let e;m+=e="-"===t?t:"^"!==t&&"!"!==t||m?t===l?"":n.escapeRegExpCharacters(t):"^"}o<r.length-1&&(r[o+1]!==c||o+2<r.length)&&(i+=u),t=!1})}return i}(e)}$`);return function(i){
return t.lastIndex=0,"string"==typeof i&&t.test(i)?e:null}}catch(e){return _}}(r);return E.set(s,a),D(a,e)}function D(e,t){return"string"==typeof t?e:function(i,n){return r.isEqualOrParent(i,t.base)?e(s.relative(t.base,i),n):null}}function x(e,t){return t.trimForExclusions&&e.endsWith("/**")?e.substr(0,e.length-2):e}function I(e,t,i){const n=s.sep!==s.posix.sep?e.replace(d,s.sep):e,r=s.sep+n,o=i?function(e,i){return"string"!=typeof e||e!==n&&!e.endsWith(r)?null:t}:function(e,i){return"string"==typeof e&&e===n?t:null};return o.allPaths=[(i?"*/":"./")+e],o}function P(e,t={}){if(!e)return C;if("string"==typeof e||k(e)){const i=b(e,t);if(i===_)return C;const n=function(e,t){return!!i(e,t)};return i.allBasenames&&(n.allBasenames=i.allBasenames),i.allPaths&&(n.allPaths=i.allPaths),n}return function(e,t){const n=L(Object.getOwnPropertyNames(e).map(i=>(function(e,t,i){if(!1===t)return _;const n=b(e,i);if(n===_)return _;if("boolean"==typeof t)return n;if(t){const i=t.when;if("string"==typeof i){const t=(t,r,s,o)=>{
if(!o||!n(t,r))return null;const c=o(i.replace("$(basename)",s));return a.isThenable(c)?c.then(t=>t?e:null):c?e:null};return t.requiresSiblings=!0,t}}return n})(i,e[i],t)).filter(e=>e!==_)),r=n.length;if(!r)return _;if(!n.some(e=>!!e.requiresSiblings)){if(1===r)return n[0];const e=function(e,t){for(let i=0,r=n.length;i<r;i++){const r=n[i](e,t);if(r)return r}return null},t=i.first(n,e=>!!e.allBasenames);t&&(e.allBasenames=t.allBasenames);const s=n.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);return s.length&&(e.allPaths=s),e}const o=function(e,t,i){let r=void 0;for(let o=0,a=n.length;o<a;o++){const a=n[o];a.requiresSiblings&&i&&(t||(t=s.basename(e)),r||(r=t.substr(0,t.length-s.extname(e).length)));const c=a(e,t,r,i);if(c)return c}return null},c=i.first(n,e=>!!e.allBasenames);c&&(o.allBasenames=c.allBasenames);const l=n.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);l.length&&(o.allPaths=l);return o}(e,t)}function R(e){const t={};for(const i of e)t[i]=!0;return t}function k(e){const t=e
;return t&&"string"==typeof t.base&&"string"==typeof t.pattern}function L(e,t){const i=e.filter(e=>!!e.basenames);if(i.length<2)return e;const n=i.reduce((e,t)=>{const i=t.basenames;return i?e.concat(i):e},[]);let r;if(t){r=[];for(let e=0,i=n.length;e<i;e++)r.push(t)}else r=i.reduce((e,t)=>{const i=t.patterns;return i?e.concat(i):e},[]);const s=function(e,t){if("string"!=typeof e)return null;if(!t){let i;for(i=e.length;i>0;i--){const t=e.charCodeAt(i-1);if(47===t||92===t)break}t=e.substr(i)}const i=n.indexOf(t);return-1!==i?r[i]:null};s.basenames=n,s.patterns=r,s.allBasenames=n;const o=e.filter(e=>!e.basenames);return o.push(s),o}t.match=function(e,t,i){return!(!e||"string"!=typeof t)&&P(e)(t,void 0,i)},t.parse=P,t.hasSiblingPromiseFn=function(e){if(!e)return;let t;return i=>(t||(t=(e()||Promise.resolve([])).then(e=>e?R(e):{})),t.then(e=>!!e[i]))},t.hasSiblingFn=function(e){if(!e)return;let t;return i=>{if(!t){const i=e();t=i?R(i):{}}return!!t[i]}},t.isRelativePattern=k,t.getBasenameTerms=function(e){
return e.allBasenames||[]},t.getPathTerms=function(e){return e.allPaths||[]}})),define(t[61],i([0,1,34]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeAccents=t.normalizeNFD=t.normalizeNFC=t.canNormalize=void 0,t.canNormalize="function"==typeof String.prototype.normalize;const n=new i.LRUCache(1e4);t.normalizeNFC=function(e){return a(e,"NFC",n)};const r=new i.LRUCache(1e4);function s(e){return a(e,"NFD",r)}t.normalizeNFD=s;const o=/[^\u0000-\u0080]/;function a(e,i,n){if(!t.canNormalize||!e)return e;const r=n.get(e);if(r)return r;let s;return s=o.test(e)?e.normalize(i):e,n.set(e,s),s}t.removeAccents=function(){if(t.canNormalize){const e=/[\u0300-\u036f]/g;return function(t){return s(t).replace(e,"")}}return function(e){return e}}()})),define(t[10],i([0,1,39,4,7,14,26,6,60,34]),(function(e,t,i,n,r,s,o,a,c,l){"use strict";function u(e){return r.uriToFsPath(e,!0)}Object.defineProperty(t,"__esModule",{value:!0}),
t.toLocalResource=t.ResourceGlobMatcher=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0,t.originalFSPath=u;class h{constructor(e){this._ignorePathCasing=e}compare(e,t,i=!1){return e===t?0:s.compare(this.getComparisonKey(e,i),this.getComparisonKey(t,i))}isEqual(e,t,i=!1){return e===t||!(!e||!t)&&this.getComparisonKey(e,i)===this.getComparisonKey(t,i)}getComparisonKey(e,t=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}isEqualOrParent(e,n,r=!1){if(e.scheme===n.scheme){
if(e.scheme===o.Schemas.file)return i.isEqualOrParent(u(e),u(n),this._ignorePathCasing(e))&&e.query===n.query&&(r||e.fragment===n.fragment);if(t.isEqualAuthority(e.authority,n.authority))return i.isEqualOrParent(e.path,n.path,this._ignorePathCasing(e),"/")&&e.query===n.query&&(r||e.fragment===n.fragment)}return!1}joinPath(e,...t){return r.URI.joinPath(e,...t)}basenameOrAuthority(e){return t.basename(e)||e.authority}basename(e){return n.posix.basename(e.path)}extname(e){return n.posix.extname(e.path)}dirname(e){if(0===e.path.length)return e;let t;return e.scheme===o.Schemas.file?t=r.URI.file(n.dirname(u(e))).path:(t=n.posix.dirname(e.path),e.authority&&t.length&&47!==t.charCodeAt(0)&&(console.error(`dirname("${e.toString})) resulted in a relative path`),t="/")),e.with({path:t})}normalizePath(e){if(!e.path.length)return e;let t;return t=e.scheme===o.Schemas.file?r.URI.file(n.normalize(u(e))).path:n.posix.normalize(e.path),e.with({path:t})}relativePath(e,r){
if(e.scheme!==r.scheme||!t.isEqualAuthority(e.authority,r.authority))return;if(e.scheme===o.Schemas.file){const t=n.relative(u(e),u(r));return a.isWindows?i.toSlashes(t):t}let s=e.path||"/",c=r.path||"/";if(this._ignorePathCasing(e)){let e=0;for(const t=Math.min(s.length,c.length);e<t&&(s.charCodeAt(e)===c.charCodeAt(e)||s.charAt(e).toLowerCase()===c.charAt(e).toLowerCase());e++);s=c.substr(0,e)+s.substr(e)}return n.posix.relative(s,c)}resolvePath(e,t){if(e.scheme===o.Schemas.file){const i=r.URI.file(n.resolve(u(e),t));return e.with({authority:i.authority,path:i.path})}return-1===t.indexOf("/")&&(t=i.toSlashes(t),/^[a-zA-Z]:(\/|$)/.test(t)&&(t="/"+t)),e.with({path:n.posix.resolve(e.path,t)})}isAbsolutePath(e){return!!e.path&&"/"===e.path[0]}isEqualAuthority(e,t){return e===t||s.equalsIgnoreCase(e,t)}hasTrailingPathSeparator(e,t=n.sep){if(e.scheme===o.Schemas.file){const n=u(e);return n.length>i.getRoot(n).length&&n[n.length-1]===t}{const t=e.path
;return t.length>1&&47===t.charCodeAt(t.length-1)&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,i=n.sep){return t.hasTrailingPathSeparator(e,i)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,r=n.sep){let s=!1;if(e.scheme===o.Schemas.file){const t=u(e);s=void 0!==t&&t.length===i.getRoot(t).length&&t[t.length-1]===r}else{r="/";const t=e.path;s=1===t.length&&47===t.charCodeAt(t.length-1)}return s||t.hasTrailingPathSeparator(e,r)?e:e.with({path:e.path+"/"})}}t.ExtUri=h,t.extUri=new h(()=>!1),t.extUriBiasedIgnorePathCase=new h(e=>e.scheme!==o.Schemas.file||!a.isLinux),t.extUriIgnorePathCase=new h(e=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),
t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri),t.distinctParents=function(e,i){const n=[];for(let r=0;r<e.length;r++){const s=i(e[r]);e.some((e,n)=>n!==r&&t.isEqualOrParent(s,i(e)))||n.push(e[r])}return n},function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime",e.parseMetaData=function(t){const i=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(e=>{const[t,n]=e.split(":");t&&n&&i.set(t,n)})
;const n=t.path.substring(0,t.path.indexOf(";"));return n&&i.set(e.META_DATA_MIME,n),i}}(t.DataUri||(t.DataUri={}));t.ResourceGlobMatcher=class{constructor(e,t){this.expressionsByRoot=l.TernarySearchTree.forUris(),this.globalExpression=c.parse(e);for(const e of t)this.expressionsByRoot.set(e.root,{root:e.root,expression:c.parse(e.expression)})}matches(e){const i=this.expressionsByRoot.findSubstr(e);if(i){const n=t.relativePath(i.root,e);if(n&&i.expression(n))return!0}return!!this.globalExpression(e.path)}},t.toLocalResource=function(e,t){if(t){let i=e.path;return i&&i[0]!==n.posix.sep&&(i=n.posix.sep+i),e.with({scheme:o.Schemas.vscodeRemote,authority:t,path:i})}return e.with({scheme:o.Schemas.file})}})),define(t[62],i([0,1,7,4,14,26,6,10]),(function(e,t,i,n,r,s,o,a){"use strict";function c(e){return!(!o.isWindows||!e||":"!==e[1])}function l(e){return c(e)?e.charAt(0).toUpperCase()+e.slice(1):e}Object.defineProperty(t,"__esModule",{value:!0}),
t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0,t.getPathLabel=function(e,t,r){if("string"==typeof e&&(e=i.URI.file(e)),r){const t=r.getWorkspaceFolder(e);if(t){const i=r.getWorkspace().folders.length>1;let n;if(n=a.isEqual(t.uri,e)?"":a.relativePath(t.uri,e),i){const e=t.name?t.name:a.basename(t.uri);n=n?e+" • "+n:e}return n}}if(e.scheme!==s.Schemas.file&&e.scheme!==s.Schemas.untitled)return e.with({query:null,fragment:null}).toString(!0);if(c(e.fsPath))return n.normalize(l(e.fsPath));let u=n.normalize(e.fsPath);return!o.isWindows&&(null==t?void 0:t.userHome)&&(u=h(u,t.userHome.fsPath)),u},t.getBaseLabel=function(e){if(!e)return;"string"==typeof e&&(e=i.URI.file(e));const t=a.basename(e)||(e.scheme===s.Schemas.file?e.fsPath:e.path);return c(t)?l(t):t},t.normalizeDriveLetter=l;let u=Object.create(null);function h(e,t){if(o.isWindows||!e||!t)return e
;let i=u.original===t?u.normalized:void 0;return i||(i=`${r.rtrim(t,n.posix.sep)}${n.posix.sep}`,u={original:t,normalized:i}),(o.isLinux?e.startsWith(i):r.startsWithIgnoreCase(e,i))&&(e=`~/${e.substr(i.length)}`),e}t.tildify=h,t.untildify=function(e,t){return e.replace(/^~($|\/|\\)/,`${t}$1`)};const d="…",f="\\\\",g="~";var p;t.shorten=function(e,t=n.sep){const i=new Array(e.length);let r=!1;for(let n=0;n<e.length;n++){let s=e[n];if(""===s){i[n]=`.${t}`;continue}if(!s){i[n]=s;continue}r=!0;let o="";0===s.indexOf(f)?(o=s.substr(0,s.indexOf(f)+f.length),s=s.substr(s.indexOf(f)+f.length)):0===s.indexOf(t)?(o=s.substr(0,s.indexOf(t)+t.length),s=s.substr(s.indexOf(t)+t.length)):0===s.indexOf(g)&&(o=s.substr(0,s.indexOf(g)+g.length),s=s.substr(s.indexOf(g)+g.length));const a=s.split(t);for(let s=1;r&&s<=a.length;s++)for(let c=a.length-s;r&&c>=0;c--){r=!1;let l=a.slice(c,c+s).join(t);for(let i=0;!r&&i<e.length;i++)if(i!==n&&e[i]&&e[i].indexOf(l)>-1){
const n=c+s===a.length,o=c>0&&e[i].indexOf(t)>-1?t+l:l,u=e[i].endsWith(o);r=!n||u}if(!r){let e="";(a[0].endsWith(":")||""!==o)&&(1===c&&(c=0,s++,l=a[0]+t+l),c>0&&(e=a[0]+t),e=o+e),c>0&&(e=e+d+t),e+=l,c+s<a.length&&(e=e+t+d),i[n]=e}}r&&(i[n]=s)}return i},function(e){e[e.TEXT=0]="TEXT",e[e.VARIABLE=1]="VARIABLE",e[e.SEPARATOR=2]="SEPARATOR"}(p||(p={})),t.template=function(e,t=Object.create(null)){const i=[];let n=!1,r="";for(const s of e)if("$"===s||n&&"{"===s)r&&i.push({value:r,type:p.TEXT}),r="",n=!0;else if("}"===s&&n){const e=t[r];if("string"==typeof e)e.length&&i.push({value:e,type:p.VARIABLE});else if(e){const t=i[i.length-1];t&&t.type===p.SEPARATOR||i.push({value:e.label,type:p.SEPARATOR})}r="",n=!1}else r+=s;return r&&!n&&i.push({value:r,type:p.TEXT}),i.filter((e,t)=>{if(e.type===p.SEPARATOR){return[i[t-1],i[t+1]].every(e=>e&&(e.type===p.VARIABLE||e.type===p.TEXT)&&e.value.length>0)}return!0}).map(e=>e.value).join("")},t.mnemonicMenuLabel=function(e,t){
return o.isMacintosh||t?e.replace(/\(&&\w\)|&&/g,"").replace(/&/g,o.isMacintosh?"&":"&&"):e.replace(/&&|&/g,e=>"&"===e?"&&":"&")},t.mnemonicButtonLabel=function(e,t){return o.isMacintosh||t?e.replace(/\(&&\w\)|&&/g,""):o.isWindows?e.replace(/&&|&/g,e=>"&"===e?"&&":"&"):e.replace(/&&/g,"_")},t.unmnemonicLabel=function(e){return e.replace(/&/g,"&&")},t.splitName=function(e){const t=-1!==e.indexOf("/")?n.posix:n.win32,i=t.basename(e),r=t.dirname(e);return i.length?{name:i,parentPath:r}:{name:r,parentPath:""}}})),define(t[86],i([0,1,7]),(function(e,t,i){"use strict";function n(e){return e.toJSON()}Object.defineProperty(t,"__esModule",{value:!0}),t.transformAndReviveIncomingURIs=t.transformIncomingURIs=t.transformOutgoingURIs=t.DefaultURITransformer=t.URITransformer=void 0;function r(e,t,n,s){if(!e||s>200)return null;if("object"==typeof e){if(1===e.$mid)return n?i.URI.revive(t.transformIncoming(e)):t.transformIncoming(e);for(let i in e)if(Object.hasOwnProperty.call(e,i)){const o=r(e[i],t,n,s+1);null!==o&&(e[i]=o)}
}return null}t.URITransformer=class{constructor(e){this._uriTransformer=e}transformIncoming(e){const t=this._uriTransformer.transformIncoming(e);return t===e?e:n(i.URI.from(t))}transformOutgoing(e){const t=this._uriTransformer.transformOutgoing(e);return t===e?e:n(i.URI.from(t))}transformOutgoingURI(e){const t=this._uriTransformer.transformOutgoing(e);return t===e?e:i.URI.from(t)}transformOutgoingScheme(e){return this._uriTransformer.transformOutgoingScheme(e)}},t.DefaultURITransformer=new class{transformIncoming(e){return e}transformOutgoing(e){return e}transformOutgoingURI(e){return e}transformOutgoingScheme(e){return e}},t.transformOutgoingURIs=function(e,t){const n=function e(t,n,r){if(!t||r>200)return null;if("object"==typeof t){if(t instanceof i.URI)return n.transformOutgoing(t);for(let i in t)if(Object.hasOwnProperty.call(t,i)){const s=e(t[i],n,r+1);null!==s&&(t[i]=s)}}return null}(e,t,0);return null===n?e:n},t.transformIncomingURIs=function(e,t){const i=r(e,t,!1,0);return null===i?e:i},
t.transformAndReviveIncomingURIs=function(e,t){const i=r(e,t,!0,0);return null===i?e:i}})),define(t[29],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;t.isUUID=function(e){return i.test(e)};const n=new Uint8Array(16),r=[];for(let e=0;e<256;e++)r.push(e.toString(16).padStart(2,"0"));const s=function(e){for(let t=0;t<e.length;t++)e[t]=Math.floor(256*Math.random());return e};t.generateUuid=function(){s(n),n[6]=15&n[6]|64,n[8]=63&n[8]|128;let e=0,t="";return t+=r[n[e++]],t+=r[n[e++]],t+=r[n[e++]],t+=r[n[e++]],t+="-",t+=r[n[e++]],t+=r[n[e++]],t+="-",t+=r[n[e++]],t+=r[n[e++]],t+="-",t+=r[n[e++]],t+=r[n[e++]],t+="-",t+=r[n[e++]],t+=r[n[e++]],t+=r[n[e++]],t+=r[n[e++]],t+=r[n[e++]],t+=r[n[e++]]}})),define(t[63],i([0,1,195]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;t.LineDecoder=class{constructor(e="utf8"){
this.stringDecoder=new i.StringDecoder(e),this.remaining=null}write(e){const t=[],i=this.remaining?this.remaining+this.stringDecoder.write(e):this.stringDecoder.write(e);if(i.length<1)return t;let n,r=0,s=r;for(;s<i.length;)if(13===(n=i.charCodeAt(s))||10===n){if(t.push(i.substring(r,s)),++s<i.length){const e=n;n=i.charCodeAt(s),(13===e&&10===n||10===e&&13===n)&&s++}r=s}else s++;return this.remaining=r<i.length?i.substr(r):null,t}end(){return this.remaining}}})),define(t[87],i([0,1,44,6]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMac=void 0;const r={windows:"getmac.exe",unix:"/sbin/ifconfig -a || /sbin/ip link"},s=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function o(e){const t=e.replace(/\-/g,":").toLowerCase();return!s.has(t)}t.getMac=function(){return new Promise(async(e,t)=>{const s=setTimeout(()=>t("Unable to retrieve mac address (timeout after 10s)"),1e4);try{e(await new Promise((e,t)=>{try{i.exec(n.isWindows?r.windows:r.unix,{
timeout:1e4},(i,n,r)=>{if(i)return t(`Unable to retrieve mac address (${i.toString()})`);{const i=/(?:[a-f\d]{2}[:\-]){5}[a-f\d]{2}/gi;let r;for(;null!==(r=i.exec(n));){const t=r[0];if(o(t))return e(t)}return t("Unable to retrieve mac address (unexpected format)")}})}catch(e){t(e)}}))}catch(e){t(e)}finally{clearTimeout(s)}})}})),define(t[88],i([0,1,20,29,40,34,87]),(function(e,t,i,n,r,s,o){"use strict";let a;Object.defineProperty(t,"__esModule",{value:!0}),t.getMachineId=t.virtualMachineHint=void 0,t.virtualMachineHint=new class{_isVirtualMachineMacAdress(e){return this._virtualMachineOUIs||(this._virtualMachineOUIs=s.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),
this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(e)}value(){if(void 0===this._value){let e=0,t=0;const i=r.networkInterfaces();for(let n in i)if(Object.prototype.hasOwnProperty.call(i,n))for(const{mac:r,internal:s}of i[n])s||(t+=1,this._isVirtualMachineMacAdress(r.toUpperCase())&&(e+=1));this._value=t>0?e/t:0}return this._value}},t.getMachineId=async function(){return a||(a=(async()=>{return await async function(){try{const t=await new Promise((t,i)=>{e(["crypto"],t,i)}),i=await o.getMac();return t.createHash("sha256").update(i,"utf8").digest("hex")}catch(e){return void i.onUnexpectedError(e)}}()||n.generateUuid()})()),a}})),define(t[89],i([0,1,31]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.getDefaultUserDataPath=t.getAppDataPath=void 0;const n=i.getPathFromAmdModule(e,"paths"),r=e.__$__nodeRequire(n);t.getAppDataPath=r.getAppDataPath,t.getDefaultUserDataPath=r.getDefaultUserDataPath})),define(t[21],i([0,1,4,9,35,40,6,3,52,39,29,61]),(function(e,t,i,n,r,s,o,a,c,l,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.copy=t.move=t.whenDeleted=t.fileExists=t.dirExists=t.readDirsInDir=t.writeFileSync=t.writeFile=t.mkdirp=t.readFile=t.truncate=t.symlink=t.unlink=t.renameIgnoreError=t.rename=t.lstat=t.statLink=t.stat=t.chmod=t.exists=t.readdirSync=t.readdirWithFileTypes=t.readdir=t.rimrafSync=t.rimraf=t.RimRafMode=t.MAX_HEAP_SIZE=t.MAX_FILE_SIZE=void 0;var d;async function f(e,t=d.UNLINK){if(l.isRootOrDriveLetter(e))throw new Error("rimraf - will refuse to recursively delete root");return t===d.UNLINK?g(e):async function(e){try{const t=i.join(s.tmpdir(),u.generateUuid());try{await E(e,t)}catch(t){return g(e)}g(t)}catch(e){if("ENOENT"!==e.code)throw e}}(e)}async function g(e){try{
const t=await w(e);if(!t.isDirectory()||t.isSymbolicLink()){const i=t.mode;return 128&i||await y(e,128|i),C(e)}{const t=await p(e);await Promise.all(t.map(t=>g(i.join(e,t)))),await c.promisify(r.rmdir)(e)}}catch(e){if("ENOENT"!==e.code)throw e}}async function p(e){return v(await c.promisify(r.readdir)(e))}function m(e){return v(r.readdirSync(e))}function v(e){return o.isMacintosh?e.map(e=>h.normalizeNFC(e)):e}function y(e,t){return c.promisify(r.chmod)(e,t)}function S(e){return c.promisify(r.stat)(e)}function w(e){return c.promisify(r.lstat)(e)}function E(e,t){return c.promisify(r.rename)(e,t)}function C(e){return c.promisify(r.unlink)(e)}async function _(e,t){return c.promisify(r.mkdir)(e,{mode:t,recursive:!0})}t.MAX_FILE_SIZE="ia32"===process.arch?314572800:17179869184,t.MAX_HEAP_SIZE="ia32"===process.arch?734003200:1468006400,function(e){e[e.UNLINK=0]="UNLINK",e[e.MOVE=1]="MOVE"}(d=t.RimRafMode||(t.RimRafMode={})),t.rimraf=f,t.rimrafSync=function e(t){
if(l.isRootOrDriveLetter(t))throw new Error("rimraf - will refuse to recursively delete root");try{const n=r.lstatSync(t);if(!n.isDirectory()||n.isSymbolicLink()){const e=n.mode;return 128&e||r.chmodSync(t,128|e),r.unlinkSync(t)}m(t).map(n=>e(i.join(t,n))),r.rmdirSync(t)}catch(e){if("ENOENT"!==e.code)throw e}},t.readdir=p,t.readdirWithFileTypes=async function(e){const t=await c.promisify(r.readdir)(e,{withFileTypes:!0});if(o.isMacintosh)for(const e of t)e.name=h.normalizeNFC(e.name);return t},t.readdirSync=m,t.exists=function(e){return c.promisify(r.exists)(e)},t.chmod=y,t.stat=S,t.statLink=async function(e){let t;try{if(!(t=await w(e)).isSymbolicLink())return{stat:t}}catch(e){}try{return{stat:await S(e),symbolicLink:(null==t?void 0:t.isSymbolicLink())?{dangling:!1}:void 0}}catch(e){if("ENOENT"===e.code&&t)return{stat:t,symbolicLink:{dangling:!0}};throw e}},t.lstat=w,t.rename=E,t.renameIgnoreError=function(e,t){return new Promise(i=>r.rename(e,t,()=>i()))},t.unlink=C,t.symlink=function(e,t,i){
return c.promisify(r.symlink)(e,t,i)},t.truncate=function(e,t){return c.promisify(r.truncate)(e,t)},t.readFile=function(e,t){return c.promisify(r.readFile)(e,t)},t.mkdirp=_;const b=new Map;t.writeFile=function(e,t,i){return function(e){const t=b.get(e);if(t)return t;const i=new n.Queue;return b.set(e,i),a.Event.once(i.onFinished)(()=>{b.delete(e),i.dispose()}),i}(function(e){let t=e;(o.isWindows||o.isMacintosh)&&(t=t.toLowerCase());return t}(e)).queue(()=>{const n=x(i);return new Promise((i,s)=>(function(e,t,i,n){if(!D)return r.writeFile(e,t,{mode:i.mode,flag:i.flag},n);r.open(e,i.flag,i.mode,(e,i)=>{if(e)return n(e);r.writeFile(i,t,e=>{if(e)return r.close(i,()=>n(e));r.fdatasync(i,e=>(e&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",e),D=!1),r.close(i,e=>n(e))))})})})(e,t,n,e=>e?s(e):i()))})};let D=!0;function x(e){return e?{mode:"number"==typeof e.mode?e.mode:438,flag:"string"==typeof e.flag?e.flag:"w"}:{mode:438,flag:"w"}}async function I(e){try{
return(await S(e)).isDirectory()}catch(e){return!1}}async function P(e,t,n){const s=n||Object.create(null),o=await S(e);if(!o.isDirectory())return async function(e,t,i){return new Promise((n,s)=>{const o=r.createReadStream(e),a=r.createWriteStream(t,{mode:i});let c=!1;const l=e=>{if(!c){if(c=!0,e)return s(e);r.chmod(t,i,e=>e?s(e):n())}};o.once("error",e=>l(e)),a.once("error",e=>l(e)),a.once("close",()=>l()),o.pipe(a)})}(e,t,511&o.mode);if(s[e])return Promise.resolve();s[e]=!0,await _(t,511&o.mode);const a=await p(e);for(let n=0;n<a.length;n++){const r=a[n];await P(i.join(e,r),i.join(t,r),s)}}t.writeFileSync=function(e,t,i){const n=x(i);if(!D)return r.writeFileSync(e,t,{mode:n.mode,flag:n.flag});const s=r.openSync(e,n.flag,n.mode);try{r.writeFileSync(s,t);try{r.fdatasyncSync(s)}catch(e){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",e),D=!1}}finally{r.closeSync(s)}},t.readDirsInDir=async function(e){const t=await p(e),n=[]
;for(const r of t)await I(i.join(e,r))&&n.push(r);return n},t.dirExists=I,t.fileExists=async function(e){try{return(await S(e)).isFile()}catch(e){return!1}},t.whenDeleted=function(e){return new Promise(t=>{let i=!1;const n=setInterval(()=>{i||(i=!0,r.exists(e,e=>{i=!1,e||(clearInterval(n),t(void 0))}))},1e3)})},t.move=async function(e,t){if(e===t)return Promise.resolve();async function i(e){const t=await w(e);if(t.isDirectory()||t.isSymbolicLink())return Promise.resolve();const i=await c.promisify(r.open)(e,"a");try{await c.promisify(r.futimes)(i,t.atime,new Date)}catch(e){}return c.promisify(r.close)(i)}try{await E(e,t),await i(t)}catch(n){if(!(e.toLowerCase()!==t.toLowerCase()&&"EXDEV"===n.code||e.endsWith(".")))throw n;await P(e,t),await f(e,d.MOVE),await i(t)}},t.copy=P})),define(t[90],i([0,1,35,14,4,21,52]),(function(e,t,i,n,r,s,o){"use strict";function a(e){return n.rtrim(r.normalize(e),r.sep)}Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0,
t.realcaseSync=function e(t){const i=r.dirname(t);if(t===i)return t;const n=(r.basename(t)||t).toLowerCase();try{const t=s.readdirSync(i).filter(e=>e.toLowerCase()===n);if(1===t.length){const n=e(i);if(n)return r.join(n,t[0])}else if(t.length>1){const s=t.indexOf(n);if(s>=0){const n=e(i);if(n)return r.join(n,t[s])}}}catch(e){}return null},t.realpath=async function(e){try{return await o.promisify(i.realpath)(e)}catch(t){const n=a(e);return await o.promisify(i.access)(n,i.constants.R_OK),n}},t.realpathSync=function(e){try{return i.realpathSync(e)}catch(t){const n=a(e);return i.accessSync(n,i.constants.R_OK),n}}})),define(t[91],i([0,1,44,31]),(function(e,t,i,n){"use strict";function r(e,t){const i=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,n=e.toString().split("\n");for(const e of n){const n=i.exec(e.trim());n&&6===n.length&&t(parseInt(n[1]),parseInt(n[2]),n[5],parseFloat(n[3]),parseFloat(n[4]))}}Object.defineProperty(t,"__esModule",{value:!0}),t.listProcesses=void 0,
t.listProcesses=function(t){return new Promise((s,o)=>{let a;const c=new Map;function l(e,i,n,r,s){const o=c.get(i);if(e===t||o){const l={name:u(n),cmd:n,pid:e,ppid:i,load:r,mem:s};c.set(e,l),e===t&&(a=l),o&&(o.children||(o.children=[]),o.children.push(l),o.children.length>1&&(o.children=o.children.sort((e,t)=>e.pid-t.pid)))}}function u(e){const t=/--disable-blink-features=Auxclick/;if(/\\watcher\\win32\\CodeHelper\.exe/.exec(e))return"watcherService ";if(/--crashes-directory/.exec(e))return"electron-crash-reporter";if(/\\pipe\\winpty-control/.exec(e))return"winpty-process";if(/conhost\.exe/.exec(e))return"console-window-host (Windows internal process)";let i=/--type=([a-zA-Z-]+)/.exec(e);if(i&&2===i.length)return"renderer"===i[1]?t.exec(e)?"shared-process":"window":i[1];const n=/[a-zA-Z-]+\.js/g;let r="";do{(i=n.exec(e))&&(r+=i+" ")}while(i);return r&&e.indexOf("node ")<0&&e.indexOf("node.exe")<0?`electron_node ${r}`:e}if("win32"===process.platform){
const i=e=>0===e.indexOf("\\\\?\\")?e.substr(4):0===e.indexOf("\\??\\")?e.substr(4):0===e.indexOf('"\\\\?\\')?'"'+e.substr(5):0===e.indexOf('"\\??\\')?'"'+e.substr(5):e;new Promise((t,i)=>{e(["windows-process-tree"],t,i)}).then(e=>{e.getProcessList(t,n=>{e.getProcessCpuUsage(n,e=>{const n=new Map;e.forEach(e=>{const t=i(e.commandLine||"");n.set(e.pid,{name:u(t),cmd:t,pid:e.pid,ppid:e.ppid,load:e.cpu||0,mem:e.memory||0})}),(a=n.get(t))?(n.forEach(e=>{const t=n.get(e.ppid);t&&(t.children||(t.children=[]),t.children.push(e))}),n.forEach(e=>{e.children&&(e.children=e.children.sort((e,t)=>e.pid-t.pid))}),s(a)):o(new Error(`Root process ${t} not found`))})},e.ProcessDataFlag.CommandLine|e.ProcessDataFlag.Memory)})}else{function h(){let t=[a];const r=[];for(;t.length;){const e=t.shift();e&&(r.push(e.pid),e.children&&(t=t.concat(e.children)))}let l=JSON.stringify(n.getPathFromAmdModule(e,"vs/base/node/cpuUsage.sh"));l+=" "+r.join(" "),i.exec(l,{},(e,t,i)=>{if(e||i)o(e||new Error(i.toString()));else{
const e=t.toString().split("\n");for(let t=0;t<r.length;t++){c.get(r[t]).load=parseFloat(e[t])}s(a)}})}i.exec("which ps",{},(t,c,u)=>{if(t||u)if("linux"!==process.platform)o(t||new Error(u.toString()));else{const t=JSON.stringify(n.getPathFromAmdModule(e,"vs/base/node/ps.sh"));i.exec(t,{},(e,t,i)=>{e||i?o(e||new Error(i.toString())):(r(t,l),h())})}else{const e=c.toString().trim(),t="-ax -o pid=,ppid=,pcpu=,pmem=,command=";i.exec(`${e} ${t}`,{maxBuffer:1024e3,env:{LC_NUMERIC:"en_US.UTF-8"}},(e,t,i)=>{e||i&&!i.includes("screen size is bogus")?o(e||new Error(i.toString())):(r(t,l),"linux"===process.platform?h():s(a))})}})}})}})),define(t[92],i([0,1,4,35,6,61,2,21]),(function(e,t,i,n,r,s,o,a){"use strict";function c(e,l,u){const h=i.basename(e.path),d=new Map;let f=!1,g=[o.toDisposable(()=>{d.forEach(e=>o.dispose(e)),d.clear()})];try{const p=n.watch(e.path);g.push(o.toDisposable(()=>{p.removeAllListeners(),p.close()}));const m=new Set;e.isDirectory&&a.readdir(e.path).then(e=>e.forEach(e=>m.add(e))),
p.on("error",(t,i)=>{f||u(`Failed to watch ${e.path} for changes using fs.watch() (${t}, ${i})`)}),p.on("change",(n,p)=>{if(f)return;let v="";if(p&&(v=p.toString(),r.isMacintosh&&(v=s.normalizeNFC(v))),!v||"change"!==n&&"rename"!==n)return;const y=e.isDirectory?i.join(e.path,v):e.path;if(e.isDirectory)if("rename"===n){const e=d.get(y);e&&o.dispose(e);const i=setTimeout(async()=>{d.delete(y);const e=await a.exists(y);if(f)return;let t;e?m.has(v)?t="changed":(t="added",m.add(v)):(m.delete(v),t="deleted"),l(t,y)},t.CHANGE_BUFFER_DELAY);d.set(y,o.toDisposable(()=>clearTimeout(i)))}else{let e;m.has(v)?e="changed":(e="added",m.add(v)),l(e,y)}else if("rename"===n||v!==h){const i=setTimeout(async()=>{const t=await a.exists(y);f||(t?(l("changed",y),g=[c(e,l,u)]):l("deleted",y))},t.CHANGE_BUFFER_DELAY);o.dispose(g),g=[o.toDisposable(()=>clearTimeout(i))]}else l("changed",y)})}catch(t){a.exists(e.path).then(i=>{i&&!f&&u(`Failed to watch ${e.path} for changes using fs.watch() (${t.toString()})`)})}
return o.toDisposable(()=>{f=!0,g=o.dispose(g)})}Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0,t.watchFile=function(e,t,i){return c({path:e,isDirectory:!1},t,i)},t.watchFolder=function(e,t,i){return c({path:e,isDirectory:!0},t,i)},t.CHANGE_BUFFER_DELAY=100})),define(t[32],i([0,1,3,2,9,27,20,17,15,18,85,14]),(function(e,t,i,n,r,s,o,a,c,l,u,h){"use strict";var d,f;function g(e){switch(e){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}function p(e){switch(e){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.createChannelSender=t.createChannelReceiver=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0,function(e){e[e.Promise=100]="Promise",
e[e.PromiseCancel=101]="PromiseCancel",e[e.EventListen=102]="EventListen",e[e.EventDispose=103]="EventDispose"}(t.RequestType||(t.RequestType={})),function(e){e[e.Initialize=200]="Initialize",e[e.PromiseSuccess=201]="PromiseSuccess",e[e.PromiseError=202]="PromiseError",e[e.PromiseErrorObj=203]="PromiseErrorObj",e[e.EventFire=204]="EventFire"}(t.ResponseType||(t.ResponseType={})),function(e){e[e.Uninitialized=0]="Uninitialized",e[e.Idle=1]="Idle"}(d||(d={}));class m{constructor(e){this.buffer=e,this.pos=0}read(e){const t=this.buffer.slice(this.pos,this.pos+e);return this.pos+=t.byteLength,t}}class v{constructor(){this.buffers=[]}get buffer(){return a.VSBuffer.concat(this.buffers)}write(e){this.buffers.push(e)}}function y(e){const t=a.VSBuffer.alloc(4);return t.writeUInt32BE(e,0),t}function S(e){return e.read(4).readUInt32BE(0)}function w(e){const t=a.VSBuffer.alloc(1);return t.writeUInt8(e,0),t}!function(e){e[e.Undefined=0]="Undefined",e[e.String=1]="String",e[e.Buffer=2]="Buffer",e[e.VSBuffer=3]="VSBuffer",
e[e.Array=4]="Array",e[e.Object=5]="Object"}(f||(f={}));const E={Undefined:w(f.Undefined),String:w(f.String),Buffer:w(f.Buffer),VSBuffer:w(f.VSBuffer),Array:w(f.Array),Object:w(f.Object)},C="undefined"!=typeof Buffer;function _(e,t){if(void 0===t)e.write(E.Undefined);else if("string"==typeof t){const i=a.VSBuffer.fromString(t);e.write(E.String),e.write(y(i.byteLength)),e.write(i)}else if(C&&Buffer.isBuffer(t)){const i=a.VSBuffer.wrap(t);e.write(E.Buffer),e.write(y(i.byteLength)),e.write(i)}else if(t instanceof a.VSBuffer)e.write(E.VSBuffer),e.write(y(t.byteLength)),e.write(t);else if(Array.isArray(t)){e.write(E.Array),e.write(y(t.length));for(const i of t)_(e,i)}else{const i=a.VSBuffer.fromString(JSON.stringify(t));e.write(E.Object),e.write(y(i.byteLength)),e.write(i)}}function b(e){switch(e.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return e.read(S(e)).toString();case f.Buffer:return e.read(S(e)).buffer;case f.VSBuffer:return e.read(S(e));case f.Array:{const t=S(e),i=[]
;for(let n=0;n<t;n++)i.push(b(e));return i}case f.Object:return JSON.parse(e.read(S(e)).toString())}}class D{constructor(e,t,i=null,n=1e3){this.protocol=e,this.ctx=t,this.logger=i,this.timeoutDelay=n,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(e=>this.onRawMessage(e)),this.sendResponse({type:200})}registerChannel(e,t){this.channels.set(e,t),setTimeout(()=>this.flushPendingRequests(e),0)}sendResponse(e){switch(e.type){case 200:{const t=this.send([e.type]);return void(this.logger&&this.logger.logOutgoing(t,0,1,p(e.type)))}case 201:case 202:case 204:case 203:{const t=this.send([e.type,e.id],e.data);return void(this.logger&&this.logger.logOutgoing(t,e.id,1,p(e.type),e.data))}}}send(e,t){const i=new v;return _(i,e),_(i,t),this.sendBuffer(i.buffer)}sendBuffer(e){try{return this.protocol.send(e),e.byteLength}catch(e){return 0}}onRawMessage(e){const t=new m(e),i=b(t),n=b(t),r=i[0];switch(r){case 100:
return this.logger&&this.logger.logIncoming(e.byteLength,i[1],1,`${g(r)}: ${i[2]}.${i[3]}`,n),this.onPromise({type:r,id:i[1],channelName:i[2],name:i[3],arg:n});case 102:return this.logger&&this.logger.logIncoming(e.byteLength,i[1],1,`${g(r)}: ${i[2]}.${i[3]}`,n),this.onEventListen({type:r,id:i[1],channelName:i[2],name:i[3],arg:n});case 101:case 103:return this.logger&&this.logger.logIncoming(e.byteLength,i[1],1,`${g(r)}`),this.disposeActiveRequest({type:r,id:i[1]})}}onPromise(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const i=new s.CancellationTokenSource;let r;try{r=t.call(this.ctx,e.name,e.arg,i.token)}catch(e){r=Promise.reject(e)}const o=e.id;r.then(t=>{this.sendResponse({id:o,data:t,type:201}),this.activeRequests.delete(e.id)},t=>{t instanceof Error?this.sendResponse({id:o,data:{message:t.message,name:t.name,stack:t.stack?t.stack.split?t.stack.split("\n"):t.stack:void 0},type:202}):this.sendResponse({id:o,data:t,type:203}),this.activeRequests.delete(e.id)})
;const a=n.toDisposable(()=>i.cancel());this.activeRequests.set(e.id,a)}onEventListen(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const i=e.id,n=t.listen(this.ctx,e.name,e.arg)(e=>this.sendResponse({id:i,data:e,type:204}));this.activeRequests.set(e.id,n)}disposeActiveRequest(e){const t=this.activeRequests.get(e.id);t&&(t.dispose(),this.activeRequests.delete(e.id))}collectPendingRequest(e){let t=this.pendingRequests.get(e.channelName);t||(t=[],this.pendingRequests.set(e.channelName,t));const i=setTimeout(()=>{console.error(`Unknown channel: ${e.channelName}`),100===e.type&&this.sendResponse({id:e.id,data:{name:"Unknown channel",message:`Channel name '${e.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);t.push({request:e,timeoutTimer:i})}flushPendingRequests(e){const t=this.pendingRequests.get(e);if(t){for(const e of t)switch(clearTimeout(e.timeoutTimer),e.request.type){case 100:this.onPromise(e.request);break
;case 102:this.onEventListen(e.request)}this.pendingRequests.delete(e)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelServer=D,function(e){e[e.LocalSide=0]="LocalSide",e[e.OtherSide=1]="OtherSide"}(t.RequestInitiator||(t.RequestInitiator={}));class x{constructor(e,t=null){this.protocol=e,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new i.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(e=>this.onBuffer(e)),this.logger=t}getChannel(e){const t=this;return{call:(i,n,r)=>t.requestPromise(e,i,n,r),listen:(i,n)=>t.requestEvent(e,i,n)}}requestPromise(e,t,i,a=s.CancellationToken.None){const c=this.lastRequestId++,l={id:c,type:100,channelName:e,name:t,arg:i};if(a.isCancellationRequested)return Promise.reject(o.canceled());let u;return new Promise((e,t)=>{
if(a.isCancellationRequested)return t(o.canceled());const i=()=>{this.handlers.set(c,i=>{switch(i.type){case 201:this.handlers.delete(c),e(i.data);break;case 202:this.handlers.delete(c);const n=new Error(i.data.message);n.stack=i.data.stack,n.name=i.data.name,t(n);break;case 203:this.handlers.delete(c),t(i.data)}}),this.sendRequest(l)};let s=null;this.state===d.Idle?i():(s=r.createCancelablePromise(e=>this.whenInitialized())).then(()=>{s=null,i()});const h=()=>{s?(s.cancel(),s=null):this.sendRequest({id:c,type:101}),t(o.canceled())},f=a.onCancellationRequested(h);u=n.combinedDisposable(n.toDisposable(h),f),this.activeRequests.add(u)}).finally(()=>{this.activeRequests.delete(u)})}requestEvent(e,t,n){const s=this.lastRequestId++,o={id:s,type:102,channelName:e,name:t,arg:n};let a=null;const c=new i.Emitter({onFirstListenerAdd:()=>{(a=r.createCancelablePromise(e=>this.whenInitialized())).then(()=>{a=null,this.activeRequests.add(c),this.sendRequest(o)})},onLastListenerRemove:()=>{a?(a.cancel(),
a=null):(this.activeRequests.delete(c),this.sendRequest({id:s,type:103}))}});return this.handlers.set(s,e=>c.fire(e.data)),c.event}sendRequest(e){switch(e.type){case 100:case 102:{const t=this.send([e.type,e.id,e.channelName,e.name],e.arg);return void(this.logger&&this.logger.logOutgoing(t,e.id,0,`${g(e.type)}: ${e.channelName}.${e.name}`,e.arg))}case 101:case 103:{const t=this.send([e.type,e.id]);return void(this.logger&&this.logger.logOutgoing(t,e.id,0,g(e.type)))}}}send(e,t){const i=new v;return _(i,e),_(i,t),this.sendBuffer(i.buffer)}sendBuffer(e){try{return this.protocol.send(e),e.byteLength}catch(e){return 0}}onBuffer(e){const t=new m(e),i=b(t),n=b(t),r=i[0];switch(r){case 200:return this.logger&&this.logger.logIncoming(e.byteLength,0,0,p(r)),this.onResponse({type:i[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(e.byteLength,i[1],0,p(r),n),this.onResponse({type:i[0],id:i[1],data:n})}}onResponse(e){if(200===e.type)return this.state=d.Idle,
void this._onDidInitialize.fire();const t=this.handlers.get(e.id);t&&t(e)}whenInitialized(){return this.state===d.Idle?Promise.resolve():i.Event.toPromise(this.onDidInitialize)}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelClient=x;t.IPCServer=class{constructor(e){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new i.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new i.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,e(({protocol:e,onDidClientDisconnect:t})=>{i.Event.once(e.onMessage)(i=>{const n=b(new m(i)),r=new D(e,n),s=new x(e);this.channels.forEach((e,t)=>r.registerChannel(t,e));const o={channelServer:r,channelClient:s,ctx:n};this._connections.add(o),this._onDidAddConnection.fire(o),t(()=>{r.dispose(),s.dispose(),this._connections.delete(o),this._onDidRemoveConnection.fire(o)})})})}
get connections(){const e=[];return this._connections.forEach(t=>e.push(t)),e}getChannel(e,t){const n=this;return{call(r,s,o){let a;if(l.isFunction(t)){let e=c.getRandomElement(n.connections.filter(t));a=e?Promise.resolve(e):i.Event.toPromise(i.Event.filter(n.onDidAddConnection,t))}else a=t.routeCall(n,r,s);return I(a.then(t=>t.channelClient.getChannel(e))).call(r,s,o)},listen(i,r){if(l.isFunction(t))return n.getMulticastEvent(e,t,i,r);return I(t.routeEvent(n,i,r).then(t=>t.channelClient.getChannel(e))).listen(i,r)}}}getMulticastEvent(e,t,r,s){const o=this;let a=new n.DisposableStore;const c=new i.Emitter({onFirstListenerAdd:()=>{a=new n.DisposableStore;const l=new i.EventMultiplexer,u=new Map,h=t=>{const i=t.channelClient.getChannel(e).listen(r,s),n=l.add(i);u.set(t,n)};o.connections.filter(t).forEach(h),i.Event.filter(o.onDidAddConnection,t)(h,void 0,a),o.onDidRemoveConnection(e=>{const t=u.get(e);t&&(t.dispose(),u.delete(e))},void 0,a),l.event(c.fire,c,a),a.add(l)},onLastListenerRemove:()=>{a.dispose()}})
;return c.event}registerChannel(e,t){this.channels.set(e,t),this._connections.forEach(i=>{i.channelServer.registerChannel(e,t)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}};function I(e){return{call:(t,i,n)=>e.then(e=>e.call(t,i,n)),listen(t,n){const r=new i.Relay;return e.then(e=>r.input=e.listen(t,n)),r.event}}}t.IPCClient=class{constructor(e,t,i=null){const n=new v;_(n,t),e.send(n.buffer),this.channelClient=new x(e,i),this.channelServer=new D(e,t,i)}getChannel(e){return this.channelClient.getChannel(e)}registerChannel(e,t){this.channelServer.registerChannel(e,t)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}},t.getDelayedChannel=I,t.getNextTickChannel=function(e){let t=!1;return{call:(i,n,s)=>t?e.call(i,n,s):r.timeout(0).then(()=>t=!0).then(()=>e.call(i,n,s)),listen(n,s){if(t)return e.listen(n,s);const o=new i.Relay;return r.timeout(0).then(()=>t=!0).then(()=>o.input=e.listen(n,s)),o.event}}}
;function P(e){return"o"===e[0]&&"n"===e[1]&&h.isUpperAsciiLetter(e.charCodeAt(2))}t.StaticRouter=class{constructor(e){this.fn=e}routeCall(e){return this.route(e)}routeEvent(e){return this.route(e)}async route(e){for(const t of e.connections)if(await Promise.resolve(this.fn(t.ctx)))return Promise.resolve(t);return await i.Event.toPromise(e.onDidAddConnection),await this.route(e)}},t.createChannelReceiver=function(e,t){const n=e,r=t&&t.disableMarshalling,s=new Map;for(const e in n)P(e)&&s.set(e,i.Event.buffer(n[e],!0));return new class{listen(e,t){const i=s.get(t);if(i)return i;throw new Error(`Event not found: ${t}`)}call(e,t,i){const s=n[t];if("function"==typeof s){if(!r&&Array.isArray(i))for(let e=0;e<i.length;e++)i[e]=u.revive(i[e]);return s.apply(n,i)}throw new Error(`Method not found: ${t}`)}}},t.createChannelSender=function(e,t){const i=t&&t.disableMarshalling;return new Proxy({},{get(n,r){var s
;if("string"==typeof r)return(null===(s=null==t?void 0:t.properties)||void 0===s?void 0:s.has(r))?t.properties.get(r):P(r)?e.listen(r):async function(...n){let s;s=t&&!l.isUndefinedOrNull(t.context)?[t.context,...n]:n;const o=await e.call(r,s);return i?o:u.revive(o)};throw new Error(`Property not found: ${String(r)}`)}})};const R=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function k(e){if(Array.isArray(e))return e;if(e&&"object"==typeof e&&"function"==typeof e.toString){let t=e.toString();if("[object Object]"!==t)return t}return e}function L(e,t,i,n,r,s,o){o=function(e){return Array.isArray(e)?e.map(k):k(e)}(o);const a=R[r],c=a[n%a.length];let l=[`%c[${e}]%c[${h.pad(t,7," ")}]%c[len: ${h.pad(i,5," ")}]%c${h.pad(n,5," ")} - ${s}`,"color: darkgreen","color: grey","color: grey",`color: ${c}`];/\($/.test(s)?(l=l.concat(o)).push(")"):l.push(o),console.log.apply(console,l)}t.logWithColors=L;t.IPCLogger=class{constructor(e,t){this._outgoingPrefix=e,
this._incomingPrefix=t,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(e,t,i,n,r){this._totalOutgoing+=e,L(this._outgoingPrefix,this._totalOutgoing,e,t,i,n,r)}logIncoming(e,t,i,n,r){this._totalIncoming+=e,L(this._incomingPrefix,this._totalIncoming,e,t,i,n,r)}}})),define(t[93],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;t.Protocol=class{constructor(e,t){this.sender=e,this.onMessage=t}send(e){try{this.sender.send("vscode:message",e.buffer)}catch(e){}}dispose(){this.sender.send("vscode:disconnect",null)}}})),define(t[94],i([0,1,3,32,2,17,6,47]),(function(e,t,i,n,r,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PersistentProtocol=t.BufferedEmitter=t.Client=t.Protocol=t.ProtocolConstants=t.ChunkStream=void 0;let c=null;function l(){return c||(c=s.VSBuffer.alloc(0)),c}class u{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(e){this._chunks.push(e),
this._totalLength+=e.byteLength}read(e){return this._read(e,!0)}peek(e){return this._read(e,!1)}_read(e,t){if(0===e)return l();if(e>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===e){const i=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=e),i}if(this._chunks[0].byteLength>e){const i=this._chunks[0].slice(0,e);return t&&(this._chunks[0]=this._chunks[0].slice(e),this._totalLength-=e),i}let i=s.VSBuffer.alloc(e),n=0,r=0;for(;e>0;){const s=this._chunks[r];if(s.byteLength>e){const o=s.slice(0,e);i.set(o,n),n+=e,t&&(this._chunks[r]=s.slice(e),this._totalLength-=e),e-=e}else i.set(s,n),n+=s.byteLength,t?(this._chunks.shift(),this._totalLength-=s.byteLength):r++,e-=s.byteLength}return i}}var h;t.ChunkStream=u,function(e){e[e.None=0]="None",e[e.Regular=1]="Regular",e[e.Control=2]="Control",e[e.Ack=3]="Ack",e[e.KeepAlive=4]="KeepAlive",e[e.Disconnect=5]="Disconnect"}(h||(h={})),function(e){e[e.HeaderLength=13]="HeaderLength",
e[e.AcknowledgeTime=2e3]="AcknowledgeTime",e[e.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",e[e.KeepAliveTime=5e3]="KeepAliveTime",e[e.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",e[e.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",e[e.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"}(t.ProtocolConstants||(t.ProtocolConstants={}));class d{constructor(e,t,i,n){this.type=e,this.id=t,this.ack=i,this.data=n,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends r.Disposable{constructor(e){super(),this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=e,this._isDisposed=!1,this._incomingData=new u,this._register(this._socket.onData(e=>this.acceptChunk(e))),this.lastReadTime=Date.now()}acceptChunk(e){if(e&&0!==e.byteLength)for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;){
const e=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=e.readUInt32BE(9),this._state.messageType=e.readUInt8(0),this._state.id=e.readUInt32BE(1),this._state.ack=e.readUInt32BE(5);else{const t=this._state.messageType,i=this._state.id,n=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(t,i,n,e)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(e){this._isDisposed=!1,this._socket=e,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){this.flush(),this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(e){if(this._isDisposed)return;e.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=s.VSBuffer.alloc(13);t.writeUInt8(e.type,0),t.writeUInt32BE(e.id,1),
t.writeUInt32BE(e.ack,5),t.writeUInt32BE(e.data.byteLength,9),this._writeSoon(t,e.data)}_bufferAdd(e,t){const i=0===this._totalLength;return this._data.push(e,t),this._totalLength+=e.byteLength+t.byteLength,i}_bufferTake(){const e=s.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,e}_writeSoon(e,t){this._bufferAdd(e,t)&&o.setImmediate(()=>{this._writeNow()})}_writeNow(){0!==this._totalLength&&this._socket.write(this._bufferTake())}}class p extends r.Disposable{constructor(e){super(),this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onClose=new i.Emitter,this.onClose=this._onClose.event,this._socket=e,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(e=>{1===e.type&&this._onMessage.fire(e.data)})),this._register(this._socket.onClose(()=>this._onClose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}
sendDisconnect(){}send(e){this._socketWriter.write(new d(1,0,0,e))}}t.Protocol=p;class m extends n.IPCClient{constructor(e,t,i=null){super(e,t,i),this.protocol=e}static fromSocket(e,t){return new m(new p(e),t)}get onClose(){return this.protocol.onClose}dispose(){super.dispose();const e=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),e.end()}}t.Client=m;class v{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,a.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(e){
this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(e):this._emitter.fire(e):this._bufferedMessages.push(e)}flushBuffer(){this._bufferedMessages=[]}}t.BufferedEmitter=v;class y{constructor(e){this.data=e,this.next=null}}class S{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let e=[],t=0,i=this._first;for(;i;)e[t++]=i.data,i=i.next;return e}pop(){if(this._first)return this._first===this._last?(this._first=null,void(this._last=null)):void(this._first=this._first.next)}push(e){const t=new y(e);if(!this._first)return this._first=t,void(this._last=t);this._last.next=t,this._last=t}}class w{constructor(){this.lastRuns=[];const e=Date.now();for(let t=0;t<w._HISTORY_LENGTH;t++)this.lastRuns[t]=e-1e3*t;setInterval(()=>{for(let e=w._HISTORY_LENGTH;e>=1;e--)this.lastRuns[e]=this.lastRuns[e-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return w._INSTANCE||(w._INSTANCE=new w),w._INSTANCE}load(){
const e=Date.now(),t=1e3*(1+w._HISTORY_LENGTH);let i=0;for(let n=0;n<w._HISTORY_LENGTH;n++)e-this.lastRuns[n]<=t&&i++;return 1-i/w._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}w._HISTORY_LENGTH=10,w._INSTANCE=null;t.PersistentProtocol=class{constructor(e,t=null){this._loadEstimator=w.getInstance(),this._onControlMessage=new v,this.onControlMessage=this._onControlMessage.event,this._onMessage=new v,this.onMessage=this._onMessage.event,this._onClose=new v,this.onClose=this._onClose.event,this._onSocketClose=new v,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new v,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new S,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._socketDisposables=[],this._socket=e,
this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),t&&this._socketReader.acceptChunk(t),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=r.dispose(this._socketDisposables)}drain(){
return this._socketWriter.drain()}sendDisconnect(){const e=new d(5,0,0,l());this._socketWriter.write(e),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const e=Date.now()-this._socketWriter.lastWriteTime;if(e>=5e3){const e=new d(4,0,0,l());return this._socketWriter.write(e),void this._sendKeepAliveCheck()}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-e+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const e=Date.now()-this._socketReader.lastReadTime;e>=2e4&&!this._loadEstimator.hasHighLoad()?this._onSocketTimeout.fire(void 0):this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-e,0)+5)}getSocket(){return this._socket}beginAcceptReconnection(e,t){this._isReconnecting=!0,this._socketDisposables=r.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),
this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._socket=e,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1;const e=this._outgoingUnackMsg.toArray();for(let t=0,i=e.length;t<i;t++)this._socketWriter.write(e[t]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onClose.fire()}_receiveMessage(e){if(e.ack>this._outgoingAckId)for(this._outgoingAckId=e.ack;;){const t=this._outgoingUnackMsg.peek();if(!(t&&t.id<=e.ack))break;this._outgoingUnackMsg.pop()}
1===e.type?e.id>this._incomingMsgId&&(e.id!==this._incomingMsgId+1&&console.error(`PROTOCOL CORRUPTION, LAST SAW MSG ${this._incomingMsgId} AND HAVE NOW RECEIVED MSG ${e.id}`),this._incomingMsgId=e.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(e.data)):2===e.type?this._onControlMessage.fire(e.data):5===e.type&&this._onClose.fire()}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(e){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const i=new d(1,t,this._incomingAckId,e);this._outgoingUnackMsg.push(i),this._isReconnecting||(this._socketWriter.write(i),this._recvAckCheck())}sendControl(e){const t=new d(2,0,0,e);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId)return;if(this._incomingAckTimeout)return;const e=Date.now()-this._incomingMsgLastTime;e>=2e3?this._sendAck():this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()
},2e3-e+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId)return;if(this._outgoingAckTimeout)return;const e=this._outgoingUnackMsg.peek(),t=Date.now()-e.writtenTime;t>=2e4&&!this._loadEstimator.hasHighLoad()?this._onSocketTimeout.fire(void 0):this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-t,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const e=new d(3,0,this._incomingAckId,l());this._socketWriter.write(e)}}})),define(t[95],i([0,1,196,3,32,4,40,29,2,17,94,20]),(function(e,t,i,n,r,s,o,a,c,l,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.connect=t.serve=t.Server=t.generateRandomPipeName=t.WebSocketNodeSocket=t.NodeSocket=void 0;class d{constructor(e){this.socket=e}dispose(){this.socket.destroy()}onData(e){const t=t=>e(l.VSBuffer.wrap(t));return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(e){return this.socket.on("close",e),{
dispose:()=>this.socket.off("close",e)}}onEnd(e){return this.socket.on("end",e),{dispose:()=>this.socket.off("end",e)}}write(e){if(!this.socket.destroyed)try{this.socket.write(e.buffer)}catch(e){if("EPIPE"===e.code)return;h.onUnexpectedError(e)}}end(){this.socket.end()}drain(){return new Promise((e,t)=>{if(0===this.socket.bufferSize)return void e();const i=()=>{this.socket.off("close",i),this.socket.off("end",i),this.socket.off("error",i),this.socket.off("timeout",i),this.socket.off("drain",i),e()};this.socket.on("close",i),this.socket.on("end",i),this.socket.on("error",i),this.socket.on("timeout",i),this.socket.on("drain",i)})}}var f,g;t.NodeSocket=d,function(e){e[e.MinHeaderByteSize=2]="MinHeaderByteSize"}(f||(f={})),function(e){e[e.PeekHeader=1]="PeekHeader",e[e.ReadHeader=2]="ReadHeader",e[e.ReadBody=3]="ReadBody",e[e.Fin=4]="Fin"}(g||(g={}));class p extends c.Disposable{constructor(e){super(),this._onData=this._register(new n.Emitter),this._state={state:1,readLen:2,mask:0},this.socket=e,
this._incomingData=new u.ChunkStream,this._register(this.socket.onData(e=>this._acceptChunk(e)))}dispose(){this.socket.dispose()}onData(e){return this._onData.event(e)}onClose(e){return this.socket.onClose(e)}onEnd(e){return this.socket.onEnd(e)}write(e){let t=2;e.byteLength<126?t+=0:e.byteLength<65536?t+=2:t+=8;const i=l.VSBuffer.alloc(t);if(i.writeUInt8(130,0),e.byteLength<126)i.writeUInt8(e.byteLength,1);else if(e.byteLength<65536){i.writeUInt8(126,1);let t=1;i.writeUInt8(e.byteLength>>>8&255,++t),i.writeUInt8(e.byteLength>>>0&255,++t)}else{i.writeUInt8(127,1);let t=1;i.writeUInt8(0,++t),i.writeUInt8(0,++t),i.writeUInt8(0,++t),i.writeUInt8(0,++t),i.writeUInt8(e.byteLength>>>24&255,++t),i.writeUInt8(e.byteLength>>>16&255,++t),i.writeUInt8(e.byteLength>>>8&255,++t),i.writeUInt8(e.byteLength>>>0&255,++t)}this.socket.write(l.VSBuffer.concat([i,e]))}end(){this.socket.end()}_acceptChunk(e){
if(0!==e.byteLength)for(this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;)if(1===this._state.state){const e=this._incomingData.peek(this._state.readLen).readUInt8(1),t=(128&e)>>>7,i=127&e;this._state.state=2,this._state.readLen=2+(t?4:0)+(126===i?2:0)+(127===i?8:0),this._state.mask=0}else if(2===this._state.state){const e=this._incomingData.read(this._state.readLen),t=e.readUInt8(1),i=(128&t)>>>7;let n=127&t,r=1;126===n?n=256*e.readUInt8(++r)+e.readUInt8(++r):127===n&&(n=0*e.readUInt8(++r)+0*e.readUInt8(++r)+0*e.readUInt8(++r)+0*e.readUInt8(++r)+e.readUInt8(++r)*2**24+65536*e.readUInt8(++r)+256*e.readUInt8(++r)+e.readUInt8(++r));let s=0;i&&(s=e.readUInt8(++r)*2**24+65536*e.readUInt8(++r)+256*e.readUInt8(++r)+e.readUInt8(++r)),this._state.state=3,this._state.readLen=n,this._state.mask=s}else if(3===this._state.state){const e=this._incomingData.read(this._state.readLen);m(e,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._onData.fire(e)}}
drain(){return this.socket.drain()}}function m(e,t){if(0===t)return;let i=e.byteLength>>>2;for(let n=0;n<i;n++){const i=e.readUInt32BE(4*n);e.writeUInt32BE(i^t,4*n)}let n=4*i,r=e.byteLength-n;const s=t>>>24&255,o=t>>>16&255,a=t>>>8&255;r>=1&&e.writeUInt8(e.readUInt8(n)^s,n),r>=2&&e.writeUInt8(e.readUInt8(n+1)^o,n+1),r>=3&&e.writeUInt8(e.readUInt8(n+2)^a,n+2)}t.WebSocketNodeSocket=p,t.generateRandomPipeName=function(){const e=a.generateUuid();return"win32"===process.platform?`\\\\.\\pipe\\vscode-ipc-${e}-sock`:s.join(o.tmpdir(),`vscode-ipc-${e}.sock`)};class v extends r.IPCServer{constructor(e){super(v.toClientConnectionEvent(e)),this.server=e}static toClientConnectionEvent(e){const t=n.Event.fromNodeEventEmitter(e,"connection");return n.Event.map(t,e=>({protocol:new u.Protocol(new d(e)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(e,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}t.Server=v,t.serve=function(e){return new Promise((t,n)=>{
const r=i.createServer();r.on("error",n),r.listen(e,()=>{r.removeListener("error",n),t(new v(r))})})},t.connect=function(e,t){return new Promise((n,r)=>{const s=i.createConnection(e,()=>{s.removeListener("error",r),n(u.Client.fromSocket(new d(s),t))});s.once("error",r)})}})),define(t[96],i([0,1,20,19,17]),(function(e,t,i,n,r){"use strict";function s(e){const t=Object.create(null);for(const i of e.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(i){const e=i.indexOf(":");t[i.substr(0,e).trim().toLowerCase()]=i.substr(e+1).trim()}return t}Object.defineProperty(t,"__esModule",{value:!0}),t.request=void 0,t.request=function(e,t){e.proxyAuthorization&&(e.headers=n.assign(e.headers||{},{"Proxy-Authorization":e.proxyAuthorization}));const o=new XMLHttpRequest;return new Promise((n,a)=>{o.open(e.type||"GET",e.url||"",!0,e.user,e.password),function(e,t){if(t.headers)e:for(let i in t.headers){switch(i){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}e.setRequestHeader(i,t.headers[i])}}(o,e),
o.responseType="arraybuffer",o.onerror=e=>a(new Error(o.statusText&&"XHR failed: "+o.statusText||"XHR failed")),o.onload=e=>{n({res:{statusCode:o.status,headers:s(o)},stream:r.bufferToStream(r.VSBuffer.wrap(new Uint8Array(o.response)))})},o.ontimeout=t=>a(new Error(`XHR timeout: ${e.timeout}ms`)),e.timeout&&(o.timeout=e.timeout),o.send(e.data),t.onCancellationRequested(()=>{o.abort(),a(i.canceled())})})}})),define(t[64],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.crashReporter=t.webFrame=t.ipcRenderer=void 0,t.ipcRenderer=window.vscode.ipcRenderer,t.webFrame=window.vscode.webFrame,t.crashReporter=window.vscode.crashReporter,t.process=window.vscode.process,t.context=window.vscode.context})),define(t[97],i([0,1,3,32,93,17,64]),(function(e,t,i,n,r,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class a extends n.IPCClient{constructor(e){const t=a.createProtocol();super(t,e),this.protocol=t}static createProtocol(){
const e=i.Event.fromNodeEventEmitter(o.ipcRenderer,"vscode:message",(e,t)=>s.VSBuffer.wrap(t));return o.ipcRenderer.send("vscode:hello"),new r.Protocol(o.ipcRenderer,e)}dispose(){this.protocol.dispose()}}t.Client=a})),define(t[98],i([0,1,2,3,9,18]),(function(e,t,i,n,r,s){"use strict";var o,a;Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0,function(e){e[e.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"}(o=t.StorageHint||(t.StorageHint={})),function(e){e[e.None=0]="None",e[e.Initialized=1]="Initialized",e[e.Closed=2]="Closed"}(a||(a={}));class c extends i.Disposable{constructor(e,t=Object.create(null)){super(),this.database=e,this.options=t,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new r.ThrottledDelayer(c.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.registerListeners()}
registerListeners(){this._register(this.database.onDidChangeItemsExternal(e=>this.onDidChangeItemsExternal(e)))}onDidChangeItemsExternal(e){var t,i;null===(t=e.changed)||void 0===t||t.forEach((e,t)=>this.accept(t,e)),null===(i=e.deleted)||void 0===i||i.forEach(e=>this.accept(e,void 0))}accept(e,t){if(this.state===a.Closed)return;let i=!1;if(s.isUndefinedOrNull(t))i=this.cache.delete(e);else{this.cache.get(e)!==t&&(this.cache.set(e,t),i=!0)}i&&this._onDidChangeStorage.fire(e)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==o.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(e,t){const i=this.cache.get(e);return s.isUndefinedOrNull(i)?t:i}getBoolean(e,t){const i=this.get(e);return s.isUndefinedOrNull(i)?t:"true"===i}getNumber(e,t){const i=this.get(e);return s.isUndefinedOrNull(i)?t:parseInt(i,10)}set(e,t){if(this.state===a.Closed)return Promise.resolve()
;if(s.isUndefinedOrNull(t))return this.delete(e);const i=String(t);return this.cache.get(e)===i?Promise.resolve():(this.cache.set(e,i),this.pendingInserts.set(e,i),this.pendingDeletes.delete(e),this._onDidChangeStorage.fire(e),this.flushDelayer.trigger(()=>this.flushPending()))}delete(e){if(this.state===a.Closed)return Promise.resolve();return this.cache.delete(e)?(this.pendingDeletes.has(e)||this.pendingDeletes.add(e),this.pendingInserts.delete(e),this._onDidChangeStorage.fire(e),this.flushDelayer.trigger(()=>this.flushPending())):Promise.resolve()}async close(){if(this.state===a.Closed)return Promise.resolve();this.state=a.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(e){}await this.database.close(()=>this.cache)}flushPending(){if(0===this.pendingInserts.size&&0===this.pendingDeletes.size)return Promise.resolve();const e={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(e)}}
t.Storage=c,c.DEFAULT_FLUSH_DELAY=100;t.InMemoryStorageDatabase=class{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(e){e.insert&&e.insert.forEach((e,t)=>this.items.set(t,e)),e.delete&&e.delete.forEach(e=>this.items.delete(e))}async close(){}}})),define(t[99],i([0,1,3,9,34,4,21]),(function(e,t,i,n,r,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SQLiteStorageDatabase=void 0;class a{constructor(e,t=Object.create(null)){this.path=e,this.options=t,this.name=s.basename(this.path),this.logger=new c(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return i.Event.None}async getItems(){const e=await this.whenConnected,t=new Map;return(await this.all(e,"SELECT * FROM ItemTable")).forEach(e=>t.set(e.key,e.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${t.size} rows`),t}async updateItems(e){const t=await this.whenConnected
;return this.doUpdateItems(t,e)}doUpdateItems(e,t){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${t.insert?r.mapToString(t.insert):"0"}), delete(${t.delete?r.setToString(t.delete):"0"})`),this.transaction(e,()=>{const i=t.insert,n=t.delete;if(i&&i.size>0){const t=[];t.push([]);let n=0;i.forEach((e,i)=>{let r=t[n];r.length>a.MAX_HOST_PARAMETERS&&(n++,r=[],t.push(r)),r.push(i,e)}),t.forEach(t=>{this.prepare(e,`INSERT INTO ItemTable VALUES ${new Array(t.length/2).fill("(?,?)").join(",")}`,e=>e.run(t),()=>{const e=[];let t=0;return i.forEach((i,n)=>{e.push(n),t+=i.length}),`Keys: ${e.join(", ")} Length: ${t}`})})}if(n&&n.size){const t=[];t.push([]);let i=0;n.forEach(e=>{let n=t[i];n.length>a.MAX_HOST_PARAMETERS&&(i++,n=[],t.push(n)),n.push(e)}),t.forEach(t=>{this.prepare(e,`DELETE FROM ItemTable WHERE key IN (${new Array(t.length).fill("?").join(",")})`,e=>e.run(t),()=>{const e=[];return n.forEach(t=>{e.push(t)}),`Keys: ${e.join(", ")}`})})}})}async close(e){
this.logger.trace(`[storage ${this.name}] close()`);const t=await this.whenConnected;return this.doClose(t,e)}doClose(e,t){return new Promise((i,n)=>{e.db.close(r=>(r&&this.handleSQLiteError(e,`[storage ${this.name}] close(): ${r}`),this.path===a.IN_MEMORY_PATH?i():e.isErroneous||e.isInMemory?"function"==typeof t?o.unlink(this.path).then(()=>this.doConnect(this.path).then(e=>{const i=()=>this.doClose(e,void 0);return this.doUpdateItems(e,{insert:t()}).then(()=>i(),e=>(i(),Promise.reject(e)))})).then(i,n):n(r||new Error("Database has errors or is in-memory without recovery option")):this.backup().then(i,e=>(this.logger.error(`[storage ${this.name}] backup(): ${e}`),i()))))})}backup(){const e=this.toBackupPath(this.path);return o.copy(this.path,e)}toBackupPath(e){return`${e}.backup`}async checkIntegrity(e){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${e})`);const t=await this.whenConnected,i=await this.get(t,e?"PRAGMA integrity_check":"PRAGMA quick_check"),n=e?i.integrity_check:i.quick_check
;return t.isErroneous?`${n} (last error: ${t.lastError})`:t.isInMemory?`${n} (in-memory!)`:n}async connect(e,t=!0){this.logger.trace(`[storage ${this.name}] open(${e}, retryOnBusy: ${t})`);try{return await this.doConnect(e)}catch(i){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${i}`),"SQLITE_BUSY"===i.code&&t)return await n.timeout(a.BUSY_OPEN_TIMEOUT),this.connect(e,!1);try{return await o.unlink(e),await o.renameIgnoreError(this.toBackupPath(e),e),await this.doConnect(e)}catch(e){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${e}`),this.doConnect(a.IN_MEMORY_PATH)}}}handleSQLiteError(e,t){e.isErroneous=!0,e.lastError=t,this.logger.error(t)}doConnect(t){return new Promise((i,n)=>{new Promise((t,i)=>{e(["vscode-sqlite3"],t,i)}).then(e=>{const r={
db:new(this.logger.isTracing?e.verbose().Database:e.Database)(t,e=>e?r.db?r.db.close(()=>n(e)):n(e):this.exec(r,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>i(r),e=>r.db.close(()=>n(e)))),isInMemory:t===a.IN_MEMORY_PATH};r.db.on("error",e=>this.handleSQLiteError(r,`[storage ${this.name}] Error (event): ${e}`)),this.logger.isTracing&&r.db.on("trace",e=>this.logger.trace(`[storage ${this.name}] Trace (event): ${e}`))},n)})}exec(e,t){return new Promise((i,n)=>{e.db.exec(t,t=>t?(this.handleSQLiteError(e,`[storage ${this.name}] exec(): ${t}`),n(t)):i())})}get(e,t){return new Promise((i,n)=>{e.db.get(t,(t,r)=>t?(this.handleSQLiteError(e,`[storage ${this.name}] get(): ${t}`),n(t)):i(r))})}all(e,t){return new Promise((i,n)=>{e.db.all(t,(t,r)=>t?(this.handleSQLiteError(e,`[storage ${this.name}] all(): ${t}`),n(t)):i(r))})}transaction(e,t){return new Promise((i,n)=>{e.db.serialize(()=>{e.db.run("BEGIN TRANSACTION"),t(),
e.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(e,`[storage ${this.name}] transaction(): ${t}`),n(t)):i())})})}prepare(e,t,i,n){const r=e.db.prepare(t),s=i=>{this.handleSQLiteError(e,`[storage ${this.name}] prepare(): ${i} (${t}). Details: ${n()}`)};r.on("error",s),i(r),r.finalize(e=>{e&&s(e),r.removeListener("error",s)})}}t.SQLiteStorageDatabase=a,a.IN_MEMORY_PATH=":memory:",a.BUSY_OPEN_TIMEOUT=2e3,a.MAX_HOST_PARAMETERS=256;class c{constructor(e){e&&"function"==typeof e.logTrace&&(this.logTrace=e.logTrace),e&&"function"==typeof e.logError&&(this.logError=e.logError)}get isTracing(){return!!this.logTrace}trace(e){this.logTrace&&this.logTrace(e)}error(e){this.logError&&this.logError(e)}}})),define(t[100],i([11,12]),(function(e,t){return e.create("vs/base/common/date",t)})),define(t[53],i([0,1,14,100]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const r=60,s=60*r,o=24*s,a=7*o,c=30*o,l=365*o;t.fromNow=function e(t,i){
"number"!=typeof t&&(t=t.getTime());const u=Math.round(((new Date).getTime()-t)/1e3);if(u<-30)return n.localize(0,null,e((new Date).getTime()+1e3*u,!1));if(u<30)return n.localize(1,null);let h;return u<r?(h=u,i?1===h?n.localize(2,null,h):n.localize(3,null,h):1===h?n.localize(4,null,h):n.localize(5,null,h)):u<s?(h=Math.floor(u/r),i?1===h?n.localize(6,null,h):n.localize(7,null,h):1===h?n.localize(8,null,h):n.localize(9,null,h)):u<o?(h=Math.floor(u/s),i?1===h?n.localize(10,null,h):n.localize(11,null,h):1===h?n.localize(12,null,h):n.localize(13,null,h)):u<a?(h=Math.floor(u/o),i?1===h?n.localize(14,null,h):n.localize(15,null,h):1===h?n.localize(16,null,h):n.localize(17,null,h)):u<c?(h=Math.floor(u/a),i?1===h?n.localize(18,null,h):n.localize(19,null,h):1===h?n.localize(20,null,h):n.localize(21,null,h)):u<l?(h=Math.floor(u/c),i?1===h?n.localize(22,null,h):n.localize(23,null,h):1===h?n.localize(24,null,h):n.localize(25,null,h)):(h=Math.floor(u/l),
i?1===h?n.localize(26,null,h):n.localize(27,null,h):1===h?n.localize(28,null,h):n.localize(29,null,h))},t.toLocalISOString=function(e){return e.getFullYear()+"-"+i.pad(e.getMonth()+1,2)+"-"+i.pad(e.getDate(),2)+"T"+i.pad(e.getHours(),2)+":"+i.pad(e.getMinutes(),2)+":"+i.pad(e.getSeconds(),2)+"."+(e.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}})),define(t[101],i([11,12]),(function(e,t){return e.create("vs/base/common/errorMessage",t)})),define(t[48],i([0,1,101,18,15]),(function(e,t,i,n,r){"use strict";function s(e,t){return t&&(e.stack||e.stacktrace)?i.localize(0,null,a(e),o(e.stack)||o(e.stacktrace)):a(e)}function o(e){return Array.isArray(e)?e.join("\n"):e}function a(e){return"string"==typeof e.code&&"number"==typeof e.errno&&"string"==typeof e.syscall?i.localize(1,null,e.message):e.message||i.localize(2,null)}Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0,t.toErrorMessage=function e(t=null,o=!1){if(!t)return i.localize(3,null);if(Array.isArray(t)){
const n=r.coalesce(t),s=e(n[0],o);return n.length>1?i.localize(4,null,s,n.length):s}if(n.isString(t))return t;if(t.detail){const e=t.detail;if(e.error)return s(e.error,o);if(e.exception)return s(e.exception,o)}return t.stack?s(t,o):t.message?t.message:i.localize(5,null)}})),define(t[102],i([11,12]),(function(e,t){return e.create("vs/base/node/processes",t)})),define(t[103],i([0,1,4,35,52,44,102,18,19,39,6,63,31]),(function(e,t,i,n,r,s,o,a,c,l,u,h,d){"use strict";function f(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(){return process.env.comspec||"cmd.exe"}Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,t.getWindowsShell=g;class p{constructor(e,t,i,n){if(void 0!==t&&void 0!==i&&void 0!==n)this.cmd=e,this.args=t,this.shell=i,this.options=n;else{const t=e;this.cmd=t.command,this.shell=t.isShellCommand,this.args=t.args.slice(0),
this.options=t.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const e=Object.create(null);Object.keys(process.env).forEach(t=>{e[t]=process.env[t]}),Object.keys(this.options.env).forEach(t=>{e[t]=this.options.env[t]}),this.options.env=e}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const t=e.lastIndexOf(i.sep);return-1!==t&&(e=e.substring(t+1)),p.WellKnowCommands[e]?e:"other"}start(e){return u.isWindows&&(this.options&&this.options.cwd&&l.isUNC(this.options.cwd)||!this.options&&l.isUNC(process.cwd()))?Promise.reject(new Error(o.localize(0,null))):this.useExec().then(t=>{let i,n;const r=new Promise((e,t)=>{i=e,n=t});if(t){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=s.exec(t,this.options,(t,r,s)=>{this.childProcess=null;t&&t.killed?n({killed:this.terminateRequested,stdout:r.toString(),stderr:s.toString()}):this.handleExec(i,e,t,r,s)})}else{let t=null;const r=t=>{this.childProcess=null,
this.childProcessPromise=null,this.handleClose(t,i,e,n);const r={terminated:this.terminateRequested};a.isNumber(t)&&(r.cmdCode=t),i(r)};if(this.shell&&u.isWindows){const e=c.deepClone(this.options);e.windowsVerbatimArguments=!0,e.detached=!1;let i=!1,n=!1;const r=[];let o=this.ensureQuotes(this.cmd);r.push(o.value),i=o.quoted,this.args&&this.args.forEach(e=>{o=this.ensureQuotes(e),r.push(o.value),n=n&&o.quoted});const a=["/s","/c"];i?n?a.push('"'+r.join(" ")+'"'):r.length>1?a.push('"'+r[0]+'" '+r.slice(1).join(" ")):a.push('"'+r[0]+'"'):a.push(r.join(" ")),t=s.spawn(g(),a,e)}else this.cmd&&(t=s.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(a.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",e=>{this.childProcess=null,n({terminated:this.terminateRequested,error:e})}),t.pid&&(this.childProcess.on("close",r),this.handleSpawn(t,i,e,n,!0)))}return r})}handleClose(e,t,i,n){}ensureQuotes(e){
return p.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&'"'===e[0]&&'"'===e[e.length-1]}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,function(t,i){if(u.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};i&&(e.cwd=i);const n=s.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise((e,t)=>{n.once("error",t=>{e({success:!1,error:t})}),n.once("exit",(t,i)=>{e(0===t?{success:!0}:{success:!1,code:null!==t?t:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?f(e.status):1})}else if(u.isLinux||u.isMacintosh)try{const i=d.getPathFromAmdModule(e,"vs/base/node/terminateProcess.sh");return new Promise((e,n)=>{s.execFile(i,[t.pid.toString()],{encoding:"utf8",shell:!0},(t,i,n)=>{e(t?{success:!1,error:t}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,
error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}(t,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise((e,t)=>{if(!this.shell||!u.isWindows)return e(!1);const i=s.spawn(g(),["/s","/c"]);i.on("error",t=>e(!0)),i.on("exit",t=>e(!1))})}}t.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;t.LineProcess=class extends p{constructor(e,t,i,n){super(e,t,i,n),this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,t,i,n,r){[n,r].forEach((e,i)=>{const n=new h.LineDecoder;n.write(e).forEach(e=>{t({line:e,source:0===i?0:1})});const r=n.end();r&&t({line:r,source:0===i?0:1})}),e({terminated:this.terminateRequested,error:i})}handleSpawn(e,t,i,n,r){const s=new h.LineDecoder,o=new h.LineDecoder;e.stdout.on("data",e=>{
s.write(e).forEach(e=>i({line:e,source:0}))}),e.stderr.on("data",e=>{o.write(e).forEach(e=>i({line:e,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=o}handleClose(e,t,i,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&i({line:r,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&i({line:s,source:1})}},t.createQueuedSender=function(e){let t=[],i=!1;const n=function(r){if(i)return void t.push(r);e.send(r,e=>{if(e&&console.error(e),i=!1,t.length>0){const e=t.slice(0);t=[],e.forEach(e=>n(e))}})&&!u.isWindows||(i=!0)};return{send:n}},function(e){e.findExecutable=async function(e,t,s){if(i.isAbsolute(e))return e;if(void 0===t&&(t=process.cwd()),"."!==i.dirname(e))return i.join(t,e);if(void 0===s&&a.isString(process.env.PATH)&&(s=process.env.PATH.split(i.delimiter)),void 0===s||0===s.length)return i.join(t,e);async function o(e){return!!await r.promisify(n.exists)(e)&&!(await r.promisify(n.stat)(e)).isDirectory()}for(let n of s){let r
;if(r=i.isAbsolute(n)?i.join(n,e):i.join(t,n,e),await o(r))return r;let s=r+".com";if(await o(s))return s;if(s=r+".exe",await o(s))return s}return i.join(t,e)}}(t.win32||(t.win32={}))})),define(t[65],i([0,1,44,2,9,19,3,103,32,84,27,20,17]),(function(e,t,i,n,r,s,o,a,c,l,u,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class f extends c.ChannelServer{constructor(e){super({send:e=>{try{process.send&&process.send(e.buffer.toString("base64"))}catch(e){}},onMessage:o.Event.fromNodeEventEmitter(process,"message",e=>d.VSBuffer.wrap(Buffer.from(e,"base64")))},e),process.once("disconnect",()=>this.dispose())}}t.Server=f;t.Client=class{constructor(e,t){this.modulePath=e,this.options=t,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new o.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const i=t&&t.timeout?t.timeout:6e4;this.disposeDelayer=new r.Delayer(i),this.child=null,this._client=null}getChannel(e){const t=this;return{
call:(i,n,r)=>t.requestPromise(e,i,n,r),listen:(i,n)=>t.requestEvent(e,i,n)}}requestPromise(e,t,i,s=u.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(h.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(e),a=r.createCancelablePromise(e=>o.call(t,i,e)),c=s.onCancellationRequested(()=>a.cancel()),l=n.toDisposable(()=>a.cancel());return this.activeRequests.add(l),a.finally(()=>{c.dispose(),this.activeRequests.delete(l),0===this.activeRequests.size&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(e,t,i){if(!this.disposeDelayer)return o.Event.None;let n;this.disposeDelayer.cancel();const r=new o.Emitter({onFirstListenerAdd:()=>{const s=this.getCachedChannel(e).listen(t,i);n=s(r.fire,r),this.activeRequests.add(n)},onLastListenerRemove:()=>{this.activeRequests.delete(n),n.dispose(),
0===this.activeRequests.size&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const e=this.options&&this.options.args?this.options.args:[],t=Object.create(null);t.env=s.assign(s.deepClone(process.env),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(t.env=s.assign(t.env,this.options.env)),this.options&&this.options.freshExecArgv&&(t.execArgv=[]),this.options&&"number"==typeof this.options.debug&&(t.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&"number"==typeof this.options.debugBrk&&(t.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),this.child=i.fork(this.modulePath,e,t);const r=new o.Emitter;o.Event.fromNodeEventEmitter(this.child,"message",e=>e)(e=>{l.isRemoteConsoleLog(e)?l.log(e,`IPC Library: ${this.options.serverName}`):r.fire(d.VSBuffer.wrap(Buffer.from(e,"base64")))});const u=this.options.useQueue?a.createQueuedSender(this.child):this.child,h={
send:e=>this.child&&this.child.connected&&u.send(e.buffer.toString("base64")),onMessage:r.event};this._client=new c.ChannelClient(h);const f=()=>this.disposeClient();process.once("exit",f),this.child.on("error",e=>console.warn('IPC "'+this.options.serverName+'" errored with '+e)),this.child.on("exit",(e,t)=>{process.removeListener("exit",f),this.activeRequests.forEach(e=>n.dispose(e)),this.activeRequests.clear(),0!==e&&"SIGTERM"!==t&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+e+" and signal "+t),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:e,signal:t})})}return this._client}getCachedChannel(e){let t=this.channels.get(e);return t||(t=this.client.getChannel(e),this.channels.set(e,t)),t}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),
this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}})),define(t[104],i([11,12]),(function(e,t){return e.create("vs/base/node/zip",t)})),define(t[105],i([11,12]),(function(e,t){return e.create("vs/platform/configuration/common/configurationRegistry",t)})),define(t[106],i([11,12]),(function(e,t){return e.create("vs/platform/extensionManagement/common/extensionManagement",t)})),define(t[107],i([11,12]),(function(e,t){return e.create("vs/platform/extensionManagement/node/extensionManagementService",t)})),define(t[108],i([11,12]),(function(e,t){return e.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)})),define(t[109],i([11,12]),(function(e,t){return e.create("vs/platform/extensionManagement/node/extensionsScanner",t)})),define(t[110],i([11,12]),(function(e,t){return e.create("vs/platform/extensions/common/extensionValidator",t)})),define(t[111],i([11,12]),(function(e,t){return e.create("vs/platform/files/common/fileService",t)})),
define(t[112],i([11,12]),(function(e,t){return e.create("vs/platform/files/common/files",t)})),define(t[113],i([11,12]),(function(e,t){return e.create("vs/platform/files/common/io",t)})),define(t[114],i([11,12]),(function(e,t){return e.create("vs/platform/files/node/diskFileSystemProvider",t)})),define(t[115],i([11,12]),(function(e,t){return e.create("vs/platform/request/common/request",t)})),define(t[116],i([11,12]),(function(e,t){return e.create("vs/platform/telemetry/common/telemetryService",t)})),define(t[117],i([11,12]),(function(e,t){return e.create("vs/platform/userDataSync/common/abstractSynchronizer",t)})),define(t[118],i([11,12]),(function(e,t){return e.create("vs/platform/userDataSync/common/keybindingsSync",t)})),define(t[119],i([11,12]),(function(e,t){return e.create("vs/platform/userDataSync/common/settingsSync",t)})),define(t[120],i([11,12]),(function(e,t){return e.create("vs/platform/userDataSync/common/userDataAutoSyncService",t)})),define(t[121],i([11,12]),(function(e,t){
return e.create("vs/platform/userDataSync/common/userDataSync",t)})),define(t[122],i([11,12]),(function(e,t){return e.create("vs/platform/userDataSync/common/userDataSyncMachines",t)})),define(t[123],i([11,12]),(function(e,t){return e.create("vs/platform/workspaces/common/workspaces",t)})),define(t[124],i([0,1,9]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeytarCredentialsService=void 0;t.KeytarCredentialsService=class{constructor(){this._keytar=new i.IdleValue(()=>new Promise((t,i)=>{e(["keytar"],t,i)}))}async getPassword(e,t){return(await this._keytar.value).getPassword(e,t)}async setPassword(e,t,i){return(await this._keytar.value).setPassword(e,t,i)}async deletePassword(e,t){return(await this._keytar.value).deletePassword(e,t)}async findPassword(e){return(await this._keytar.value).findPassword(e)}async findCredentials(e){return(await this._keytar.value).findCredentials(e)}}})),define(t[125],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{
value:!0}),t.isRemoteDiagnosticError=void 0,t.isRemoteDiagnosticError=function(e){return!!e.hostName&&!!e.errorMessage}})),define(t[126],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiagnosticsService=t.DiagnosticsChannel=void 0;t.DiagnosticsChannel=class{constructor(e){this.service=e}listen(e,t){throw new Error("Invalid listen")}call(e,t,i){switch(t){case"getDiagnostics":return this.service.getDiagnostics(i[0],i[1]);case"getSystemInfo":return this.service.getSystemInfo(i[0],i[1]);case"getPerformanceInfo":return this.service.getPerformanceInfo(i[0],i[1]);case"reportWorkspaceStats":return this.service.reportWorkspaceStats(i)}throw new Error("Invalid call")}};t.DiagnosticsService=class{constructor(e){this.channel=e}getDiagnostics(e,t){return this.channel.call("getDiagnostics",[e,t])}getSystemInfo(e,t){return this.channel.call("getSystemInfo",[e,t])}getPerformanceInfo(e,t){return this.channel.call("getPerformanceInfo",[e,t])}reportWorkspaceStats(e){
return this.channel.call("reportWorkspaceStats",e)}}})),define(t[127],i([0,1,7,14]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getRemotes=t.getDomainsOfRemotes=t.AllowedSecondLevelDomains=void 0;const r=/^([^@:]+@)?([^:]+):/,s=/^([^@:]+@)?([^:]+):(.+)$/,o=/^([^@]+@)?([^:]+)(:\d+)?$/,a=/([^@:.]+\.[^@:.]+)(:\d+)?$/,c=/^\s*url\s*=\s*(.+\S)\s*$/gm,l=/[^.]/g;function u(e){const t=e.match(a);return t?t[1]:null}function h(e){if(-1===e.indexOf("://")){const t=e.match(r);return t?u(t[2]):null}try{const t=i.URI.parse(e);if(t.authority)return u(t.authority)}catch(e){}return null}function d(e,t,i){return e&&t?(i&&n.endsWith(t,".git")&&(t=t.substr(0,t.length-4)),0===t.indexOf("/")?`${e}${t}`:`${e}/${t}`):null}function f(e,t){if(-1===e.indexOf("://")){const i=e.match(s);if(i)return d(i[2],i[3],t)}try{const n=i.URI.parse(e);if(n.authority)return d(function(e){const t=e.match(o);return t?t[2]:null}(n.authority),n.path,t)}catch(e){}return null}
t.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"],t.getDomainsOfRemotes=function(e,t){const i=new Set;let n;for(;n=c.exec(e);){const e=h(n[1]);e&&i.add(e)}const r=new Set(t);return Array.from(i).map(e=>r.has(e)?e:e.replace(l,"a"))},t.getRemotes=function(e,t=!1){const i=[];let n;for(;n=c.exec(e);){const e=f(n[1],t);e&&i.push(e)}return i}})),define(t[128],i([0,1,3,7,86,19]),(function(e,t,i,n,r,s){"use strict";function o(e,t){return n.URI.revive(t?t.transformIncoming(e):e)}function a(e,t){t=t||r.DefaultURITransformer;const i=e.manifest,n=r.transformAndReviveIncomingURIs(Object.assign(Object.assign({},e),{manifest:void 0}),t);return Object.assign(Object.assign({},n),{manifest:i})}function c(e,t){return t?s.cloneAndChange(e,e=>e instanceof n.URI?t.transformOutgoingURI(e):void 0):e}Object.defineProperty(t,"__esModule",{value:!0}),
t.ExtensionTipsChannel=t.ExtensionManagementChannelClient=t.ExtensionManagementChannel=void 0;t.ExtensionManagementChannel=class{constructor(e,t){this.service=e,this.getUriTransformer=t,this.onInstallExtension=i.Event.buffer(e.onInstallExtension,!0),this.onDidInstallExtension=i.Event.buffer(e.onDidInstallExtension,!0),this.onUninstallExtension=i.Event.buffer(e.onUninstallExtension,!0),this.onDidUninstallExtension=i.Event.buffer(e.onDidUninstallExtension,!0)}listen(e,t){const n=this.getUriTransformer(e);switch(t){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return i.Event.map(this.onDidInstallExtension,e=>Object.assign(Object.assign({},e),{local:e.local?c(e.local,n):e.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(e,t,i){const n=this.getUriTransformer(e);switch(t){case"zip":return this.service.zip(a(i[0],n)).then(e=>(function(e,t){
return t?t.transformOutgoingURI(e):e})(e,n));case"unzip":return this.service.unzip(o(i[0],n));case"install":return this.service.install(o(i[0],n));case"getManifest":return this.service.getManifest(o(i[0],n));case"canInstall":return this.service.canInstall(i[0]);case"installFromGallery":return this.service.installFromGallery(i[0]);case"uninstall":return this.service.uninstall(a(i[0],n),i[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(a(i[0],n));case"getInstalled":return this.service.getInstalled(i[0]).then(e=>e.map(e=>c(e,n)));case"updateMetadata":return this.service.updateMetadata(a(i[0],n),i[1]).then(e=>c(e,n));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}};t.ExtensionManagementChannelClient=class{constructor(e){this.channel=e}get onInstallExtension(){return this.channel.listen("onInstallExtension")}get onDidInstallExtension(){return i.Event.map(this.channel.listen("onDidInstallExtension"),e=>Object.assign(Object.assign({},e),{
local:e.local?a(e.local,null):e.local}))}get onUninstallExtension(){return this.channel.listen("onUninstallExtension")}get onDidUninstallExtension(){return this.channel.listen("onDidUninstallExtension")}zip(e){return Promise.resolve(this.channel.call("zip",[e]).then(e=>n.URI.revive(e)))}unzip(e){return Promise.resolve(this.channel.call("unzip",[e]))}install(e){return Promise.resolve(this.channel.call("install",[e])).then(e=>a(e,null))}getManifest(e){return Promise.resolve(this.channel.call("getManifest",[e]))}async canInstall(e){return!0}installFromGallery(e){return Promise.resolve(this.channel.call("installFromGallery",[e])).then(e=>a(e,null))}uninstall(e,t=!1){return Promise.resolve(this.channel.call("uninstall",[e,t]))}reinstallFromGallery(e){return Promise.resolve(this.channel.call("reinstallFromGallery",[e]))}getInstalled(e=null){return Promise.resolve(this.channel.call("getInstalled",[e])).then(e=>e.map(e=>a(e,null)))}updateMetadata(e,t){
return Promise.resolve(this.channel.call("updateMetadata",[e,t])).then(e=>a(e,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}};t.ExtensionTipsChannel=class{constructor(e){this.service=e}listen(e,t){throw new Error("Invalid listen")}call(e,t,i){switch(t){case"getConfigBasedTips":return this.service.getConfigBasedTips(n.URI.revive(i[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}})),define(t[129],i([0,1,19]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;t.localizeManifest=function(e,t){return i.cloneAndChange(e,e=>{if("string"!=typeof e)return;const i=n.exec(e);return i?t[i[1]]||e:void 0})}})),define(t[66],i([0,1,110]),(function(e,t,i){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function r(e){return"*"===(e=e.trim())||n.test(e)}function s(e){if(!r(e))return null;if("*"===(e=e.trim()))return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let t=e.match(n);return t?{hasCaret:"^"===t[1],hasGreaterEquals:">="===t[1],majorBase:"x"===t[2]?0:parseInt(t[2],10),majorMustEqual:"x"!==t[2],minorBase:"x"===t[4]?0:parseInt(t[4],10),minorMustEqual:"x"!==t[4],patchBase:"x"===t[6]?0:parseInt(t[6],10),patchMustEqual:"x"!==t[6],preRelease:t[8]||null}:null}function o(e){if(!e)return null;let t=e.majorBase,i=e.majorMustEqual,n=e.minorBase,r=e.minorMustEqual,s=e.patchBase,o=e.patchMustEqual;return e.hasCaret&&(0===t?o=!1:(r=!1,o=!1)),{majorBase:t,majorMustEqual:i,
minorBase:n,minorMustEqual:r,patchBase:s,patchMustEqual:o,isMinimum:e.hasGreaterEquals}}function a(e,t){let i,n;if(i="string"==typeof e?o(s(e)):e,n="string"==typeof t?o(s(t)):t,!i||!n)return!1;let r=i.majorBase,a=i.minorBase,c=i.patchBase,l=n.majorBase,u=n.minorBase,h=n.patchBase,d=n.majorMustEqual,f=n.minorMustEqual,g=n.patchMustEqual;return n.isMinimum?r>l||!(r<l)&&(a>u||!(a<u)&&c>=h):(1!==r||0!==l||d&&f&&g||(l=1,u=0,h=0,d=!0,f=!1,g=!1),!(r<l)&&(r>l?!d:!(a<u)&&(a>u?!f:!(c<h)&&(!(c>h)||!g))))}function c(e,t,n=[]){let r=o(s(t));if(!r)return n.push(i.localize(0,null,t)),!1;if(0===r.majorBase){if(!r.majorMustEqual||!r.minorMustEqual)return n.push(i.localize(1,null,t)),!1}else if(!r.majorMustEqual)return n.push(i.localize(2,null,t)),!1;return!!a(e,r)||(n.push(i.localize(3,null,e,t)),!1)}t.isValidVersionStr=r,t.parseVersion=s,t.normalizeVersion=o,t.isValidVersion=a,t.isValidExtensionVersion=function(e,t,i){return!(!t.isBuiltin&&void 0!==t.main)||c(e,t.engines.vscode,i)},t.isEngineValid=function(e,t){
return"*"===e||c(t,e)},t.isVersionValid=c})),define(t[130],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WatcherChannelClient=t.WatcherChannel=void 0;t.WatcherChannel=class{constructor(e){this.service=e}listen(e,t,i){switch(t){case"watch":return this.service.watch(i);case"onLogMessage":return this.service.onLogMessage}throw new Error(`Event not found: ${t}`)}call(e,t,i){switch(t){case"setRoots":return this.service.setRoots(i);case"setVerboseLogging":return this.service.setVerboseLogging(i);case"stop":return this.service.stop()}throw new Error(`Call not found: ${t}`)}};t.WatcherChannelClient=class{constructor(e){this.channel=e}watch(e){return this.channel.listen("watch",e)}setVerboseLogging(e){return this.channel.call("setVerboseLogging",e)}setRoots(e){return this.channel.call("setRoots",e)}get onLogMessage(){return this.channel.listen("onLogMessage")}stop(){return this.channel.call("stop")}}})),define(t[131],i([0,1,32,65,130,2,31]),(function(e,t,i,n,r,s,o){
"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class a extends s.Disposable{constructor(e,t,i,n){super(),this.folders=e,this.onDidFilesChange=t,this.onLogMessage=i,this.verboseLogging=n,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const t=this._register(new n.Client(o.getPathFromAmdModule(e,"bootstrap-fork"),{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",PIPE_LOGGING:"true",VERBOSE_LOGGING:"true"}}));this._register(t.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=a.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))}));const s=i.getNextTickChannel(t.getChannel("watcher"));this.service=new r.WatcherChannelClient(s),this.service.setVerboseLogging(this.verboseLogging)
;this._register(this.service.watch({})(e=>!this.isDisposed&&this.onDidFilesChange(e))),this._register(this.service.onLogMessage(e=>this.onLogMessage(e))),this.setFolders(this.folders)}setVerboseLogging(e){this.verboseLogging=e,!this.isDisposed&&this.service&&this.service.setVerboseLogging(e)}error(e){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${e}`})}setFolders(e){this.folders=e,this.service&&this.service.setRoots(e)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=a,a.MAX_RESTARTS=5})),define(t[132],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WatcherChannelClient=t.WatcherChannel=void 0;t.WatcherChannel=class{constructor(e){this.service=e}listen(e,t,i){switch(t){case"watch":return this.service.watch(i);case"onLogMessage":return this.service.onLogMessage}throw new Error(`Event not found: ${t}`)}call(e,t,i){switch(t){case"setRoots":return this.service.setRoots(i);case"setVerboseLogging":return this.service.setVerboseLogging(i)
;case"stop":return this.service.stop()}throw new Error(`Call not found: ${t}`)}};t.WatcherChannelClient=class{constructor(e){this.channel=e}watch(e){return this.channel.listen("watch",e)}setVerboseLogging(e){return this.channel.call("setVerboseLogging",e)}get onLogMessage(){return this.channel.listen("onLogMessage")}setRoots(e){return this.channel.call("setRoots",e)}stop(){return this.channel.call("stop")}}})),define(t[133],i([0,1,32,65,132,2,31]),(function(e,t,i,n,r,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class a extends s.Disposable{constructor(e,t,i,n,r={}){super(),this.folders=e,this.onDidFilesChange=t,this.onLogMessage=i,this.verboseLogging=n,this.watcherOptions=r,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const t=this._register(new n.Client(o.getPathFromAmdModule(e,"bootstrap-fork"),{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",
PIPE_LOGGING:"true",VERBOSE_LOGGING:"true"}}));this._register(t.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=a.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))}));const s=i.getNextTickChannel(t.getChannel("watcher"));this.service=new r.WatcherChannelClient(s),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.watch(this.watcherOptions)(e=>!this.isDisposed&&this.onDidFilesChange(e))),this._register(this.service.onLogMessage(e=>this.onLogMessage(e))),this.service.setRoots(this.folders)}error(e){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${e}`})}setVerboseLogging(e){this.verboseLogging=e,this.service&&this.service.setVerboseLogging(e)}setFolders(e){this.folders=e,this.service&&this.service.setRoots(e)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=a,
a.MAX_RESTARTS=5})),define(t[134],i([0,1,44,63,60,31]),(function(e,t,i,n,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class o{constructor(e,t,i,n,s){this.watchedFolder=e,this.eventCallback=i,this.logCallback=n,this.verboseLogging=s,this.restartCounter=0,Array.isArray(t)?this.ignored=t.map(e=>r.parse(e)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${e}`),this.startWatcher()}startWatcher(){const t=[this.watchedFolder];this.verboseLogging&&t.push("-verbose"),this.handle=i.spawn(s.getPathFromAmdModule(e,"vs/platform/files/node/watcher/win32/CodeHelper.exe"),t);const r=new n.LineDecoder;this.handle.stdout.on("data",e=>{const t=[];r.write(e).forEach(e=>{const i=e.split("|");if(2===i.length){const e=Number(i[0]),n=i[1];if(e>=0&&e<3){if(this.ignored&&this.ignored.some(e=>e(n)))return void(this.verboseLogging&&this.log(n));t.push({type:o.changeTypeMap[e],path:n})}else this.log(i[1])}}),t.length>0&&this.eventCallback(t)}),
this.handle.on("error",e=>this.onError(e)),this.handle.stderr.on("data",e=>this.onError(e)),this.handle.on("exit",(e,t)=>this.onExit(e,t))}onError(e){this.error("process error: "+e.toString())}onExit(e,t){this.handle&&(this.error(`terminated unexpectedly (code: ${e}, signal: ${t})`),this.restartCounter<=o.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(e){this.logCallback({type:"error",message:`[File Watcher (C#)] ${e}`})}log(e){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${e}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=o,o.MAX_RESTARTS=5,o.changeTypeMap=[0,1,2]})),define(t[135],i([0,1,134,4,14]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;t.FileWatcher=class{constructor(e,t,i,s){this.onDidFilesChange=t,
this.onLogMessage=i,this.verboseLogging=s,this.service=void 0,this.folder=e[0],0===this.folder.path.indexOf("\\\\")&&this.folder.path.endsWith(n.posix.sep)&&(this.folder.path=r.rtrim(this.folder.path,n.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new i.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,e=>this.onFileEvents(e),e=>this.onLogMessage(e),this.verboseLogging)}setVerboseLogging(e){this.verboseLogging=e,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(e){this.isDisposed||e.length>0&&this.onDidFilesChange(e)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}})),define(t[67],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class i{constructor(e,t=[],i=!1){this.ctor=e,this.staticArguments=t,this.supportsDelayedInstantiation=i}}t.SyncDescriptor=i
;t.createSyncDescriptor=(e,...t)=>new i(e,t)})),define(t[136],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class i{constructor(e){this.incoming=new Map,this.outgoing=new Map,this.data=e}}t.Node=i;t.Graph=class{constructor(e){this._hashFn=e,this._nodes=new Map}roots(){const e=[];for(let t of this._nodes.values())0===t.outgoing.size&&e.push(t);return e}insertEdge(e,t){const i=this.lookupOrInsertNode(e),n=this.lookupOrInsertNode(t);i.outgoing.set(this._hashFn(t),n),n.incoming.set(this._hashFn(e),i)}removeNode(e){const t=this._hashFn(e);this._nodes.delete(t);for(let e of this._nodes.values())e.outgoing.delete(t),e.incoming.delete(t)}lookupOrInsertNode(e){const t=this._hashFn(e);let n=this._nodes.get(t);return n||(n=new i(e),this._nodes.set(t,n)),n}lookup(e){return this._nodes.get(this._hashFn(e))}isEmpty(){return 0===this._nodes.size}toString(){let e=[]
;for(let[t,i]of this._nodes)e.push(`${t}, (incoming)[${[...i.incoming.keys()].join(", ")}], (outgoing)[${[...i.outgoing.keys()].join(",")}]`);return e.join("\n")}}})),define(t[5],i([0,1]),(function(e,t){"use strict";var i;function n(e,t,n,r){t[i.DI_TARGET]===t?t[i.DI_DEPENDENCIES].push({id:e,index:n,optional:r}):(t[i.DI_DEPENDENCIES]=[{id:e,index:n,optional:r}],t[i.DI_TARGET]=t)}function r(e){if(i.serviceIds.has(e))return i.serviceIds.get(e);const t=function(e,i,r){if(3!==arguments.length)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(t,e,r,!1)};return t.toString=()=>e,i.serviceIds.set(e,t),t}Object.defineProperty(t,"__esModule",{value:!0}),t.optional=t.createDecorator=t.IInstantiationService=t._util=void 0,function(e){e.serviceIds=new Map,e.DI_TARGET="$di$target",e.DI_DEPENDENCIES="$di$dependencies",e.getServiceDependencies=function(t){return t[e.DI_DEPENDENCIES]||[]}}(i=t._util||(t._util={})),t.IInstantiationService=r("instantiationService"),t.createDecorator=r,
t.optional=function(e){return function(t,i,r){if(3!==arguments.length)throw new Error("@optional-decorator can only be used to decorate a parameter");n(e,t,r,!0)}}})),define(t[137],i([0,1,14,5,6]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SET_CONTEXT_COMMAND_ID=t.IContextKeyService=t.RawContextKey=t.ContextKeyOrExpr=t.ContextKeyAndExpr=t.ContextKeyNotRegexExpr=t.ContextKeyRegexExpr=t.ContextKeyNotExpr=t.ContextKeyNotEqualsExpr=t.ContextKeyNotInExpr=t.ContextKeyInExpr=t.ContextKeyEqualsExpr=t.ContextKeyDefinedExpr=t.ContextKeyTrueExpr=t.ContextKeyFalseExpr=t.ContextKeyExpr=t.ContextKeyExprType=void 0;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",r.isMacintosh),s.set("isLinux",r.isLinux),s.set("isWindows",r.isWindows),s.set("isWeb",r.isWeb),s.set("isMacNative",r.isMacintosh&&!r.isWeb);const o=Object.prototype.hasOwnProperty;!function(e){e[e.False=0]="False",e[e.True=1]="True",e[e.Defined=2]="Defined",e[e.Not=3]="Not",e[e.Equals=4]="Equals",
e[e.NotEquals=5]="NotEquals",e[e.And=6]="And",e[e.Regex=7]="Regex",e[e.NotRegex=8]="NotRegex",e[e.Or=9]="Or",e[e.In=10]="In",e[e.NotIn=11]="NotIn"}(t.ContextKeyExprType||(t.ContextKeyExprType={}));class a{static false(){return l.INSTANCE}static true(){return u.INSTANCE}static has(e){return h.create(e)}static equals(e,t){return d.create(e,t)}static notEquals(e,t){return p.create(e,t)}static regex(e,t){return v.create(e,t)}static in(e,t){return f.create(e,t)}static not(e){return m.create(e)}static and(...e){return S.create(e)}static or(...e){return w.create(e)}static deserialize(e,t=!1){if(e)return this._deserializeOrExpression(e,t)}static _deserializeOrExpression(e,t){let i=e.split("||");return w.create(i.map(e=>this._deserializeAndExpression(e,t)))}static _deserializeAndExpression(e,t){let i=e.split("&&");return S.create(i.map(e=>this._deserializeOne(e,t)))}static _deserializeOne(e,t){if((e=e.trim()).indexOf("!=")>=0){let i=e.split("!=");return p.create(i[0].trim(),this._deserializeValue(i[1],t))}
if(e.indexOf("==")>=0){let i=e.split("==");return d.create(i[0].trim(),this._deserializeValue(i[1],t))}if(e.indexOf("=~")>=0){let i=e.split("=~");return v.create(i[0].trim(),this._deserializeRegexValue(i[1],t))}if(e.indexOf(" in ")>=0){let t=e.split(" in ");return f.create(t[0].trim(),t[1].trim())}return/^\!\s*/.test(e)?m.create(e.substr(1).trim()):h.create(e)}static _deserializeValue(e,t){if("true"===(e=e.trim()))return!0;if("false"===e)return!1;let i=/^'([^']*)'$/.exec(e);return i?i[1].trim():e}static _deserializeRegexValue(e,t){if(i.isFalsyOrWhitespace(e)){if(t)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let n=e.indexOf("/"),r=e.lastIndexOf("/");if(n===r||n<0){if(t)throw new Error(`bad regexp-value '${e}', missing /-enclosure`);return console.warn(`bad regexp-value '${e}', missing /-enclosure`),null}let s=e.slice(n+1,r),o="i"===e[r+1]?"i":"";try{return new RegExp(s,o)}catch(i){
if(t)throw new Error(`bad regexp-value '${e}', parse error: ${i}`);return console.warn(`bad regexp-value '${e}', parse error: ${i}`),null}}}function c(e,t){return e.cmp(t)}t.ContextKeyExpr=a;class l{constructor(){this.type=0}cmp(e){return this.type-e.type}equals(e){return e.type===this.type}evaluate(e){return!1}serialize(){return"false"}keys(){return[]}map(e){return this}negate(){return u.INSTANCE}}t.ContextKeyFalseExpr=l,l.INSTANCE=new l;class u{constructor(){this.type=1}cmp(e){return this.type-e.type}equals(e){return e.type===this.type}evaluate(e){return!0}serialize(){return"true"}keys(){return[]}map(e){return this}negate(){return l.INSTANCE}}t.ContextKeyTrueExpr=u,u.INSTANCE=new u;class h{constructor(e){this.key=e,this.type=2}static create(e){const t=s.get(e);return"boolean"==typeof t?t?u.INSTANCE:l.INSTANCE:new h(e)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:0}equals(e){return e.type===this.type&&this.key===e.key}evaluate(e){return!!e.getValue(this.key)}
serialize(){return this.key}keys(){return[this.key]}map(e){return e.mapDefined(this.key)}negate(){return m.create(this.key)}}t.ContextKeyDefinedExpr=h;class d{constructor(e,t){this.key=e,this.value=t,this.type=4}static create(e,t){if("boolean"==typeof t)return t?h.create(e):m.create(e);const i=s.get(e);if("boolean"==typeof i){return t===(i?"true":"false")?u.INSTANCE:l.INSTANCE}return new d(e,t)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.value<e.value?-1:this.value>e.value?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.value===e.value)}evaluate(e){return e.getValue(this.key)==this.value}serialize(){return this.key+" == '"+this.value+"'"}keys(){return[this.key]}map(e){return e.mapEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}t.ContextKeyEqualsExpr=d;class f{constructor(e,t){this.key=e,this.valueKey=t,this.type=10}static create(e,t){return new f(e,t)}cmp(e){
return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.valueKey<e.valueKey?-1:this.valueKey>e.valueKey?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.valueKey===e.valueKey)}evaluate(e){const t=e.getValue(this.valueKey),i=e.getValue(this.key);return Array.isArray(t)?t.indexOf(i)>=0:"string"==typeof i&&"object"==typeof t&&null!==t&&o.call(t,i)}serialize(){return this.key+" in '"+this.valueKey+"'"}keys(){return[this.key,this.valueKey]}map(e){return e.mapIn(this.key,this.valueKey)}negate(){return g.create(this)}}t.ContextKeyInExpr=f;class g{constructor(e){this._actual=e,this.type=11}static create(e){return new g(e)}cmp(e){return e.type!==this.type?this.type-e.type:this._actual.cmp(e._actual)}equals(e){return e.type===this.type&&this._actual.equals(e._actual)}evaluate(e){return!this._actual.evaluate(e)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(e){return new g(this._actual.map(e))}negate(){return this._actual}}
t.ContextKeyNotInExpr=g;class p{constructor(e,t){this.key=e,this.value=t,this.type=5}static create(e,t){if("boolean"==typeof t)return t?m.create(e):h.create(e);const i=s.get(e);if("boolean"==typeof i){return t===(i?"true":"false")?l.INSTANCE:u.INSTANCE}return new p(e,t)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.value<e.value?-1:this.value>e.value?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.value===e.value)}evaluate(e){return e.getValue(this.key)!=this.value}serialize(){return this.key+" != '"+this.value+"'"}keys(){return[this.key]}map(e){return e.mapNotEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}t.ContextKeyNotEqualsExpr=p;class m{constructor(e){this.key=e,this.type=3}static create(e){const t=s.get(e);return"boolean"==typeof t?t?l.INSTANCE:u.INSTANCE:new m(e)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:0}equals(e){return e.type===this.type&&this.key===e.key}evaluate(e){
return!e.getValue(this.key)}serialize(){return"!"+this.key}keys(){return[this.key]}map(e){return e.mapNot(this.key)}negate(){return h.create(this.key)}}t.ContextKeyNotExpr=m;class v{constructor(e,t){this.key=e,this.regexp=t,this.type=7}static create(e,t){return new v(e,t)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.key<e.key)return-1;if(this.key>e.key)return 1;const t=this.regexp?this.regexp.source:"",i=e.regexp?e.regexp.source:"";return t<i?-1:t>i?1:0}equals(e){if(e.type===this.type){const t=this.regexp?this.regexp.source:"",i=e.regexp?e.regexp.source:"";return this.key===e.key&&t===i}return!1}evaluate(e){let t=e.getValue(this.key);return!!this.regexp&&this.regexp.test(t)}serialize(){const e=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${e}`}keys(){return[this.key]}map(e){return e.mapRegex(this.key,this.regexp)}negate(){return y.create(this)}}t.ContextKeyRegexExpr=v;class y{constructor(e){this._actual=e,this.type=8}static create(e){
return new y(e)}cmp(e){return e.type!==this.type?this.type-e.type:this._actual.cmp(e._actual)}equals(e){return e.type===this.type&&this._actual.equals(e._actual)}evaluate(e){return!this._actual.evaluate(e)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(e){return new y(this._actual.map(e))}negate(){return this._actual}}t.ContextKeyNotRegexExpr=y;class S{constructor(e){this.expr=e,this.type=6}static create(e){return S._normalizeArr(e)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(let t=0,i=this.expr.length;t<i;t++){const i=c(this.expr[t],e.expr[t]);if(0!==i)return i}return 0}equals(e){if(e.type===this.type){if(this.expr.length!==e.expr.length)return!1;for(let t=0,i=this.expr.length;t<i;t++)if(!this.expr[t].equals(e.expr[t]))return!1;return!0}return!1}evaluate(e){for(let t=0,i=this.expr.length;t<i;t++)if(!this.expr[t].evaluate(e))return!1;return!0}static _normalizeArr(e){
const t=[];let i=!1;for(const n of e)if(n)if(1!==n.type){if(0===n.type)return l.INSTANCE;6!==n.type?t.push(n):t.push(...n.expr)}else i=!0;if(0===t.length&&i)return u.INSTANCE;if(0!==t.length){if(1===t.length)return t[0];for(t.sort(c);t.length>1;){const e=t[t.length-1];if(9!==e.type)break;t.pop();const i=t.pop(),n=w.create(e.expr.map(e=>S.create([e,i])));n&&(t.push(n),t.sort(c))}return new S(t)}}serialize(){return this.expr.map(e=>e.serialize()).join(" && ")}keys(){const e=[];for(let t of this.expr)e.push(...t.keys());return e}map(e){return new S(this.expr.map(t=>t.map(e)))}negate(){let e=[];for(let t of this.expr)e.push(t.negate());return w.create(e)}}t.ContextKeyAndExpr=S;class w{constructor(e){this.expr=e,this.type=9}static create(e){const t=w._normalizeArr(e);if(0!==t.length)return 1===t.length?t[0]:new w(t)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(let t=0,i=this.expr.length;t<i;t++){
const i=c(this.expr[t],e.expr[t]);if(0!==i)return i}return 0}equals(e){if(e.type===this.type){if(this.expr.length!==e.expr.length)return!1;for(let t=0,i=this.expr.length;t<i;t++)if(!this.expr[t].equals(e.expr[t]))return!1;return!0}return!1}evaluate(e){for(let t=0,i=this.expr.length;t<i;t++)if(this.expr[t].evaluate(e))return!0;return!1}static _normalizeArr(e){let t=[],i=!1;if(e){for(let n=0,r=e.length;n<r;n++){const r=e[n];if(r)if(0!==r.type){if(1===r.type)return[u.INSTANCE];9!==r.type?t.push(r):t=t.concat(r.expr)}else i=!0}if(0===t.length&&i)return[l.INSTANCE];t.sort(c)}return t}serialize(){return this.expr.map(e=>e.serialize()).join(" || ")}keys(){const e=[];for(let t of this.expr)e.push(...t.keys());return e}map(e){return new w(this.expr.map(t=>t.map(e)))}negate(){let e=[];for(let t of this.expr)e.push(t.negate());const t=e=>9===e.type?e.expr:[e];for(;e.length>1;){const i=e.shift(),n=e.shift(),r=[];for(const e of t(i))for(const i of t(n))r.push(a.and(e,i));e.unshift(a.or(...r))}return e[0]}}
t.ContextKeyOrExpr=w;t.RawContextKey=class extends h{constructor(e,t){super(e),this._defaultValue=t}bindTo(e){return e.createKey(this.key,this._defaultValue)}getValue(e){return e.getContextKeyValue(this.key)}toNegated(){return a.not(this.key)}isEqualTo(e){return a.equals(this.key,e)}notEqualsTo(e){return a.notEquals(this.key,e)}},t.IContextKeyService=n.createDecorator("contextKeyService"),t.SET_CONTEXT_COMMAND_ID="setContext"})),define(t[138],i([0,1,5]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ICredentialsService=void 0,t.ICredentialsService=i.createDecorator("ICredentialsService")})),define(t[68],i([0,1,5]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=i.createDecorator("downloadService")})),define(t[8],i([0,1,5]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BACKUPS=t.IEnvironmentService=void 0,t.IEnvironmentService=i.createDecorator("environmentService"),
t.BACKUPS="Backups"}));var r=this&&this.__decorate||function(e,t,i,n){var r,s=arguments.length,o=s<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,i):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,i,n);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(o=(s<3?r(o):s>3?r(t,i,o):r(t,i))||o);return s>3&&o&&Object.defineProperty(t,i,o),o},s=this&&this.__param||function(e,t){return function(i,n){t(i,n,e)}};define(t[139],i([0,1,8,4,21,20,2]),(function(e,t,i,n,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogsDataCleaner=void 0;let l=class extends c.Disposable{constructor(e){super(),this.environmentService=e,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let e=setTimeout(()=>{e=void 0;const t=n.basename(this.environmentService.logsPath),i=n.dirname(this.environmentService.logsPath);o.readdir(i).then(e=>{const r=e.filter(e=>/^\d{8}T\d{6}$/.test(e)).sort().filter((e,i)=>e!==t),s=r.slice(0,Math.max(0,r.length-9))
;return Promise.all(s.map(e=>o.rimraf(n.join(i,e))))}).then(null,a.onUnexpectedError)},1e4);this._register(c.toDisposable(()=>{e&&(clearTimeout(e),e=void 0)}))}};l=r([s(0,i.IEnvironmentService)],l),t.LogsDataCleaner=l})),define(t[140],i([0,1,8,4,21,20,2]),(function(e,t,i,n,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StorageDataCleaner=void 0;let l=class e extends c.Disposable{constructor(e){super(),this.environmentService=e,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let t=setTimeout(()=>{t=void 0,o.readFile(this.environmentService.backupWorkspacesPath,"utf8").then(t=>{const i=JSON.parse(t).emptyWorkspaceInfos.map(e=>e.backupFolder);return o.readdir(this.environmentService.workspaceStorageHome.fsPath).then(t=>{const r=[];return t.forEach(t=>{t.length!==e.NON_EMPTY_WORKSPACE_ID_LENGTH&&-1===i.indexOf(t)&&r.push(o.rimraf(n.join(this.environmentService.workspaceStorageHome.fsPath,t)))}),Promise.all(r)})}).then(null,a.onUnexpectedError)},3e4);this._register(c.toDisposable(()=>{
t&&(clearTimeout(t),t=void 0)}))}};l.NON_EMPTY_WORKSPACE_ID_LENGTH=32,l=r([s(0,i.IEnvironmentService)],l),t.StorageDataCleaner=l})),define(t[30],i([0,1,106,5]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.isIExtensionIdentifier=function(e){
return e&&"object"==typeof e&&"string"==typeof e.id&&(!e.uuid||"string"==typeof e.uuid)},function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",e[e.PublisherName=3]="PublisherName",e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=5]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"}(t.SortBy||(t.SortBy={})),function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"}(t.SortOrder||(t.SortOrder={})),function(e){e.Uninstall="uninstall"}(t.StatisticType||(t.StatisticType={})),function(e){e[e.None=0]="None",e[e.Install=1]="Install",e[e.Update=2]="Update"}(t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=n.createDecorator("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(e,t){super(e),this.code=t}}
t.ExtensionManagementError=r,t.IExtensionManagementService=n.createDecorator("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=n.createDecorator("IGlobalExtensionEnablementService"),t.IExtensionTipsService=n.createDecorator("IExtensionTipsService"),t.DefaultIconPath=e.toUrl("./media/defaultIcon.png"),t.ExtensionsLabel=i.localize(0,null),t.ExtensionsChannelId="extensions",t.PreferencesLabel=i.localize(1,null)})),define(t[69],i([0,1,14,5]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",
t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.isIExtensionIdentifier=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&(!e.uuid||"string"==typeof e.uuid)},t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Themes","Testing","Visualization","Other"],function(e){e[e.System=0]="System",e[e.User=1]="User"}(t.ExtensionType||(t.ExtensionType={}));t.ExtensionIdentifier=class{constructor(e){this.value=e,this._lower=e.toLowerCase()}static equals(e,t){if(null==e)return null==t;if(null==t)return!1;if("string"==typeof e||"string"==typeof t){let n="string"==typeof e?e:e.value,r="string"==typeof t?t:t.value;return i.equalsIgnoreCase(n,r)}return e._lower===t._lower}static toKey(e){return"string"==typeof e?e.toLowerCase():e._lower}},t.isLanguagePackExtension=function(e){
return!(!e.contributes||!e.contributes.localizations)&&e.contributes.localizations.length>0},t.isAuthenticaionProviderExtension=function(e){return!(!e.contributes||!e.contributes.authentication)&&e.contributes.authentication.length>0},t.IBuiltinExtensionsScannerService=n.createDecorator("IBuiltinExtensionsScannerService")})),define(t[36],i([0,1,14,69]),(function(e,t,i,n){"use strict";function r(e,t){return e.uuid&&t.uuid?e.uuid===t.uuid:e.id===t.id||0===i.compareIgnoreCase(e.id,t.id)}Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0,t.areSameExtensions=r;class s{constructor(e,t){this.identifier=e,this.version=t}key(){return`${this.identifier.id}-${this.version}`}equals(e){return e instanceof s&&(r(this.identifier,e.identifier)&&this.version===e.version)}}
t.ExtensionIdentifierWithVersion=s,t.adoptToGalleryExtensionId=function(e){return e.toLocaleLowerCase()},t.getGalleryExtensionId=function(e,t){return`${e.toLocaleLowerCase()}.${t.toLocaleLowerCase()}`},t.groupByExtension=function(e,t){const i=[],n=e=>{for(const n of i)if(n.some(i=>r(t(i),t(e))))return n;return null};for(const t of e){const e=n(t);e?e.push(t):i.push([t])}return i},t.getLocalExtensionTelemetryData=function(e){return{id:e.identifier.id,name:e.manifest.name,galleryId:null,publisherId:e.publisherId,publisherName:e.manifest.publisher,publisherDisplayName:e.publisherDisplayName,dependencies:e.manifest.extensionDependencies&&e.manifest.extensionDependencies.length>0}},t.getGalleryExtensionTelemetryData=function(e){return Object.assign({id:e.identifier.id,name:e.name,galleryId:e.identifier.uuid,publisherId:e.publisherId,publisherName:e.publisher,publisherDisplayName:e.publisherDisplayName,dependencies:!!(e.properties.dependencies&&e.properties.dependencies.length>0)},e.telemetryData)},
t.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge"),t.getMaliciousExtensionsSet=function(e){const t=new Set;for(const i of e)i.malicious&&t.add(i.id.id);return t}})),define(t[141],i([0,1,2,4,69,21]),(function(e,t,i,n,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class o extends i.Disposable{constructor(e,t){super(),this.environmentService=e,this.extensionsManifestCache=n.join(this.environmentService.userDataPath,r.MANIFEST_CACHE_FOLDER,r.USER_MANIFEST_CACHE_FILE),this._register(t.onDidInstallExtension(e=>this.onDidInstallExtension(e))),this._register(t.onDidUninstallExtension(e=>this.onDidUnInstallExtension(e)))}onDidInstallExtension(e){e.error||this.invalidate()}onDidUnInstallExtension(e){e.error||this.invalidate()}invalidate(){s.rimraf(this.extensionsManifestCache,s.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=o})),define(t[16],i([0,1,112,4,7,5,14,18]),(function(e,t,i,n,r,s,o,a){"use strict";var c
;Object.defineProperty(t,"__esModule",{value:!0}),t.BinarySize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FileType=t.IFileService=void 0,t.IFileService=s.createDecorator("fileService"),function(e){e[e.Unknown=0]="Unknown",e[e.File=1]="File",e[e.Directory=2]="Directory",e[e.SymbolicLink=64]="SymbolicLink"}(t.FileType||(t.FileType={})),function(e){
e[e.FileReadWrite=2]="FileReadWrite",e[e.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",e[e.FileReadStream=16]="FileReadStream",e[e.FileFolderCopy=8]="FileFolderCopy",e[e.PathCaseSensitive=1024]="PathCaseSensitive",e[e.Readonly=2048]="Readonly",e[e.Trash=4096]="Trash"}(t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={})),t.hasReadWriteCapability=function(e){return!!(2&e.capabilities)},t.hasFileFolderCopyCapability=function(e){return!!(8&e.capabilities)},t.hasOpenReadWriteCloseCapability=function(e){return!!(4&e.capabilities)},t.hasFileReadStreamCapability=function(e){return!!(16&e.capabilities)},function(e){e.FileExists="EntryExists",e.FileNotFound="EntryNotFound",e.FileNotADirectory="EntryNotADirectory",e.FileIsADirectory="EntryIsADirectory",e.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",e.FileTooLarge="EntryTooLarge",e.NoPermissions="NoPermissions",e.Unavailable="Unavailable",e.Unknown="Unknown"}(c=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}))
;class l extends Error{constructor(e,t){super(e),this.code=t}}function u(e,t){const i=new l(e.toString(),t);return h(i,t),i}function h(e,t){return e.name=t?`${t} (FileSystemError)`:"FileSystemError",e}function d(e){if(!e)return c.Unknown;if(e instanceof l)return e.code;const t=/^(.+) \(FileSystemError\)$/.exec(e.name);if(!t)return c.Unknown;switch(t[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}t.FileSystemProviderError=l,t.createFileSystemProviderError=u,t.ensureFileSystemProviderError=function(e){return e||u(i.localize(0,null),c.Unknown)},t.markAsFileSystemProviderError=h,t.toFileSystemProviderErrorCode=d,t.toFileOperationResult=function(e){
if(e instanceof g)return e.fileOperationResult;switch(d(e)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}},function(e){e[e.CREATE=0]="CREATE",e[e.DELETE=1]="DELETE",e[e.MOVE=2]="MOVE",e[e.COPY=3]="COPY"}(t.FileOperation||(t.FileOperation={}));t.FileOperationEvent=class{constructor(e,t,i){this.resource=e,this.operation=t,this.target=i}isOperation(e){return this.operation===e}},function(e){e[e.UPDATED=0]="UPDATED",e[e.ADDED=1]="ADDED",e[e.DELETED=2]="DELETED"}(t.FileChangeType||(t.FileChangeType={}));class f{constructor(e,t){this.changes=e,this.extUri=t}contains(e,t){if(!e)return!1;const i=!a.isUndefinedOrNull(t);return this.changes.some(n=>(!i||n.type===t)&&(2===n.type?this.extUri.isEqualOrParent(e,n.resource):this.extUri.isEqual(e,n.resource)))}getAdded(){return this.getOfType(1)}gotAdded(){return this.hasType(1)}
getDeleted(){return this.getOfType(2)}gotDeleted(){return this.hasType(2)}getUpdated(){return this.getOfType(0)}gotUpdated(){return this.hasType(0)}getOfType(e){return this.changes.filter(t=>t.type===e)}hasType(e){return this.changes.some(t=>t.type===e)}filter(e){return new f(this.changes.filter(t=>e(t)),this.extUri)}}t.FileChangesEvent=f,t.isParent=function(e,t,i){return!(!e||!t||e===t)&&(!(t.length>e.length)&&(t.charAt(t.length-1)!==n.sep&&(t+=n.sep),i?o.startsWithIgnoreCase(e,t):0===e.indexOf(t)))};class g extends Error{constructor(e,t,i){super(e),this.fileOperationResult=t,this.options=i}static isFileOperationError(e){return e instanceof Error&&!a.isUndefinedOrNull(e.fileOperationResult)}}t.FileOperationError=g,function(e){e[e.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",e[e.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",e[e.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",e[e.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",e[e.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",e[e.FILE_READ_ONLY=5]="FILE_READ_ONLY",
e[e.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",e[e.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",e[e.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",e[e.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",e[e.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",e[e.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"}(t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",function(e){e[e.FILE=0]="FILE",e[e.FOLDER=1]="FOLDER",e[e.ROOT_FOLDER=2]="ROOT_FOLDER"}(t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="",t.etag=function(e){if("number"==typeof e.size&&"number"==typeof e.mtime)return e.mtime.toString(29)+e.size.toString(31)},t.whenProviderRegistered=function(e,t){return t.canHandleResource(r.URI.from({scheme:e.scheme
}))?Promise.resolve():new Promise((i,n)=>{const r=t.onDidChangeFileSystemProviderRegistrations(t=>{t.scheme===e.scheme&&t.added&&(r.dispose(),i())})})},t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class p{static formatSize(e){return e<p.KB?i.localize(1,null,e):e<p.MB?i.localize(2,null,(e/p.KB).toFixed(2)):e<p.GB?i.localize(3,null,(e/p.MB).toFixed(2)):e<p.TB?i.localize(4,null,(e/p.GB).toFixed(2)):i.localize(5,null,(e/p.TB).toFixed(2))}}t.BinarySize=p,p.KB=1024,p.MB=p.KB*p.KB,p.GB=p.MB*p.KB,p.TB=p.GB*p.KB})),define(t[70],i([0,1,113,17,16,20]),(function(e,t,i,n,r,s){"use strict";function o(e){if(e.isCancellationRequested)throw s.canceled();return!0}function a(e,t){if(null==t?void 0:t.limits){if("number"==typeof t.limits.memory&&e>t.limits.memory)throw r.createFileSystemProviderError(i.localize(0,null),r.FileSystemProviderErrorCode.FileExceedsMemoryLimit)
;if("number"==typeof t.limits.size&&e>t.limits.size)throw r.createFileSystemProviderError(i.localize(1,null),r.FileSystemProviderErrorCode.FileTooLarge)}return!0}Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0,t.readFileIntoStream=async function(e,t,i,s,c,l){let u=void 0;try{await async function(e,t,i,s,c,l){o(l);const u=await e.open(t,{create:!1});o(l);try{let t=0,r=0,h=c&&"number"==typeof c.length?c.length:void 0,d=n.VSBuffer.alloc(Math.min(c.bufferSize,"number"==typeof h?h:c.bufferSize)),f=c&&"number"==typeof c.position?c.position:0,g=0;do{r=await e.read(u,f,d.buffer,g,d.byteLength-g),f+=r,t+=r,"number"==typeof h&&(h-=r),(g+=r)===d.byteLength&&(await i.write(s(d)),d=n.VSBuffer.alloc(Math.min(c.bufferSize,"number"==typeof h?h:c.bufferSize)),g=0)}while(r>0&&("number"!=typeof h||h>0)&&o(l)&&a(t,c));if(g>0){let e=g;"number"==typeof h&&(e=Math.min(g,h)),i.write(s(d.slice(0,e)))}}catch(e){throw r.ensureFileSystemProviderError(e)}finally{await e.close(u)}}(e,t,i,s,c,l)}catch(e){u=e
}finally{u&&c.errorTransformer&&(u=c.errorTransformer(u)),i.end(u)}}})),define(t[71],i([0,1,7,16,6]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0,t.toFileChanges=function(e){return e.map(e=>({type:e.type,resource:i.URI.file(e.path)}))},t.normalizeFileChanges=function(e){const t=new s;for(const i of e)t.processEvent(i);return t.normalize()};class s{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(e){const t=this.mapPathToChange.get(e.path);if(t){const i=t.type,n=e.type;1===i&&2===n?(this.mapPathToChange.delete(e.path),this.normalized.splice(this.normalized.indexOf(t),1)):2===i&&1===n?t.type=0:1===i&&0===n||(t.type=n)}else this.normalized.push(e),this.mapPathToChange.set(e.path,e)}normalize(){const e=[],t=[];return this.normalized.filter(t=>2===t.type||(e.push(t),!1)).sort((e,t)=>e.path.length-t.path.length).filter(e=>!t.some(t=>n.isParent(e.path,t,!r.isLinux))&&(t.push(e.path),!0)).concat(e)}}})),
define(t[142],i([0,1,71,2,21,90,92,9,4]),(function(e,t,i,n,r,s,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class l extends n.Disposable{constructor(e,t,i,n){super(),this.path=e,this.onDidFilesChange=t,this.onLogMessage=i,this.verboseLogging=n,this.fileChangesDelayer=this._register(new a.ThrottledDelayer(2*o.CHANGE_BUFFER_DELAY)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(e){this.verboseLogging=e}async startWatching(){try{const{stat:e,symbolicLink:t}=await r.statLink(this.path);if(this.isDisposed)return;let i=this.path;if(t)try{i=await s.realpath(i)}catch(e){this.onError(e)}e.isDirectory()?this._register(o.watchFolder(i,(e,t)=>{this.onFileChange({type:"changed"===e?0:"added"===e?1:2,path:c.join(this.path,c.basename(t))})},e=>this.onError(e))):this._register(o.watchFile(i,e=>{this.onFileChange({type:"changed"===e?0:2,path:this.path})},e=>this.onError(e)))}catch(e){this.onError(e)}}onFileChange(e){this.fileChangesBuffer.push(e),
this.verboseLogging&&this.onVerbose(`${1===e.type?"[ADDED]":2===e.type?"[DELETED]":"[CHANGED]"} ${e.path}`),this.fileChangesDelayer.trigger(()=>{const e=this.fileChangesBuffer;this.fileChangesBuffer=[];const t=i.normalizeFileChanges(e);return this.verboseLogging&&t.forEach(e=>{this.onVerbose(`>> normalized ${1===e.type?"[ADDED]":2===e.type?"[DELETED]":"[CHANGED]"} ${e.path}`)}),t.length>0&&this.onDidFilesChange(t),Promise.resolve()})}onError(e){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${e}`})}onVerbose(e){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${e}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=l})),define(t[72],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;t.ServiceCollection=class{constructor(...e){this._entries=new Map;for(let[t,i]of e)this.set(t,i)}set(e,t){const i=this._entries.get(e);return this._entries.set(e,t),i}has(e){
return this._entries.has(e)}get(e){return this._entries.get(e)}}})),define(t[143],i([0,1,20,136,67,5,72,9]),(function(e,t,i,n,r,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class l extends Error{constructor(e){super("cyclic dependency between services"),this.message=e.toString()}}class u{constructor(e=new o.ServiceCollection,t=!1,i){this._services=e,this._strict=t,this._parent=i,this._services.set(s.IInstantiationService,this)}createChild(e){return new u(e,this._strict,this)}invokeFunction(e,...t){let n=d.traceInvocation(e),r=!1;try{return e({get:(e,t)=>{if(r)throw i.illegalState("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(e,n);if(!o&&t!==s.optional)throw new Error(`[invokeFunction] unknown service '${e}'`);return o}},...t)}finally{r=!0,n.stop()}}createInstance(e,...t){let i,n;return e instanceof r.SyncDescriptor?(i=d.traceCreation(e.ctor),
n=this._createInstance(e.ctor,e.staticArguments.concat(t),i)):(i=d.traceCreation(e),n=this._createInstance(e,t,i)),i.stop(),n}_createInstance(e,t=[],i){let n=s._util.getServiceDependencies(e).sort((e,t)=>e.index-t.index),r=[];for(const t of n){let n=this._getOrCreateServiceInstance(t.id,i);if(!n&&this._strict&&!t.optional)throw new Error(`[createInstance] ${e.name} depends on UNKNOWN service ${t.id}.`);r.push(n)}let o=n.length>0?n[0].index:t.length;if(t.length!==o){console.warn(`[createInstance] First service dependency of ${e.name} at position ${o+1} conflicts with ${t.length} static arguments`);let i=o-t.length;t=i>0?t.concat(new Array(i)):t.slice(0,o)}return new e(...[...t,...r])}_setServiceInstance(e,t){if(this._services.get(e)instanceof r.SyncDescriptor)this._services.set(e,t);else{if(!this._parent)throw new Error("illegalState - setting UNKNOWN service instance");this._parent._setServiceInstance(e,t)}}_getServiceInstanceOrDescriptor(e){let t=this._services.get(e)
;return!t&&this._parent?this._parent._getServiceInstanceOrDescriptor(e):t}_getOrCreateServiceInstance(e,t){let i=this._getServiceInstanceOrDescriptor(e);return i instanceof r.SyncDescriptor?this._createAndCacheServiceInstance(e,i,t.branch(e,!0)):(t.branch(e,!1),i)}_createAndCacheServiceInstance(e,t,i){const o=new n.Graph(e=>e.id.toString());let a=0;const c=[{id:e,desc:t,_trace:i}];for(;c.length;){const t=c.pop();if(o.lookupOrInsertNode(t),a++>1e3)throw new l(o);for(let i of s._util.getServiceDependencies(t.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(i.id);if(n||i.optional||console.warn(`[createInstance] ${e} depends on ${i.id} which is NOT registered.`),n instanceof r.SyncDescriptor){const e={id:i.id,desc:n,_trace:t._trace.branch(i.id,!0)};o.insertEdge(t,e),c.push(e)}}}for(;;){const e=o.roots();if(0===e.length){if(!o.isEmpty())throw new l(o);break}for(const{data:t}of e){const e=this._createServiceInstanceWithOwner(t.id,t.desc.ctor,t.desc.staticArguments,t.desc.supportsDelayedInstantiation,t._trace)
;this._setServiceInstance(t.id,e),o.removeNode(t)}}return this._getServiceInstanceOrDescriptor(e)}_createServiceInstanceWithOwner(e,t,i=[],n,s){if(this._services.get(e)instanceof r.SyncDescriptor)return this._createServiceInstance(t,i,n,s);if(this._parent)return this._parent._createServiceInstanceWithOwner(e,t,i,n,s);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}_createServiceInstance(e,t=[],i,n){if(i){const i=new a.IdleValue(()=>this._createInstance(e,t,n));return new Proxy(Object.create(null),{get(e,t){if(t in e)return e[t];let n=i.value,r=n[t];return"function"!=typeof r?r:(r=r.bind(n),e[t]=r,r)},set:(e,t,n)=>(i.value[t]=n,!0)})}return this._createInstance(e,t,n)}}var h;t.InstantiationService=u,function(e){e[e.Creation=0]="Creation",e[e.Invocation=1]="Invocation",e[e.Branch=2]="Branch"}(h||(h={}));class d{constructor(e,t){this.type=e,this.name=t,this._start=Date.now(),this._dep=[]}static traceInvocation(e){
return c?new d(1,e.name||e.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(e){return c?new d(0,e.name):d._None}branch(e,t){let i=new d(2,e.toString());return this._dep.push([e,t,i]),i}stop(){let e=Date.now()-this._start;d._totals+=e;let t=!1;let i=[`${0===this.type?"CREATE":"CALL"} ${this.name}`,`${function e(i,n){let r=[],s=new Array(i+1).join("\t");for(const[o,a,c]of n._dep)if(a&&c){t=!0,r.push(`${s}CREATES -> ${o}`);let n=e(i+1,c);n&&r.push(n)}else r.push(`${s}uses -> ${o}`);return r.join("\n")}(1,this)}`,`DONE, took ${e.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(e>2||t)&&console.log(i.join("\n"))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0})),define(t[73],i([0,1,97,2,5]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=r.createDecorator("mainProcessService");class s extends n.Disposable{constructor(e){
super(),this.mainProcessConnection=this._register(new i.Client(`window:${e}`))}getChannel(e){return this.mainProcessConnection.getChannel(e)}registerChannel(e,t){this.mainProcessConnection.registerChannel(e,t)}}t.MainProcessService=s})),define(t[74],i([0,1,5,73,32]),(function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronService=t.IElectronService=void 0,t.IElectronService=i.createDecorator("electronService");let a=class{constructor(e,t){return this.windowId=e,o.createChannelSender(t.getChannel("electron"),{context:e,properties:(()=>{const t=new Map;return t.set("windowId",e),t})()})}};a=r([s(1,n.IMainProcessService)],a),t.ElectronService=a})),define(t[75],i([0,1,5]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=i.createDecorator("localizationsService"),t.isValidLocalization=function(e){if("string"!=typeof e.languageId)return!1
;if(!Array.isArray(e.translations)||0===e.translations.length)return!1;for(const t of e.translations){if("string"!=typeof t.id)return!1;if("string"!=typeof t.path)return!1}return(!e.languageName||"string"==typeof e.languageName)&&(!e.localizedLanguageName||"string"==typeof e.localizedLanguageName)}})),define(t[13],i([0,1,5,2,6,3,48]),(function(e,t,i,n,r,s,o){"use strict";function a(){return(new Date).toISOString()}var c;Object.defineProperty(t,"__esModule",{value:!0}),t.getLogLevel=t.NullLogService=t.DelegatedLogService=t.MultiplexLogService=t.ConsoleLogInMainService=t.LogServiceAdapter=t.ConsoleLogService=t.ConsoleLogMainService=t.AbstractLogService=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=i.createDecorator("logService"),t.ILoggerService=i.createDecorator("loggerService"),function(e){e[e.Trace=0]="Trace",e[e.Debug=1]="Debug",e[e.Info=2]="Info",e[e.Warning=3]="Warning",e[e.Error=4]="Error",e[e.Critical=5]="Critical",e[e.Off=6]="Off"}(c=t.LogLevel||(t.LogLevel={})),
t.DEFAULT_LOG_LEVEL=c.Info;class l extends n.Disposable{constructor(){super(...arguments),this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new s.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogService=l;t.ConsoleLogMainService=class extends l{constructor(e=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(e),this.useColors=!r.isWindows}trace(e,...t){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}debug(e,...t){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}info(e,...t){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}warn(e,...t){
this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${a()}][0m`,e,...t):console.warn(`[main ${a()}]`,e,...t))}error(e,...t){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${a()}][0m`,e,...t):console.error(`[main ${a()}]`,e,...t))}critical(e,...t){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${a()}][0m`,e,...t):console.error(`[main ${a()}]`,e,...t))}dispose(){}flush(){}};t.ConsoleLogService=class extends l{constructor(e=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(e)}trace(e,...t){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...t)}debug(e,...t){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...t)}info(e,...t){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...t)}warn(e,...t){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...t)}error(e,...t){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...t)}critical(e,...t){
this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...t)}dispose(){}flush(){}};class u extends l{constructor(e,i=t.DEFAULT_LOG_LEVEL){super(),this.adapter=e,this.setLevel(i)}trace(e,...t){this.getLevel()<=c.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(e),...t])}debug(e,...t){this.getLevel()<=c.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(e),...t])}info(e,...t){this.getLevel()<=c.Info&&this.adapter.consoleLog("info",[this.extractMessage(e),...t])}warn(e,...t){this.getLevel()<=c.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(e),...t])}error(e,...t){this.getLevel()<=c.Error&&this.adapter.consoleLog("error",[this.extractMessage(e),...t])}critical(e,...t){this.getLevel()<=c.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(e),...t])}extractMessage(e){return"string"==typeof e?e:o.toErrorMessage(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.LogServiceAdapter=u;t.ConsoleLogInMainService=class extends u{
constructor(e,i=t.DEFAULT_LOG_LEVEL){super({consoleLog:(t,i)=>e.consoleLog(t,i)},i)}};t.MultiplexLogService=class extends l{constructor(e){super(),this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const t of this.logServices)t.setLevel(e);super.setLevel(e)}trace(e,...t){for(const i of this.logServices)i.trace(e,...t)}debug(e,...t){for(const i of this.logServices)i.debug(e,...t)}info(e,...t){for(const i of this.logServices)i.info(e,...t)}warn(e,...t){for(const i of this.logServices)i.warn(e,...t)}error(e,...t){for(const i of this.logServices)i.error(e,...t)}critical(e,...t){for(const i of this.logServices)i.critical(e,...t)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}};class h extends n.Disposable{constructor(e){super(),this.logService=e,this._register(e)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(e){this.logService.setLevel(e)}getLevel(){return this.logService.getLevel()}trace(e,...t){
this.logService.trace(e,...t)}debug(e,...t){this.logService.debug(e,...t)}info(e,...t){this.logService.info(e,...t)}warn(e,...t){this.logService.warn(e,...t)}error(e,...t){this.logService.error(e,...t)}critical(e,...t){this.logService.critical(e,...t)}flush(){this.logService.flush()}}t.DelegatedLogService=h;t.NullLogService=class{constructor(){this.onDidChangeLogLevel=(new s.Emitter).event}setLevel(e){}getLevel(){return c.Info}trace(e,...t){}debug(e,...t){}info(e,...t){}warn(e,...t){}error(e,...t){}critical(e,...t){}dispose(){}flush(){}},t.getLogLevel=function(e){if(e.verbose)return c.Trace;if("string"==typeof e.logLevel){switch(e.logLevel.toLowerCase()){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}return t.DEFAULT_LOG_LEVEL}})),define(t[144],i([0,1,2,16,30,8,7,10,36,13,29,76]),(function(e,t,i,n,o,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{
value:!0}),t.ExtensionsDownloader=void 0;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends i.Disposable{constructor(e,t,i,n){super(),this.fileService=t,this.extensionGalleryService=i,this.logService=n,this.extensionsDownloadDir=c.URI.file(e.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(e,t){await this.cleanUpPromise;const i=l.joinPath(this.extensionsDownloadDir,this.getName(e));return await this.download(e,i,t),i}async delete(e){}async download(e,t,i){await this.fileService.exists(t)||await this.extensionGalleryService.download(e,t,i)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir))return void this.logService.trace("Extension VSIX downlads cache dir does not exist");const e=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(e.children){const t=[],i=[];for(const t of e.children){const e=this.parse(t.name);e&&i.push([e,t])}const n=u.groupByExtension(i,([e])=>e.identifier),r=[]
;for(const e of n)e.sort((e,t)=>f.rcompare(e[0].version,t[0].version)),t.push(...e.slice(1).map(e=>e[1].resource)),r.push(e[0][1]);r.sort((e,t)=>e.mtime-t.mtime),t.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(e=>e.resource)),await Promise.all(t.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(e){this.logService.error(e)}}getName(e){return this.cache?new u.ExtensionIdentifierWithVersion(e.identifier,e.version).key().toLowerCase():d.generateUuid()}parse(e){const t=g.exec(e);return t&&t[1]&&t[2]?new u.ExtensionIdentifierWithVersion({id:t[1]},t[2]):null}};p=r([s(0,a.IEnvironmentService),s(1,n.IFileService),s(2,o.IExtensionGalleryService),s(3,h.ILogService)],p),t.ExtensionsDownloader=p})),define(t[145],i([0,1,2,13,44,48,4,9,3,26,21,8]),(function(e,t,i,n,o,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let g=class extends i.Disposable{constructor(e,t){super(),this.environmentService=e,
this.logService=t,this.processesLimiter=new l.Limiter(5)}async postUninstall(e){const t=this.parseScript(e,"uninstall");return t&&(this.logService.info(e.identifier.id,e.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(t.script,"uninstall",t.args,!0,e).then(()=>this.logService.info(e.identifier.id,e.manifest.version,"Finished running post uninstall script"),t=>this.logService.error(e.identifier.id,e.manifest.version,`Failed to run post uninstall script: ${t}`)))),d.rimraf(this.getExtensionStoragePath(e)).then(void 0,e=>this.logService.error("Error while removing extension storage path",e))}parseScript(e,t){const i=`vscode:${t}`;if(e.location.scheme===h.Schemas.file&&e.manifest&&e.manifest.scripts&&"string"==typeof e.manifest.scripts[i]){const t=e.manifest.scripts[i].split(" ");return t.length<2||"node"!==t[0]||!t[1]?(this.logService.warn(e.identifier.id,e.manifest.version,`${i} should be a node script`),null):{script:c.join(e.location.fsPath,t[1]),
args:t.slice(2)||[]}}return null}runLifecycleHook(e,t,i,n,r){return new Promise((s,o)=>{const c=this.start(e,t,i,r);let l;const u=e=>{l&&(clearTimeout(l),l=null),e?o(e):s(void 0)};c.on("error",e=>{u(a.toErrorMessage(e)||"Unknown")}),c.on("exit",(e,i)=>{u(e?`post-${t} process exited with code ${e}`:void 0)}),n&&(l=setTimeout(()=>{l=null,c.kill(),o("timed out")},5e3))})}start(e,t,i,n){const r={silent:!0,execArgv:void 0},s=o.fork(e,[`--type=extension-post-${t}`,...i],r);s.stdout.setEncoding("utf8"),s.stderr.setEncoding("utf8");const a=u.Event.fromNodeEventEmitter(s.stdout,"data"),c=u.Event.fromNodeEventEmitter(s.stderr,"data");a(e=>this.logService.info(n.identifier.id,n.manifest.version,`post-${t}`,e)),c(e=>this.logService.error(n.identifier.id,n.manifest.version,`post-${t}`,e));const l=u.Event.any(u.Event.map(a,e=>({data:`%c${e}`,format:[""]})),u.Event.map(c,e=>({data:`%c${e}`,format:["color: red"]})));return u.Event.debounce(l,(e,t)=>e?{data:e.data+t.data,format:[...e.format,...t.format]}:{data:t.data,
format:t.format},100)(e=>{console.group(n.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),s}getExtensionStoragePath(e){return c.join(this.environmentService.globalStorageHome.fsPath,e.identifier.id.toLowerCase())}};g=r([s(0,f.IEnvironmentService),s(1,n.ILogService)],g),t.ExtensionsLifecycle=g})),define(t[146],i([0,1,2,16,3,10,111,34,15,62,13,17,51,9,27,26,70]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let S=class extends i.Disposable{constructor(e){super(),this.logService=e,this.BUFFER_SIZE=65536,this._onDidChangeFileSystemProviderRegistrations=this._register(new o.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new o.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new o.Emitter),
this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new o.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new o.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new o.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueues=new Map}registerProvider(e,t){if(this.provider.has(e))throw new Error(`A filesystem provider for the scheme '${e}' is already registered.`);this.provider.set(e,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:e,provider:t});const r=new i.DisposableStore;return r.add(t.onDidChangeFile(e=>this._onDidFilesChange.fire(new n.FileChangesEvent(e,this.getExtUri(t).extUri)))),r.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:e}))),
"function"==typeof t.onDidErrorOccur&&r.add(t.onDidErrorOccur(e=>this._onError.fire(new Error(e)))),i.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:e,provider:t}),this.provider.delete(e),i.dispose(r)})}async activateProvider(e){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:e,join(e){e&&t.push(e)}}),this.provider.has(e)||await Promise.all(t)}canHandleResource(e){return this.provider.has(e.scheme)}hasCapability(e,t){const i=this.provider.get(e.scheme);return!!(i&&i.capabilities&t)}async withProvider(e){if(!a.isAbsolutePath(e))throw new n.FileOperationError(c.localize(0,null,this.resourceForError(e)),8);await this.activateProvider(e.scheme);const t=this.provider.get(e.scheme);if(!t){const t=new Error;throw t.name="ENOPRO",t.message=c.localize(1,null,e.toString()),t}return t}async withReadProvider(e){const t=await this.withProvider(e);if(n.hasOpenReadWriteCloseCapability(t)||n.hasReadWriteCapability(t)||n.hasFileReadStreamCapability(t))return t
;throw new Error(`Filesystem provider for scheme '${e.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(e){const t=await this.withProvider(e);if(n.hasOpenReadWriteCloseCapability(t)||n.hasReadWriteCapability(t))return t;throw new Error(`Filesystem provider for scheme '${e.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(e,t){try{return await this.doResolveFile(e,t)}catch(t){if(n.toFileSystemProviderErrorCode(t)===n.FileSystemProviderErrorCode.FileNotFound)throw new n.FileOperationError(c.localize(2,null,this.resourceForError(e)),1);throw n.ensureFileSystemProviderError(t)}}async doResolveFile(e,t){const i=await this.withProvider(e),n=null==t?void 0:t.resolveTo,r=null==t?void 0:t.resolveSingleChildDescendants,s=null==t?void 0:t.resolveMetadata,o=await i.stat(e);let a
;return this.toFileStat(i,e,o,void 0,!!s,(t,i)=>(a||((a=l.TernarySearchTree.forUris()).set(e,!0),u.isNonEmptyArray(n)&&n.forEach(e=>a.set(e,!0))),!!Boolean(a.findSuperstr(t.resource)||a.get(t.resource))||!(!t.isDirectory||!r)&&1===i))}async toFileStat(e,t,i,r,s,o){const c={resource:t,name:h.getBaseLabel(t),isFile:0!=(i.type&n.FileType.File),isDirectory:0!=(i.type&n.FileType.Directory),isSymbolicLink:0!=(i.type&n.FileType.SymbolicLink),mtime:i.mtime,ctime:i.ctime,size:i.size,etag:n.etag({mtime:i.mtime,size:i.size})};if(c.isDirectory&&o(c,r)){try{const i=await e.readdir(t),n=await Promise.all(i.map(async([n,r])=>{try{const c=a.joinPath(t,n),l=s?await e.stat(c):{type:r};return await this.toFileStat(e,c,l,i.length,s,o)}catch(e){return this.logService.trace(e),null}}));c.children=u.coalesce(n)}catch(e){this.logService.trace(e),c.children=[]}return c}return c}async resolveAll(e){return Promise.all(e.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(e){
return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(e){const t=await this.withProvider(e);try{return!!await t.stat(e)}catch(e){return!1}}async canCreateFile(e,t){try{await this.doValidateCreateFile(e,t)}catch(e){return e}return!0}async doValidateCreateFile(e,t){if(!(null==t?void 0:t.overwrite)&&await this.exists(e))throw new n.FileOperationError(c.localize(3,null,this.resourceForError(e)),3,t)}async createFile(e,t=f.VSBuffer.fromString(""),i){await this.doValidateCreateFile(e,i);const r=await this.writeFile(e,t);return this._onDidRunOperation.fire(new n.FileOperationEvent(e,0,r)),r}async writeFile(e,t,i){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);try{let s;if(await this.validateWriteFile(r,e,i)||await this.mkdirp(r,a.dirname(e)),!n.hasReadWriteCapability(r)||t instanceof f.VSBuffer)s=t;else if(g.isReadableStream(t)){const e=await g.peekStream(t,3);s=e.ended?f.VSBuffer.concat(e.buffer):e}else s=g.peekReadable(t,e=>f.VSBuffer.concat(e),3)
;!n.hasOpenReadWriteCloseCapability(r)||n.hasReadWriteCapability(r)&&s instanceof f.VSBuffer?await this.doWriteUnbuffered(r,e,s):await this.doWriteBuffered(r,e,s instanceof f.VSBuffer?f.bufferToReadable(s):s)}catch(t){throw new n.FileOperationError(c.localize(4,null,this.resourceForError(e),n.ensureFileSystemProviderError(t).toString()),n.toFileOperationResult(t),i)}return this.resolve(e,{resolveMetadata:!0})}async validateWriteFile(e,t,i){let r=void 0;try{r=await e.stat(t)}catch(e){return}if(0!=(r.type&n.FileType.Directory))throw new n.FileOperationError(c.localize(5,null,this.resourceForError(t)),0,i);if(i&&"number"==typeof i.mtime&&"string"==typeof i.etag&&i.etag!==n.ETAG_DISABLED&&"number"==typeof r.mtime&&"number"==typeof r.size&&i.mtime<r.mtime&&i.etag!==n.etag({mtime:i.mtime,size:r.size}))throw new n.FileOperationError(c.localize(6,null),3,i);return r}async readFile(e,t){const i=await this.withReadProvider(e),n=await this.doReadAsFileStream(i,e,Object.assign(Object.assign({},t),{preferUnbuffered:!0}))
;return Object.assign(Object.assign({},n),{value:await f.streamToBuffer(n.value)})}async readFileStream(e,t){const i=await this.withReadProvider(e);return this.doReadAsFileStream(i,e,t)}async doReadAsFileStream(e,t,i){const r=new m.CancellationTokenSource,s=this.validateReadFile(t,i).then(e=>e,e=>{throw r.cancel(),e});try{let o;i&&"string"==typeof i.etag&&i.etag!==n.ETAG_DISABLED&&await s,o=!n.hasOpenReadWriteCloseCapability(e)&&!n.hasFileReadStreamCapability(e)||n.hasReadWriteCapability(e)&&(null==i?void 0:i.preferUnbuffered)?this.readFileUnbuffered(e,t,i):n.hasFileReadStreamCapability(e)?Promise.resolve(this.readFileStreamed(e,t,r.token,i)):Promise.resolve(this.readFileBuffered(e,t,r.token,i));const[a,c]=await Promise.all([s,o]);return Object.assign(Object.assign({},a),{value:c})}catch(e){throw new n.FileOperationError(c.localize(7,null,this.resourceForError(t),n.ensureFileSystemProviderError(e).toString()),n.toFileOperationResult(e),i)}}readFileStreamed(e,t,i,r=Object.create(null)){
const s=e.readFileStream(t,r,i);return g.transform(s,{data:e=>e instanceof f.VSBuffer?e:f.VSBuffer.wrap(e),error:e=>new n.FileOperationError(c.localize(8,null,this.resourceForError(t),n.ensureFileSystemProviderError(e).toString()),n.toFileOperationResult(e),r)},e=>f.VSBuffer.concat(e))}readFileBuffered(e,t,i,r=Object.create(null)){const s=f.newWriteableBufferStream();return y.readFileIntoStream(e,t,s,e=>e,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:e=>new n.FileOperationError(c.localize(9,null,this.resourceForError(t),n.ensureFileSystemProviderError(e).toString()),n.toFileOperationResult(e),r)}),i),s}async readFileUnbuffered(e,t,i){let n=await e.readFile(t);return i&&"number"==typeof i.position&&(n=n.slice(i.position)),i&&"number"==typeof i.length&&(n=n.slice(0,i.length)),this.validateReadFileLimits(t,n.byteLength,i),f.bufferToStream(f.VSBuffer.wrap(n))}async validateReadFile(e,t){const i=await this.resolve(e,{resolveMetadata:!0})
;if(i.isDirectory)throw new n.FileOperationError(c.localize(10,null,this.resourceForError(e)),0,t);if(t&&"string"==typeof t.etag&&t.etag!==n.ETAG_DISABLED&&t.etag===i.etag)throw new n.FileOperationError(c.localize(11,null),2,t);return this.validateReadFileLimits(e,i.size,t),i}validateReadFileLimits(e,t,i){if(null==i?void 0:i.limits){let r=void 0;if("number"==typeof i.limits.memory&&t>i.limits.memory&&(r=9),"number"==typeof i.limits.size&&t>i.limits.size&&(r=7),"number"==typeof r)throw new n.FileOperationError(c.localize(12,null,this.resourceForError(e)),r)}}async canMove(e,t,i){return this.doCanMoveCopy(e,t,"move",i)}async canCopy(e,t,i){return this.doCanMoveCopy(e,t,"copy",i)}async doCanMoveCopy(e,t,i,n){if(e.toString()!==t.toString())try{const r="move"===i?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e):await this.withReadProvider(e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(r,e,s,t,i,n)}catch(e){return e}return!0}
async move(e,t,i){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(r,e,s,t,"move",!!i),a=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new n.FileOperationEvent(e,"move"===o?2:3,a)),a}async copy(e,t,i){const r=await this.withReadProvider(e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(r,e,s,t,"copy",!!i),a=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new n.FileOperationEvent(e,"copy"===o?3:2,a)),a}async doMoveCopy(e,t,i,r,s,o){if(t.toString()===r.toString())return s;const{exists:c,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(e,t,i,r,s,o);if(c&&!l&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(i,a.dirname(r)),"copy"===s){if(e===i&&n.hasFileFolderCopyCapability(e))await e.copy(t,r,{overwrite:o});else{const n=await this.resolve(t)
;n.isDirectory?await this.doCopyFolder(e,n,i,r):await this.doCopyFile(e,t,i,r)}return s}return e===i?(await e.rename(t,r,{overwrite:o}),s):(await this.doMoveCopy(e,t,i,r,"copy",o),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(e,t,i,r){return n.hasOpenReadWriteCloseCapability(e)&&n.hasOpenReadWriteCloseCapability(i)?this.doPipeBuffered(e,t,i,r):n.hasOpenReadWriteCloseCapability(e)&&n.hasReadWriteCapability(i)?this.doPipeBufferedToUnbuffered(e,t,i,r):n.hasReadWriteCapability(e)&&n.hasOpenReadWriteCloseCapability(i)?this.doPipeUnbufferedToBuffered(e,t,i,r):n.hasReadWriteCapability(e)&&n.hasReadWriteCapability(i)?this.doPipeUnbuffered(e,t,i,r):void 0}async doCopyFolder(e,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await Promise.all(t.children.map(async t=>{const r=a.joinPath(n,t.name);return t.isDirectory?this.doCopyFolder(e,await this.resolve(t.resource),i,r):this.doCopyFile(e,t.resource,i,r)}))}async doValidateMoveCopy(e,t,i,r,s,o){let a=!1;if(e===i){
const{extUri:i,isPathCaseSensitive:n}=this.getExtUri(e);if(n||(a=i.isEqual(t,r)),a&&"copy"===s)throw new Error(c.localize(13,null,this.resourceForError(t),this.resourceForError(r)));if(!a&&i.isEqualOrParent(r,t))throw new Error(c.localize(14,null,this.resourceForError(t),this.resourceForError(r)))}const l=await this.exists(r);if(l&&!a){if(!o)throw new n.FileOperationError(c.localize(15,null,this.resourceForError(t),this.resourceForError(r)),4);if(e===i){const{extUri:i}=this.getExtUri(e);if(i.isEqualOrParent(t,r))throw new Error(c.localize(16,null,this.resourceForError(t),this.resourceForError(r)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(e){const t=!!(1024&e.capabilities);return{extUri:t?a.extUri:a.extUriIgnorePathCase,isPathCaseSensitive:t}}async createFolder(e){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(e),e);await this.mkdirp(t,e);const i=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new n.FileOperationEvent(e,0,i)),i}
async mkdirp(e,t){const i=[],{extUri:r}=this.getExtUri(e);for(;!r.isEqual(t,a.dirname(t));)try{if(0==((await e.stat(t)).type&n.FileType.Directory))throw new Error(c.localize(17,null,this.resourceForError(t)));break}catch(e){if(n.toFileSystemProviderErrorCode(e)!==n.FileSystemProviderErrorCode.FileNotFound)throw e;i.push(a.basename(t)),t=a.dirname(t)}for(let r=i.length-1;r>=0;r--){t=a.joinPath(t,i[r]);try{await e.mkdir(t)}catch(e){if(n.toFileSystemProviderErrorCode(e)!==n.FileSystemProviderErrorCode.FileExists)throw e}}}async canDelete(e,t){try{await this.doValidateDelete(e,t)}catch(e){return e}return!0}async doValidateDelete(e,t){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(e),e);if(!!(null==t?void 0:t.useTrash)&&!(4096&i.capabilities))throw new Error(c.localize(18,null,this.resourceForError(e)));const r=await this.exists(e);if(!r)throw new n.FileOperationError(c.localize(19,null,this.resourceForError(e)),1);if(!!!(null==t?void 0:t.recursive)&&r){const t=await this.resolve(e)
;if(t.isDirectory&&Array.isArray(t.children)&&t.children.length>0)throw new Error(c.localize(20,null,this.resourceForError(e)))}return i}async del(e,t){const i=await this.doValidateDelete(e,t),r=!!(null==t?void 0:t.useTrash),s=!!(null==t?void 0:t.recursive);await i.delete(e,{recursive:s,useTrash:r}),this._onDidRunOperation.fire(new n.FileOperationEvent(e,1))}watch(e,t={recursive:!1,excludes:[]}){let n=!1,r=i.toDisposable(()=>n=!0);return this.doWatch(e,t).then(e=>{n?i.dispose(e):r=e},e=>this.logService.error(e)),i.toDisposable(()=>i.dispose(r))}async doWatch(e,t){const n=await this.withProvider(e),r=this.toWatchKey(n,e,t),s=this.activeWatchers.get(r)||{count:0,disposable:n.watch(e,t)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,s),s.count+=1,i.toDisposable(()=>{s.count--,0===s.count&&(i.dispose(s.disposable),this.activeWatchers.delete(r))})}toWatchKey(e,t,i){const{extUri:n}=this.getExtUri(e);return[n.getComparisonKey(t),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose(),
this.activeWatchers.forEach(e=>i.dispose(e.disposable)),this.activeWatchers.clear()}ensureWriteQueue(e,t){const{extUri:n}=this.getExtUri(e),r=n.getComparisonKey(t);let s=this.writeQueues.get(r);if(!s){s=new p.Queue,this.writeQueues.set(r,s),o.Event.once(s.onFinished)(()=>{this.writeQueues.delete(r),i.dispose(s)})}return s}async doWriteBuffered(e,t,i){return this.ensureWriteQueue(e,t).queue(async()=>{const r=await e.open(t,{create:!0});try{g.isReadableStream(i)||g.isReadableBufferedStream(i)?await this.doWriteStreamBufferedQueued(e,r,i):await this.doWriteReadableBufferedQueued(e,r,i)}catch(e){throw n.ensureFileSystemProviderError(e)}finally{await e.close(r)}})}async doWriteStreamBufferedQueued(e,t,i){let n,r=0;if(g.isReadableBufferedStream(i)){if(i.buffer.length>0){const n=f.VSBuffer.concat(i.buffer);await this.doWriteBuffer(e,t,n,n.byteLength,r,0),r+=n.byteLength}if(i.ended)return;n=i.stream}else n=i;return new Promise(async(i,s)=>{n.on("data",async i=>{n.pause();try{
await this.doWriteBuffer(e,t,i,i.byteLength,r,0)}catch(e){return s(e)}r+=i.byteLength,setTimeout(()=>n.resume())}),n.on("error",e=>s(e)),n.on("end",()=>i())})}async doWriteReadableBufferedQueued(e,t,i){let n,r=0;for(;null!==(n=i.read());)await this.doWriteBuffer(e,t,n,n.byteLength,r,0),r+=n.byteLength}async doWriteBuffer(e,t,i,n,r,s){let o=0;for(;o<n;){o+=await e.write(t,r+o,i.buffer,s+o,n-o)}}async doWriteUnbuffered(e,t,i){return this.ensureWriteQueue(e,t).queue(()=>this.doWriteUnbufferedQueued(e,t,i))}async doWriteUnbufferedQueued(e,t,i){let n;n=i instanceof f.VSBuffer?i:g.isReadableStream(i)?await f.streamToBuffer(i):g.isReadableBufferedStream(i)?await f.bufferedStreamToBuffer(i):f.readableToBuffer(i),await e.writeFile(t,n.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(e,t,i,n){return this.ensureWriteQueue(i,n).queue(()=>this.doPipeBufferedQueued(e,t,i,n))}async doPipeBufferedQueued(e,t,i,r){let s=void 0,o=void 0;try{s=await e.open(t,{create:!1}),o=await i.open(r,{create:!0})
;const n=f.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,c=0,l=0;do{l=await e.read(s,a,n.buffer,c,n.byteLength-c),await this.doWriteBuffer(i,o,n,l,a,c),a+=l,(c+=l)===n.byteLength&&(c=0)}while(l>0)}catch(e){throw n.ensureFileSystemProviderError(e)}finally{await Promise.all(["number"==typeof s?e.close(s):Promise.resolve(),"number"==typeof o?i.close(o):Promise.resolve()])}}async doPipeUnbuffered(e,t,i,n){return this.ensureWriteQueue(i,n).queue(()=>this.doPipeUnbufferedQueued(e,t,i,n))}async doPipeUnbufferedQueued(e,t,i,n){return i.writeFile(n,await e.readFile(t),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(e,t,i,n){return this.ensureWriteQueue(i,n).queue(()=>this.doPipeUnbufferedToBufferedQueued(e,t,i,n))}async doPipeUnbufferedToBufferedQueued(e,t,i,r){const s=await i.open(r,{create:!0});try{const n=await e.readFile(t);await this.doWriteBuffer(i,s,f.VSBuffer.wrap(n),n.byteLength,0,0)}catch(e){throw n.ensureFileSystemProviderError(e)}finally{await i.close(s)}}async doPipeBufferedToUnbuffered(e,t,i,n){
const r=await f.streamToBuffer(this.readFileBuffered(e,t,m.CancellationToken.None));await this.doWriteUnbuffered(i,n,r)}throwIfFileSystemIsReadonly(e,t){if(2048&e.capabilities)throw new n.FileOperationError(c.localize(21,null,this.resourceForError(t)),6);return e}resourceForError(e){return e.scheme===v.Schemas.file?e.fsPath:e.toString(!0)}};S=r([s(0,d.ILogService)],S),t.FileService=S})),define(t[147],i([0,1,35,52,2,16,3,6,21,4,10,39,9,13,114,71,133,135,131,142,51,70,15,17]),(function(e,t,i,n,r,s,o,a,c,l,u,h,d,f,g,p,m,v,y,S,w,E,C,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class b extends r.Disposable{constructor(e,t){var i;super(),this.logService=e,this.options=t,this.BUFFER_SIZE=(null===(i=this.options)||void 0===i?void 0:i.bufferSize)||65536,this.onDidChangeCapabilities=o.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new o.Emitter),
this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new o.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new d.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=30,a.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:t,symbolicLink:i}=await c.statLink(this.toFilePath(e));return{type:this.toType(t,i),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(e){throw this.toFileSystemProviderError(e)}}async readdir(e){try{const t=await c.readdirWithFileTypes(this.toFilePath(e)),i=[];return await Promise.all(t.map(async t=>{try{let n;n=t.isSymbolicLink()?(await this.stat(u.joinPath(e,t.name))).type:this.toType(t),i.push([t.name,n])}catch(e){this.logService.trace(e)}})),i}catch(e){throw this.toFileSystemProviderError(e)}}toType(e,t){let i
;return i=(null==t?void 0:t.dangling)?s.FileType.Unknown:e.isFile()?s.FileType.File:e.isDirectory()?s.FileType.Directory:s.FileType.Unknown,t&&(i|=s.FileType.SymbolicLink),i}async readFile(e){try{const t=this.toFilePath(e);return await c.readFile(t)}catch(e){throw this.toFileSystemProviderError(e)}}readFileStream(e,t,i){const n=w.newWriteableStream(e=>_.VSBuffer.concat(e.map(e=>_.VSBuffer.wrap(e))).buffer);return E.readFileIntoStream(this,e,n,e=>e.buffer,Object.assign(Object.assign({},t),{bufferSize:this.BUFFER_SIZE}),i),n}async writeFile(e,t,i){let n=void 0;try{const r=this.toFilePath(e);if(!i.create||!i.overwrite){if(await c.exists(r)){if(!i.overwrite)throw s.createFileSystemProviderError(g.localize(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw s.createFileSystemProviderError(g.localize(1,null),s.FileSystemProviderErrorCode.FileNotFound)}n=await this.open(e,{create:!0}),await this.write(n,0,t,0,t.byteLength)}catch(e){throw this.toFileSystemProviderError(e)}finally{
"number"==typeof n&&await this.close(n)}}async open(e,t){try{const r=this.toFilePath(e);let s=void 0;if(t.create){if(a.isWindows&&await c.exists(r))try{await c.truncate(r,0),s="r+"}catch(e){this.logService.trace(e)}s||(s="w")}else s="r";const o=await n.promisify(i.open)(r,s);return this.mapHandleToPos.set(o,0),t.create&&this.writeHandles.add(o),o}catch(e){throw this.toFileSystemProviderError(e)}}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await n.promisify(i.fdatasync)(e)}catch(e){this.canFlush=!1,this.logService.error(e)}return await n.promisify(i.close)(e)}catch(e){throw this.toFileSystemProviderError(e)}}async read(e,t,r,s,o){const a=this.normalizePos(e,t);let c=null;try{const t=await n.promisify(i.read)(e,r,s,o,a);return c="number"==typeof t?t:t.bytesRead}catch(e){throw this.toFileSystemProviderError(e)}finally{this.updatePos(e,a,c)}}normalizePos(e,t){return t===this.mapHandleToPos.get(e)?null:t}updatePos(e,t,i){const n=this.mapHandleToPos.get(e)
;"number"==typeof n&&("number"==typeof t||("number"==typeof i?this.mapHandleToPos.set(e,n+i):this.mapHandleToPos.delete(e)))}async write(e,t,i,n,r){return d.retry(()=>this.doWrite(e,t,i,n,r),100,3)}async doWrite(e,t,r,s,o){const a=this.normalizePos(e,t);let c=null;try{const t=await n.promisify(i.write)(e,r,s,o,a);return c="number"==typeof t?t:t.bytesWritten}catch(e){throw this.toFileSystemProviderError(e)}finally{this.updatePos(e,a,c)}}async mkdir(e){try{await n.promisify(i.mkdir)(this.toFilePath(e))}catch(e){throw this.toFileSystemProviderError(e)}}async delete(e,t){try{const i=this.toFilePath(e);await this.doDelete(i,t)}catch(e){throw this.toFileSystemProviderError(e)}}async doDelete(e,t){t.recursive?await c.rimraf(e,c.RimRafMode.MOVE):await c.unlink(e)}async rename(e,t,i){const n=this.toFilePath(e),r=this.toFilePath(t);if(n!==r)try{await this.validateTargetDeleted(e,t,"move",i.overwrite),await c.move(n,r)}catch(e){
throw"EINVAL"!==e.code&&"EBUSY"!==e.code&&"ENAMETOOLONG"!==e.code||(e=new Error(g.localize(2,null,l.basename(n),l.basename(l.dirname(r)),e.toString()))),this.toFileSystemProviderError(e)}}async copy(e,t,i){const n=this.toFilePath(e),r=this.toFilePath(t);if(n!==r)try{await this.validateTargetDeleted(e,t,"copy",i.overwrite),await c.copy(n,r)}catch(e){throw"EINVAL"!==e.code&&"EBUSY"!==e.code&&"ENAMETOOLONG"!==e.code||(e=new Error(g.localize(3,null,l.basename(n),l.basename(l.dirname(r)),e.toString()))),this.toFileSystemProviderError(e)}}async validateTargetDeleted(e,t,i,n){const r=this.toFilePath(e),o=this.toFilePath(t);let a=!1;if(!!(1024&this.capabilities)||(a=h.isEqual(r,o,!0)),a&&"copy"===i)throw s.createFileSystemProviderError(g.localize(4,null),s.FileSystemProviderErrorCode.FileExists);if(!a&&await c.exists(o)){if(!n)throw s.createFileSystemProviderError(g.localize(5,null),s.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}watch(e,t){
return t.recursive?this.watchRecursive(e,t.excludes):this.watchNonRecursive(e)}watchRecursive(e,t){const i={path:this.toFilePath(e),excludes:t},n=C.insert(this.recursiveFoldersToWatch,i);return this.refreshRecursiveWatchers(),r.toDisposable(()=>{n(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var e,t,i;if(this.recursiveWatcher instanceof y.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(r.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,r=void 0;(null===(t=null===(e=this.options)||void 0===e?void 0:e.watcher)||void 0===t?void 0:t.usePolling)?(n=m.FileWatcher,r=null===(i=this.options)||void 0===i?void 0:i.watcher):n=1===this.recursiveFoldersToWatch.length?a.isWindows?v.FileWatcher:m.FileWatcher:y.FileWatcher,
this.recursiveWatcher=new n(this.recursiveFoldersToWatch,e=>this._onDidChangeFile.fire(p.toFileChanges(e)),e=>{"error"===e.type&&this._onDidWatchErrorOccur.fire(e.message),this.logService[e.type](e.message)},this.logService.getLevel()===f.LogLevel.Trace,r),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))}}watchNonRecursive(e){const t=new S.FileWatcher(this.toFilePath(e),e=>this._onDidChangeFile.fire(p.toFileChanges(e)),e=>{"error"===e.type&&this._onDidWatchErrorOccur.fire(e.message),this.logService[e.type](e.message)},this.logService.getLevel()===f.LogLevel.Trace),i=this.logService.onDidChangeLogLevel(()=>{t.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return r.combinedDisposable(t,i)}toFilePath(e){return l.normalize(e.fsPath)}toFileSystemProviderError(e){if(e instanceof s.FileSystemProviderError)return e
;let t;switch(e.code){case"ENOENT":t=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=s.FileSystemProviderErrorCode.NoPermissions;break;default:t=s.FileSystemProviderErrorCode.Unknown}return s.createFileSystemProviderError(e,t)}dispose(){super.dispose(),r.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,r.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=b})),define(t[148],i([0,1,21,149,30,2,8,9,36,13,75,15,3,26,4]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let v=class extends a.Disposable{constructor(e,t,i){super(),this.extensionManagementService=e,this.logService=i,
this._onDidLanguagesChange=this._register(new g.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new y(t,i)),this._register(e.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(e.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(e=>{const t=["en",...Object.keys(e)];return f.distinct(t)})}onDidInstallExtension(e){e&&e.manifest&&e.manifest.contributes&&e.manifest.contributes.localizations&&e.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",e.identifier.id),this.update().then(e=>{e&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(e){this.cache.getLanguagePacks().then(t=>{Object.keys(t).some(i=>t[i]&&t[i].extensions.some(t=>u.areSameExtensions(t.extensionIdentifier,e)))&&(this.logService.debug("Removing language packs from the extension",e.id),this.update().then(e=>{
e&&this._onDidLanguagesChange.fire()}))})}update(){return Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]).then(([e,t])=>this.cache.update(t).then(t=>!f.equals(Object.keys(e),Object.keys(t))))}};v=r([s(0,o.IExtensionManagementService),s(1,c.IEnvironmentService),s(2,h.ILogService)],v),t.LocalizationsService=v;let y=class extends a.Disposable{constructor(e,t){super(),this.logService=t,this.languagePacks={},this.languagePacksFilePath=m.join(e.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new l.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(e){return this.withLanguagePacks(t=>{Object.keys(t).forEach(e=>delete t[e]),this.createLanguagePacksFromExtensions(t,...e)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(e,...t){
for(const i of t)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(e,i);Object.keys(e).forEach(t=>this.updateHash(e[t]))}createLanguagePacksFromExtension(e,t){const i=t.identifier,n=t.manifest.contributes&&t.manifest.contributes.localizations?t.manifest.contributes.localizations:[];for(const r of n)if(t.location.scheme===p.Schemas.file&&d.isValidLocalization(r)){let n=e[r.languageId];n||(n={hash:"",extensions:[],translations:{}},e[r.languageId]=n);let s=n.extensions.filter(e=>u.areSameExtensions(e.extensionIdentifier,i))[0];s?s.version=t.manifest.version:n.extensions.push({extensionIdentifier:i,version:t.manifest.version});for(const e of r.translations)n.translations[e.id]=m.join(t.location.fsPath,e.path)}}updateHash(e){if(e){const t=n.createHash("md5");for(const i of e.extensions)t.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);e.hash=t.digest("hex")}}
withLanguagePacks(e=(()=>null)){return this.languagePacksFileLimiter.queue(()=>{let t=null;return i.readFile(this.languagePacksFilePath,"utf8").then(void 0,e=>"ENOENT"===e.code?Promise.resolve("{}"):Promise.reject(e)).then(e=>{try{return JSON.parse(e)}catch(e){return{}}}).then(i=>(t=e(i),i)).then(e=>{for(const t of Object.keys(e))e[t]||delete e[t];this.languagePacks=e,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),i.writeFile(this.languagePacksFilePath,t)}).then(()=>t,e=>this.logService.error(e))})}};y=r([s(0,c.IEnvironmentService),s(1,h.ILogService)],y)})),define(t[150],i([0,1,13]),(function(e,t,i){"use strict";function n(e,t){switch(t){case i.LogLevel.Trace:return e.trace;case i.LogLevel.Debug:return e.debug;case i.LogLevel.Info:return e.info;case i.LogLevel.Warning:return e.warn;case i.LogLevel.Error:return e.error;case i.LogLevel.Critical:return e.critical;default:throw new Error("Invalid log level")}}
Object.defineProperty(t,"__esModule",{value:!0}),t.BufferLogService=void 0;class r extends i.AbstractLogService{constructor(e=i.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(e),this._register(this.onDidChangeLogLevel(e=>{this._logger&&this._logger.setLevel(e)}))}set logger(e){this._logger=e;for(const{level:t,args:i}of this.buffer){n(e,t).apply(e,i)}this.buffer=[]}_log(e,...t){if(this._logger){n(this._logger,e).apply(this._logger,t)}else this.getLevel()<=e&&this.buffer.push({level:e,args:t})}trace(e,...t){this._log(i.LogLevel.Trace,e,...t)}debug(e,...t){this._log(i.LogLevel.Debug,e,...t)}info(e,...t){this._log(i.LogLevel.Info,e,...t)}warn(e,...t){this._log(i.LogLevel.Warning,e,...t)}error(e,...t){this._log(i.LogLevel.Error,e,...t)}critical(e,...t){this._log(i.LogLevel.Critical,e,...t)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}t.BufferLogService=r})),define(t[151],i([0,1,13,16,9,17,10,2,5,150]),(function(e,t,i,n,o,a,c,l,u,h){
"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileLoggerService=t.FileLogService=void 0;let d=class extends i.AbstractLogService{constructor(e,t,i,n){super(),this.name=e,this.resource=t,this.fileService=n,this.backupIndex=1,this.setLevel(i),this.queue=this._register(new o.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=i.LogLevel.Trace&&this._log(i.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=i.LogLevel.Debug&&this._log(i.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=i.LogLevel.Info&&this._log(i.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=i.LogLevel.Warning&&this._log(i.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=i.LogLevel.Error){const e=arguments[0];if(e instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=e.stack,this._log(i.LogLevel.Error,this.format(t))}else this._log(i.LogLevel.Error,this.format(arguments))}}critical(){
this.getLevel()<=i.LogLevel.Critical&&this._log(i.LogLevel.Critical,this.format(arguments))}flush(){}log(e,t){this._log(e,this.format(t))}async initialize(){await this.fileService.createFile(this.resource)}_log(e,t){this.queue.queue(async()=>{await this.initializePromise;let i=await this.loadContent();i.length>5242880&&(await this.fileService.writeFile(this.getBackupResource(),a.VSBuffer.fromString(i)),i=""),i+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(e)}] ${t}\n`,await this.fileService.writeFile(this.resource,a.VSBuffer.fromString(i))})}getCurrentTimestamp(){const e=e=>e<10?`0${e}`:e,t=new Date;return`${t.getFullYear()}-${e(t.getMonth()+1)}-${e(t.getDate())} ${e(t.getHours())}:${e(t.getMinutes())}:${e(t.getSeconds())}.${(e=>e<10?`00${e}`:e<100?`0${e}`:e)(t.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,c.joinPath(c.dirname(this.resource),`${c.basename(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{
return(await this.fileService.readFile(this.resource)).value.toString()}catch(e){return""}}stringifyLogLevel(e){switch(e){case i.LogLevel.Critical:return"critical";case i.LogLevel.Debug:return"debug";case i.LogLevel.Error:return"error";case i.LogLevel.Info:return"info";case i.LogLevel.Trace:return"trace";case i.LogLevel.Warning:return"warning"}return""}format(e){let t="";for(let i=0;i<e.length;i++){let n=e[i];if("object"==typeof n)try{n=JSON.stringify(n)}catch(e){}t+=(i>0?" ":"")+n}return t}};d=r([s(3,n.IFileService)],d),t.FileLogService=d;let f=class extends l.Disposable{constructor(e,t,i){super(),this.logService=e,this.instantiationService=t,this.fileService=i,this.loggers=new Map,this._register(e.onDidChangeLogLevel(e=>this.loggers.forEach(t=>t.setLevel(e))))}getLogger(e){let t=this.loggers.get(e.toString());return t||(t=new h.BufferLogService(this.logService.getLevel()),this.loggers.set(e.toString(),t),
n.whenProviderRegistered(e,this.fileService).then(()=>t.logger=this.instantiationService.createInstance(d,c.basename(e),e,this.logService.getLevel()))),t}dispose(){this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}};f=r([s(0,i.ILogService),s(1,u.IInstantiationService),s(2,n.IFileService)],f),t.FileLoggerService=f})),define(t[152],i([0,1,13,3]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FollowerLogService=t.LoggerChannelClient=t.LoggerChannel=void 0;t.LoggerChannel=class{constructor(e){this.service=e,this.onDidChangeLogLevel=n.Event.buffer(e.onDidChangeLogLevel,!0)}listen(e,t){switch(t){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${t}`)}call(e,t,i){switch(t){case"setLevel":return this.service.setLevel(i),Promise.resolve();case"consoleLog":return this.consoleLog(i[0],i[1]),Promise.resolve()}throw new Error(`Call not found: ${t}`)}consoleLog(e,t){let i=console.log;switch(e){case"error":i=console.error
;break;case"warn":i=console.warn;break;case"info":i=console.info}i.call(console,...t)}};class r{constructor(e){this.channel=e}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(e){r.setLevel(this.channel,e)}static setLevel(e,t){return e.call("setLevel",t)}consoleLog(e,t){this.channel.call("consoleLog",[e,t])}}t.LoggerChannelClient=r;class s extends i.DelegatedLogService{constructor(e,t){super(t),this.parent=e,this._register(e.onDidChangeLogLevel(e=>t.setLevel(e)))}setLevel(e){super.setLevel(e),this.parent.setLevel(e)}}t.FollowerLogService=s})),define(t[77],i([0,1,4,13]),(function(e,t,i,n){"use strict";function r(e,t,i){switch(t){case n.LogLevel.Trace:e.trace(i);break;case n.LogLevel.Debug:e.debug(i);break;case n.LogLevel.Info:e.info(i);break;case n.LogLevel.Warning:e.warn(i);break;case n.LogLevel.Error:e.error(i);break;case n.LogLevel.Critical:e.critical(i);break;default:throw new Error("Invalid log level")}}Object.defineProperty(t,"__esModule",{value:!0}),
t.SpdLogService=t.createRotatingLogger=void 0,t.createRotatingLogger=function(t,i,n,r){return e.__$__nodeRequire("spdlog").createRotatingLogger(t,i,n,r)};class s extends n.AbstractLogService{constructor(e,t,i){super(),this.name=e,this.logsFolder=t,this.buffer=[],this._loggerCreationPromise=void 0,this.setLevel(i),this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(e=>{this._logger&&this._logger.setLevel(e)}))}_createSpdLogLogger(){return this._loggerCreationPromise||(this._loggerCreationPromise=async function(t,n){try{const r=await new Promise((t,i)=>{e(["spdlog"],t,i)});r.setAsyncMode(8192,500);const s=i.join(n,`${t}.log`);return r.createRotatingLoggerAsync(t,s,5242880,6)}catch(e){console.error(e)}return null}(this.name,this.logsFolder).then(e=>{if(e){this._logger=e,this._logger.setLevel(this.getLevel());for(const{level:e,message:t}of this.buffer)r(this._logger,e,t);this.buffer=[]}})),this._loggerCreationPromise}_log(e,t){this._logger?r(this._logger,e,t):this.getLevel()<=e&&this.buffer.push({
level:e,message:t})}trace(e,...t){this.getLevel()<=n.LogLevel.Trace&&this._log(n.LogLevel.Trace,this.format([e,...t]))}debug(e,...t){this.getLevel()<=n.LogLevel.Debug&&this._log(n.LogLevel.Debug,this.format([e,...t]))}info(e,...t){this.getLevel()<=n.LogLevel.Info&&this._log(n.LogLevel.Info,this.format([e,...t]))}warn(e,...t){this.getLevel()<=n.LogLevel.Warning&&this._log(n.LogLevel.Warning,this.format([e,...t]))}error(e,...t){if(this.getLevel()<=n.LogLevel.Error)if(e instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=e.stack,this._log(n.LogLevel.Error,this.format(t))}else this._log(n.LogLevel.Error,this.format([e,...t]))}critical(e,...t){this.getLevel()<=n.LogLevel.Critical&&this._log(n.LogLevel.Critical,this.format([e,...t]))}flush(){this._logger?this._logger.flush():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.disposeLogger()),
this._loggerCreationPromise=void 0}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}format(e){let t="";for(let i=0;i<e.length;i++){let n=e[i];if("object"==typeof n)try{n=JSON.stringify(n)}catch(e){}t+=(i>0?" ":"")+n}return t}}t.SpdLogService=s})),define(t[153],i([0,1,13,2,10,26,151,5,77]),(function(e,t,i,n,o,a,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LoggerService=void 0;let h=class extends n.Disposable{constructor(e,t){super(),this.logService=e,this.instantiationService=t,this.loggers=new Map,this._register(e.onDidChangeLogLevel(e=>this.loggers.forEach(t=>t.setLevel(e))))}getLogger(e){let t=this.loggers.get(e.toString());if(!t){if(e.scheme===a.Schemas.file){const i=o.basename(e),n=o.extname(e);t=new u.SpdLogService(i.substring(0,i.length-n.length),o.dirname(e).fsPath,this.logService.getLevel())}else t=this.instantiationService.createInstance(c.FileLogService,o.basename(e),e,this.logService.getLevel());this.loggers.set(e.toString(),t)}return t}dispose(){
this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}};h=r([s(0,i.ILogService),s(1,l.IInstantiationService)],h),t.LoggerService=h})),define(t[41],i([0,1,6,4,31,47]),(function(e,t,i,n,r,s){"use strict";let o;if(Object.defineProperty(t,"__esModule",{value:!0}),i.isWeb)o={},0===Object.keys(o).length&&Object.assign(o,{version:"1.49.0-dev",nameLong:"Visual Studio Code Web Dev",nameShort:"VSCode Web Dev",urlProtocol:"code-oss",extensionAllowedProposedApi:["ms-vscode.references-view","ms-vscode.github-browser"]});else{if(void 0===e||"function"!=typeof e.__$__nodeRequire)throw new Error("Unable to resolve product configuration");{const t=n.dirname(r.getPathFromAmdModule(e,""));o=e.__$__nodeRequire(n.join(t,"product.json"));const i=e.__$__nodeRequire(n.join(t,"package.json"));s.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`}),Object.assign(o,{version:i.version})}}t.default=o})),
define(t[154],i([0,1,4,21,41,2,20,13,8]),(function(e,t,i,n,o,a,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LanguagePackCachedDataCleaner=void 0;let h=class extends a.Disposable{constructor(e,t){super(),this._environmentService=e,this._logService=t,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let e=setTimeout(async()=>{e=void 0,this._logService.info("Starting to clean up unused language packs.");const t=o.default.nameLong.indexOf("Insiders")>=0?6048e5:7776e6;try{const e=Object.create(null),r=JSON.parse(await n.readFile(i.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let t of Object.keys(r)){e[`${r[t].hash}.${t}`]=!0}const s=i.join(this._environmentService.userDataPath,"clp");if(!await n.exists(s))return;for(let t of await n.readdir(s))e[t]?this._logService.info(`Skipping directory ${t}. Language pack still in use.`):(this._logService.info("Removing unused language pack:",t),await n.rimraf(i.join(s,t)))
;const o=Date.now();for(let r of Object.keys(e)){const e=i.join(s,r);for(let s of await n.readdir(e)){if("tcf.json"===s)continue;const a=i.join(e,s),c=await n.stat(a);if(c.isDirectory()){o-c.mtime.getTime()>t&&(this._logService.info("Removing language pack cache entry: ",i.join(r,s)),await n.rimraf(a))}}}}catch(e){c.onUnexpectedError(e)}},4e4);this._register(a.toDisposable(()=>{void 0!==e&&clearTimeout(e)}))}};h=r([s(0,u.IEnvironmentService),s(1,l.ILogService)],h),t.LanguagePackCachedDataCleaner=h})),define(t[155],i([0,1,4,20,2,21,8,41]),(function(e,t,i,n,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeCachedDataCleaner=void 0;let u=class e{constructor(e){this._environmentService=e,this._disposables=new o.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!this._environmentService.nodeCachedDataDir)return;const t=i.dirname(this._environmentService.nodeCachedDataDir),r=i.basename(this._environmentService.nodeCachedDataDir)
;let s=setTimeout(()=>{s=void 0,a.readdir(t).then(n=>{const s=Date.now(),o=[];return n.forEach(n=>{if(n!==r){const r=i.join(t,n);o.push(a.stat(r).then(t=>{if(t.isDirectory()){if(s-t.mtime.getTime()>e._DataMaxAge)return a.rimraf(r)}}))}}),Promise.all(o)}).then(void 0,n.onUnexpectedError)},3e4);this._disposables.add(o.toDisposable(()=>{s&&(clearTimeout(s),s=void 0)}))}};u._DataMaxAge=l.default.nameLong.indexOf("Insiders")>=0?6048e5:7776e6,u=r([s(0,c.IEnvironmentService)],u),t.NodeCachedDataCleaner=u})),define(t[156],i([0,1,8,149,89,40,4,10,82,41,53,6,31,7]),(function(e,t,i,n,s,o,a,c,l,u,h,d,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseUserDataDir=t.parsePathArg=t.parseSearchPort=t.parseExtensionHostPort=t.xdgRuntimeDir=t.EnvironmentService=void 0;class p{constructor(e,t){if(this._args=e,this._execPath=t,!process.env.VSCODE_LOGS){const e=h.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");process.env.VSCODE_LOGS=a.join(this.userDataPath,"logs",e)}
this.logsPath=process.env.VSCODE_LOGS}get args(){return this._args}get appRoot(){return a.dirname(f.getPathFromAmdModule(e,""))}get execPath(){return this._execPath}get cliPath(){return function(e,t,i){if(d.isWindows)return i?a.join(a.dirname(e),"bin",`${u.default.applicationName}.cmd`):a.join(t,"scripts","code-cli.bat");if(d.isLinux)return i?a.join(a.dirname(e),"bin",`${u.default.applicationName}`):a.join(t,"scripts","code-cli.sh");if(i)return a.join(t,"bin","code");return a.join(t,"scripts","code-cli.sh")}(this.execPath,this.appRoot,this.isBuilt)}get userHome(){return g.URI.file(o.homedir())}get userDataPath(){const e=process.env.VSCODE_PORTABLE;return e?a.join(e,"user-data"):E(this._args,process)}get appSettingsHome(){return g.URI.file(a.join(this.userDataPath,"User"))}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return c.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return c.joinPath(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){
return g.URI.file(a.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get enableSyncByDefault(){return!1}get machineSettingsResource(){return c.joinPath(g.URI.file(a.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return g.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return g.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return c.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return c.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const e=process.env.VSCODE_PORTABLE;return e?g.URI.file(a.join(e,"argv.json")):c.joinPath(this.userHome,u.default.dataFolderName,"argv.json")}get snippetsHome(){return c.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get backupHome(){return g.URI.file(a.join(this.userDataPath,i.BACKUPS))}get backupWorkspacesPath(){
return a.join(this.backupHome.fsPath,"workspaces.json")}get untitledWorkspacesHome(){return g.URI.file(a.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return a.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const t=w(this._args["builtin-extensions-dir"],process);return t||a.normalize(a.join(f.getPathFromAmdModule(e,""),"..","extensions"))}get extensionsDownloadPath(){const e=w(this._args["extensions-download-dir"],process);return e||a.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const e=w(this._args["extensions-dir"],process);if(e)return e;const t=process.env.VSCODE_EXTENSIONS;if(t)return t;const i=process.env.VSCODE_PORTABLE;return i?a.join(i,"extensions"):c.joinPath(this.userHome,u.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const e=this._args.extensionDevelopmentPath;if(Array.isArray(e))return e.map(e=>/^[^:/?#]+?:\/\//.test(e)?g.URI.parse(e):g.URI.file(a.normalize(e)))}get extensionTestsLocationURI(){
const e=this._args.extensionTestsPath;if(e)return/^[^:/?#]+?:\/\//.test(e)?g.URI.parse(e):g.URI.file(a.normalize(e))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const e=this._args["disable-extension"];if(e){if("string"==typeof e)return[e];if(Array.isArray(e)&&e.length>0)return e}return!1}get extensionEnabledProposedApi(){return Array.isArray(this.args["enable-proposed-api"])?this.args["enable-proposed-api"]:"enable-proposed-api"in this.args?[]:void 0}get debugExtensionHost(){return y(this._args,this.isBuilt)}get logExtensionHostCommunication(){return!!this.args.logExtensionHostCommunication}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get mainIPCHandle(){return v(this.userDataPath,"main")}get sharedIPCHandle(){return v(this.userDataPath,"shared")}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}get serviceMachineIdResource(){
return c.joinPath(g.URI.file(this.userDataPath),"machineid")}get disableUpdates(){return!!this._args["disable-updates"]}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get driverVerbose(){return!!this._args["driver-verbose"]}get disableTelemetry(){return!!this._args["disable-telemetry"]}get sandbox(){return!!this._args.__sandbox}}r([l.memoize],p.prototype,"appRoot",null),r([l.memoize],p.prototype,"cliPath",null),r([l.memoize],p.prototype,"userHome",null),r([l.memoize],p.prototype,"userDataPath",null),r([l.memoize],p.prototype,"appSettingsHome",null),r([l.memoize],p.prototype,"userRoamingDataHome",null),r([l.memoize],p.prototype,"settingsResource",null),r([l.memoize],p.prototype,"userDataSyncHome",null),r([l.memoize],p.prototype,"userDataSyncLogResource",null),r([l.memoize],p.prototype,"sync",null),r([l.memoize],p.prototype,"enableSyncByDefault",null),
r([l.memoize],p.prototype,"machineSettingsResource",null),r([l.memoize],p.prototype,"globalStorageHome",null),r([l.memoize],p.prototype,"workspaceStorageHome",null),r([l.memoize],p.prototype,"keybindingsResource",null),r([l.memoize],p.prototype,"keyboardLayoutResource",null),r([l.memoize],p.prototype,"argvResource",null),r([l.memoize],p.prototype,"snippetsHome",null),r([l.memoize],p.prototype,"isExtensionDevelopment",null),r([l.memoize],p.prototype,"backupHome",null),r([l.memoize],p.prototype,"backupWorkspacesPath",null),r([l.memoize],p.prototype,"untitledWorkspacesHome",null),r([l.memoize],p.prototype,"installSourcePath",null),r([l.memoize],p.prototype,"builtinExtensionsPath",null),r([l.memoize],p.prototype,"extensionsPath",null),r([l.memoize],p.prototype,"extensionDevelopmentLocationURI",null),r([l.memoize],p.prototype,"extensionTestsLocationURI",null),r([l.memoize],p.prototype,"debugExtensionHost",null),r([l.memoize],p.prototype,"logExtensionHostCommunication",null),
r([l.memoize],p.prototype,"mainIPCHandle",null),r([l.memoize],p.prototype,"sharedIPCHandle",null),r([l.memoize],p.prototype,"nodeCachedDataDir",null),r([l.memoize],p.prototype,"serviceMachineIdResource",null),t.EnvironmentService=p,t.xdgRuntimeDir=process.env.XDG_RUNTIME_DIR;const m={2:107,1:103};function v(e,i){return d.isWindows?function(e,t){return`\\\\.\\pipe\\${n.createHash("md5").update(e).digest("hex")}-${u.default.version}-${t}-sock`}(e,i):function(e,i){const r=process.env.VSCODE_PORTABLE;let s;if(t.xdgRuntimeDir&&!r){const r=n.createHash("md5").update(e).digest("hex").substr(0,8);s=a.join(t.xdgRuntimeDir,`vscode-${r}-${u.default.version}-${i}.sock`)}else s=a.join(e,`${u.default.version}-${i}.sock`);const o=m[d.platform];return"number"==typeof o&&s.length>=o&&console.warn(`WARNING: IPC handle "${s}" is longer than ${o} chars, try a shorter --user-data-dir`),s}(e,i)}function y(e,t){return S(e["inspect-extensions"],e["inspect-brk-extensions"],5870,t,e.debugId)}function S(e,t,i,n,r){
const s=Number(t||e)||(n?null:i);return{port:s,break:!!s&&Boolean(!!t),debugId:r}}function w(e,t){if(!e)return;const i=a.resolve(e);return a.normalize(e)===i?i:a.resolve(t.env.VSCODE_CWD||t.cwd(),e)}function E(e,t){return w(e["user-data-dir"],t)||a.resolve(s.getDefaultUserDataPath(t.platform))}t.parseExtensionHostPort=y,t.parseSearchPort=function(e,t){return S(e["inspect-search"],e["inspect-brk-search"],5876,t)},t.parsePathArg=w,t.parseUserDataDir=E})),define(t[37],i([0,1,5]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=i.createDecorator("productService")})),define(t[33],i([0,1,18,81]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;t.Registry=new class{constructor(){this.data=new Map}add(e,t){n.ok(i.isString(e)),n.ok(i.isObject(t)),n.ok(!this.data.has(e),"There is already an extension with this id"),this.data.set(e,t)}knows(e){return this.data.has(e)}as(e){
return this.data.get(e)||null}}})),define(t[78],i([0,1,33,3]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};const r=new class{constructor(){this._onDidChangeSchema=new n.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(e,t){var i;this.schemasById[(i=e,i.length>0&&"#"===i.charAt(i.length-1)?i.substring(0,i.length-1):i)]=t,this._onDidChangeSchema.fire(e)}notifySchemaChanged(e){this._onDidChangeSchema.fire(e)}getSchemaContributions(){return{schemas:this.schemasById}}};i.Registry.add(t.Extensions.JSONContribution,r)})),define(t[42],i([0,1,105,3,33,18,78]),(function(e,t,i,n,r,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"},function(e){e[e.APPLICATION=1]="APPLICATION",e[e.MACHINE=2]="MACHINE",e[e.WINDOW=3]="WINDOW",e[e.RESOURCE=4]="RESOURCE",e[e.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",e[e.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"}(t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},
t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const a=r.Registry.as(o.Extensions.JSONContribution);function c(e){return e.substring(1,e.length-1)}function l(e){switch(Array.isArray(e)?e[0]:e){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.OVERRIDE_PROPERTY_PATTERN=new RegExp("\\[.*\\]$"),t.overrideIdentifierFromKey=c,t.getDefaultValue=l;const u=new class{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:i.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},
patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(e,t=!0){this.registerConfigurations([e],t)}registerConfigurations(e,i=!0){const n=[];e.forEach(e=>{n.push(...this.validateAndRegisterProperties(e,i)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(n)}deregisterConfigurations(e){const i=[],n=e=>{if(e.properties)for(const t in e.properties)i.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,e.properties[t]);e.allOf&&e.allOf.forEach(e=>n(e))};for(const t of e){n(t);const e=this.configurationContributors.indexOf(t)
;-1!==e&&this.configurationContributors.splice(e,1)}a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(i)}registerDefaultConfigurations(e){const n=[],r=[];for(const s of e)for(const e in s)if(n.push(e),this.defaultValues[e]=s[e],t.OVERRIDE_PROPERTY_PATTERN.test(e)){const n={type:"object",default:this.defaultValues[e],description:i.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};r.push(c(e)),this.configurationProperties[e]=n,this.defaultLanguageConfigurationOverridesNode.properties[e]=n}else{const t=this.configurationProperties[e];t&&(this.updatePropertyDefaultValue(e,t),this.updateSchema(e,t))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(n)}deregisterDefaultConfigurations(e){const i=[];for(const n of e)for(const e in n)if(i.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],
delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const t=this.configurationProperties[e];t&&(this.updatePropertyDefaultValue(e,t),this.updateSchema(e,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(i)}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const t of e)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(e,i=!0,n=3){n=s.isUndefinedOrNull(e.scope)?n:e.scope;let r=[],o=e.properties;if(o)for(let e in o){if(i&&h(e)){delete o[e];continue}const a=o[e];this.updatePropertyDefaultValue(e,a),t.OVERRIDE_PROPERTY_PATTERN.test(e)?a.scope=void 0:a.scope=s.isUndefinedOrNull(a.scope)?n:a.scope,!o[e].hasOwnProperty("included")||o[e].included?(this.configurationProperties[e]=o[e],!o[e].deprecationMessage&&o[e].markdownDeprecationMessage&&(o[e].deprecationMessage=o[e].markdownDeprecationMessage),
r.push(e)):(this.excludedConfigurationProperties[e]=o[e],delete o[e])}let a=e.allOf;if(a)for(let e of a)r.push(...this.validateAndRegisterProperties(e,i,n));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(e){const t=e=>{let i=e.properties;if(i)for(const e in i)this.updateSchema(e,i[e]);let n=e.allOf;n&&n.forEach(t)};t(e)}updateSchema(e,i){switch(t.allSettings.properties[e]=i,i.scope){case 1:t.applicationSettings.properties[e]=i;break;case 2:t.machineSettings.properties[e]=i;break;case 6:t.machineOverridableSettings.properties[e]=i;break;case 3:t.windowSettings.properties[e]=i;break;case 4:t.resourceSettings.properties[e]=i;break;case 5:t.resourceSettings.properties[e]=i,this.resourceLanguageSettingsSchema.properties[e]=i}}removeFromSchema(e,i){switch(delete t.allSettings.properties[e],i.scope){case 1:
delete t.applicationSettings.properties[e];break;case 2:delete t.machineSettings.properties[e];break;case 6:delete t.machineOverridableSettings.properties[e];break;case 3:delete t.windowSettings.properties[e];break;case 4:case 5:delete t.resourceSettings.properties[e]}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const n=`[${e}]`,r={type:"object",description:i.localize(2,null),errorMessage:i.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,r),t.allSettings.properties[n]=r,t.applicationSettings.properties[n]=r,t.machineSettings.properties[n]=r,t.machineOverridableSettings.properties[n]=r,t.windowSettings.properties[n]=r,t.resourceSettings.properties[n]=r}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,t){let i=this.defaultValues[e];s.isUndefined(i)&&(i=t.default),s.isUndefined(i)&&(i=l(t.type)),t.default=i}};function h(e){
return t.OVERRIDE_PROPERTY_PATTERN.test(e)?i.localize(4,null,e):void 0!==u.getConfigurationProperties()[e]?i.localize(5,null,e):null}r.Registry.add(t.Extensions.Configuration,u),t.validateProperty=h,t.getScopes=function(){const e=[],t=u.getConfigurationProperties();for(const i of Object.keys(t))e.push([i,t[i].scope]);return e.push(["launch",4]),e.push(["task",4]),e}})),define(t[25],i([0,1,19,18,7,33,5,42]),(function(e,t,i,n,r,s,o,a){"use strict";function c(e,t){const i=Object.create(null);for(let n in e)l(i,n,e[n],t);return i}function l(e,t,i,n){const r=t.split("."),s=r.pop();let o=e;for(let e=0;e<r.length;e++){let i=r[e],s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:return void n(`Ignoring ${t} as ${r.slice(0,e+1).join(".")} is ${JSON.stringify(s)}`)}o=s}if("object"==typeof o&&null!==o)try{o[s]=i}catch(e){n(`Ignoring ${t} as ${r.join(".")} is ${JSON.stringify(o)}`)}else n(`Ignoring ${t} as ${r.join(".")} is ${JSON.stringify(o)}`)}function u(e,t,i){
const n=function(e,t){let i=e;for(const e of t){if("object"!=typeof i||null===i)return;i=i[e]}return i}(e,t.split("."));return void 0===n?i:n}function h(e){return`[${e}]`}Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=o.createDecorator("configurationService"),t.isConfigurationOverrides=function(e){return e&&"object"==typeof e&&(!e.overrideIdentifier||"string"==typeof e.overrideIdentifier)&&(!e.resource||e.resource instanceof r.URI)},function(e){e[e.USER=1]="USER",e[e.USER_LOCAL=2]="USER_LOCAL",e[e.USER_REMOTE=3]="USER_REMOTE",e[e.WORKSPACE=4]="WORKSPACE",e[e.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",e[e.DEFAULT=6]="DEFAULT",e[e.MEMORY=7]="MEMORY"
}(t.ConfigurationTarget||(t.ConfigurationTarget={})),t.ConfigurationTargetToString=function(e){switch(e){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}},t.compare=function e(t,n){const r=n?t?n.keys.filter(e=>-1===t.keys.indexOf(e)):[...n.keys]:[],s=t?n?t.keys.filter(e=>-1===n.keys.indexOf(e)):[...t.keys]:[],o=[];if(n&&t)for(const e of t.keys)if(-1!==n.keys.indexOf(e)){const r=u(t.contents,e),s=u(n.contents,e);i.equals(r,s)||o.push(e)}const c=[],l=e=>{const t={};for(const i of e)for(const e of i.identifiers)t[h(e)]=i;return t},d=n?l(n.overrides):{},f=t?l(t.overrides):{};if(Object.keys(d).length)for(const e of r){const t=d[e];t&&c.push([a.overrideIdentifierFromKey(e),t.keys])}if(Object.keys(f).length)for(const e of s){const t=f[e];t&&c.push([a.overrideIdentifierFromKey(e),t.keys])}if(Object.keys(d).length&&Object.keys(f).length)for(const t of o){const i=f[t],n=d[t];if(i&&n){
const r=e({contents:i.contents,keys:i.keys,overrides:[]},{contents:n.contents,keys:n.keys,overrides:[]});c.push([a.overrideIdentifierFromKey(t),[...r.added,...r.removed,...r.updated]])}}return{added:r,removed:s,updated:o,overrides:c}},t.toOverrides=function(e,t){const i=[];for(const n of Object.keys(e))if(a.OVERRIDE_PROPERTY_PATTERN.test(n)){const r={};for(const t in e[n])r[t]=e[n][t];i.push({identifiers:[a.overrideIdentifierFromKey(n).trim()],keys:Object.keys(r),contents:c(r,t)})}return i},t.toValuesTree=c,t.addToValueTree=l,t.removeFromValueTree=function(e,t){!function e(t,i){const n=i.shift();if(0===i.length)return void delete t[n];if(-1!==Object.keys(t).indexOf(n)){const r=t[n];"object"!=typeof r||Array.isArray(r)||(e(r,i),0===Object.keys(r).length&&delete t[n])}}(e,t.split("."))},t.getConfigurationValue=u,t.merge=function e(t,i,r){Object.keys(i).forEach(s=>{"__proto__"!==s&&(s in t?n.isObject(t[s])&&n.isObject(i[s])?e(t[s],i[s],r):r&&(t[s]=i[s]):t[s]=i[s])})},t.getConfigurationKeys=function(){
const e=s.Registry.as(a.Extensions.Configuration).getConfigurationProperties();return Object.keys(e)},t.getDefaultValues=function(){const e=Object.create(null),t=s.Registry.as(a.Extensions.Configuration).getConfigurationProperties();for(let i in t){l(e,i,t[i].default,e=>console.error(`Conflict in default settings: ${e}`))}return e},t.keyFromOverrideIdentifier=h,t.getMigratedSettingValue=function(e,t,i){const n=e.inspect(t),r=e.inspect(i);return void 0!==n.userValue||void 0!==n.workspaceValue||void 0!==n.workspaceFolderValue?n.value:void 0!==r.userValue||void 0!==r.workspaceValue||void 0!==r.workspaceFolderValue?r.value:n.defaultValue}})),define(t[157],i([0,1,28,34,15,18,19,7,42,25,33,2,3,10]),(function(e,t,i,n,r,s,o,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class g{
constructor(e={},t=[],i=[]){this._contents=e,this._keys=t,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return 0===this._keys.length&&0===Object.keys(this._contents).length&&0===this._overrides.length}getValue(e){return e?l.getConfigurationValue(this.contents,e):this.contents}getOverrideValue(e,t){const i=this.getContentsForOverrideIdentifer(t);return i?e?l.getConfigurationValue(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const t of this.overrides)if(-1!==t.identifiers.indexOf(e))return t.keys;return[]}override(e){const t=this.getContentsForOverrideIdentifer(e);if(!t||"object"!=typeof t||!Object.keys(t).length)return this;let i={};for(const e of r.distinct([...Object.keys(this.contents),...Object.keys(t)])){let n=this.contents[e],r=t[e];r&&("object"==typeof n&&"object"==typeof r?(n=o.deepClone(n),this.mergeContents(n,r)):n=r),i[e]=n}
return new g(i,this.keys,this.overrides)}merge(...e){const t=o.deepClone(this.contents),i=o.deepClone(this.overrides),n=[...this.keys];for(const s of e){this.mergeContents(t,s.contents);for(const e of s.overrides){const[t]=i.filter(t=>r.equals(t.identifiers,e.identifiers));t?this.mergeContents(t.contents,e.contents):i.push(o.deepClone(e))}for(const e of s.keys)-1===n.indexOf(e)&&n.push(e)}return new g(t,n,i)}freeze(){return this.isFrozen=!0,this}mergeContents(e,t){for(const i of Object.keys(t))i in e&&s.isObject(e[i])&&s.isObject(t[i])?this.mergeContents(e[i],t[i]):e[i]=o.deepClone(t[i])}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?o.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const t of this.overrides)if(-1!==t.identifiers.indexOf(e))return t.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,t){this.addKey(e),l.addToValueTree(this.contents,e,t,e=>{throw new Error(e)})}removeValue(e){
this.removeKey(e)&&l.removeFromValueTree(this.contents,e)}addKey(e){let t=this.keys.length;for(let i=0;i<t;i++)0===e.indexOf(this.keys[i])&&(t=i);this.keys.splice(t,1,e)}removeKey(e){let t=this.keys.indexOf(e);return-1!==t&&(this.keys.splice(t,1),!0)}}t.ConfigurationModel=g;t.DefaultConfigurationModel=class extends g{constructor(){const e=l.getDefaultValues(),t=l.getConfigurationKeys(),i=[];for(const t of Object.keys(e))c.OVERRIDE_PROPERTY_PATTERN.test(t)&&i.push({identifiers:[c.overrideIdentifierFromKey(t).trim()],keys:Object.keys(e[t]),contents:l.toValuesTree(e[t],e=>console.error(`Conflict in default settings file: ${e}`))});super(e,t,i)}};class p{constructor(e,t){this._name=e,this._scopes=t,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get errors(){return this._parseErrors}parseContent(e){if(!s.isUndefinedOrNull(e)){const t=this.doParseContent(e);this.parseRaw(t)}}parseRaw(e){this._raw=e;const t=this.doParseRaw(e)
;this._configurationModel=new g(t.contents,t.keys,t.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(e){let t={},n=null,r=[],s=[],o=[];function a(e){Array.isArray(r)?r.push(e):n&&(r[n]=e)}let c={onObjectBegin:()=>{let e={};a(e),s.push(r),r=e,n=null},onObjectProperty:e=>{n=e},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{let e=[];a(e),s.push(r),r=e,n=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:a,onError:(e,t,i)=>{o.push({error:e,offset:t,length:i})}};if(e)try{i.visit(e,c),t=r[0]||{}}catch(e){console.error(`Error while parsing settings file ${this._name}: ${e}`),this._parseErrors=[e]}return t}doParseRaw(e){if(this._scopes){const t=u.Registry.as(c.Extensions.Configuration).getConfigurationProperties();e=this.filterByScope(e,t,!0,this._scopes)}return{contents:l.toValuesTree(e,e=>console.error(`Conflict in settings file ${this._name}: ${e}`)),keys:Object.keys(e),overrides:l.toOverrides(e,e=>console.error(`Conflict in settings file ${this._name}: ${e}`))}}filterByScope(e,t,i,n){const r={}
;for(let s in e)if(c.OVERRIDE_PROPERTY_PATTERN.test(s)&&i)r[s]=this.filterByScope(e[s],t,!1,n);else{const i=this.getScope(s,t);void 0!==i&&-1===n.indexOf(i)||(r[s]=e[s])}return r}getScope(e,t){const i=t[e];return i?void 0!==i.scope?i.scope:3:void 0}}t.ConfigurationModelParser=p;class m extends h.Disposable{constructor(e,t,i){super(),this.userSettingsResource=e,this.scopes=t,this.fileService=i,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(f.dirname(this.userSettingsResource))),this._register(d.Event.filter(this.fileService.onDidFilesChange,e=>e.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(e.value.toString()||"{}"),this.parser.configurationModel}catch(e){return new g}}reprocess(){return this.parser.parse(),
this.parser.configurationModel}}t.UserSettings=m;class v{constructor(e,t,i=new g,r=new g,s=new n.ResourceMap,o=new g,a=new n.ResourceMap,c=!0){this._defaultConfiguration=e,this._localUserConfiguration=t,this._remoteUserConfiguration=i,this._workspaceConfiguration=r,this._folderConfigurations=s,this._memoryConfiguration=o,this._memoryConfigurationByResource=a,this._freeze=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new n.ResourceMap,this._userConfiguration=null}getValue(e,t,i){return this.getConsolidateConfigurationModel(t,i).getValue(e)}updateValue(e,t,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource))||(n=new g,this._memoryConfigurationByResource.set(i.resource,n)):n=this._memoryConfiguration,void 0===t?n.removeValue(e):n.setValue(e,t),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,t,i){
const n=this.getConsolidateConfigurationModel(t,i),s=this.getFolderConfigurationModelForResource(t.resource,i),o=t.resource&&this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration,a=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),c=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),l=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),u=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),h=i?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,d=s?t.overrideIdentifier?s.freeze().override(t.overrideIdentifier).getValue(e):s.freeze().getValue(e):void 0,f=t.overrideIdentifier?o.override(t.overrideIdentifier).getValue(e):o.getValue(e),g=n.getValue(e),p=r.distinct(r.flatten(n.overrides.map(e=>e.identifiers))).filter(t=>void 0!==n.getOverrideValue(e,t))
;return{defaultValue:a,userValue:c,userLocalValue:l,userRemoteValue:u,workspaceValue:h,workspaceFolderValue:d,memoryValue:f,value:g,default:void 0!==a?{value:this._defaultConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,user:void 0!==c?{value:this.userConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userLocal:void 0!==l?{value:this.localUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userRemote:void 0!==u?{value:this.remoteUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspace:void 0!==h?{value:this._workspaceConfiguration.freeze().getValue(e),
override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspaceFolder:void 0!==d?{value:null==s?void 0:s.freeze().getValue(e),override:t.overrideIdentifier?null==s?void 0:s.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,memory:void 0!==f?{value:o.getValue(e),override:t.overrideIdentifier?o.getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:p.length?p:void 0}}keys(e){const t=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,
this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,t){this._folderConfigurations.set(e,t),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,t){const i=t.filter(e=>c.OVERRIDE_PROPERTY_PATTERN.test(e)).map(t=>{
const i=c.overrideIdentifierFromKey(t),n=this._defaultConfiguration.getKeysForOverrideIdentifier(i),r=e.getKeysForOverrideIdentifier(i),s=[...r.filter(e=>-1===n.indexOf(e)),...n.filter(e=>-1===r.indexOf(e)),...n.filter(t=>!o.equals(this._defaultConfiguration.override(i).getValue(t),e.override(i).getValue(t)))];return[i,s]});return this.updateDefaultConfiguration(e),{keys:t,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:t,updated:i,removed:n,overrides:r}=l.compare(this.localUserConfiguration,e),s=[...t,...i,...n];return s.length&&this.updateLocalUserConfiguration(e),{keys:s,overrides:r}}compareAndUpdateRemoteUserConfiguration(e){const{added:t,updated:i,removed:n,overrides:r}=l.compare(this.remoteUserConfiguration,e);let s=[...t,...i,...n];return s.length&&this.updateRemoteUserConfiguration(e),{keys:s,overrides:r}}compareAndUpdateWorkspaceConfiguration(e){const{added:t,updated:i,removed:n,overrides:r}=l.compare(this.workspaceConfiguration,e);let s=[...t,...i,...n]
;return s.length&&this.updateWorkspaceConfiguration(e),{keys:s,overrides:r}}compareAndUpdateFolderConfiguration(e,t){const i=this.folderConfigurations.get(e),{added:n,updated:r,removed:s,overrides:o}=l.compare(i,t);let a=[...n,...r,...s];return!a.length&&i||this.updateFolderConfiguration(e,t),{keys:a,overrides:o}}compareAndDeleteFolderConfiguration(e){const t=this.folderConfigurations.get(e);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:n,removed:r,overrides:s}=l.compare(t,void 0);return{keys:[...i,...n,...r],overrides:s}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){
return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,t){let i=this.getConsolidatedConfigurationModelForResource(e,t);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},t){let i=this.getWorkspaceConsolidatedConfiguration();if(t&&e){const n=t.getFolder(e);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const r=this._memoryConfigurationByResource.get(e);r&&(i=i.merge(r))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){
let t=this._foldersConsolidatedConfigurations.get(e);if(!t){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(t=i.merge(n),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(e,t)):t=i}return t}getFolderConfigurationModelForResource(e,t){if(t&&e){const i=t.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,t)=>{const{contents:i,overrides:n,keys:r}=this._folderConfigurations.get(t);return e.push([t,{contents:i,overrides:n,keys:r}]),e},[])}}allKeys(){
const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>e.add(t)),this.userConfiguration.freeze().keys.forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(t=>e.add(t))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e))),[...t.values()]}static parse(e){const t=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),s=e.folders.reduce((e,t)=>(e.set(a.URI.revive(t[0]),this.parseConfigurationModel(t[1])),e),new n.ResourceMap);return new v(t,i,new g,r,s,new g,new n.ResourceMap,!1)}
static parseConfigurationModel(e){return new g(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=v,t.mergeChanges=function(...e){if(0===e.length)return{keys:[],overrides:[]};if(1===e.length)return e[0];const t=new Set,i=new Map;for(const r of e)r.keys.forEach(e=>t.add(e)),r.overrides.forEach(([e,t])=>{const r=n.getOrSet(i,e,new Set);t.forEach(e=>r.add(e))});const r=[];return i.forEach((e,t)=>r.push([t,[...e.values()]])),{keys:[...t.values()],overrides:r}};class y{constructor(e,t,i,n){this.change=e,this.previous=t,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const r=new Set;e.keys.forEach(e=>r.add(e)),e.overrides.forEach(([,e])=>e.forEach(e=>r.add(e))),this.affectedKeys=[...r.values()];const s=new g;this.affectedKeys.forEach(e=>s.setValue(e,{})),this.affectedKeysTree=s.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}
affectsConfiguration(e,t){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(t){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,t,null===(i=this.previous)||void 0===i?void 0:i.workspace):void 0,r=this.currentConfiguraiton.getValue(e,t,this.currentWorkspace);return!o.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(e,t){let i,n=l.toValuesTree({[t]:!0},()=>{});for(;"object"==typeof n&&(i=Object.keys(n)[0]);){if(!(e=e[i]))return!1;n=n[i]}return!0}}t.ConfigurationChangeEvent=y;t.AllKeysConfigurationChangeEvent=class extends y{constructor(e,t,i,n){super({keys:e.allKeys(),overrides:[]},void 0,e,t),this.source=i,this.sourceConfig=n}}})),define(t[158],i([0,1,33,42,2,25,157,3,9]),(function(e,t,i,n,r,s,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class l extends r.Disposable{constructor(e,t){super(),this.settingsResource=e,this._onDidChangeConfiguration=this._register(new a.Emitter),
this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new o.UserSettings(this.settingsResource,void 0,t)),this.configuration=new o.Configuration(new o.DefaultConfigurationModel,new o.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new c.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(i.Registry.as(n.Extensions.Configuration).onDidUpdateConfiguration(e=>this.onDidDefaultConfigurationChange(e))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const e=await this.userConfiguration.loadConfiguration();this.configuration=new o.Configuration(new o.DefaultConfigurationModel,e)}getConfigurationData(){return this.configuration.toData()}getValue(e,t){const i="string"==typeof e?e:void 0,n=s.isConfigurationOverrides(e)?e:s.isConfigurationOverrides(t)?t:{};return this.configuration.getValue(i,n,void 0)}updateValue(e,t,i,n){
return Promise.reject(new Error("not supported"))}inspect(e){return this.configuration.inspect(e,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const e=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(e)}onDidChangeUserConfiguration(e){const t=this.configuration.toData(),i=this.configuration.compareAndUpdateLocalUserConfiguration(e);this.trigger(i,t,1)}onDidDefaultConfigurationChange(e){const t=this.configuration.toData(),i=this.configuration.compareAndUpdateDefaultConfiguration(new o.DefaultConfigurationModel,e);this.trigger(i,t,6)}trigger(e,t,i){const n=new o.ConfigurationChangeEvent(e,{data:t},this.configuration);n.source=i,n.sourceConfig=this.getTargetConfiguration(i),this._onDidChangeConfiguration.fire(n)}getTargetConfiguration(e){switch(e){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=l})),
define(t[159],i([0,1,26]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getRemoteName=t.getRemoteAuthority=t.REMOTE_HOST_SCHEME=void 0,t.REMOTE_HOST_SCHEME=i.Schemas.vscodeRemote,t.getRemoteAuthority=function(e){return e.scheme===t.REMOTE_HOST_SCHEME?e.authority:void 0},t.getRemoteName=function(e){if(!e)return;const t=e.indexOf("+");return t<0?e:e.substr(0,t)}})),define(t[160],i([0,1,25,13,96]),(function(e,t,i,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let a=class{constructor(e,t){this.configurationService=e,this.logService=t}request(e,t){return this.logService.trace("RequestService#request",e.url),e.proxyAuthorization||(e.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),o.request(e,t)}async resolveProxy(e){}};a=r([s(0,i.IConfigurationService),s(1,n.ILogService)],a),t.RequestService=a})),define(t[43],i([0,1,115,5,42,33,17]),(function(e,t,i,n,r,s,o){"use strict";function a(e){
return e.res.statusCode&&e.res.statusCode>=200&&e.res.statusCode<300||1223===e.res.statusCode}function c(e){return 204===e.res.statusCode}Object.defineProperty(t,"__esModule",{value:!0}),t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=n.createDecorator("requestService"),t.isSuccess=a,t.asText=async function(e){if(!a(e))throw new Error("Server returned "+e.res.statusCode);return c(e)?null:(await o.streamToBuffer(e.stream)).toString()},t.asJson=async function(e){if(!a(e))throw new Error("Server returned "+e.res.statusCode);if(c(e))return null;const t=(await o.streamToBuffer(e.stream)).toString();try{return JSON.parse(t)}catch(e){throw e.message+=":\n"+t,e}},s.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:i.localize(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:i.localize(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,
description:i.localize(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:i.localize(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[i.localize(4,null),i.localize(5,null),i.localize(6,null)],default:"override",description:i.localize(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:i.localize(8,null)}}})})),define(t[161],i([0,1,43,27,16,26]),(function(e,t,i,n,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let c=class{constructor(e,t){this.requestService=e,this.fileService=t}async download(e,t,r=n.CancellationToken.None){if(e.scheme===a.Schemas.file||e.scheme===a.Schemas.vscodeRemote)return void await this.fileService.copy(e,t);const s={type:"GET",url:e.toString()},o=await this.requestService.request(s,r);if(200!==o.res.statusCode){const e=await i.asText(o);throw new Error(`Expected 200, got back ${o.res.statusCode} instead.\n\n${e}`)}
await this.fileService.writeFile(t,o.stream)}};c=r([s(0,i.IRequestService),s(1,o.IFileService)],c),t.DownloadService=c})),define(t[162],i([0,1,37,16,15,57,43,27,13,10,127]),(function(e,t,i,n,o,a,c,l,u,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionTipsService=void 0;let f=class{constructor(e,t,i,n){this.fileService=e,this.productService=t,this.requestService=i,this.logService=n,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&a.forEach(this.productService.configBasedExtensionTips,({value:e})=>this.allConfigBasedTips.set(e.configPath,e))}getConfigBasedTips(e){return this.getValidConfigBasedTips(e)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(e){const t=[];for(const[i,n]of this.allConfigBasedTips)try{const r=await this.fileService.readFile(h.joinPath(e,i)),s=new Map;a.forEach(n.recommendations,({key:e,value:i})=>{
if(o.isNonEmptyArray(i.remotes))for(const t of i.remotes)s.set(t,{extensionId:e,extensionName:i.name,configName:n.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack});else t.push({extensionId:e,extensionName:i.name,configName:n.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack})});const c=d.getDomainsOfRemotes(r.value.toString(),[...s.keys()]);for(const e of c){const i=s.get(e);i&&t.push(i)}}catch(e){}return t}async fetchWorkspacesTips(){var e,t;if(!(null===(e=this.productService.extensionsGallery)||void 0===e?void 0:e.recommendationsUrl))return[];try{const e=await this.requestService.request({type:"GET",url:null===(t=this.productService.extensionsGallery)||void 0===t?void 0:t.recommendationsUrl},l.CancellationToken.None);if(200!==e.res.statusCode)return[];const i=await c.asJson(e);return i&&i.workspaceRecommendations||[]}catch(e){return this.logService.error(e),[]}}};f=r([s(0,n.IFileService),s(1,i.IProductService),s(2,c.IRequestService),s(3,u.ILogService)],f),
t.ExtensionTipsService=f})),define(t[163],i([0,1,7,4,37,8,47,16,6,15,57,43,13,162]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionTipsService=void 0;let m=class extends p.ExtensionTipsService{constructor(e,t,i,n,r){super(t,i,n,r),this.environmentService=e,this.allImportantExecutableTips=new Map,this.allOtherExecutableTips=new Map,i.exeBasedExtensionTips&&d.forEach(i.exeBasedExtensionTips,({key:e,value:t})=>{const i=[],n=[];d.forEach(t.recommendations,({key:e,value:t})=>{t.important?i.push({extensionId:e,extensionName:t.name,isExtensionPack:!!t.isExtensionPack}):n.push({extensionId:e,extensionName:t.name,isExtensionPack:!!t.isExtensionPack})}),i.length&&this.allImportantExecutableTips.set(e,{exeFriendlyName:t.friendlyName,windowsPath:t.windowsPath,recommendations:i}),n.length&&this.allOtherExecutableTips.set(e,{exeFriendlyName:t.friendlyName,windowsPath:t.windowsPath,recommendations:n})})}getImportantExecutableBasedTips(){
return this.getValidExecutableBasedExtensionTips(this.allImportantExecutableTips)}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async getValidExecutableBasedExtensionTips(e){const t=[],r=new Map;for(const s of e.keys()){const o=e.get(s);if(!o||!h.isNonEmptyArray(o.recommendations))continue;const a=[];u.isWindows?o.windowsPath&&a.push(o.windowsPath.replace("%USERPROFILE%",c.env.USERPROFILE).replace("%ProgramFiles(x86)%",c.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",c.env.ProgramFiles).replace("%APPDATA%",c.env.APPDATA).replace("%WINDIR%",c.env.WINDIR)):(a.push(n.join("/usr/local/bin",s)),a.push(n.join("/usr/bin",s)),a.push(n.join(this.environmentService.userHome.fsPath,s)));for(const e of a){let n=r.get(e);if(void 0===n&&(n=await this.fileService.exists(i.URI.file(e)),r.set(e,n)),n)for(const{extensionId:e,extensionName:i,isExtensionPack:n}of o.recommendations)t.push({extensionId:e,extensionName:i,isExtensionPack:n,exeName:s,
exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath})}}return t}};m=r([s(0,a.IEnvironmentService),s(1,l.IFileService),s(2,o.IProductService),s(3,f.IRequestService),s(4,g.ILogService)],m),t.ExtensionTipsService=m})),define(t[49],i([0,1,29,17]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0,t.getServiceMachineId=async function(e,t,r){let s=r&&r.get("storage.serviceMachineId",0)||null;if(s)return s;try{const n=(await t.readFile(e.serviceMachineIdResource)).value.toString();s=i.isUUID(n)?n:null}catch(e){s=null}if(!s){s=i.generateUuid();try{await t.writeFile(e.serviceMachineIdResource,n.VSBuffer.fromString(s))}catch(e){}}return r&&r.store("storage.serviceMachineId",s,0),s}})),define(t[22],i([0,1,5,3,2,18]),(function(e,t,i,n,r,s){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,
t.IS_NEW_KEY="__$__isNewStorageMarker",t.IStorageService=i.createDecorator("storageService"),function(e){e[e.NONE=0]="NONE",e[e.SHUTDOWN=1]="SHUTDOWN"}(o=t.WillSaveStateReason||(t.WillSaveStateReason={})),function(e){e[e.GLOBAL=0]="GLOBAL",e[e.WORKSPACE=1]="WORKSPACE"}(t.StorageScope||(t.StorageScope={}));class a extends r.Disposable{constructor(){super(...arguments),this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.globalCache=new Map,this.workspaceCache=new Map}getCache(e){return 0===e?this.globalCache:this.workspaceCache}get(e,t,i){const n=this.getCache(t).get(e);return s.isUndefinedOrNull(n)?i:n}getBoolean(e,t,i){const n=this.getCache(t).get(e);return s.isUndefinedOrNull(n)?i:"true"===n}getNumber(e,t,i){const n=this.getCache(t).get(e);return s.isUndefinedOrNull(n)?i:parseInt(n,10)}store(e,t,i){if(s.isUndefinedOrNull(t))return this.remove(e,i)
;const n=String(t);return this.getCache(i).get(e)===n?Promise.resolve():(this.getCache(i).set(e,n),this._onDidChangeStorage.fire({scope:i,key:e}),Promise.resolve())}remove(e,t){return this.getCache(t).delete(e)?(this._onDidChangeStorage.fire({scope:t,key:e}),Promise.resolve()):Promise.resolve()}logStorage(){c(this.globalCache,this.workspaceCache,"inMemory","inMemory")}async migrate(e){}flush(){this._onWillSaveState.fire({reason:o.NONE})}isNew(){return!0}async close(){}}async function c(e,t,i,n){const r=e=>{try{return JSON.parse(e)}catch(t){return e}},s=new Map,o=new Map;e.forEach((e,t)=>{s.set(t,e),o.set(t,r(e))});const a=new Map,c=new Map;t.forEach((e,t)=>{a.set(t,e),c.set(t,r(e))}),console.group(`Storage: Global (path: ${i})`);let l=[];s.forEach((e,t)=>{l.push({key:t,value:e})}),console.table(l),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${n})`);let u=[];a.forEach((e,t)=>{u.push({key:t,value:e})}),console.table(u),console.groupEnd(),console.log(c)}t.InMemoryStorageService=a,
t.logStorage=c})),define(t[164],i([0,1,3,2,30,36,22,18]),(function(e,t,i,n,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StorageManager=t.GlobalExtensionEnablementService=void 0;let u=class extends n.Disposable{constructor(e){super(),this._onDidChangeEnablement=new i.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new h(e)),this._register(this.storageManger.onDidChange(e=>this._onDidChangeEnablement.fire({extensions:e,source:"storage"})))}async enableExtension(e,t){return!!this._removeFromDisabledExtensions(e)&&(this._onDidChangeEnablement.fire({extensions:[e],source:t}),!0)}async disableExtension(e,t){return!!this._addToDisabledExtensions(e)&&(this._onDidChangeEnablement.fire({extensions:[e],source:t}),!0)}getDisabledExtensions(){return this._getExtensions(o.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(e){let t=this.getDisabledExtensions()
;return!!t.every(t=>!a.areSameExtensions(t,e))&&(t.push(e),this._setDisabledExtensions(t),!0)}_removeFromDisabledExtensions(e){let t=this.getDisabledExtensions();for(let i=0;i<t.length;i++){const n=t[i];if(a.areSameExtensions(n,e))return t.splice(i,1),this._setDisabledExtensions(t),!0}return!1}_setDisabledExtensions(e){this._setExtensions(o.DISABLED_EXTENSIONS_STORAGE_PATH,e)}_getExtensions(e){return this.storageManger.get(e,0)}_setExtensions(e,t){this.storageManger.set(e,t,0)}};u=r([s(0,c.IStorageService)],u),t.GlobalExtensionEnablementService=u;class h extends n.Disposable{constructor(e){super(),this.storageService=e,this.storage=Object.create(null),this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this._register(e.onDidChangeStorage(e=>this.onDidStorageChange(e)))}get(e,t){let i;return 0===t?(l.isUndefinedOrNull(this.storage[e])&&(this.storage[e]=this._get(e,t)),i=this.storage[e]):i=this._get(e,t),JSON.parse(i)}set(e,t,i){let n=JSON.stringify(t.map(({id:e,uuid:t})=>({
id:e,uuid:t})));this._get(e,i)!==n&&(0===i&&(t.length?this.storage[e]=n:delete this.storage[e]),this._set(e,t.length?n:void 0,i))}onDidStorageChange(e){if(0===e.scope&&!l.isUndefinedOrNull(this.storage[e.key])){if(this._get(e.key,e.scope)!==this.storage[e.key]){const t=this.get(e.key,e.scope);delete this.storage[e.key];const i=this.get(e.key,e.scope),n=t.filter(e=>!i.some(t=>a.areSameExtensions(e,t))),r=i.filter(e=>!t.some(t=>a.areSameExtensions(t,e)));(n.length||r.length)&&this._onDidChange.fire([...n,...r])}}}_get(e,t){return this.storageService.get(e,t,"[]")}_set(e,t,i){t?this.storageService.store(e,t,i):this.storageService.remove(e,i)}}t.StorageManager=h})),define(t[24],i([0,1,5]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ITelemetryService=void 0,t.ITelemetryService=i.createDecorator("telemetryService"),
t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"})),define(t[165],i([0,1,40,88,125,35,4,28,91,41,14,6,7,24,5,59]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v){"use strict";async function y(e,t){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",
filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,r=new Map,s=2e4;const o={count:0,maxReached:!1};await function e(t,o,l,u){const h=o.substring(t.length+1);return new Promise(d=>{a.readdir(o,{withFileTypes:!0},async(a,f)=>{var g,p,m;if(a)return void d();if(u.count>s)return u.count+=f.length,u.maxReached=!0,void d();let v=f.length;if(0===v)return void d();let y=f;u.count+f.length>s&&(u.maxReached=!0,v=s-u.count,y=f.slice(0,v)),u.count+=f.length;for(const s of y)if(s.isDirectory()){if(l.includes(s.name)||await e(t,c.join(o,s.name),l,u),0==--v)return void d()}else{const e=s.name.lastIndexOf(".");if(e>=0){const t=s.name.substring(e+1);t&&n.set(t,(null!==(g=n.get(t))&&void 0!==g?g:0)+1)}
for(const e of i)!1!==(null===(p=e.relativePathPattern)||void 0===p?void 0:p.test(h))&&e.filePattern.test(s.name)&&r.set(e.tag,(null!==(m=r.get(e.tag))&&void 0!==m?m:0)+1);if(0==--v)return void d()}})})}(e,e,t,o);const l=await E(e);return{configFiles:S(r),fileTypes:S(n),fileCount:o.count,maxFilesReached:o.maxReached,launchConfigFiles:l}}function S(e){return[...v.Iterable.map(e.entries(),([e,t])=>({name:e,count:t}))].sort((e,t)=>t.count-e.count)}function w(){const e=1073741824,t={os:`${i.type()} ${i.arch()} ${i.release()}`,memory:`${(i.totalmem()/e).toFixed(2)}GB (${(i.freemem()/e).toFixed(2)}GB free)`,vmHint:`${Math.round(100*n.virtualMachineHint.value())}%`},r=i.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}function E(e){let t=new Map,i=c.join(e,".vscode","launch.json");return new Promise((e,n)=>{a.exists(i,n=>{if(!n)return e([]);a.readFile(i,(n,r)=>{if(n)return e([]);const s=[],o=l.parse(r.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),e([])
;if("object"===l.getNodeType(o)&&o.configurations)for(const e of o.configurations){const i=e.type;i&&(t.has(i)?t.set(i,t.get(i)+1):t.set(i,1))}return e(S(t))})})})}Object.defineProperty(t,"__esModule",{value:!0}),t.DiagnosticsService=t.collectLaunchConfigs=t.getMachineInfo=t.collectWorkspaceStats=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=m.createDecorator(t.ID),t.collectWorkspaceStats=y,t.getMachineInfo=w,t.collectLaunchConfigs=E;let C=class{constructor(e){this.telemetryService=e}formatMachineInfo(e){const t=[];return t.push(`OS Version:       ${e.os}`),t.push(`CPUs:             ${e.cpus}`),t.push(`Memory (System):  ${e.memory}`),t.push(`VM:               ${e.vmHint}`),t.join("\n")}formatEnvironment(e){const t=1073741824,r=[];r.push(`Version:          ${h.default.nameShort} ${h.default.version} (${h.default.commit||"Commit unknown"}, ${h.default.date||"Date unknown"})`),r.push(`OS Version:       ${i.type()} ${i.arch()} ${i.release()}`);const s=i.cpus()
;return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(i.totalmem()/t).toFixed(2)}GB (${(i.freemem()/t).toFixed(2)}GB free)`),f.isWindows||r.push(`Load (avg):       ${i.loadavg().map(e=>Math.round(e)).join(", ")}`),r.push(`VM:               ${Math.round(100*n.virtualMachineHint.value())}%`),r.push(`Screen Reader:    ${e.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${e.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(e.gpuFeatureStatus)}`),r.join("\n")}async getPerformanceInfo(e,t){return Promise.all([u.listProcesses(e.mainPID),this.formatWorkspaceMetadata(e)]).then(async i=>{let[n,r]=i,s=this.formatProcessList(e,n);return t.forEach(t=>{if(o.isRemoteDiagnosticError(t))s+=`\n${t.errorMessage}`,r+=`\n${t.errorMessage}`;else if(s+=`\n\nRemote: ${t.hostName}`,t.processes&&(s+=`\n${this.formatProcessList(e,t.processes)}`),t.workspaceMetadata){r+=`\n|  Remote: ${t.hostName}`
;for(const e of Object.keys(t.workspaceMetadata)){const i=t.workspaceMetadata[e];let n=`${i.fileCount} files`;i.maxFilesReached&&(n=`more than ${n}`),r+=`|    Folder (${e}): ${n}`,r+=this.formatWorkspaceStats(i)}}}),{processInfo:s,workspaceInfo:r}})}async getSystemInfo(e,t){const{memory:n,vmHint:r,os:s,cpus:o}=w(),a={os:s,memory:n,cpus:o,vmHint:r,processArgs:`${e.mainArguments.join(" ")}`,gpuStatus:e.gpuFeatureStatus,screenReader:`${e.screenReader?"yes":"no"}`,remoteData:t};return f.isWindows||(a.load=`${i.loadavg().map(e=>Math.round(e)).join(", ")}`),f.isLinux&&(a.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(a)}async getDiagnostics(e,t){const i=[];return u.listProcesses(e.mainPID).then(async n=>(i.push(""),i.push(this.formatEnvironment(e)),i.push(""),i.push(this.formatProcessList(e,n)),
e.windows.some(e=>e.folderURIs&&e.folderURIs.length>0&&!e.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(e))),t.forEach(t=>{if(o.isRemoteDiagnosticError(t))i.push(`\n${t.errorMessage}`);else if(i.push("\n\n"),i.push(`Remote:           ${t.hostName}`),i.push(this.formatMachineInfo(t.machineInfo)),t.processes&&i.push(this.formatProcessList(e,t.processes)),t.workspaceMetadata)for(const e of Object.keys(t.workspaceMetadata)){const n=t.workspaceMetadata[e];let r=`${n.fileCount} files`;n.maxFilesReached&&(r=`more than ${r}`),i.push(`Folder (${e}): ${r}`),i.push(this.formatWorkspaceStats(n))}}),i.push(""),i.push(""),i.join("\n")))}formatWorkspaceStats(e){const t=[];let i=0;const n=(e,n)=>{const s=` ${e}(${n})`;i+s.length>60?(t.push(r),i=(r="|                 ").length):i+=s.length,r+=s};let r="|      File types:";let s=e.fileTypes.length>10?10:e.fileTypes.length;for(let t=0;t<s;t++){const i=e.fileTypes[t];n(i.name,i.count)}if(t.push(r),
e.configFiles.length>=0&&(r="|      Conf files:",i=0,e.configFiles.forEach(e=>{n(e.name,e.count)}),t.push(r)),e.launchConfigFiles.length>0){let i="|      Launch Configs:";e.launchConfigFiles.forEach(e=>{const t=e.count>1?` ${e.name}(${e.count})`:` ${e.name}`;i+=t}),t.push(i)}return t.join("\n")}expandGPUFeatures(e){const t=Math.max(...Object.keys(e).map(e=>e.length));return Object.keys(e).map(i=>`${i}:  ${d.repeat(" ",t-i.length)}  ${e[i]}`).join("\n                  ")}formatWorkspaceMetadata(e){const t=[],i=[];return e.windows.forEach(e=>{0===e.folderURIs.length||e.remoteAuthority||(t.push(`|  Window (${e.title})`),e.folderURIs.forEach(e=>{const n=g.URI.revive(e);if("file"===n.scheme){const e=n.fsPath;i.push(y(e,["node_modules",".git"]).then(i=>{let n=`${i.fileCount} files`;i.maxFilesReached&&(n=`more than ${n}`),t.push(`|    Folder (${c.basename(e)}): ${n}`),t.push(this.formatWorkspaceStats(i))}).catch(i=>{t.push(`|      Error: Unable to collect workspace stats for folder ${e} (${i.toString()})`)}))
}else t.push(`|    Folder (${n.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(e=>t.join("\n")).catch(e=>`Unable to collect workspace stats: ${e}`)}formatProcessList(e,t){const i=new Map;e.windows.forEach(e=>i.set(e.pid,e.title));const n=[];return n.push("CPU %\tMem MB\t   PID\tProcess"),t&&this.formatProcessItem(e.mainPID,i,n,t,0),n.join("\n")}formatProcessItem(e,t,n,r,s){let o;0===s?o=r.pid===e?`${h.default.applicationName} main`:"remote agent":(o=`${d.repeat("  ",s)} ${r.name}`,"window"===r.name&&(o=`${o} (${t.get(r.pid)})`));const a="win32"===process.platform?r.mem:i.totalmem()*(r.mem/100);n.push(`${d.pad(Number(r.load.toFixed(0)),5," ")}\t${d.pad(Number((a/1048576).toFixed(0)),6," ")}\t${d.pad(Number(r.pid.toFixed(0)),6," ")}\t${o}`),Array.isArray(r.children)&&r.children.forEach(i=>this.formatProcessItem(e,t,n,i,s+1))}async reportWorkspaceStats(e){for(const{uri:t}of e.folders){const i=g.URI.revive(t);if("file"!==i.scheme)continue;const n=i.fsPath;try{
const t=await y(n,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":e.telemetryId,rendererSessionId:e.rendererSessionId}),t.fileTypes.forEach(t=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:e.rendererSessionId,type:t.name,count:t.count})}),t.launchConfigFiles.forEach(t=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:e.rendererSessionId,type:t.name,count:t.count})}),t.configFiles.forEach(t=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:e.rendererSessionId,type:t.name,count:t.count})})}catch(e){}}}};C=r([s(0,p.ITelemetryService)],C),t.DiagnosticsService=C})),define(t[166],i([0,1,20,30,36,19,24,43,66,8,27,13,16,7,37,22,49,5,10]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v,y,S,w){"use strict";var E,C;Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0,function(e){e[e.None=0]="None",
e[e.IncludeVersions=1]="IncludeVersions",e[e.IncludeFiles=2]="IncludeFiles",e[e.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",e[e.IncludeSharedAccounts=8]="IncludeSharedAccounts",e[e.IncludeVersionProperties=16]="IncludeVersionProperties",e[e.ExcludeNonValidated=32]="ExcludeNonValidated",e[e.IncludeInstallationTargets=64]="IncludeInstallationTargets",e[e.IncludeAssetUri=128]="IncludeAssetUri",e[e.IncludeStatistics=256]="IncludeStatistics",e[e.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",e[e.Unpublished=4096]="Unpublished"}(E||(E={})),function(e){e[e.Tag=1]="Tag",e[e.ExtensionId=4]="ExtensionId",e[e.Category=5]="Category",e[e.ExtensionName=7]="ExtensionName",e[e.Target=8]="Target",e[e.Featured=9]="Featured",e[e.SearchText=10]="SearchText",e[e.ExcludeWithFlags=12]="ExcludeWithFlags"}(C||(C={}));const _={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",
Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},b={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:E.None,criteria:[],assetTypes:[]};class x{constructor(e=D){this.state=e}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(e,t=this.state.pageSize){return new x(a.assign({},this.state,{pageNumber:e,pageSize:t}))}withFilter(e,...t){const i=[...this.state.criteria,...t.length?t.map(t=>({
filterType:e,value:t})):[{filterType:e}]];return new x(a.assign({},this.state,{criteria:i}))}withSortBy(e){return new x(a.assign({},this.state,{sortBy:e}))}withSortOrder(e){return new x(a.assign({},this.state,{sortOrder:e}))}withFlags(...e){return new x(a.assign({},this.state,{flags:e.reduce((e,t)=>e|t,0)}))}withAssetTypes(...e){return new x(a.assign({},this.state,{assetTypes:e}))}get raw(){const{criteria:e,pageNumber:t,pageSize:i,sortBy:n,sortOrder:r,flags:s,assetTypes:o}=this.state;return{filters:[{criteria:e,pageNumber:t,pageSize:i,sortBy:n,sortOrder:r}],assetTypes:o,flags:s}}get searchText(){const e=this.state.criteria.filter(e=>e.filterType===C.SearchText)[0];return e&&e.value?e.value:""}}function I(e,t){const i=(e||[]).filter(e=>e.statisticName===t)[0];return i?i.value:0}function P(e){return e.files.filter(e=>0===e.assetType.indexOf("Microsoft.VisualStudio.Code.Translation.")).reduce((t,i)=>{const n=O(e,i.assetType)
;return n&&t.push([i.assetType.substring("Microsoft.VisualStudio.Code.Translation.".length),n]),t},[])}function R(e){if(e.properties){const t=e.properties.filter(e=>e.key===_.Repository),i=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),n=t.filter(e=>i.test(e.value))[0];return n?{uri:n.value,fallbackUri:n.value}:null}return O(e,_.Repository)}function k(e){return{uri:`${e.fallbackAssetUri}/${_.VSIX}?redirect=true`,fallbackUri:`${e.fallbackAssetUri}/${_.VSIX}`}}function L(e){const t=O(e,_.Icon);if(t)return t;const i=n.DefaultIconPath;return{uri:i,fallbackUri:i}}function O(e,t){return e.files.filter(e=>e.assetType===t)[0]?{uri:`${e.assetUri}/${t}`,fallbackUri:`${e.fallbackAssetUri}/${t}`}:null}function A(e,t){const i=e.properties?e.properties.filter(e=>e.key===t):[],n=i.length>0&&i[0].value;return n?n.split(",").map(e=>o.adoptToGalleryExtensionId(e)):[]}function T(e){const t=e.properties?e.properties.filter(e=>e.key===b.Engine):[];return t.length>0&&t[0].value||""}function U(e){
const t=e.properties?e.properties.filter(e=>e.key===b.LocalizedLanguages):[],i=t.length>0&&t[0].value||"";return i?i.split(","):[]}function M(e){const t=e.properties?e.properties.find(e=>e.key===b.WebExtension):void 0;return!!t&&"true"===t.value}function F(e){return e.files.some(e=>e.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?w.joinPath(p.URI.parse(e.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function N(e,t,i,n,r){const s={manifest:O(t,_.Manifest),readme:O(t,_.Details),changelog:O(t,_.Changelog),license:O(t,_.License),repository:R(t),download:k(t),icon:L(t),coreTranslations:P(t)};return{identifier:{id:o.getGalleryExtensionId(e.publisher.publisherName,e.extensionName),uuid:e.extensionId},name:e.extensionName,version:t.version,date:t.lastUpdated,displayName:e.displayName,publisherId:e.publisher.publisherId,publisher:e.publisher.publisherName,publisherDisplayName:e.publisher.displayName,description:e.shortDescription||"",installCount:I(e.statistics,"install"),
rating:I(e.statistics,"averagerating"),ratingCount:I(e.statistics,"ratingcount"),assetUri:p.URI.parse(t.assetUri),webResource:F(t),assetTypes:t.files.map(({assetType:e})=>e),assets:s,properties:{dependencies:A(t,b.Dependency),extensionPack:A(t,b.ExtensionPack),engine:T(t),localizedLanguages:U(t),webExtension:M(t)},telemetryData:{index:(n.pageNumber-1)*n.pageSize+i,searchText:n.searchText,querySource:r},preview:(a=e.flags,-1!==a.indexOf("preview"))};var a}let j=class{constructor(e,t,i,n,r,s,o){this.requestService=e,this.logService=t,this.environmentService=i,this.telemetryService=n,this.fileService=r,this.productService=s;const a=s.extensionsGallery;this.extensionsGalleryUrl=a&&a.serviceUrl,this.extensionsControlUrl=a&&a.controlUrl,this.commonHeadersPromise=$(s.version,this.environmentService,this.fileService,o)}api(e=""){return`${this.extensionsGalleryUrl}${e}`}isEnabled(){return!!this.extensionsGalleryUrl}async getCompatibleExtension(e,t){const i=await this.getCompatibleExtensionByEngine(e,t)
;return(null==i?void 0:i.properties.webExtension)?i.webResource?i:null:i}getCompatibleExtensionByEngine(e,t){const i=n.isIExtensionIdentifier(e)?null:e;if(i&&i.properties.engine&&u.isEngineValid(i.properties.engine,this.productService.version))return Promise.resolve(i);const{id:r,uuid:s}=i?i.identifier:e;let o=(new x).withFlags(E.IncludeAssetUri,E.IncludeStatistics,E.IncludeFiles,E.IncludeVersionProperties).withPage(1,1).withFilter(C.Target,"Microsoft.VisualStudio.Code");return o=s?o.withFilter(C.ExtensionId,s):o.withFilter(C.ExtensionName,r),this.queryGallery(o,d.CancellationToken.None).then(({galleryExtensions:e})=>{const[i]=e;if(!i||!i.versions.length)return null;if(t){const e=i.versions.filter(e=>e.version===t)[0];if(e){const t=N(i,e,0,o);if(t.properties.engine&&u.isEngineValid(t.properties.engine,this.productService.version))return t}return null}return this.getLastValidExtensionVersion(i,i.versions).then(e=>e?N(i,e,0,o):null)})}query(e,t){
const n=d.CancellationToken.isCancellationToken(e)?{}:e,r=d.CancellationToken.isCancellationToken(e)?e:t;if(!this.isEnabled())return Promise.reject(new Error("No extension gallery service configured."));const s=n.names?"ids":n.text?"text":"all";let o=n.text||"";const c=a.getOrDefault(n,e=>e.pageSize,50);this.telemetryService.publicLog2("galleryService:query",{type:s,text:o});let l=(new x).withFlags(E.IncludeLatestVersionOnly,E.IncludeAssetUri,E.IncludeStatistics,E.IncludeFiles,E.IncludeVersionProperties).withPage(1,c).withFilter(C.Target,"Microsoft.VisualStudio.Code");return o?((o=(o=(o=(o=o.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(e,t,i)=>(l=l.withFilter(C.Category,i||t),""))).replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(e,t,i)=>(l=l.withFilter(C.Tag,i||t),""))).replace(/\bfeatured(\s+|\b|$)/g,()=>(l=l.withFilter(C.Featured),""))).trim())&&(o=o.length<200?o:o.substring(0,200),l=l.withFilter(C.SearchText,o)),
l=l.withSortBy(0)):l=n.ids?l.withFilter(C.ExtensionId,...n.ids):n.names?l.withFilter(C.ExtensionName,...n.names):l.withSortBy(4),"number"==typeof n.sortBy&&(l=l.withSortBy(n.sortBy)),"number"==typeof n.sortOrder&&(l=l.withSortOrder(n.sortOrder)),this.queryGallery(l,r).then(({galleryExtensions:e,total:t})=>{return{firstPage:e.map((e,t)=>N(e,e.versions[0],t,l,n.source)),total:t,pageSize:l.pageSize,getPage:(e,t)=>{if(t.isCancellationRequested)return Promise.reject(i.canceled());const r=l.withPage(e+1);return this.queryGallery(r,t).then(({galleryExtensions:e})=>e.map((e,t)=>N(e,e.versions[0],t,r,n.source)))}}})}queryGallery(e,t){return e=e.withFlags(e.flags,E.ExcludeNonValidated).withFilter(C.ExcludeWithFlags,function(...e){return String(e.reduce((e,t)=>e|t,0))}(E.Unpublished)),this.isEnabled()?this.commonHeadersPromise.then(i=>{const n=JSON.stringify(e.raw),r=a.assign({},i,{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":n.length})
;return this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:n,headers:r},t).then(e=>e.res.statusCode&&e.res.statusCode>=400&&e.res.statusCode<500?{galleryExtensions:[],total:0}:l.asJson(e).then(e=>{if(e){const t=e.results[0],i=t.extensions,n=t.resultMetadata&&t.resultMetadata.filter(e=>"ResultCount"===e.metadataType)[0];return{galleryExtensions:i,total:n&&n.metadataItems.filter(e=>"TotalCount"===e.name)[0].count||0}}return{galleryExtensions:[],total:0}}))}):Promise.reject(new Error("No extension gallery service configured."))}reportStatistic(e,t,i,n){return this.isEnabled()?this.commonHeadersPromise.then(r=>{const s=Object.assign(Object.assign({},r),{Accept:"*/*;api-version=4.0-preview.1"});return this.requestService.request({type:"POST",url:this.api(`/publishers/${e}/extensions/${t}/${i}/stats?statType=${n}`),headers:s},d.CancellationToken.None).then(void 0,()=>void 0)}):Promise.resolve(void 0)}download(e,t,i){this.logService.trace("ExtensionGalleryService#download",e.identifier.id)
;const n=o.getGalleryExtensionTelemetryData(e),r=(new Date).getTime(),s=e=>this.telemetryService.publicLog("galleryService:downloadVSIX",a.assign(n,{duration:e})),c=1===i?"install":2===i?"update":"",l=c?{uri:`${e.assets.download.uri}&${c}=true`,fallbackUri:`${e.assets.download.fallbackUri}?${c}=true`}:e.assets.download;return this.getAsset(l).then(e=>this.fileService.writeFile(t,e.stream)).then(()=>s((new Date).getTime()-r))}getReadme(e,t){return e.assets.readme?this.getAsset(e.assets.readme,{},t).then(e=>l.asText(e)).then(e=>e||""):Promise.resolve("")}getManifest(e,t){return e.assets.manifest?this.getAsset(e.assets.manifest,{},t).then(l.asText).then(e=>e?JSON.parse(e):null):Promise.resolve(null)}getCoreTranslation(e,t){const i=e.assets.coreTranslations.filter(e=>e[0]===t.toUpperCase())[0];return i?this.getAsset(i[1]).then(l.asText).then(e=>e?JSON.parse(e):null):Promise.resolve(null)}getChangelog(e,t){
return e.assets.changelog?this.getAsset(e.assets.changelog,{},t).then(e=>l.asText(e)).then(e=>e||""):Promise.resolve("")}async getAllVersions(e,t){let i=(new x).withFlags(E.IncludeVersions,E.IncludeFiles,E.IncludeVersionProperties).withPage(1,1).withFilter(C.Target,"Microsoft.VisualStudio.Code");i=e.identifier.uuid?i.withFilter(C.ExtensionId,e.identifier.uuid):i.withFilter(C.ExtensionName,e.identifier.id);const n=[],{galleryExtensions:r}=await this.queryGallery(i,d.CancellationToken.None);return r.length&&(t?await Promise.all(r[0].versions.map(async e=>{let t;try{t=await this.getEngine(e)}catch(e){}t&&u.isEngineValid(t,this.productService.version)&&n.push({version:e.version,date:e.lastUpdated})})):n.push(...r[0].versions.map(e=>({version:e.version,date:e.lastUpdated})))),n}getAsset(e,t={},n=d.CancellationToken.None){return this.commonHeadersPromise.then(r=>{const s=a.assign({},r,t.headers||{});t=a.assign({},t,{type:"GET"},{headers:s});const o=e.uri,c=e.fallbackUri,u=a.assign({},t,{url:o})
;return this.requestService.request(u,n).then(e=>200===e.res.statusCode?Promise.resolve(e):l.asText(e).then(t=>Promise.reject(new Error(`Expected 200, got back ${e.res.statusCode} instead.\n\n${t}`)))).then(void 0,e=>{if(i.isPromiseCanceledError(e))return Promise.reject(e);const r=i.getErrorMessage(e);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:o,message:r});const s=a.assign({},t,{url:c});return this.requestService.request(s,n)})})}getLastValidExtensionVersion(e,t){const i=this.getLastValidExtensionVersionFromProperties(e,t);return i||this.getLastValidExtensionVersionRecursively(e,t)}getLastValidExtensionVersionFromProperties(e,t){for(const e of t){const t=T(e);if(!t)return null;if(u.isEngineValid(t,this.productService.version))return Promise.resolve(e)}return null}getEngine(e){const t=T(e);if(t)return Promise.resolve(t);const i=O(e,_.Manifest);if(!i)return Promise.reject("Manifest was not found");return this.getAsset(i,{headers:{"Accept-Encoding":"gzip"}
}).then(e=>l.asJson(e)).then(e=>e?e.engines.vscode:Promise.reject("Error while reading manifest"))}getLastValidExtensionVersionRecursively(e,t){if(!t.length)return Promise.resolve(null);const i=t[0];return this.getEngine(i).then(n=>u.isEngineValid(n,this.productService.version)?(i.properties=i.properties||[],i.properties.push({key:b.Engine,value:n}),i):this.getLastValidExtensionVersionRecursively(e,t.slice(1)))}getExtensionsReport(){return this.isEnabled()?this.extensionsControlUrl?this.requestService.request({type:"GET",url:this.extensionsControlUrl},d.CancellationToken.None).then(e=>200!==e.res.statusCode?Promise.reject(new Error("Could not get extensions report.")):l.asJson(e).then(e=>{const t=new Map;if(e)for(const i of e.malicious){const e=t.get(i)||{id:{id:i},malicious:!0,slow:!1};e.malicious=!0,t.set(i,e)}return[...t.values()]})):Promise.resolve([]):Promise.reject(new Error("No extension gallery service configured."))}};async function $(e,t,i,n){const r={"X-Market-Client-Id":`VSCode ${e}`,
"User-Agent":`VSCode ${e}`},s=await y.getServiceMachineId(t,i,n);return r["X-Market-User-Id"]=s,r}j=r([s(0,l.IRequestService),s(1,f.ILogService),s(2,h.IEnvironmentService),s(3,c.ITelemetryService),s(4,g.IFileService),s(5,m.IProductService),s(6,S.optional(v.IStorageService))],j),t.ExtensionGalleryService=j,t.resolveMarketplaceHeaders=$})),define(t[167],i([0,1,3,2,29,24]),(function(e,t,i,n,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalStorageDatabaseChannelClient=t.GlobalStorageDatabaseChannel=void 0;class o extends n.Disposable{constructor(e,t){super(),this.logService=e,this.storageMainService=t,this._onDidChangeItems=this._register(new i.Emitter),this.onDidChangeItems=this._onDidChangeItems.event,this.whenReady=this.init()}async init(){try{await this.storageMainService.initialize()}catch(e){this.logService.error(`[storage] init(): Unable to init global storage due to ${e}`)}this.initTelemetry(),this.registerListeners()}initTelemetry(){
void 0===this.storageMainService.get(s.instanceStorageKey,void 0)&&this.storageMainService.store(s.instanceStorageKey,r.generateUuid()),void 0===this.storageMainService.get(s.firstSessionDateStorageKey,void 0)&&this.storageMainService.store(s.firstSessionDateStorageKey,(new Date).toUTCString());const e=this.storageMainService.get(s.currentSessionDateStorageKey,void 0),t=(new Date).toUTCString();this.storageMainService.store(s.lastSessionDateStorageKey,void 0===e?null:e),this.storageMainService.store(s.currentSessionDateStorageKey,t)}registerListeners(){this._register(i.Event.debounce(this.storageMainService.onDidChangeStorage,(e,t)=>(e?e.push(t):e=[t],e),o.STORAGE_CHANGE_DEBOUNCE_TIME)(e=>{e.length&&this._onDidChangeItems.fire(this.serializeEvents(e))}))}serializeEvents(e){const t=new Map,i=new Set;return e.forEach(e=>{const n=this.storageMainService.get(e.key);"string"==typeof n?t.set(e.key,n):i.add(e.key)}),{changed:Array.from(t.entries()),deleted:Array.from(i.values())}}listen(e,t){switch(t){
case"onDidChangeItems":return this.onDidChangeItems}throw new Error(`Event not found: ${t}`)}async call(e,t,i){switch(await this.whenReady,t){case"getItems":return Array.from(this.storageMainService.items.entries());case"updateItems":{const e=i;if(e.insert)for(const[t,i]of e.insert)this.storageMainService.store(t,i);e.delete&&e.delete.forEach(e=>this.storageMainService.remove(e));break}default:throw new Error(`Call not found: ${t}`)}}}t.GlobalStorageDatabaseChannel=o,o.STORAGE_CHANGE_DEBOUNCE_TIME=100;class a extends n.Disposable{constructor(e){super(),this.channel=e,this._onDidChangeItemsExternal=this._register(new i.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this.onDidChangeItemsOnMainListener=this.channel.listen("onDidChangeItems")(e=>this.onDidChangeItemsOnMain(e))}onDidChangeItemsOnMain(e){(Array.isArray(e.changed)||Array.isArray(e.deleted))&&this._onDidChangeItemsExternal.fire({changed:e.changed?new Map(e.changed):void 0,
deleted:e.deleted?new Set(e.deleted):void 0})}async getItems(){const e=await this.channel.call("getItems");return new Map(e)}updateItems(e){const t=Object.create(null);return e.insert&&(t.insert=Array.from(e.insert.entries())),e.delete&&(t.delete=Array.from(e.delete.values())),this.channel.call("updateItems",t)}close(){return n.dispose(this.onDidChangeItemsOnMainListener),Promise.resolve()}dispose(){super.dispose(),n.dispose(this.onDidChangeItemsOnMainListener)}}t.GlobalStorageDatabaseChannelClient=a})),define(t[168],i([0,1,116,14,5,25,42,2,19,33]),(function(e,t,i,n,o,a,c,l,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let d=class{constructor(e,t){this._configurationService=t,this._experimentProperties={},this._disposables=new l.DisposableStore,this._cleanupPatterns=[],this._appender=e.appender,this._commonProperties=e.commonProperties||Promise.resolve({}),this._piiPaths=e.piiPaths||[],this._userOptIn=!0,this._enabled=!0,
this.sendErrorTelemetry=!!e.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let e of this._piiPaths)this._cleanupPatterns.push(new RegExp(n.escapeRegExpCharacters(e),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(e=>{const t=/^[a-f0-9]+$/i.test(e["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!t})}))}setExperimentProperty(e,t){this._experimentProperties[e]=t}setEnabled(e){this._enabled=e}_updateUserOptIn(){var e;const t=null===(e=this._configurationService)||void 0===e?void 0:e.getValue(f);this._userOptIn=t?t.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const e=await this._commonProperties;return{sessionId:e.sessionID,instanceId:e["common.instanceId"],machineId:e["common.machineId"],
msftInternal:e["common.msftInternal"]}}dispose(){this._disposables.dispose()}publicLog(e,t,i){return this.isOptedIn?this._commonProperties.then(n=>{t=u.mixin(t,n),t=u.mixin(t,this._experimentProperties),t=u.cloneAndChange(t,e=>{if("string"==typeof e)return this._cleanupInfo(e,i)}),this._appender.log(e,t)},e=>{console.error(e)}):Promise.resolve(void 0)}publicLog2(e,t,i){return this.publicLog(e,t,i)}publicLogError(e,t){return this.sendErrorTelemetry?this.publicLog(e,t,!0):Promise.resolve(void 0)}publicLogError2(e,t){return this.publicLogError(e,t)}_cleanupInfo(e,t){let i=e;if(t){const t=[];for(let i of this._cleanupPatterns)for(;;){const n=i.exec(e);if(!n)break;t.push([n.index,i.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(i="";;){const o=r.exec(e);if(!o)break;!n.test(o[0])&&t.every(([e,t])=>o.index<e||o.index>=t)&&(i+=e.substring(s,o.index)+"<REDACTED: user-file-path>",s=r.lastIndex)}
s<e.length&&(i+=e.substr(s))}for(let e of this._cleanupPatterns)i=i.replace(e,"");return i}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=r([s(1,o.optional(a.IConfigurationService))],d),t.TelemetryService=d;const f="telemetry";h.Registry.as(c.Extensions.Configuration).registerConfiguration({id:f,order:110,type:"object",title:i.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",description:i.localize(1,null),default:!0,tags:["usesOnlineServices"]}}})})),define(t[79],i([0,1,25,13,19,18]),(function(e,t,i,n,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.LogAppender=t.NullAppender=t.combinedAppender=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(e,t){return Promise.resolve(void 0)}publicLog2(e,t){return this.publicLog(e,t)}publicLogError(e,t){return Promise.resolve(void 0)}
publicLogError2(e,t){return this.publicLogError(e,t)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId"})}},t.combinedAppender=function(...e){return{log:(t,i)=>e.forEach(e=>e.log(t,i)),flush:()=>Promise.all(e.map(e=>e.flush()))}},t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};let c=class{constructor(e){this._logService=e,this.commonPropertiesRegex=/^sessionID$|^version$|^timestamp$|^commitHash$|^common\./}flush(){return Promise.resolve(void 0)}log(e,t){const i={};Object.keys(t).forEach(e=>{this.commonPropertiesRegex.test(e)||(i[e]=t[e])}),this._logService.trace(`telemetry/${e}`,i)}};function l(e){if(!e)return[];const t=[];return function e(t,i,n){n&&"object"==typeof n&&!Array.isArray(n)?Object.keys(n).forEach(r=>e(t,i?`${i}.${r}`:r,n[r])):t.push(i)}(t,"",e),t}c=r([s(0,n.ILogService)],c),t.LogAppender=c,t.configurationTelemetry=function(e,t){
return t.onDidChangeConfiguration(t=>{6!==t.source&&e.publicLog2("updateConfiguration",{configurationSource:i.ConfigurationTargetToString(t.source),configurationKeys:l(t.sourceConfig)})})},t.validateTelemetryData=function(e){const t=Object.create(null),i=Object.create(null),n=Object.create(null);!function e(t,i,n=0,r){if(!t)return;for(let s of Object.getOwnPropertyNames(t)){const c=t[s],l=r?r+s:s;Array.isArray(c)?i[l]=o.safeStringify(c):c instanceof Date?i[l]=c.toISOString():a.isObject(c)?n<2?e(c,i,n+1,l+"."):i[l]=o.safeStringify(c):i[l]=c}}(e,n);for(let e in n){const r=n[e=e.length>150?e.substr(e.length-149):e];"number"==typeof r?i[e]=r:"boolean"==typeof r?i[e]=r?1:0:"string"==typeof r?t[e]=r.substring(0,1023):null!=r&&(t[e]=r)}return{properties:t,measurements:i}},t.cleanRemoteAuthority=function(e){if(!e)return"none";let t="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(i=>{0===e.indexOf(`${i}+`)&&(t=i)}),t}})),define(t[169],i([0,1,197,19,79,13]),(function(e,t,i,n,o,a){
"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;let c=class{constructor(e,t,n,r){this._eventPrefix=e,this._defaultData=t,this._logService=r,this._defaultData||(this._defaultData=Object.create(null)),"string"==typeof n?this._aiClient=function(e){let t;return i.defaultClient?(t=new i.TelemetryClient(e)).channel.setUseDiskRetryCaching(!0):(i.setup(e).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),t=i.defaultClient),0===e.indexOf("AIF-")&&(t.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),t}(n):"function"==typeof n&&(this._aiClient=n())}log(e,t){this._aiClient&&(t=n.mixin(t,this._defaultData),t=o.validateTelemetryData(t),this._logService&&this._logService.trace(`telemetry/${e}`,t),this._aiClient.trackEvent({name:this._eventPrefix+"/"+e,properties:t.properties,
measurements:t.measurements}))}flush(){return this._aiClient?new Promise(e=>{this._aiClient.flush({callback:()=>{this._aiClient=void 0,e(void 0)}})}):Promise.resolve(void 0)}};c=r([s(3,a.ILogService)],c),t.AppInsightsAppender=c})),define(t[170],i([0,1,6,40,29,21]),(function(e,t,i,n,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0,t.resolveCommonProperties=async function(e,t,o,a,c,l){const u=Object.create(null);u["common.machineId"]=o,u.sessionID=r.generateUuid()+Date.now(),u.commitHash=e,u.version=t,u["common.platformVersion"]=(n.release()||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=i.PlatformToString(i.platform),u["common.nodePlatform"]=process.platform,u["common.nodeArch"]=process.arch,u["common.product"]=l||"desktop";const h=function(e){if(!process||!process.env||!process.env.USERDNSDOMAIN)return!1;const t=process.env.USERDNSDOMAIN.toLowerCase();return e.some(e=>t===e)}(a||[]);h&&(u["common.msftInternal"]=h);let d=0
;const f=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),"linux"===process.platform&&process.env.SNAP&&process.env.SNAP_REVISION&&(u["common.snap"]="true");try{const e=await s.readFile(c,"utf8");u["common.source"]=e.slice(0,30)}catch(e){}return u}})),define(t[171],i([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryAppenderClient=t.TelemetryAppenderChannel=void 0;t.TelemetryAppenderChannel=class{constructor(e){this.appender=e}listen(e,t){throw new Error(`Event not found: ${t}`)}call(e,t,{eventName:i,data:n}){return this.appender.log(i,n),Promise.resolve(null)}};t.TelemetryAppenderClient=class{constructor(e){this.channel=e}log(e,t){return this.channel.call("log",{eventName:e,data:t}).then(void 0,e=>`Failed to log telemetry: ${console.warn(e)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}})),
define(t[50],i([0,1,38]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLineEndOffset=t.getLineStartOffset=t.edit=void 0,t.edit=function(e,t,n,r){const s=i.setProperty(e,t,n,r)[0];return s&&(e=e.substring(0,s.offset)+s.content+e.substring(s.offset+s.length)),e},t.getLineStartOffset=function(e,t,i){let n=i;for(;n>=0;){if(e.charAt(n)===t.charAt(t.length-1)&&1===t.length)return n+1;if(n--,2===t.length&&n>=0&&e.charAt(n)===t.charAt(0))return n+2}return 0},t.getLineEndOffset=function(e,t,i){let n=i;for(;n>=0;){if(e.charAt(n)===t.charAt(t.length-1)&&1===t.length)return n;if(n++,2===t.length&&n>=0&&e.charAt(n)===t.charAt(1))return n}return e.length-1}})),define(t[172],i([0,1,19,15]),(function(e,t,i,n){"use strict";function r(e,t,i,{checkInstalledProperty:n}={checkInstalledProperty:!1}){const r=e?[...e.keys()].filter(e=>!i.has(e)):[],s=[...t.keys()].filter(e=>!i.has(e)),o=s.filter(e=>-1===r.indexOf(e)).reduce((e,t)=>(e.add(t),
e),new Set),a=r.filter(e=>-1===s.indexOf(e)).reduce((e,t)=>(e.add(t),e),new Set),c=new Set;for(const i of r){if(a.has(i))continue;const r=e.get(i),s=t.get(i);(!s||r.disabled!==s.disabled||r.version!==s.version||n&&r.installed!==s.installed)&&c.add(i)}return{added:o,removed:a,updated:c}}function s(e){return Object.assign(Object.assign({},e),{disabled:!!e.disabled,installed:!!e.installed})}function o(e,t){const i={identifier:{id:e.identifier.id,uuid:t.startsWith("uuid:")?t.substring("uuid:".length):void 0}};return e.disabled&&(i.disabled=!0),e.installed&&(i.installed=!0),e.version&&(i.version=e.version),i}Object.defineProperty(t,"__esModule",{value:!0}),t.getIgnoredExtensions=t.merge=void 0,t.merge=function(e,t,n,a,c){var l,u;const h=[],d=[],f=[];if(!t){const t=e.filter(({identifier:e})=>c.every(t=>t.toLowerCase()!==e.id.toLowerCase()));return{added:h,removed:d,updated:f,remote:t.length>0?t:null}}e=e.map(s),t=t.map(s),n=n?n.map(s):null;const g=new Map,p=e=>{e.uuid&&g.set(e.id.toLowerCase(),e.uuid)}
;e.forEach(({identifier:e})=>p(e)),t.forEach(({identifier:e})=>p(e)),n&&n.forEach(({identifier:e})=>p(e));const m=e=>{const t=e.identifier.uuid||g.get(e.identifier.id.toLowerCase());return t?`uuid:${t}`:`id:${e.identifier.id.toLowerCase()}`},v=(e,t)=>(e.set(m(t),t),e),y=e.reduce(v,new Map),S=t.reduce(v,new Map),w=t.reduce((e,t)=>{var n;const r=m(t);return t=i.deepClone(t),(null===(n=y.get(r))||void 0===n?void 0:n.installed)&&(t.installed=!0),v(e,t)},new Map),E=n?n.reduce(v,new Map):null,C=a.reduce(v,new Map),_=c.reduce((e,t)=>{const i=g.get(t.toLowerCase());return e.add(i?`uuid:${i}`:`id:${t.toLowerCase()}`)},new Set),b=r(y,S,_);if(b.added.size>0||b.removed.size>0||b.updated.size>0){const e=r(E,y,_),t=r(E,S,_);for(const e of t.removed.values()){const t=y.get(e);t&&d.push(t.identifier)}for(const i of t.added.values())if(e.added.has(i))b.updated.has(i)&&f.push(o(S.get(i),i));else{const e=S.get(i);e.installed&&h.push(o(e,i))}for(const e of t.updated.values())f.push(o(S.get(e),e))
;for(const i of e.added.values())t.added.has(i)||w.set(i,y.get(i));for(const n of e.updated.values())if(!t.removed.has(n)&&!t.updated.has(n)){const e=i.deepClone(y.get(n));(null===(l=w.get(n))||void 0===l?void 0:l.installed)&&(e.installed=!0),w.set(n,e)}for(const i of e.removed.values())C.has(i)||t.updated.has(i)||(null===(u=null==E?void 0:E.get(i))||void 0===u?void 0:u.installed)&&w.delete(i)}const D=[],x=r(S,w,new Set,{checkInstalledProperty:!0});return(x.added.size>0||x.updated.size>0||x.removed.size>0)&&w.forEach((e,t)=>D.push(o(e,t))),{added:h,removed:d,updated:f,remote:D.length?D:null}},t.getIgnoredExtensions=function(e,t){const i=e.filter(e=>e.isMachineScoped).map(e=>e.identifier.id.toLowerCase()),r=function(e){let t=e.inspect("settingsSync.ignoredExtensions").userValue;if(void 0!==t)return t;if(void 0!==(t=e.inspect("sync.ignoredExtensions").userValue))return t;return e.getValue("settingsSync.ignoredExtensions")||[]}(t).map(e=>e.toLowerCase()),s=[],o=[]
;if(Array.isArray(r))for(const e of r)e.startsWith("-")?o.push(e.substring(1)):s.push(e);return n.distinct([...i,...s].filter(e=>-1===o.indexOf(e)))}})),define(t[173],i([0,1,19]),(function(e,t,i){"use strict";function n(e,t){const n=Object.keys(e),r=Object.keys(t),s=r.filter(e=>-1===n.indexOf(e)).reduce((e,t)=>(e.add(t),e),new Set),o=n.filter(e=>-1===r.indexOf(e)).reduce((e,t)=>(e.add(t),e),new Set),a=new Set;for(const r of n){if(o.has(r))continue;const n=e[r],s=t[r];i.equals(n,s)||a.add(r)}return{added:s,removed:o,updated:a}}function r(e,t){const{added:i,removed:r,updated:s}=n(e,t);return 0===i.size&&0===r.size&&0===s.size}Object.defineProperty(t,"__esModule",{value:!0}),t.merge=void 0,t.merge=function(e,t,s,o,a,c){if(!t)return{remote:Object.keys(e).length>0?e:null,local:{added:{},removed:[],updated:{}},skipped:[]};const l=n(e,t);if(0===l.added.size&&0===l.removed.size&&0===l.updated.size)return{remote:null,local:{added:{},removed:[],updated:{}},skipped:[]};const u=s?n(s,t):{
added:Object.keys(t).reduce((e,t)=>(e.add(t),e),new Set),removed:new Set,updated:new Set},h=s?n(s,e):{added:Object.keys(e).reduce((e,t)=>(e.add(t),e),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},f=i.deepClone(t),g=[];for(const i of u.added.values()){const n=t[i],r=o.filter(e=>e.key===i)[0];if(!r){g.push(i),c.trace(`GlobalState: Skipped adding ${i} in local storage as it is not registered.`);continue}if(r.version!==n.version){c.info(`GlobalState: Skipped adding ${i} in local storage. Local version '${r.version}' and remote version '${n.version} are not same.`);continue}const s=e[i];s&&s.value===n.value||(h.added.has(i)?d.updated[i]=n:d.added[i]=n)}for(const i of u.updated.values()){const n=t[i],r=o.filter(e=>e.key===i)[0];if(!r){g.push(i),c.trace(`GlobalState: Skipped updating ${i} in local storage as is not registered.`);continue}if(r.version!==n.version){
c.info(`GlobalState: Skipped updating ${i} in local storage. Local version '${r.version}' and remote version '${n.version} are not same.`);continue}const s=e[i];s&&s.value===n.value||(d.updated[i]=n)}for(const e of u.removed.values()){o.filter(t=>t.key===e)[0]?d.removed.push(e):c.trace(`GlobalState: Skipped removing ${e} in local storage. It is not registered to sync.`)}for(const t of h.added.values())u.added.has(t)||(f[t]=e[t]);for(const t of h.updated.values()){if(u.updated.has(t)||u.removed.has(t))continue;const i=f[t],n=e[t];n.version<i.version?c.info(`GlobalState: Skipped updating ${t} in remote storage. Local version '${n.version}' and remote version '${i.version} are not same.`):f[t]=n}for(const e of h.removed.values()){if(u.updated.has(e))continue;const t=o.filter(t=>t.key===e)[0];if(!t){g.push(e),c.trace(`GlobalState: Skipped removing ${e} in remote storage. It is not registered to sync.`);continue}const i=f[e]
;t.version<i.version?c.info(`GlobalState: Skipped updating ${e} in remote storage. Local version '${t.version}' and remote version '${i.version} are not same.`):-1===a.indexOf(e)?delete f[e]:d.added[e]=f[e]}return{local:d,remote:r(f,t)?null:f,skipped:g}}})),define(t[174],i([0,1,19,28,15,137,50]),(function(e,t,i,n,r,s,o){"use strict";function a(e){return n.parse(e)||[]}function c(e,t,i){const n=new Set,r=new Set,s=new Set,o=new Set;for(const e of t.removed.values())i.updated.has(e)&&o.add(e);for(const e of i.removed.values())o.has(e)||(t.updated.has(e)?o.add(e):r.add(e));for(const n of t.added.values())o.has(n)||i.added.has(n)&&e.updated.has(n)&&o.add(n);for(const r of i.added.values())o.has(r)||(t.added.has(r)?e.updated.has(r)&&o.add(r):n.add(r));for(const n of t.updated.values())o.has(n)||i.updated.has(n)&&e.updated.has(n)&&o.add(n);for(const n of i.updated.values())o.has(n)||(t.updated.has(n)?e.updated.has(n)&&o.add(n):s.add(n));return{added:n,removed:r,updated:s,conflicts:o}}function l(e,t){const i=new Map
;for(const n of e){const e=t[n.key];let r=i.get(e);r||(r=[],i.set(e,r)),r.push(n)}return i}function u(e){const t=new Map;for(const i of e){const e="-"===i.command[0]?i.command.substring(1):i.command;let n=t.get(e);n||(n=[],t.set(e,n)),n.push(i)}return t}function h(e,t){const i=[...e.keys()],n=[...t.keys()],s=n.filter(e=>-1===i.indexOf(e)).reduce((e,t)=>(e.add(t),e),new Set),o=i.filter(e=>-1===n.indexOf(e)).reduce((e,t)=>(e.add(t),e),new Set),a=new Set;for(const n of i){if(o.has(n))continue;const i=e.get(n).map(e=>Object.assign(Object.assign({},e),{key:n})),s=t.get(n).map(e=>Object.assign(Object.assign({},e),{key:n}));r.equals(i,s,(e,t)=>g(e,t))||a.add(n)}return{added:s,removed:o,updated:a}}function d(e,t,i){const n=[...e.keys()],r=[...t.keys()],s=r.filter(e=>-1===n.indexOf(e)).reduce((e,t)=>(e.add(t),e),new Set),o=n.filter(e=>-1===r.indexOf(e)).reduce((e,t)=>(e.add(t),e),new Set),a=new Set;for(const r of n){if(o.has(r))continue;f(e.get(r).map(e=>Object.assign(Object.assign({},e),{key:i[e.key]
})),t.get(r).map(e=>Object.assign(Object.assign({},e),{key:i[e.key]})))||a.add(r)}return{added:s,removed:o,updated:a}}function f(e,t){return!!r.equals(e.filter(({command:e})=>"-"!==e[0]),t.filter(({command:e})=>"-"!==e[0]),(e,t)=>g(e,t))&&!!r.equals(e.filter(({command:e})=>"-"===e[0]),t.filter(({command:e})=>"-"===e[0]),(e,t)=>g(e,t))}function g(e,t){if(e.command!==t.command)return!1;if(e.key!==t.key)return!1;const n=s.ContextKeyExpr.deserialize(e.when),r=s.ContextKeyExpr.deserialize(t.when);return!(n&&!r||!n&&r)&&(!(n&&r&&!n.equals(r))&&!!i.equals(e.args,t.args))}function p(e,t,i){for(const n of t)e=o.edit(e,[-1],n,i);return e}function m(e,t,i){const n=a(e);for(let r=n.length-1;r>=0;r--)n[r].command!==t&&n[r].command!==`-${t}`||(e=o.edit(e,[r],void 0,i));return e}function v(e,t,i,n){const s=a(e),c=r.firstIndex(s,e=>e.command===t||e.command===`-${t}`);for(let i=s.length-1;i>=0;i--)s[i].command!==t&&s[i].command!==`-${t}`||(e=o.edit(e,[i],void 0,n));for(let t=i.length-1;t>=0;t--)e=o.edit(e,[c],i[t],n);return e
}Object.defineProperty(t,"__esModule",{value:!0}),t.merge=t.parseKeybindings=void 0,t.parseKeybindings=a,t.merge=async function(e,t,i,n,r){const s=a(e),o=a(t),f=i?a(i):null,g=[...s,...o,...f||[]].map(e=>e.key),y=await r.resolveUserBindings(g);let S=function(e,t,i,n){const r=new Set,s=l(e,n),o=l(t,n),a=i?l(i,n):null,u=h(s,o);if(0===u.added.size&&0===u.removed.size&&0===u.updated.size)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const d=a?h(a,s):{added:[...s.keys()].reduce((e,t)=>(e.add(t),e),new Set),removed:new Set,updated:new Set};if(0===d.added.size&&0===d.removed.size&&0===d.updated.size)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const f=a?h(a,o):{added:[...o.keys()].reduce((e,t)=>(e.add(t),e),new Set),removed:new Set,updated:new Set};if(0===f.added.size&&0===f.removed.size&&0===f.updated.size)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r}
;const{added:g,removed:p,updated:m,conflicts:v}=c(u,d,f);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:g,removed:p,updated:m,conflicts:v}}(s,o,f,y);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:e,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:t,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:e,hasChanges:!0,hasConflicts:!1};const w=u(s),E=u(o),C=f?u(f):null,_=c(d(w,E,y),C?d(C,w,y):{added:[...w.keys()].reduce((e,t)=>(e.add(t),e),new Set),removed:new Set,updated:new Set},C?d(C,E,y):{added:[...E.keys()].reduce((e,t)=>(e.add(t),e),new Set),removed:new Set,updated:new Set});let b=e;for(const e of _.removed.values())_.conflicts.has(e)||(b=m(b,e,n));for(const e of _.added.values()){if(_.conflicts.has(e))continue;const t=E.get(e);t.some(t=>t.command!==`-${e}`&&S.conflicts.has(y[t.key]))?_.conflicts.add(e):b=p(b,t,n)}for(const e of _.updated.values()){if(_.conflicts.has(e))continue
;const t=E.get(e);t.some(t=>t.command!==`-${e}`&&S.conflicts.has(y[t.key]))?_.conflicts.add(e):b=v(b,e,t,n)}return{mergeContent:b,hasChanges:!0,hasConflicts:_.conflicts.size>0}}})),define(t[175],i([0,1]),(function(e,t){"use strict";function i(e,t){const i=e?Object.keys(e):[],n=t?Object.keys(t):[],r=n.filter(e=>-1===i.indexOf(e)).reduce((e,t)=>(e.add(t),e),new Set),s=i.filter(e=>-1===n.indexOf(e)).reduce((e,t)=>(e.add(t),e),new Set),o=new Set;for(const n of i){if(s.has(n))continue;e[n]!==t[n]&&o.add(n)}return{added:r,removed:s,updated:o}}Object.defineProperty(t,"__esModule",{value:!0}),t.areSame=t.merge=void 0,t.merge=function(e,t,n){const r={},s={},o=new Set;if(!t)return{local:{added:r,updated:s,removed:[...o.values()]},remote:{added:e,updated:{},removed:[]},conflicts:[]};const a=i(e,t);if(0===a.added.size&&0===a.removed.size&&0===a.updated.size)return{local:{added:r,updated:s,removed:[...o.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const c=i(n,e),l=i(n,t),u={},h={},d=new Set,f=new Set
;for(const e of c.removed.values())l.updated.has(e)?r[e]=t[e]:d.add(e);for(const e of l.removed.values())f.has(e)||(c.updated.has(e)?f.add(e):o.add(e));for(const t of c.updated.values())f.has(t)||(l.updated.has(t)?a.updated.has(t)&&f.add(t):h[t]=e[t]);for(const i of l.updated.values())f.has(i)||(c.updated.has(i)?a.updated.has(i)&&f.add(i):void 0!==e[i]&&(s[i]=t[i]));for(const t of c.added.values())f.has(t)||(l.added.has(t)?a.updated.has(t)&&f.add(t):u[t]=e[t]);for(const e of l.added.values())f.has(e)||(c.added.has(e)?a.updated.has(e)&&f.add(e):r[e]=t[e]);return{local:{added:r,removed:[...o.values()],updated:s},remote:{added:u,removed:[...d.values()],updated:h},conflicts:[...f.values()]}},t.areSame=function(e,t){const{added:n,removed:r,updated:s}=i(e,t);return 0===n.size&&0===r.size&&0===s.size}})),define(t[80],i([0,1,3,2,5]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StorageKeysSyncRegistryService=t.IStorageKeysSyncRegistryService=void 0,
t.IStorageKeysSyncRegistryService=r.createDecorator("IStorageKeysSyncRegistryService");class s extends n.Disposable{constructor(){super(),this._storageKeys=new Map,this._onDidChangeStorageKeys=this._register(new i.Emitter),this.onDidChangeStorageKeys=this._onDidChangeStorageKeys.event,this._register(n.toDisposable(()=>this._storageKeys.clear()))}get storageKeys(){return[...this._storageKeys.values()]}registerStorageKey(e){this._storageKeys.has(e.key)||(this._storageKeys.set(e.key,e),this._onDidChangeStorageKeys.fire(this.storageKeys))}}t.StorageKeysSyncRegistryService=s})),define(t[23],i([0,1,5,30,33,42,121,78,10,15,18]),(function(e,t,i,n,r,s,o,a,c,l,u){"use strict";function h(){const e=r.Registry.as(s.Extensions.Configuration).getConfigurationProperties();return Object.keys(e).filter(t=>!!e[t].disallowSyncIgnore)}function d(){const e=r.Registry.as(s.Extensions.Configuration).getConfigurationProperties(),i=Object.keys(e).filter(t=>2===e[t].scope||6===e[t].scope),n=h()
;return l.distinct([t.CONFIGURATION_SYNC_STORE_KEY,...i,...n])}var f;Object.defineProperty(t,"__esModule",{value:!0}),t.getSyncResourceFromLocalPreview=t.PREVIEW_DIR_NAME=t.USER_DATA_SYNC_SCHEME=t.IUserDataSyncLogService=t.IUserDataSyncUtilService=t.IUserDataAutoSyncService=t.IUserDataSyncService=t.IUserDataSyncResourceEnablementService=t.MergeState=t.Change=t.SyncStatus=t.UserDataAutoSyncError=t.UserDataSyncStoreError=t.UserDataSyncError=t.UserDataSyncErrorCode=t.HEADER_EXECUTION_ID=t.HEADER_OPERATION_ID=t.IUserDataSyncBackupStoreService=t.IUserDataSyncStoreService=t.IUserDataSyncStoreManagementService=t.ALL_SYNC_RESOURCES=t.SyncResource=t.isAuthenticationProvider=t.registerConfiguration=t.getDefaultIgnoredSettings=t.getDisallowedIgnoredSettings=t.CONFIGURATION_SYNC_STORE_KEY=void 0,t.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store",t.getDisallowedIgnoredSettings=h,t.getDefaultIgnoredSettings=d,t.registerConfiguration=function(){const e=r.Registry.as(s.Extensions.Configuration)
;e.registerConfiguration({id:"settingsSync",order:30,title:o.localize(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:o.localize(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"sync.keybindingsPerPlatform":{type:"boolean",deprecationMessage:o.localize(2,null)},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:o.localize(3,null),items:[{type:"string",pattern:n.EXTENSION_IDENTIFIER_PATTERN,errorMessage:o.localize(4,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"sync.ignoredExtensions":{type:"array",deprecationMessage:o.localize(5,null)},"settingsSync.ignoredSettings":{type:"array",description:o.localize(6,null),default:[],scope:1,$ref:"vscode://schemas/ignoredSettings",additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"sync.ignoredSettings":{type:"array",deprecationMessage:o.localize(7,null)}}})
;const i=r.Registry.as(a.Extensions.JSONContribution);return e.onDidUpdateConfiguration(()=>(()=>{const e=h(),n=d().filter(e=>e!==t.CONFIGURATION_SYNC_STORE_KEY),r={items:{type:"string",enum:[...Object.keys(s.allSettings.properties).filter(e=>-1===n.indexOf(e)),...n.filter(t=>-1===e.indexOf(t)).map(e=>`-${e}`)]}};i.registerSchema("vscode://schemas/ignoredSettings",r)})())},t.isAuthenticationProvider=function(e){return e&&u.isObject(e)&&u.isString(e.id)&&u.isArray(e.scopes)},function(e){e.Settings="settings",e.Keybindings="keybindings",e.Snippets="snippets",e.Extensions="extensions",e.GlobalState="globalState"}(t.SyncResource||(t.SyncResource={})),t.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],t.IUserDataSyncStoreManagementService=i.createDecorator("IUserDataSyncStoreManagementService"),t.IUserDataSyncStoreService=i.createDecorator("IUserDataSyncStoreService"),t.IUserDataSyncBackupStoreService=i.createDecorator("IUserDataSyncBackupStoreService"),
t.HEADER_OPERATION_ID="x-operation-id",t.HEADER_EXECUTION_ID="X-Execution-Id",function(e){e.Unauthorized="Unauthorized",e.Conflict="Conflict",e.Gone="Gone",e.PreconditionFailed="PreconditionFailed",e.TooLarge="TooLarge",e.UpgradeRequired="UpgradeRequired",e.PreconditionRequired="PreconditionRequired",e.TooManyRequests="RemoteTooManyRequests",e.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",e.ConnectionRefused="ConnectionRefused",e.NoRef="NoRef",e.TurnedOff="TurnedOff",e.SessionExpired="SessionExpired",e.ServiceChanged="ServiceChanged",e.DefaultServiceChanged="DefaultServiceChanged",e.LocalTooManyRequests="LocalTooManyRequests",e.LocalPreconditionFailed="LocalPreconditionFailed",e.LocalInvalidContent="LocalInvalidContent",e.LocalError="LocalError",e.IncompatibleLocalContent="IncompatibleLocalContent",e.IncompatibleRemoteContent="IncompatibleRemoteContent",e.UnresolvedConflicts="UnresolvedConflicts",e.Unknown="Unknown"}(f=t.UserDataSyncErrorCode||(t.UserDataSyncErrorCode={}));class g extends Error{
constructor(e,t,i,n){super(e),this.code=t,this.resource=i,this.operationId=n,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}t.UserDataSyncError=g;t.UserDataSyncStoreError=class extends g{constructor(e,t,i){super(e,t,void 0,i),this.operationId=i}};t.UserDataAutoSyncError=class extends g{constructor(e,t){super(e,t)}},function(e){e.toUserDataSyncError=function(t){if(t instanceof e)return t;const i=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(t.name);if(i&&i[1]){const n="unknown"===i[2]?void 0:i[2],r="unknown"===i[3]?void 0:i[3];return new e(t.message,i[1],n,r)}return new e(t.message,f.Unknown)}}(g=t.UserDataSyncError||(t.UserDataSyncError={})),function(e){e.Uninitialized="uninitialized",e.Idle="idle",e.Syncing="syncing",e.HasConflicts="hasConflicts"}(t.SyncStatus||(t.SyncStatus={})),function(e){e[e.None=0]="None",e[e.Added=1]="Added",e[e.Modified=2]="Modified",e[e.Deleted=3]="Deleted"
}(t.Change||(t.Change={})),function(e){e.Preview="preview",e.Conflict="conflict",e.Accepted="accepted"}(t.MergeState||(t.MergeState={})),t.IUserDataSyncResourceEnablementService=i.createDecorator("IUserDataSyncResourceEnablementService"),t.IUserDataSyncService=i.createDecorator("IUserDataSyncService"),t.IUserDataAutoSyncService=i.createDecorator("IUserDataAutoSyncService"),t.IUserDataSyncUtilService=i.createDecorator("IUserDataSyncUtilService"),t.IUserDataSyncLogService=i.createDecorator("IUserDataSyncLogService"),t.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",t.PREVIEW_DIR_NAME="preview",t.getSyncResourceFromLocalPreview=function(e,i){if(e.scheme!==t.USER_DATA_SYNC_SCHEME)return e=e.with({scheme:i.userDataSyncHome.scheme}),t.ALL_SYNC_RESOURCES.filter(n=>c.isEqualOrParent(e,c.joinPath(i.userDataSyncHome,n,t.PREVIEW_DIR_NAME)))[0]}})),define(t[45],i([0,1,2,16,17,7,23,8,10,9,3,24,28,117,25,18,14,15,49,22,27]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v,y,S,w,E,C){"use strict";function _(e){
if(e&&void 0!==e.version&&"number"==typeof e.version&&void 0!==e.content&&"string"==typeof e.content){if(2===Object.keys(e).length)return!0;if(3===Object.keys(e).length&&void 0!==e.machineId&&"string"==typeof e.machineId)return!0}return!1}function b(e,t){return u.joinPath(t.userDataSyncHome,e,`lastSync${e}.json`)}Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractInitializer=t.AbstractJsonFileSynchroniser=t.AbstractFileSynchroniser=t.AbstractSynchroniser=void 0;let D=class extends i.Disposable{constructor(e,t,i,n,r,s,o,a,l,f){super(),this.resource=e,this.fileService=t,this.environmentService=i,this.userDataSyncStoreService=r,this.userDataSyncBackupStoreService=s,this.userDataSyncResourceEnablementService=o,this.telemetryService=a,this.logService=l,this.configurationService=f,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new d.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new d.Emitter),
this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new h.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new d.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.syncHeaders={},this.syncResourceLogLabel=y.uppercaseFirstLetter(this.resource),this.syncFolder=u.joinPath(i.userDataSyncHome,e),this.syncPreviewFolder=u.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=b(e,i),this.currentMachineIdPromise=w.getServiceMachineId(i,t,n)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if("hasConflicts"===this.status){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const e=await this.syncPreviewPromise
;this.syncPreviewPromise=null;const t=await this.performSync(e.remoteUserData,e.lastSyncUserData,!0);this.setStatus(t)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const e=await this.getLastSyncUserData();(!e||(await this.doGenerateSyncResourcePreview(e,e,!0,C.CancellationToken.None)).resourcePreviews.some(({remoteChange:e})=>0!==e))&&this._onDidChangeLocal.fire()}}setStatus(e){if(this._status!==e){const t=this._status;"hasConflicts"===e&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),"hasConflicts"===t&&"idle"===e&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=e,this._onDidChangStatus.fire(e)}}async sync(e,t={}){await this._sync(e,!0,t)}async preview(e,t={}){return this._sync(e,!1,t)}async apply(e,t={}){try{this.syncHeaders=Object.assign({},t);const i=await this.doApply(e);return this.setStatus(i),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(e,t,i){try{
if(this.syncHeaders=Object.assign({},i),!this.isEnabled())return"idle"!==this.status&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if("hasConflicts"===this.status)return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if("syncing"===this.status)return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let n="idle";try{const i=await this.getLastSyncUserData(),r=await this.getLatestRemoteUserData(e,i)
;return"hasConflicts"===(n=await this.performSync(r,i,t))?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):"idle"===n&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(n)}}finally{this.syncHeaders={}}}async replace(e){const t=await this.resolveContent(e);if(!t)return!1;const i=this.parseSyncData(t);if(!i)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const e=await this.getLastSyncUserData(),t=await this.getLatestRemoteUserData(null,e),n=await this.generateSyncPreview({ref:t.ref,syncData:i},e,C.CancellationToken.None),r=[];for(const e of n){
const t=await this.getAcceptResult(e,e.remoteResource,void 0,C.CancellationToken.None),{remoteChange:i}=await this.getAcceptResult(e,e.previewResource,e.remoteContent,C.CancellationToken.None);r.push([e,Object.assign(Object.assign({},t),{remoteChange:0!==i?i:2})])}await this.applyResult(t,e,r,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(e,t){if(t){const i=e&&e.latest?e.latest[this.resource]:void 0;if(t.ref===i)return t;if(void 0===i&&null===t.syncData)return t}return this.getRemoteUserData(t)}async performSync(e,t,i){if(e.syncData&&e.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError(p.localize(0,null,this.resource,this.version,e.syncData.version),c.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(e,t,i)}catch(n){
if(n instanceof c.UserDataSyncError)switch(n.code){case c.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(e,t,i);case c.UserDataSyncErrorCode.Conflict:case c.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),e=await this.getRemoteUserData(null),t=await this.getLastSyncUserData(),this.performSync(e,t,i)}throw n}}async doSync(e,t,i){try{this.syncPreviewPromise||(this.syncPreviewPromise=h.createCancelablePromise(n=>this.doGenerateSyncResourcePreview(e,t,i,n)));const n=await this.syncPreviewPromise;return this.updateConflicts(n.resourcePreviews),n.resourcePreviews.some(({mergeState:e})=>"conflict"===e)?"hasConflicts":i?await this.doApply(!1):"syncing"}catch(e){
throw this.syncPreviewPromise=null,e}}async merge(e){return await this.updateSyncResourcePreview(e,async e=>{const t=await this.getMergeResult(e,C.CancellationToken.None);await this.fileService.writeFile(e.previewResource,o.VSBuffer.fromString((null==t?void 0:t.content)||""));const i=t&&!t.hasConflicts?await this.getAcceptResult(e,e.previewResource,void 0,C.CancellationToken.None):void 0;return e.acceptResult=i,e.mergeState=t.hasConflicts?"conflict":i?"accepted":"preview",e.localChange=i?i.localChange:t.localChange,e.remoteChange=i?i.remoteChange:t.remoteChange,e}),this.syncPreviewPromise}async accept(e,t){return await this.updateSyncResourcePreview(e,async i=>{const n=await this.getAcceptResult(i,e,t,C.CancellationToken.None);return i.acceptResult=n,i.mergeState="accepted",i.localChange=n.localChange,i.remoteChange=n.remoteChange,i}),this.syncPreviewPromise}async discard(e){return await this.updateSyncResourcePreview(e,async e=>{const t=await this.getMergeResult(e,C.CancellationToken.None)
;return await this.fileService.writeFile(e.previewResource,o.VSBuffer.fromString(t.content||"")),e.acceptResult=void 0,e.mergeState="preview",e.localChange=t.localChange,e.remoteChange=t.remoteChange,e}),this.syncPreviewPromise}async updateSyncResourcePreview(e,t){if(!this.syncPreviewPromise)return;let i=await this.syncPreviewPromise;const n=i.resourcePreviews.findIndex(({localResource:t,remoteResource:i,previewResource:n})=>u.isEqual(t,e)||u.isEqual(i,e)||u.isEqual(n,e));-1!==n&&(this.syncPreviewPromise=h.createCancelablePromise(async e=>{const r=[...i.resourcePreviews];return r[n]=await t(r[n]),Object.assign(Object.assign({},i),{resourcePreviews:r})}),i=await this.syncPreviewPromise,this.updateConflicts(i.resourcePreviews),i.resourcePreviews.some(({mergeState:e})=>"conflict"===e)?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(e){if(!this.syncPreviewPromise)return"idle";const t=await this.syncPreviewPromise
;return t.resourcePreviews.some(({mergeState:e})=>"conflict"===e)?"hasConflicts":t.resourcePreviews.some(({mergeState:e})=>"accepted"!==e)?"syncing":(await this.applyResult(t.remoteUserData,t.lastSyncUserData,t.resourcePreviews.map(e=>[e,e.acceptResult]),e),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(e){}}updateConflicts(e){const t=e.filter(({mergeState:e})=>"conflict"===e);S.equals(this._conflicts,t,(e,t)=>u.isEqual(e.previewResource,t.previewResource))||(this._conflicts=t,this._onDidChangeConflicts.fire(t))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:e,ref:t})=>({created:e,uri:this.toRemoteBackupResource(t)}))}async getLocalSyncResourceHandles(){
return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:e,ref:t})=>({created:e,uri:this.toLocalBackupResource(t)}))}toRemoteBackupResource(e){return a.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${e}`})}toLocalBackupResource(e){return a.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${e}`})}async getMachineId({uri:e}){const t=u.basename(e);if(u.isEqual(e,this.toRemoteBackupResource(t))){const{content:e}=await this.getUserData(t);if(e){const t=this.parseSyncData(e);return null==t?void 0:t.machineId}}}async resolveContent(e){const t=u.basename(e);if(u.isEqual(e,this.toRemoteBackupResource(t))){const{content:e}=await this.getUserData(t);return e}return u.isEqual(e,this.toLocalBackupResource(t))?this.userDataSyncBackupStoreService.resolveContent(this.resource,t):null}async resolvePreviewContent(e){const t=this.syncPreviewPromise?await this.syncPreviewPromise:null
;if(t)for(const i of t.resourcePreviews){if(u.isEqual(i.acceptedResource,e))return i.acceptResult?i.acceptResult.content:null;if(u.isEqual(i.remoteResource,e))return i.remoteContent;if(u.isEqual(i.localResource,e))return i.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(e){}}async doGenerateSyncResourcePreview(e,t,i,n){var r;const s=await this.currentMachineIdPromise,a=!!(null===(r=e.syncData)||void 0===r?void 0:r.machineId)&&e.syncData.machineId===s,l=null===t&&a?e:t,u=await this.generateSyncPreview(e,l,n),h=[];for(const e of u){const t=e.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(0===e.localChange&&0===e.remoteChange)h.push(Object.assign(Object.assign({},e),{acceptedResource:t,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const t=i?await this.getMergeResult(e,n):void 0;if(n.isCancellationRequested)break
;await this.fileService.writeFile(e.previewResource,o.VSBuffer.fromString((null==t?void 0:t.content)||""));const r=t&&!t.hasConflicts?await this.getAcceptResult(e,e.previewResource,void 0,n):void 0;h.push(Object.assign(Object.assign({},e),{acceptResult:r,mergeState:(null==t?void 0:t.hasConflicts)?"conflict":r?"accepted":"preview",localChange:r?r.localChange:t?t.localChange:e.localChange,remoteChange:r?r.remoteChange:t?t.remoteChange:e.remoteChange}))}}return{remoteUserData:e,lastSyncUserData:t,resourcePreviews:h,isLastSyncFromCurrentMachine:a}}async getLastSyncUserData(){try{const e=await this.fileService.readFile(this.lastSyncResource),t=JSON.parse(e.value.toString()),i=t;if(null===i.content)return{ref:t.ref,syncData:null};const n=JSON.parse(i.content);if(_(n))return Object.assign(Object.assign({},t),{syncData:n,content:void 0})}catch(e){e instanceof n.FileOperationError&&1===e.fileOperationResult||this.logService.error(e)}return null}async updateLastSyncUserData(e,t={}){const i=Object.assign({ref:e.ref,
content:e.syncData?JSON.stringify(e.syncData):null},t);await this.fileService.writeFile(this.lastSyncResource,o.VSBuffer.fromString(JSON.stringify(i)))}async getRemoteUserData(e){const{ref:t,content:i}=await this.getUserData(e);let n=null;return null!==i&&(n=this.parseSyncData(i)),{ref:t,syncData:n}}parseSyncData(e){try{const t=JSON.parse(e);if(_(t))return t}catch(e){this.logService.error(e)}throw new c.UserDataSyncError(p.localize(1,null),c.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(e){if(v.isString(e)){return{ref:e,content:await this.userDataSyncStoreService.resolveContent(this.resource,e)}}{const t=e?{ref:e.ref,content:e.syncData?JSON.stringify(e.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,t,this.syncHeaders)}}async updateRemoteUserData(e,t){const i=await this.currentMachineIdPromise,n={version:this.version,machineId:i,content:e};return{ref:t=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(n),t,this.syncHeaders),
syncData:n}}async backupLocal(e){const t={version:this.version,content:e};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(t))}async stop(){"idle"!==this.status&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};D=r([s(1,n.IFileService),s(2,l.IEnvironmentService),s(3,E.IStorageService),s(4,c.IUserDataSyncStoreService),s(5,c.IUserDataSyncBackupStoreService),s(6,c.IUserDataSyncResourceEnablementService),s(7,f.ITelemetryService),s(8,c.IUserDataSyncLogService),s(9,m.IConfigurationService)],D),t.AbstractSynchroniser=D;let x=class extends D{constructor(e,t,i,n,r,s,o,a,c,l,h){super(t,i,n,r,s,o,a,c,l,h),this.file=e,
this._register(this.fileService.watch(u.dirname(e))),this._register(this.fileService.onDidFilesChange(e=>this.onFileChanges(e)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(e){return null}}async updateLocalFileContent(e,t,i){try{t?await this.fileService.writeFile(this.file,o.VSBuffer.fromString(e),i?void 0:t):await this.fileService.createFile(this.file,o.VSBuffer.fromString(e),{overwrite:i})}catch(e){throw e instanceof n.FileOperationError&&1===e.fileOperationResult||e instanceof n.FileOperationError&&3===e.fileOperationResult?new c.UserDataSyncError(e.message,c.UserDataSyncErrorCode.LocalPreconditionFailed):e}}onFileChanges(e){e.contains(this.file)&&this.triggerLocalChange()}};x=r([s(2,n.IFileService),s(3,l.IEnvironmentService),s(4,E.IStorageService),s(5,c.IUserDataSyncStoreService),s(6,c.IUserDataSyncBackupStoreService),s(7,c.IUserDataSyncResourceEnablementService),s(8,f.ITelemetryService),s(9,c.IUserDataSyncLogService),s(10,m.IConfigurationService)],x),
t.AbstractFileSynchroniser=x;let I=class extends x{constructor(e,t,i,n,r,s,o,a,c,l,u,h){super(e,t,i,n,r,s,o,a,c,l,h),this.userDataSyncUtilService=u,this._formattingOptions=void 0}hasErrors(e){const t=[];return g.parse(e,t,{allowEmptyContent:!0,allowTrailingComma:!0}),t.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};I=r([s(2,n.IFileService),s(3,l.IEnvironmentService),s(4,E.IStorageService),s(5,c.IUserDataSyncStoreService),s(6,c.IUserDataSyncBackupStoreService),s(7,c.IUserDataSyncResourceEnablementService),s(8,f.ITelemetryService),s(9,c.IUserDataSyncLogService),s(10,c.IUserDataSyncUtilService),s(11,m.IConfigurationService)],I),t.AbstractJsonFileSynchroniser=I;let P=class{constructor(e,t,i,n){this.resource=e,this.environmentService=t,this.logService=i,this.fileService=n,this.lastSyncResource=b(this.resource,t)}async initialize({ref:e,content:t}){
if(!t)return void this.logService.info("Remote content does not exist.",this.resource);const i=this.parseSyncData(t);if(i)if(await this.fileService.exists(this.lastSyncResource))this.logService.info("Remote content does not exist.",this.resource);else try{await this.doInitialize({ref:e,syncData:i})}catch(e){this.logService.error(e)}}parseSyncData(e){try{const t=JSON.parse(e);if(_(t))return t}catch(e){this.logService.error(e)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(e,t={}){const i=Object.assign({ref:e.ref,content:e.syncData?JSON.stringify(e.syncData):null},t);await this.fileService.writeFile(this.lastSyncResource,o.VSBuffer.fromString(JSON.stringify(i)))}};P=r([s(1,l.IEnvironmentService),s(2,c.IUserDataSyncLogService),s(3,n.IFileService)],P),t.AbstractInitializer=P})),define(t[176],i([0,1,23,3,8,30,36,16,25,172,45,24,7,10,46,38,14,22,27]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v,y,S,w){"use strict"
;async function E(e,t){const i=JSON.parse(e.content);if(1===e.version||2===e.version){const n=await t.getInstalled(0);for(const t of i)1===e.version&&(!1===t.enabled&&(t.disabled=!0),delete t.enabled),2===e.version&&n.every(e=>!c.areSameExtensions(e.identifier,t.identifier))&&(t.installed=!0)}return i}Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsInitializer=t.ExtensionsSynchroniser=void 0;let C=class e extends d.AbstractSynchroniser{constructor(e,t,r,s,o,a,c,l,u,h,d,f){super("extensions",t,e,r,s,o,d,f,l,h),this.extensionManagementService=a,this.extensionEnablementService=c,this.extensionGalleryService=u,this.version=4,this.previewResource=p.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"}),
this._register(n.Event.debounce(n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtension,e=>!!e.gallery),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,e=>!e.error),this.extensionEnablementService.onDidChangeEnablement),()=>void 0,500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(e,t){const i=e.syncData?await E(e.syncData,this.extensionManagementService):null,n=t&&t.skippedExtensions||[],r=t?await E(t.syncData,this.extensionManagementService):null,s=await this.extensionManagementService.getInstalled(),o=this.getLocalExtensions(s),a=h.getIgnoredExtensions(s,this.configurationService);i?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`)
;const{added:c,removed:l,updated:u,remote:d}=h.merge(o,i,r,n,a),f={added:c,removed:l,updated:u,remote:d,content:this.getPreviewContent(o,c,u,l),localChange:c.length>0||l.length>0||u.length>0?2:0,remoteChange:null!==d?2:0};return[{skippedExtensions:n,localResource:this.localResource,localContent:this.format(o),localExtensions:o,remoteResource:this.remoteResource,remoteContent:i?this.format(i):null,previewResource:this.previewResource,previewResult:f,localChange:f.localChange,remoteChange:f.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(e,t,i,n){const r=[...t,...i],s=new Set,o=e=>{s.add(e.id.toLowerCase()),e.uuid&&s.add(e.uuid)};r.forEach(({identifier:e})=>o(e)),n.forEach(o);for(const t of e)s.has(t.identifier.id.toLowerCase())||t.identifier.uuid&&s.has(t.identifier.uuid)||r.push(t);return this.format(r)}async getMergeResult(e,t){return Object.assign(Object.assign({},e.previewResult),{hasConflicts:!1})}async getAcceptResult(e,t,i,n){
if(p.isEqual(t,this.localResource))return this.acceptLocal(e);if(p.isEqual(t,this.remoteResource))return this.acceptRemote(e);if(p.isEqual(t,this.previewResource))return e.previewResult;throw new Error(`Invalid Resource: ${t.toString()}`)}async acceptLocal(e){const t=await this.extensionManagementService.getInstalled(),i=h.getIgnoredExtensions(t,this.configurationService),n=h.merge(e.localExtensions,null,null,e.skippedExtensions,i),{added:r,removed:s,updated:o,remote:a}=n;return{content:e.localContent,added:r,removed:s,updated:o,remote:a,localChange:r.length>0||s.length>0||o.length>0?2:0,remoteChange:null!==a?2:0}}async acceptRemote(e){const t=await this.extensionManagementService.getInstalled(),i=h.getIgnoredExtensions(t,this.configurationService),n=e.remoteContent?JSON.parse(e.remoteContent):null;if(null!==n){const t=h.merge(e.localExtensions,n,e.localExtensions,[],i),{added:r,removed:s,updated:o,remote:a}=t;return{content:e.remoteContent,added:r,removed:s,updated:o,remote:a,
localChange:r.length>0||s.length>0||o.length>0?2:0,remoteChange:null!==a?2:0}}return{content:e.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(e,t,i,n){let{skippedExtensions:r,localExtensions:s}=i[0][0],{added:o,removed:a,updated:c,remote:l,localChange:u,remoteChange:h}=i[0][1];if(0===u&&0===h&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),0!==u&&(await this.backupLocal(JSON.stringify(s)),r=await this.updateLocalExtensions(o,a,c,r)),l){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const t=JSON.stringify(l);e=await this.updateRemoteUserData(t,n?null:e.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(null==t?void 0:t.ref)!==e.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(e,{skippedExtensions:r}),
this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:t}){return[{resource:p.joinPath(t,"extensions.json"),comparableResource:e.EXTENSIONS_DATA_URI}]}async resolveContent(t){if(p.isEqual(t,e.EXTENSIONS_DATA_URI)){const e=await this.extensionManagementService.getInstalled(),t=h.getIgnoredExtensions(e,this.configurationService),i=this.getLocalExtensions(e).filter(e=>!t.some(t=>c.areSameExtensions({id:t},e.identifier)));return this.format(i)}if(p.isEqual(this.remoteResource,t)||p.isEqual(this.localResource,t)||p.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let i=await super.resolveContent(t);if(i)return i;if(i=await super.resolveContent(p.dirname(t))){const e=this.parseSyncData(i);if(e)switch(p.basename(t)){case"extensions.json":return this.format(this.parseExtensions(e))}}return null}format(e){
e.sort((e,t)=>!e.identifier.uuid&&t.identifier.uuid?-1:e.identifier.uuid&&!t.identifier.uuid?1:y.compare(e.identifier.id,t.identifier.id));const t=JSON.stringify(e),i=m.format(t,void 0,{});return v.applyEdits(t,i)}async hasLocalData(){try{const e=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(e).some(e=>e.installed||e.disabled))return!0}catch(e){}return!1}async updateLocalExtensions(e,t,i,n){const r=[],s=[];if(t.length){const e=(await this.extensionManagementService.getInstalled(1)).filter(({identifier:e})=>t.some(t=>c.areSameExtensions(e,t)));await Promise.all(e.map(async e=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,e.identifier.id),await this.extensionManagementService.uninstall(e),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,e.identifier.id),r.push(e.identifier)}))}(e.length||i.length)&&await Promise.all([...e,...i].map(async e=>{
const t=(await this.extensionManagementService.getInstalled()).filter(t=>c.areSameExtensions(t.identifier,e.identifier))[0];if(t&&0===t.type)return e.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,e.identifier.id),await this.extensionEnablementService.disableExtension(e.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,e.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,e.identifier.id),await this.extensionEnablementService.enableExtension(e.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,e.identifier.id)),void r.push(e.identifier);const i=await this.extensionGalleryService.getCompatibleExtension(e.identifier,e.version);if(i)try{e.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,e.identifier.id,i.version),await this.extensionEnablementService.disableExtension(i.identifier),
this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,e.identifier.id,i.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,e.identifier.id,i.version),await this.extensionEnablementService.enableExtension(i.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,e.identifier.id,i.version)),t&&t.manifest.version===i.version||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,e.identifier.id,i.version),await this.extensionManagementService.installFromGallery(i),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,e.identifier.id,i.version),r.push(i.identifier))}catch(t){s.push(e),this.logService.error(t),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,i.displayName||i.identifier.id)}else s.push(e)}));const o=[];for(const e of n)r.some(t=>c.areSameExtensions(t,e.identifier))||o.push(e)
;for(const e of s)o.some(t=>c.areSameExtensions(t.identifier,e.identifier))||o.push(e);return o}parseExtensions(e){return JSON.parse(e.content)}getLocalExtensions(e){const t=this.extensionEnablementService.getDisabledExtensions();return e.map(({identifier:e,type:i})=>{const n={identifier:e};return t.some(t=>c.areSameExtensions(t,e))&&(n.disabled=!0),1===i&&(n.installed=!0),n})}};C.EXTENSIONS_DATA_URI=g.URI.from({scheme:i.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),C=r([s(0,o.IEnvironmentService),s(1,l.IFileService),s(2,S.IStorageService),s(3,i.IUserDataSyncStoreService),s(4,i.IUserDataSyncBackupStoreService),s(5,a.IExtensionManagementService),s(6,a.IGlobalExtensionEnablementService),s(7,i.IUserDataSyncLogService),s(8,a.IExtensionGalleryService),s(9,u.IConfigurationService),s(10,i.IUserDataSyncResourceEnablementService),s(11,f.ITelemetryService)],C),t.ExtensionsSynchroniser=C;let _=class extends d.AbstractInitializer{constructor(e,t,i,n,r,s){super("extensions",r,s,n),
this.extensionManagementService=e,this.galleryService=t,this.extensionEnablementService=i}async doInitialize(e){const t=e.syncData?await E(e.syncData,this.extensionManagementService):null;if(!t)return void this.logService.info("Skipping initializing extensions because remote extensions does not exist.");const i=await this.extensionManagementService.getInstalled(),n={names:[],uuids:[]},r=[];for(const e of t)i.some(t=>c.areSameExtensions(t.identifier,e.identifier))?e.disabled&&r.push(e.identifier):e.installed&&(e.identifier.uuid?n.uuids.push(e.identifier.uuid):n.names.push(e.identifier.id));if(n.names.length||n.uuids.length){const e=(await this.galleryService.query({ids:n.uuids,names:n.names,pageSize:n.uuids.length+n.names.length},w.CancellationToken.None)).firstPage;for(const t of e)try{this.logService.trace("Installing extension...",t.identifier.id),await this.extensionManagementService.installFromGallery(t),this.logService.info("Installed extension.",t.identifier.id)}catch(e){this.logService.error(e)}}
if(r.length)for(const e of r)this.logService.trace("Enabling extension...",e.id),await this.extensionEnablementService.disableExtension(e),this.logService.info("Enabled extension",e.id)}};_=r([s(0,a.IExtensionManagementService),s(1,a.IExtensionGalleryService),s(2,a.IGlobalExtensionEnablementService),s(3,l.IFileService),s(4,o.IEnvironmentService),s(5,i.IUserDataSyncLogService)],_),t.ExtensionsInitializer=_})),define(t[177],i([0,1,23,17,3,8,10,16,50,173,28,45,24,25,7,46,38,22,80,15]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v,y,S,w,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalStateInitializer=t.GlobalStateSynchroniser=void 0;const C=["locale"];let _=class e extends f.AbstractSynchroniser{constructor(e,t,n,r,s,a,l,u,h,d){super("globalState",e,s,h,t,n,a,l,r,u),this.environmentService=s,this.storageService=h,this.storageKeysSyncRegistryService=d,this.version=1,this.previewResource=c.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({
scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(this.fileService.watch(c.dirname(this.environmentService.argvResource))),this._register(o.Event.any(o.Event.filter(this.fileService.onDidFilesChange,e=>e.contains(this.environmentService.argvResource)),o.Event.filter(this.storageService.onDidChangeStorage,e=>d.storageKeys.some(({key:t})=>e.key===t)),this.storageKeysSyncRegistryService.onDidChangeStorageKeys)(()=>this.triggerLocalChange()))}async generateSyncPreview(e,t,i){const n=e.syncData?JSON.parse(e.syncData.content):null,r=t&&t.syncData?JSON.parse(t.syncData.content):null,s=await this.getLocalGlobalState()
;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const{local:o,remote:a,skipped:c}=h.merge(s.storage,n?n.storage:null,r?r.storage:null,this.getSyncStorageKeys(),(null==t?void 0:t.skippedStorageKeys)||[],this.logService),l={content:null,local:o,remote:a,localChange:Object.keys(o.added).length>0||Object.keys(o.updated).length>0||o.removed.length>0?2:0,remoteChange:null!==a?2:0};return[{skippedStorageKeys:c,localResource:this.localResource,localContent:this.format(s),localUserData:s,remoteResource:this.remoteResource,remoteContent:n?this.format(n):null,previewResource:this.previewResource,previewResult:l,localChange:l.localChange,remoteChange:l.remoteChange,acceptedResource:this.acceptedResource}]}async getMergeResult(e,t){return Object.assign(Object.assign({},e.previewResult),{hasConflicts:!1})}async getAcceptResult(e,t,i,n){
if(c.isEqual(t,this.localResource))return this.acceptLocal(e);if(c.isEqual(t,this.remoteResource))return this.acceptRemote(e);if(c.isEqual(t,this.previewResource))return e.previewResult;throw new Error(`Invalid Resource: ${t.toString()}`)}async acceptLocal(e){return{content:e.localContent,local:{added:{},removed:[],updated:{}},remote:e.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(e){if(null!==e.remoteContent){const t=JSON.parse(e.remoteContent),{local:i,remote:n}=h.merge(e.localUserData.storage,t.storage,null,this.getSyncStorageKeys(),e.skippedStorageKeys,this.logService);return{content:e.remoteContent,local:i,remote:n,localChange:Object.keys(i.added).length>0||Object.keys(i.updated).length>0||i.removed.length>0?2:0,remoteChange:null!==n?2:0}}return{content:e.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(e,t,i,n){let{localUserData:r,skippedStorageKeys:s}=i[0][0],{local:o,remote:a,localChange:c,remoteChange:l}=i[0][1]
;if(0===c&&0===l&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),0!==c&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(r)),await this.writeLocalGlobalState(o),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),0!==l){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const t=JSON.stringify({storage:a});e=await this.updateRemoteUserData(t,n?null:e.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(null==t?void 0:t.ref)===e.ref&&E.equals(t.skippedStorageKeys,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(e,{skippedStorageKeys:s}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:t}){return[{resource:c.joinPath(t,"globalState.json"),
comparableResource:e.GLOBAL_STATE_DATA_URI}]}async resolveContent(t){if(c.isEqual(t,e.GLOBAL_STATE_DATA_URI)){const e=await this.getLocalGlobalState();return this.format(e)}if(c.isEqual(this.remoteResource,t)||c.isEqual(this.localResource,t)||c.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let i=await super.resolveContent(t);if(i)return i;if(i=await super.resolveContent(c.dirname(t))){const e=this.parseSyncData(i);if(e)switch(c.basename(t)){case"globalState.json":return this.format(JSON.parse(e.content))}}return null}format(e){const t=Object.keys(e.storage).sort(),i={};t.forEach(t=>i[t]=e.storage[t]),e.storage=i;const n=JSON.stringify(e),r=v.format(n,void 0,{});return y.applyEdits(n,r)}async hasLocalData(){var e;try{const{storage:t}=await this.getLocalGlobalState();if(Object.keys(t).length>1||"en"!==(null===(e=t["globalState.argv..locale"])||void 0===e?void 0:e.value))return!0}catch(e){}return!1}async getLocalGlobalState(){const e={},t=await this.getLocalArgvContent(),i=d.parse(t)
;for(const t of C)void 0!==i[t]&&(e[`globalState.argv.${t}`]={version:1,value:i[t]});for(const{key:t,version:i}of this.storageKeysSyncRegistryService.storageKeys){const n=this.storageService.get(t,0);n&&(e[t]={version:i,value:n})}return{storage:e}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(e){}return"{}"}async writeLocalGlobalState({added:e,removed:t,updated:i}){const n={},r={},s=(e,t)=>{for(const i of e)if(i.startsWith("globalState.argv."))n[i.substring("globalState.argv.".length)]=t?t[i].value:void 0;else if(t){const e=t[i];e.value!==String(this.storageService.get(i,0))&&(r[i]=e.value)}else void 0!==this.storageService.get(i,0)&&(r[i]=void 0)};if(s(Object.keys(e),e),s(Object.keys(i),i),s(t),Object.keys(n).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(n),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(r).length){
this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const e of Object.keys(r))this.storageService.store(e,r[e],0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(r))}}async updateArgv(e){const t=await this.getLocalArgvContent();let i=t;for(const t of Object.keys(e))i=u.edit(i,[t],e[t],{});t!==i&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,n.VSBuffer.fromString(i)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getSyncStorageKeys(){return[...this.storageKeysSyncRegistryService.storageKeys,...C.map(e=>({key:`globalState.argv.${e}`,version:1}))]}};_.GLOBAL_STATE_DATA_URI=m.URI.from({scheme:i.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),
_=r([s(0,l.IFileService),s(1,i.IUserDataSyncStoreService),s(2,i.IUserDataSyncBackupStoreService),s(3,i.IUserDataSyncLogService),s(4,a.IEnvironmentService),s(5,i.IUserDataSyncResourceEnablementService),s(6,g.ITelemetryService),s(7,p.IConfigurationService),s(8,S.IStorageService),s(9,w.IStorageKeysSyncRegistryService)],_),t.GlobalStateSynchroniser=_;let b=class extends f.AbstractInitializer{constructor(e,t,i,n){super("globalState",i,n,t),this.storageService=e}async doInitialize(e){const t=e.syncData?JSON.parse(e.syncData.content):null;if(!t)return void this.logService.info("Skipping initializing global state because remote global state does not exist.");const i={},r={};for(const e of Object.keys(t.storage))e.startsWith("globalState.argv.")?i[e.substring("globalState.argv.".length)]=t.storage[e].value:void 0===this.storageService.get(e,0)&&(r[e]=t.storage[e].value);if(Object.keys(i).length){let e="{}";try{e=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(e){}
for(const t of Object.keys(i))e=u.edit(e,[t],i[t],{});await this.fileService.writeFile(this.environmentService.argvResource,n.VSBuffer.fromString(e))}if(Object.keys(r).length)for(const e of Object.keys(r))this.storageService.store(e,r[e],0)}};b=r([s(0,S.IStorageService),s(1,l.IFileService),s(2,a.IEnvironmentService),s(3,i.IUserDataSyncLogService)],b),t.GlobalStateInitializer=b})),define(t[178],i([0,1,16,23,174,28,118,8,25,6,18,15,45,24,10,22,17]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v,y){"use strict";function S(e,t){const i=JSON.parse(e);if(!t)return d.isUndefined(i.all)?null:i.all;switch(h.OS){case 2:return d.isUndefined(i.mac)?null:i.mac;case 3:return d.isUndefined(i.linux)?null:i.linux;case 1:return d.isUndefined(i.windows)?null:i.windows}}Object.defineProperty(t,"__esModule",{value:!0}),t.KeybindingsInitializer=t.KeybindingsSynchroniser=t.getKeybindingsContentFromSyncContent=void 0,t.getKeybindingsContentFromSyncContent=S;let w=class extends g.AbstractJsonFileSynchroniser{
constructor(e,t,i,r,s,o,a,c,l,u){super(a.keybindingsResource,"keybindings",o,a,c,e,t,s,u,i,l,r),this.version=2,this.previewResource=m.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(e,t,i){const r=e.syncData?this.getKeybindingsContentFromSyncContent(e.syncData.content):null,s=t&&t.syncData?this.getKeybindingsContentFromSyncContent(t.syncData.content):null,a=await this.getLocalFileContent(),l=await this.getFormattingOptions();let u=null,h=!1,d=!1,f=!1;if(r){let e=a?a.value.toString():"[]";if(e=e||"[]",this.hasErrors(e))throw new n.UserDataSyncError(c.localize(0,null),n.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!s||s!==e||s!==r){
this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const t=await o.merge(e,r,s,l,this.userDataSyncUtilService);t.hasChanges&&(u=t.mergeContent,h=(f=t.hasConflicts)||t.mergeContent!==e,d=f||t.mergeContent!==r)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=a.value.toString(),d=!0);const g={content:u,localChange:h?a?2:1:0,remoteChange:d?2:0,hasConflicts:f};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:g.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:g.remoteChange,previewResource:this.previewResource,previewResult:g,acceptedResource:this.acceptedResource}]}async getMergeResult(e,t){return e.previewResult}async getAcceptResult(e,t,i,n){if(m.isEqual(t,this.localResource))return{content:e.fileContent?e.fileContent.value.toString():null,localChange:0,remoteChange:2}
;if(m.isEqual(t,this.remoteResource))return{content:e.remoteContent,localChange:2,remoteChange:0};if(m.isEqual(t,this.previewResource))return void 0===i?{content:e.previewResult.content,localChange:e.previewResult.localChange,remoteChange:e.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(e,t,i,r){var s;const{fileContent:o}=i[0][0];let{content:a,localChange:l,remoteChange:u}=i[0][1];if(0===l&&0===u&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),null!==a&&(a=(a=a.trim())||"[]",this.hasErrors(a)))throw new n.UserDataSyncError(c.localize(1,null),n.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(0!==l&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString(),null)),await this.updateLocalFileContent(a||"[]",o,r),
this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),0!==u){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const t=this.toSyncContent(a||"[]",e.syncData?e.syncData.content:null);e=await this.updateRemoteUserData(t,r?null:e.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(e){}if((null==t?void 0:t.ref)!==e.ref){this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`);const t=null!==a?this.toSyncContent(a,null):null===(s=e.syncData)||void 0===s?void 0:s.content;await this.updateLastSyncUserData({ref:e.ref,syncData:t?{version:e.syncData?e.syncData.version:this.version,machineId:e.syncData.machineId,content:t}:null}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`)}}async hasLocalData(){try{const e=await this.getLocalFileContent();if(e){const t=a.parse(e.value.toString())
;if(f.isNonEmptyArray(t))return!0}}catch(e){if(1!==e.fileOperationResult)return!0}return!1}async getAssociatedResources({uri:e}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:m.joinPath(e,"keybindings.json"),comparableResource:t}]}async resolveContent(e){if(m.isEqual(this.remoteResource,e)||m.isEqual(this.localResource,e)||m.isEqual(this.acceptedResource,e))return this.resolvePreviewContent(e);let t=await super.resolveContent(e);if(t)return t;if(t=await super.resolveContent(m.dirname(e))){const i=this.parseSyncData(t);if(i)switch(m.basename(e)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(i.content)}}return null}getKeybindingsContentFromSyncContent(e){try{return S(e,this.syncKeybindingsPerPlatform())}catch(e){return this.logService.error(e),null}}toSyncContent(e,t){let i={};try{i=JSON.parse(t||"{}")}catch(e){this.logService.error(e)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=e,h.OS){case 2:i.mac=e;break;case 3:
i.linux=e;break;case 1:i.windows=e}return JSON.stringify(i)}syncKeybindingsPerPlatform(){let e=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return void 0!==e?e:void 0!==(e=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue)?e:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};w=r([s(0,n.IUserDataSyncStoreService),s(1,n.IUserDataSyncBackupStoreService),s(2,n.IUserDataSyncLogService),s(3,u.IConfigurationService),s(4,n.IUserDataSyncResourceEnablementService),s(5,i.IFileService),s(6,l.IEnvironmentService),s(7,v.IStorageService),s(8,n.IUserDataSyncUtilService),s(9,p.ITelemetryService)],w),t.KeybindingsSynchroniser=w;let E=class extends g.AbstractInitializer{constructor(e,t,i){super("keybindings",t,i,e)}async doInitialize(e){const t=e.syncData?this.getKeybindingsContentFromSyncContent(e.syncData.content):null
;t?await this.isEmpty()?(await this.fileService.writeFile(this.environmentService.keybindingsResource,y.VSBuffer.fromString(t)),await this.updateLastSyncUserData(e)):this.logService.info("Skipping initializing keybindings because local keybindings exist."):this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.")}async isEmpty(){try{const e=await this.fileService.readFile(this.environmentService.settingsResource),t=a.parse(e.value.toString());return!f.isNonEmptyArray(t)}catch(e){return 1===e.fileOperationResult}}getKeybindingsContentFromSyncContent(e){try{return S(e,!0)}catch(e){return this.logService.error(e),null}}};E=r([s(0,i.IFileService),s(1,l.IEnvironmentService),s(2,n.IUserDataSyncLogService)],E),t.KeybindingsInitializer=E})),define(t[179],i([0,1,19,28,38,46,50,23,15]),(function(e,t,i,n,r,s,o,a,c){"use strict";function l(e,t,i,r){if(i.length){const s=S(t),a=n.parse(t),c=n.parse(e),l=[];for(const t of i){const i=a[t],n=c[t]
;void 0===i?e=o.edit(e,[t],void 0,r):void 0!==n?e=o.edit(e,[t],i,r):l.push(g(t,s))}l.sort((e,t)=>e.startOffset-t.startOffset),l.forEach(i=>e=f(i.setting.key,t,e,r))}return e}function u(e,t,r){if(e===t)return!0;const s=n.parse(e),o=n.parse(t),a=r.reduce((e,t)=>(e.add(t),e),new Set),c=S(e).filter(e=>!(e.setting&&a.has(e.setting.key))),l=S(t).filter(e=>!(e.setting&&a.has(e.setting.key)));if(c.length!==l.length)return!1;for(let e=0;e<c.length;e++){const t=c[e],n=l[e];if(t.setting&&n.setting){if(t.setting.key!==n.setting.key)return!1;if(!i.equals(s[t.setting.key],o[t.setting.key]))return!1}else{if(t.setting||n.setting)return!1;if(t.value!==n.value)return!1}}return!0}function h(e){if(e){return 0===S(e).length}return!0}function d(e,t,n){const r=e?Object.keys(e).filter(e=>!n.has(e)):[],s=Object.keys(t).filter(e=>!n.has(e)),o=s.filter(e=>-1===r.indexOf(e)).reduce((e,t)=>(e.add(t),e),new Set),a=r.filter(e=>-1===s.indexOf(e)).reduce((e,t)=>(e.add(t),e),new Set),c=new Set;if(e)for(const n of r){if(a.has(n))continue
;const r=e[n],s=t[n];i.equals(r,s)||c.add(n)}return{added:o,removed:a,updated:c}}function f(e,t,i,o){const a=n.parse(t),l=S(t),u=S(i),h=function(e,t,i){const n=c.firstIndex(t,t=>{var i;return(null===(i=t.setting)||void 0===i?void 0:i.key)===e}),r=t[n-1];if(r){if(r.setting){const e=g(r.setting.key,i);if(e)return{index:i.indexOf(e),insertAfter:!0}}else{const e=p(n,t);if(e){const r=g(e.setting.key,i);if(r){const s=m(i.indexOf(r),i),o=v(t,e,t[n]);if(s){const e=v(i,r,s),t=y(o,e);return t?{index:i.indexOf(t),insertAfter:!0}:{index:i.indexOf(s),insertAfter:!1}}{const e=v(i,r,i[i.length-1]),t=y(o,e);return t?{index:i.indexOf(t),insertAfter:!0}:{index:i.length-1,insertAfter:!0}}}}}const e=t[n+1];if(e)if(e.setting){const t=g(e.setting.key,i);if(t)return{index:i.indexOf(t),insertAfter:!1}}else{const e=m(n,t);if(e){const r=g(e.setting.key,i);if(r){const s=p(i.indexOf(r),i),o=v(t,t[n],e);if(s){const e=v(i,s,r),t=y(o.reverse(),e.reverse());return t?{index:i.indexOf(t),insertAfter:!1}:{index:i.indexOf(s),insertAfter:!0}}{
const e=v(i,i[0],r),t=y(o.reverse(),e.reverse());return t?{index:i.indexOf(t),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:i.length-1,insertAfter:!0}}(e,l,u);return function(e,t,i,n,o,a){let c;c=-1===n.index?r.setProperty(e,[t],i,a):function(e,t,i,n,r,o){var a;const c=`${JSON.stringify(t)}: ${JSON.stringify(i)}`,l=s.getEOL(o,e),u=r[n.index];if(n.insertAfter){const e=[];if(u.setting)e.push({offset:u.endOffset,length:0,content:","+c});else{const t=m(n.index,r),i=p(n.index,r),s=null===(a=null==i?void 0:i.setting)||void 0===a?void 0:a.commaOffset;i&&void 0===s&&e.push({offset:i.endOffset,length:0,content:","});const o=void 0!==s&&s>u.endOffset;e.push({offset:o?s+1:u.endOffset,length:0,content:t?l+c+",":l+c})}return e}{if(u.setting)return[{offset:u.startOffset,length:0,content:c+","}];const e=(r[n.index-1]&&!r[n.index-1].setting?l:"")+c+(m(n.index,r)?",":"")+l;return[{offset:u.startOffset,length:0,content:e}]}}(e,t,i,n,o,a).map(t=>r.withFormatting(e,t,a)[0]);return r.applyEdits(e,c)}(i,e,a[e],h,u,o)}
function g(e,t){return t.filter(t=>{var i;return(null===(i=t.setting)||void 0===i?void 0:i.key)===e})[0]}function p(e,t){for(let i=e-1;i>=0;i--)if(t[i].setting)return t[i]}function m(e,t){for(let i=e+1;i<t.length;i++)if(t[i].setting)return t[i]}function v(e,t,i){const n=e.indexOf(t),r=e.indexOf(i);return e.filter((e,t)=>n<t&&t<r)}function y(e,t){if(e.length&&t.length){let i=0;for(;i<t.length&&i<e.length;i++)if(e[i].value!==t[i].value)return t[i-1];return t[i-1]}}function S(e){const t=[];let i,r,s=-1;const o={onObjectBegin:e=>{s++},onObjectProperty:(e,t,n)=>{0===s&&(i=t,r=e)},onObjectEnd:(n,o)=>{0===--s&&t.push({startOffset:i,endOffset:n+o,value:e.substring(i,n+o),setting:{key:r,commaOffset:void 0}})},onArrayBegin:(e,t)=>{s++},onArrayEnd:(n,o)=>{0===--s&&t.push({startOffset:i,endOffset:n+o,value:e.substring(i,n+o),setting:{key:r,commaOffset:void 0}})},onLiteralValue:(n,o,a)=>{0===s&&t.push({startOffset:i,endOffset:o+a,value:e.substring(i,o+a),setting:{key:r,commaOffset:void 0}})},onSeparator:(e,i,n)=>{
if(0===s&&","===e){let e=t.length-1;for(;e>=0&&!t[e].setting;e--);const n=t[e];n&&t.splice(e,1,{startOffset:n.startOffset,endOffset:n.endOffset,value:n.value,setting:{key:n.setting.key,commaOffset:i}})}},onComment:(i,n)=>{0===s&&t.push({startOffset:i,endOffset:i+n,value:e.substring(i,i+n)})}};return n.visit(e,o),t}Object.defineProperty(t,"__esModule",{value:!0}),t.addSetting=t.isEmpty=t.areSame=t.merge=t.updateIgnoredSettings=t.getIgnoredSettings=void 0,t.getIgnoredSettings=function(e,t,i){let r=[];r=i?function(e){const t=n.parse(e);return t&&(t["settingsSync.ignoredSettings"]||t["sync.ignoredSettings"])||[]}(i):function(e){let t=e.inspect("settingsSync.ignoredSettings").userValue;if(void 0!==t)return t;if(void 0!==(t=e.inspect("sync.ignoredSettings").userValue))return t;return e.getValue("settingsSync.ignoredSettings")||[]}(t);const s=[],o=[...a.getDisallowedIgnoredSettings()];if(Array.isArray(r))for(const e of r)e.startsWith("-")?o.push(e.substring(1)):s.push(e)
;return c.distinct([...e,...s].filter(e=>-1===o.indexOf(e)))},t.updateIgnoredSettings=l,t.merge=function(e,t,i,r,s,a){const c=l(e,t,r,a),g=i!==c,p=i!==t;if(!g&&!p)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(g&&!p)return{conflictsSettings:[],localContent:null,remoteContent:c,hasConflicts:!1};if(p&&!g)return{conflictsSettings:[],localContent:l(t,e,r,a),remoteContent:null,hasConflicts:!1};if(null===i&&h(e)){return{conflictsSettings:[],localContent:u(e,t,r)?null:l(t,e,r,a),remoteContent:null,hasConflicts:!1}}let m=e,v=t;const y=n.parse(e),S=n.parse(t),w=i?n.parse(i):null,E=r.reduce((e,t)=>(e.add(t),e),new Set),C=d(y,S,E),_=d(w,y,E),b=d(w,S,E),D=new Map,x=new Set,I=e=>{x.add(e);const t=s.filter(({key:t})=>t===e)[0];t?(m=o.edit(m,[e],t.value,a),v=o.edit(v,[e],t.value,a)):D.set(e,{key:e,localValue:y[e],remoteValue:S[e]})};for(const e of _.removed.values())b.updated.has(e)?I(e):v=o.edit(v,[e],void 0,a)
;for(const e of b.removed.values())x.has(e)||(_.updated.has(e)?I(e):m=o.edit(m,[e],void 0,a));for(const e of _.updated.values())x.has(e)||(b.updated.has(e)?C.updated.has(e)&&I(e):v=o.edit(v,[e],y[e],a));for(const e of b.updated.values())x.has(e)||(_.updated.has(e)?C.updated.has(e)&&I(e):m=o.edit(m,[e],S[e],a));for(const e of _.added.values())x.has(e)||(b.added.has(e)?C.updated.has(e)&&I(e):v=f(e,m,v,a));for(const e of b.added.values())x.has(e)||(_.added.has(e)?C.updated.has(e)&&I(e):m=f(e,v,m,a));const P=D.size>0||!u(m,v,r),R=P||!u(m,e,[]),k=P||!u(v,t,[]);return{localContent:R?m:null,remoteContent:k?v:null,conflictsSettings:[...D.values()],hasConflicts:P}},t.areSame=u,t.isEmpty=h,t.addSetting=f})),define(t[180],i([0,1,16,23,17,119,3,8,25,179,50,45,24,30,10,22,38]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v,y){"use strict";function S(e){const t=JSON.parse(e);return(i=t)&&i.settings&&"string"==typeof i.settings&&1===Object.keys(i).length?t:{settings:e};var i}Object.defineProperty(t,"__esModule",{value:!0}),
t.SettingsInitializer=t.SettingsSynchroniser=t.parseSettingsSyncContent=void 0,t.parseSettingsSyncContent=S;let w=class extends f.AbstractJsonFileSynchroniser{constructor(e,t,i,r,s,o,a,c,l,u,h){super(t.settingsResource,"settings",e,t,i,r,s,l,u,o,a,c),this.extensionManagementService=h,this.version=2,this.previewResource=m.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(e,t,i){const n=await this.getLocalFileContent(),r=await this.getFormattingOptions(),s=this.getSettingsSyncContent(e),o=t?this.getSettingsSyncContent(t):null,a=await this.getIgnoredSettings();let c=null,l=!1,u=!1,d=!1;if(s){let e=n?n.value.toString().trim():"{}";e=e||"{}",
this.validateContent(e),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const t=h.merge(e,s.settings,o?o.settings:null,a,[],r);c=t.localContent||t.remoteContent,l=null!==t.localContent,u=null!==t.remoteContent,d=t.hasConflicts}else n&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),c=n.value.toString(),u=!0);const f={content:c,localChange:l?2:0,remoteChange:u?2:0,hasConflicts:d};return[{fileContent:n,localResource:this.localResource,localContent:n?n.value.toString():null,localChange:f.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:f.remoteChange,previewResource:this.previewResource,previewResult:f,acceptedResource:this.acceptedResource}]}async getMergeResult(e,t){const i=await this.getFormattingOptions(),n=await this.getIgnoredSettings();return Object.assign(Object.assign({},e.previewResult),{
content:e.previewResult.content?h.updateIgnoredSettings(e.previewResult.content,"{}",n,i):null})}async getAcceptResult(e,t,i,n){const r=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(m.isEqual(t,this.localResource))return{content:e.fileContent?h.updateIgnoredSettings(e.fileContent.value.toString(),"{}",s,r):null,localChange:0,remoteChange:2};if(m.isEqual(t,this.remoteResource))return{content:null!==e.remoteContent?h.updateIgnoredSettings(e.remoteContent,e.fileContent?e.fileContent.value.toString():"{}",s,r):null,localChange:2,remoteChange:0};if(m.isEqual(t,this.previewResource))return void 0===i?{content:e.previewResult.content,localChange:e.previewResult.localChange,remoteChange:e.previewResult.remoteChange}:{content:null!==i?h.updateIgnoredSettings(i,e.fileContent?e.fileContent.value.toString():"{}",s,r):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(e,t,i,n){const{fileContent:r}=i[0][0]
;let{content:s,localChange:o,remoteChange:a}=i[0][1];if(0===o&&0===a&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=(s=s?s.trim():"{}")||"{}",this.validateContent(s),0!==o&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),r&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(r.value.toString()))),await this.updateLocalFileContent(s,r,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),0!==a){const t=await this.getFormattingOptions(),i=this.getSettingsSyncContent(e),r=await this.getIgnoredSettings(s);s=h.updateIgnoredSettings(s,i?i.settings:"{}",r,t),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),e=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),n?null:e.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(e){}
(null==t?void 0:t.ref)!==e.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(e),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const e=await this.getLocalFileContent();if(e){const t=await this.getFormattingOptions(),i=d.edit(e.value.toString(),[n.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!h.isEmpty(i)}}catch(e){if(1!==e.fileOperationResult)return!0}return!1}async getAssociatedResources({uri:e}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:m.joinPath(e,"settings.json"),comparableResource:t}]}async resolveContent(e){if(m.isEqual(this.remoteResource,e)||m.isEqual(this.localResource,e)||m.isEqual(this.acceptedResource,e))return this.resolvePreviewContent(e);let t=await super.resolveContent(e);if(t)return t;if(t=await super.resolveContent(m.dirname(e))){const i=this.parseSyncData(t);if(i){
const t=this.parseSettingsSyncContent(i.content);if(t)switch(m.basename(e)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(e){let t=await super.resolvePreviewContent(e);if(t){const e=await this.getFormattingOptions(),i=await this.getIgnoredSettings();t=h.updateIgnoredSettings(t,"{}",i,e)}return t}getSettingsSyncContent(e){return e.syncData?this.parseSettingsSyncContent(e.syncData.content):null}parseSettingsSyncContent(e){try{return S(e)}catch(e){this.logService.error(e)}return null}toSettingsSyncContent(e){return{settings:e}}async getIgnoredSettings(e){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const e=c.Event.any(c.Event.filter(this.extensionManagementService.onDidInstallExtension,e=>!!e.gallery),c.Event.filter(this.extensionManagementService.onDidUninstallExtension,e=>!e.error))(()=>{e.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings
;return h.getIgnoredSettings(t,this.configurationService,e)}validateContent(e){if(this.hasErrors(e))throw new n.UserDataSyncError(a.localize(0,null),n.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const e=await this.getLocalFileContent();if(!e)return;const t=JSON.parse(e.value.toString());if(!function(e){if(e&&void 0!==e.version&&"number"==typeof e.version&&void 0!==e.content&&"string"==typeof e.content&&void 0!==e.machineId&&"string"==typeof e.machineId)return!0;return!1}(t))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(t.content);if(!i||!i.settings)return;let n=i.settings;const r=await this.getFormattingOptions();for(const e in t)if(-1===["version","content","machineId"].indexOf(e)&&void 0!==t[e]){const i=y.setProperty(n,[e],t[e],r);i.length&&(n=y.applyEdits(n,i))}await this.fileService.writeFile(this.file,o.VSBuffer.fromString(n))}catch(e){}}}
;w=r([s(0,i.IFileService),s(1,l.IEnvironmentService),s(2,v.IStorageService),s(3,n.IUserDataSyncStoreService),s(4,n.IUserDataSyncBackupStoreService),s(5,n.IUserDataSyncLogService),s(6,n.IUserDataSyncUtilService),s(7,u.IConfigurationService),s(8,n.IUserDataSyncResourceEnablementService),s(9,g.ITelemetryService),s(10,p.IExtensionManagementService)],w),t.SettingsSynchroniser=w;let E=class extends f.AbstractInitializer{constructor(e,t,i){super("settings",t,i,e)}async doInitialize(e){const t=e.syncData?this.parseSettingsSyncContent(e.syncData.content):null;t?await this.isEmpty()?(await this.fileService.writeFile(this.environmentService.settingsResource,o.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(e)):this.logService.info("Skipping initializing settings because local settings exist."):this.logService.info("Skipping initializing settings because remote settings does not exist.")}async isEmpty(){try{const e=await this.fileService.readFile(this.environmentService.settingsResource)
;return h.isEmpty(e.value.toString().trim())}catch(e){return 1===e.fileOperationResult}}parseSettingsSyncContent(e){try{return S(e)}catch(e){this.logService.error(e)}return null}};E=r([s(0,i.IFileService),s(1,l.IEnvironmentService),s(2,n.IUserDataSyncLogService)],E),t.SettingsInitializer=E})),define(t[181],i([0,1,23,8,16,25,45,24,10,17,175,22,19]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SnippetsInitializer=t.SnippetsSynchroniser=void 0;let p=class extends c.AbstractSynchroniser{constructor(e,t,i,n,r,s,o,a,c){super("snippets",t,e,i,n,r,a,c,s,o),this.version=1,this.snippetsFolder=e.snippetsHome,this._register(this.fileService.watch(e.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(this.fileService.onDidFilesChange(e=>this.onFileChanges(e)))}onFileChanges(e){e.changes.some(e=>u.isEqualOrParent(e.resource,this.snippetsFolder))&&this.triggerLocalChange()}async generateSyncPreview(e,t,i){
const n=await this.getSnippetsFileContents(),r=this.toSnippetsContents(n),s=e.syncData?this.parseSnippets(e.syncData):null,o=t&&t.syncData?this.parseSnippets(t.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const a=d.merge(r,s,o);return this.getResourcePreviews(a,n,s||{})}async getMergeResult(e,t){return e.previewResult}async getAcceptResult(e,t,n,r){if(u.isEqualOrParent(t,this.syncPreviewFolder.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:e.fileContent?e.fileContent.value.toString():null,localChange:0,remoteChange:e.fileContent?null!==e.remoteContent?2:1:3};if(u.isEqualOrParent(t,this.syncPreviewFolder.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:e.remoteContent,localChange:null!==e.remoteContent?e.fileContent?2:1:3,remoteChange:0}
;if(u.isEqualOrParent(t,this.syncPreviewFolder))return void 0===n?{content:e.previewResult.content,localChange:e.previewResult.localChange,remoteChange:e.previewResult.remoteChange}:{content:n,localChange:null===n?null!==e.fileContent?3:0:2,remoteChange:null===n?null!==e.remoteContent?3:0:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(e,t,i,n){const r=i.map(([e,t])=>Object.assign(Object.assign({},e),{acceptResult:t}));r.every(({localChange:e,remoteChange:t})=>0===e&&0===t)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),r.some(({localChange:e})=>0!==e)&&(await this.updateLocalBackup(r),await this.updateLocalSnippets(r,n)),r.some(({remoteChange:e})=>0!==e)&&(e=await this.updateRemoteSnippets(r,e,n)),(null==t?void 0:t.ref)!==e.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(e),
this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:e}of r)try{await this.fileService.del(e)}catch(e){}}getResourcePreviews(e,t,n){const r=new Map;for(const t of Object.keys(e.local.added)){const s={content:e.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{fileContent:null,localResource:u.joinPath(this.syncPreviewFolder,t).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:u.joinPath(this.syncPreviewFolder,t).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:n[t],previewResource:u.joinPath(this.syncPreviewFolder,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:u.joinPath(this.syncPreviewFolder,t).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(e.local.updated)){const o={content:e.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0};r.set(s,{
localResource:u.joinPath(this.syncPreviewFolder,s).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:t[s],localContent:t[s].value.toString(),remoteResource:u.joinPath(this.syncPreviewFolder,s).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:n[s],previewResource:u.joinPath(this.syncPreviewFolder,s),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:u.joinPath(this.syncPreviewFolder,s).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of e.local.removed){const e={content:null,hasConflicts:!1,localChange:3,remoteChange:0};r.set(n,{localResource:u.joinPath(this.syncPreviewFolder,n).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:t[n],localContent:t[n].value.toString(),remoteResource:u.joinPath(this.syncPreviewFolder,n).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:u.joinPath(this.syncPreviewFolder,n),previewResult:e,localChange:e.localChange,
remoteChange:e.remoteChange,acceptedResource:u.joinPath(this.syncPreviewFolder,n).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(e.remote.added)){const s={content:e.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1};r.set(n,{localResource:u.joinPath(this.syncPreviewFolder,n).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:t[n],localContent:t[n].value.toString(),remoteResource:u.joinPath(this.syncPreviewFolder,n).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:u.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:u.joinPath(this.syncPreviewFolder,n).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(e.remote.updated)){const o={content:e.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2};r.set(s,{localResource:u.joinPath(this.syncPreviewFolder,s).with({
scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:t[s],localContent:t[s].value.toString(),remoteResource:u.joinPath(this.syncPreviewFolder,s).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:n[s],previewResource:u.joinPath(this.syncPreviewFolder,s),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:u.joinPath(this.syncPreviewFolder,s).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of e.remote.removed){const e={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{localResource:u.joinPath(this.syncPreviewFolder,t).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:u.joinPath(this.syncPreviewFolder,t).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:n[t],previewResource:u.joinPath(this.syncPreviewFolder,t),previewResult:e,localChange:e.localChange,remoteChange:e.remoteChange,
acceptedResource:u.joinPath(this.syncPreviewFolder,t).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of e.conflicts){const e={content:t[s]?t[s].value.toString():null,hasConflicts:!0,localChange:t[s]?2:1,remoteChange:n[s]?2:1};r.set(s,{localResource:u.joinPath(this.syncPreviewFolder,s).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:t[s]||null,localContent:t[s]?t[s].value.toString():null,remoteResource:u.joinPath(this.syncPreviewFolder,s).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:n[s]||null,previewResource:u.joinPath(this.syncPreviewFolder,s),previewResult:e,localChange:e.localChange,remoteChange:e.remoteChange,acceptedResource:u.joinPath(this.syncPreviewFolder,s).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const e of Object.keys(t))if(!r.has(e)){const s={content:t[e]?t[e].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};r.set(e,{localResource:u.joinPath(this.syncPreviewFolder,e).with({
scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:t[e]||null,localContent:t[e]?t[e].value.toString():null,remoteResource:u.joinPath(this.syncPreviewFolder,e).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:n[e]||null,previewResource:u.joinPath(this.syncPreviewFolder,e),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:u.joinPath(this.syncPreviewFolder,e).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async getAssociatedResources({uri:e}){let t=await super.resolveContent(e);if(t){const n=this.parseSyncData(t);if(n){const t=this.parseSnippets(n),r=[];for(const n of Object.keys(t)){const t=u.joinPath(e,n),s=u.joinPath(this.snippetsFolder,n),o=await this.fileService.exists(s);r.push({resource:t,comparableResource:o?s:u.joinPath(this.syncPreviewFolder,n).with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"})})}return r}}return[]}async resolveContent(e){
if(u.isEqualOrParent(e,this.syncPreviewFolder.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}))||u.isEqualOrParent(e,this.syncPreviewFolder.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}))||u.isEqualOrParent(e,this.syncPreviewFolder.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(e);let t=await super.resolveContent(e);if(t)return t;if(t=await super.resolveContent(u.dirname(e))){const i=this.parseSyncData(t);if(i){return this.parseSnippets(i)[u.basename(e)]||null}}return null}async hasLocalData(){try{const e=await this.getSnippetsFileContents();if(Object.keys(e).length)return!0}catch(e){}return!1}async updateLocalBackup(e){const t={};for(const i of e)i.fileContent&&(t[u.basename(i.localResource)]=i.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(t)))}async updateLocalSnippets(e,t){for(const{fileContent:i,acceptResult:n,localResource:r,remoteResource:s,localChange:o}of e)if(0!==o){
const e=s?u.basename(s):u.basename(r),a=u.joinPath(this.snippetsFolder,e);3===o?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,u.basename(a)),await this.fileService.del(a),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,u.basename(a))):1===o?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,u.basename(a)),await this.fileService.createFile(a,h.VSBuffer.fromString(n.content),{overwrite:t}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,u.basename(a))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,u.basename(a)),await this.fileService.writeFile(a,h.VSBuffer.fromString(n.content),t?void 0:i),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,u.basename(a)))}}async updateRemoteSnippets(e,t,i){const n=t.syncData?this.parseSnippets(t.syncData):{},r=g.deepClone(n);for(const{acceptResult:t,localResource:i,remoteResource:n,remoteChange:s}of e)if(0!==s){
const e=i?u.basename(i):u.basename(n);3===s?delete r[e]:r[e]=t.content}return d.areSame(n,r)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),t=await this.updateRemoteUserData(JSON.stringify(r),i?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),t}parseSnippets(e){return JSON.parse(e.content)}toSnippetsContents(e){const t={};for(const i of Object.keys(e))t[i]=e[i].value.toString();return t}async getSnippetsFileContents(){const e={};let t;try{t=await this.fileService.resolve(this.snippetsFolder)}catch(t){if(t instanceof o.FileOperationError&&1===t.fileOperationResult)return e;throw t}for(const i of t.children||[]){const t=i.resource,n=u.extname(t);if(".json"===n||".code-snippets"===n){const i=u.relativePath(this.snippetsFolder,t),n=await this.fileService.readFile(t);e[i]=n}}return e}}
;p=r([s(0,n.IEnvironmentService),s(1,o.IFileService),s(2,f.IStorageService),s(3,i.IUserDataSyncStoreService),s(4,i.IUserDataSyncBackupStoreService),s(5,i.IUserDataSyncLogService),s(6,a.IConfigurationService),s(7,i.IUserDataSyncResourceEnablementService),s(8,l.ITelemetryService)],p),t.SnippetsSynchroniser=p;let m=class extends c.AbstractInitializer{constructor(e,t,i){super("snippets",t,i,e)}async doInitialize(e){const t=e.syncData?JSON.parse(e.syncData.content):null;if(t)if(await this.isEmpty()){for(const e of Object.keys(t)){const i=t[e];if(i){const t=u.joinPath(this.environmentService.snippetsHome,e);await this.fileService.createFile(t,h.VSBuffer.fromString(i)),this.logService.info("Created snippet",u.basename(t))}}await this.updateLastSyncUserData(e)}else this.logService.info("Skipping initializing snippets because local snippets exist.");else this.logService.info("Skipping initializing snippets because remote snippets does not exist.")}async isEmpty(){var e;try{
return!(null===(e=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)||void 0===e?void 0:e.length)}catch(e){return 1===e.fileOperationResult}}};m=r([s(0,o.IFileService),s(1,n.IEnvironmentService),s(2,i.IUserDataSyncLogService)],m),t.SnippetsInitializer=m})),define(t[54],i([0,1,5,3,2,23]),(function(e,t,i,n,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataSyncAccountService=t.IUserDataSyncAccountService=void 0,t.IUserDataSyncAccountService=i.createDecorator("IUserDataSyncAccountService");let c=class extends o.Disposable{constructor(e){super(),this.userDataSyncStoreService=e,this._onDidChangeAccount=this._register(new n.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new n.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(e.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),
this._register(e.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(e){(e&&this._account?e.token!==this._account.token||e.authenticationProviderId!==this._account.authenticationProviderId:e!==this._account)&&(this._account=e,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(e))}};c=r([s(0,a.IUserDataSyncStoreService)],c),t.UserDataSyncAccountService=c})),define(t[182],i([0,1,2,23,10,25,16,8,53,17]),(function(e,t,i,n,o,a,c,l,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataSyncBackupStoreService=void 0;let d=class extends i.Disposable{constructor(e,t,i,r){super(),this.environmentService=e,this.fileService=t,this.configurationService=i,this.logService=r,n.ALL_SYNC_RESOURCES.forEach(e=>this.cleanUpBackup(e))}async getAllRefs(e){const t=o.joinPath(this.environmentService.userDataSyncHome,e),i=await this.fileService.resolve(t);if(i.children){
return i.children.filter(e=>e.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(e.name)).sort().reverse().map(e=>({ref:e.name,created:this.getCreationTime(e)}))}return[]}async resolveContent(e,t){if(!t){const i=await this.getAllRefs(e);i.length&&(t=i[i.length-1].ref)}if(t){const i=o.joinPath(this.environmentService.userDataSyncHome,e,t);return(await this.fileService.readFile(i)).value.toString()}return null}async backup(e,t){const i=o.joinPath(this.environmentService.userDataSyncHome,e),n=o.joinPath(i,`${u.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(n,h.VSBuffer.fromString(t))}catch(e){this.logService.error(e)}try{this.cleanUpBackup(e)}catch(e){}}async cleanUpBackup(e){const t=o.joinPath(this.environmentService.userDataSyncHome,e);try{try{if(!await this.fileService.exists(t))return}catch(e){return}const e=await this.fileService.resolve(t);if(e.children){
const t=e.children.filter(e=>e.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(e.name)).sort(),i=864e5*(this.configurationService.getValue("sync.localBackupDuration")||30);let n=t.filter(e=>Date.now()-this.getCreationTime(e)>i);const r=t.length-n.length;r<10&&(n=n.slice(10-r)),await Promise.all(n.map(e=>{this.logService.info("Deleting from backup",e.resource.path),this.fileService.del(e.resource)}))}}catch(e){this.logService.error(e)}}getCreationTime(e){return e.ctime||new Date(parseInt(e.name.substring(0,4)),parseInt(e.name.substring(4,6))-1,parseInt(e.name.substring(6,8)),parseInt(e.name.substring(9,11)),parseInt(e.name.substring(11,13)),parseInt(e.name.substring(13,15))).getTime()}};d=r([s(0,l.IEnvironmentService),s(1,c.IFileService),s(2,a.IConfigurationService),s(3,n.IUserDataSyncLogService)],d),t.UserDataSyncBackupStoreService=d})),define(t[183],i([0,1,3,7,2]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.UserDataSyncStoreManagementServiceChannel=t.UserDataSyncAccountServiceChannel=t.UserDataSyncMachinesServiceChannel=t.StorageKeysSyncRegistryChannelClient=t.StorageKeysSyncRegistryChannel=t.UserDataSyncUtilServiceClient=t.UserDataSycnUtilServiceChannel=t.UserDataAutoSyncChannel=t.UserDataSyncChannel=void 0;t.UserDataSyncChannel=class{constructor(e,t,i){this.server=e,this.service=t,this.logService=i}listen(e,t){switch(t){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote}throw new Error(`Event not found: ${t}`)}async call(e,t,i){try{return await this._call(e,t,i)}catch(e){throw this.logService.error(e),e}}_call(e,t,i){switch(t){
case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"createManualSyncTask":return this.createManualSyncTask();case"replace":return this.service.replace(n.URI.revive(i[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(i[0],n.URI.revive(i[1]),i[2],i[3]);case"resolveContent":return this.service.resolveContent(n.URI.revive(i[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(i[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(i[0]);case"getAssociatedResources":return this.service.getAssociatedResources(i[0],{created:i[1].created,uri:n.URI.revive(i[1].uri)});case"getMachineId":return this.service.getMachineId(i[0],{
created:i[1].created,uri:n.URI.revive(i[1].uri)})}throw new Error("Invalid call")}async createManualSyncTask(){const e=await this.service.createManualSyncTask(),t=new s(e,this.logService);return this.server.registerChannel(`manualSyncTask-${e.id}`,t),{id:e.id,manifest:e.manifest,status:e.status}}};class s{constructor(e,t){this.manualSyncTask=e,this.logService=t}listen(e,t){switch(t){case"onSynchronizeResources":return this.manualSyncTask.onSynchronizeResources}throw new Error(`Event not found: ${t}`)}async call(e,t,i){try{return await this._call(e,t,i)}catch(e){throw this.logService.error(e),e}}async _call(e,t,i){switch(t){case"preview":return this.manualSyncTask.preview();case"accept":return this.manualSyncTask.accept(n.URI.revive(i[0]),i[1]);case"merge":return this.manualSyncTask.merge(n.URI.revive(i[0]));case"discard":return this.manualSyncTask.discard(n.URI.revive(i[0]));case"discardConflicts":return this.manualSyncTask.discardConflicts();case"apply":return this.manualSyncTask.apply();case"pull":
return this.manualSyncTask.pull();case"push":return this.manualSyncTask.push();case"stop":return this.manualSyncTask.stop();case"_getStatus":return this.manualSyncTask.status;case"dispose":return this.manualSyncTask.dispose()}throw new Error("Invalid call")}}t.UserDataAutoSyncChannel=class{constructor(e){this.service=e}listen(e,t){switch(t){case"onError":return this.service.onError}throw new Error(`Event not found: ${t}`)}call(e,t,i){switch(t){case"triggerSync":return this.service.triggerSync(i[0],i[1],i[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(i[0])}throw new Error("Invalid call")}};t.UserDataSycnUtilServiceChannel=class{constructor(e){this.service=e}listen(e,t){throw new Error(`Event not found: ${t}`)}call(e,t,i){switch(t){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(i[0]);case"resolveFormattingOptions":
return this.service.resolveFormattingOptions(n.URI.revive(i[0]))}throw new Error("Invalid call")}};t.UserDataSyncUtilServiceClient=class{constructor(e){this.channel=e}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(e){return this.channel.call("resolveUserKeybindings",[e])}async resolveFormattingOptions(e){return this.channel.call("resolveFormattingOptions",[e])}};t.StorageKeysSyncRegistryChannel=class{constructor(e){this.service=e}listen(e,t){switch(t){case"onDidChangeStorageKeys":return this.service.onDidChangeStorageKeys}throw new Error(`Event not found: ${t}`)}call(e,t,i){switch(t){case"_getInitialData":return Promise.resolve(this.service.storageKeys);case"registerStorageKey":return Promise.resolve(this.service.registerStorageKey(i[0]))}throw new Error("Invalid call")}};class o extends r.Disposable{constructor(e){super(),this.channel=e,this._storageKeys=[],this._onDidChangeStorageKeys=this._register(new i.Emitter),
this.onDidChangeStorageKeys=this._onDidChangeStorageKeys.event,this.channel.call("_getInitialData").then(e=>{this.updateStorageKeys(e),this._register(this.channel.listen("onDidChangeStorageKeys")(e=>this.updateStorageKeys(e)))})}get storageKeys(){return this._storageKeys}async updateStorageKeys(e){this._storageKeys=e,this._onDidChangeStorageKeys.fire(this.storageKeys)}registerStorageKey(e){this.channel.call("registerStorageKey",[e])}}t.StorageKeysSyncRegistryChannelClient=o;t.UserDataSyncMachinesServiceChannel=class{constructor(e){this.service=e}listen(e,t){switch(t){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${t}`)}async call(e,t,i){switch(t){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(i[0],i[1]);case"setEnablement":return this.service.setEnablement(i[0],i[1])}
throw new Error("Invalid call")}};t.UserDataSyncAccountServiceChannel=class{constructor(e){this.service=e}listen(e,t){switch(t){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${t}`)}call(e,t,i){switch(t){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(i)}throw new Error("Invalid call")}};t.UserDataSyncStoreManagementServiceChannel=class{constructor(e){this.service=e}listen(e,t){throw new Error(`Event not found: ${t}`)}call(e,t,i){switch(t){case"switch":return this.service.switch(i[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}})),define(t[184],i([0,1,13,8]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataSyncLogService=void 0;let o=class extends i.AbstractLogService{constructor(e,t){super(),
this.logger=this._register(e.getLogger(t.userDataSyncLogResource))}trace(e,...t){this.logger.trace(e,...t)}debug(e,...t){this.logger.debug(e,...t)}info(e,...t){this.logger.info(e,...t)}warn(e,...t){this.logger.warn(e,...t)}error(e,...t){this.logger.error(e,...t)}critical(e,...t){this.logger.critical(e,...t)}flush(){this.logger.flush()}};o=r([s(0,i.ILoggerService),s(1,n.IEnvironmentService)],o),t.UserDataSyncLogService=o})),define(t[55],i([0,1,5,2,49,8,16,22,23,122,37,6,14,3]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataSyncMachinesService=t.IUserDataSyncMachinesService=void 0,t.IUserDataSyncMachinesService=i.createDecorator("IUserDataSyncMachinesService");let m=class e extends n.Disposable{constructor(e,t,i,n,r,s){super(),this.storageService=i,this.userDataSyncStoreService=n,this.logService=r,this.productService=s,this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,
this.currentMachineIdPromise=o.getServiceMachineId(e,t,i)}async getMachines(e){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(e)).machines.map(e=>Object.assign(Object.assign({},e),{isCurrent:e.id===t}))}async addCurrentMachine(e){const t=await this.currentMachineIdPromise,i=await this.readMachinesData(e);i.machines.some(({id:e})=>e===t)||(i.machines.push({id:t,name:this.computeCurrentMachineName(i.machines)}),await this.writeMachinesData(i))}async removeCurrentMachine(e){const t=await this.currentMachineIdPromise,i=await this.readMachinesData(e),n=i.machines.filter(({id:e})=>e!==t);n.length!==i.machines.length&&(i.machines=n,await this.writeMachinesData(i))}async renameMachine(e,t,i){const n=await this.currentMachineIdPromise,r=await this.readMachinesData(i),s=r.machines.find(({id:t})=>t===e);s&&(s.name=t,await this.writeMachinesData(r),r.machines.some(({id:e})=>e===n)&&this.storageService.store("sync.currentMachineName",t,0))}async setEnablement(e,t){
const i=await this.readMachinesData(),n=i.machines.find(({id:t})=>t===e);n&&(n.disabled=!t||void 0,await this.writeMachinesData(i))}computeCurrentMachineName(e){const t=this.storageService.get("sync.currentMachineName",0);if(t)return t;const i=`${this.productService.nameLong} (${f.PlatformToString(f.isWeb?0:f.platform)})`,n=new RegExp(`${g.escapeRegExpCharacters(i)}\\s#(\\d+)`);let r=0;for(const t of e){const e=n.exec(t.name),i=e?parseInt(e[1]):0;r=i>r?i:r}return`${i} #${r+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const i=this.parse(this.userData);if(i.version!==e.VERSION)throw new Error(h.localize(0,null,this.productService.nameLong));return i}async writeMachinesData(t){var i;const n=JSON.stringify(t),r=await this.userDataSyncStoreService.write(e.RESOURCE,n,(null===(i=this.userData)||void 0===i?void 0:i.ref)||null);this.userData={ref:r,content:n},this._onDidChange.fire()}async readUserData(t){if(this.userData){const i=t&&t.latest?t.latest[e.RESOURCE]:void 0
;if(this.userData.ref===i)return this.userData;if(void 0===i&&null===this.userData.content)return this.userData}return this.userDataSyncStoreService.read(e.RESOURCE,this.userData)}parse(t){if(null!==t.content)try{return JSON.parse(t.content)}catch(e){this.logService.error(e)}return{version:e.VERSION,machines:[]}}};m.VERSION=1,m.RESOURCE="machines",m=r([s(0,a.IEnvironmentService),s(1,c.IFileService),s(2,l.IStorageService),s(3,u.IUserDataSyncStoreService),s(4,u.IUserDataSyncLogService),s(5,d.IProductService)],m),t.UserDataSyncMachinesService=m})),define(t[185],i([0,1,9,3,2,23,54,24,20,22,8,55,120,53,7,10]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataAutoSyncService=t.UserDataAutoSyncEnablementService=void 0;const y="sync.sessionId";let S=class extends o.Disposable{constructor(e,t,i){super(),this.storageService=e,this.environmentService=t,this.userDataSyncStoreManagementService=i,this._onDidChangeEnablement=new n.Emitter,
this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(e.onDidChangeStorage(e=>this.onDidStorageChange(e)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean("sync.enable",0,this.environmentService.enableSyncByDefault)}canToggleEnablement(){return void 0!==this.userDataSyncStoreManagementService.userDataSyncStore&&void 0===this.environmentService.sync}onDidStorageChange(e){0===e.scope&&"sync.enable"===e.key&&this._onDidChangeEnablement.fire(this.isEnabled())}};S=r([s(0,h.IStorageService),s(1,d.IEnvironmentService),s(2,a.IUserDataSyncStoreManagementService)],S),t.UserDataAutoSyncEnablementService=S;let w=class extends S{constructor(e,t,r,s,a,c,l,u,h,d){var f;super(h,d,e),this.userDataSyncStoreService=t,this.userDataSyncResourceEnablementService=r,this.userDataSyncService=s,this.logService=a,this.userDataSyncAccountService=c,this.telemetryService=l,this.userDataSyncMachinesService=u,
this.autoSync=this._register(new o.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new n.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new i.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=null===(f=e.userDataSyncStore)||void 0===f?void 0:f.url,e.userDataSyncStore&&(this.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(c.onDidChangeAccount(()=>this.updateAutoSync())),this._register(t.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(n.Event.debounce(s.onDidChangeLocal,(e,t)=>e?[...e,t]:[t],1e3)(e=>this.triggerSync(e,!1,!1))),this._register(n.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,e])=>e)(()=>this.triggerSync(["resourceEnablement"],!1,!1))))}get syncUrl(){
const e=this.storageService.get("sync.storeUrl",0);return e?m.URI.parse(e):void 0}set syncUrl(e){e?this.storageService.store("sync.storeUrl",e.toString(),0):this.storageService.remove("sync.storeUrl",0)}updateAutoSync(){const{enabled:e,message:t}=this.isAutoSyncEnabled();e?void 0===this.autoSync.value&&(this.autoSync.value=new E(this.lastSyncUrl,3e5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=(new Date).getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(e=>this.onDidFinishSync(e))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),void 0!==this.autoSync.value?(t&&this.logService.info(t),this.autoSync.clear()):t&&this.isEnabled()&&this.logService.info(t))}startAutoSync(){return!0}isAutoSyncEnabled(){
return this.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${p.toLocalISOString(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.setEnablement(!0)}async turnOff(e,t,i){try{this.userDataSyncAccountService.account&&!i&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.setEnablement(!1),this.storageService.remove(y,0),e?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(e){if(!t)throw e;this.logService.error(e),this.setEnablement(!1)}}setEnablement(e){
this.isEnabled()!==e&&(this.telemetryService.publicLog2("sync.enable",{enabled:e}),this.storageService.store("sync.enable",e,0),this.updateAutoSync())}async onDidFinishSync(e){if(!e)return void(this.successiveFailures=0);const t=a.UserDataSyncError.toUserDataSyncError(e);t instanceof a.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:t.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),t.code===a.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):t.code===a.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code===a.UserDataSyncErrorCode.LocalTooManyRequests||t.code===a.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),
this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code===a.UserDataSyncErrorCode.UpgradeRequired||t.code===a.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code===a.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code===a.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code===a.UserDataSyncErrorCode.ServiceChanged||t.code===a.UserDataSyncErrorCode.DefaultServiceChanged?(await this.turnOff(!1,!0,!0),await this.turnOn(),
this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(t),this.successiveFailures++),this._onError.fire(t)}async disableMachineEventually(){this.storageService.store("sync.disableMachineEventually",!0,0),await i.timeout(6e5),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean("sync.disableMachineEventually",0,!1)}stopDisableMachineEventually(){this.storageService.remove("sync.disableMachineEventually",0)}async triggerSync(e,t,i){return void 0===this.autoSync.value?this.syncTriggerDelayer.cancel():t&&this.lastSyncTriggerTime&&Math.round(((new Date).getTime()-this.lastSyncTriggerTime)/1e3)<10?void this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds."):(this.sources.push(...e),
this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",i)},this.successiveFailures?1*this.getSyncTriggerDelayTime()*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime()))}getSyncTriggerDelayTime(){return 1e3}};w=r([s(0,a.IUserDataSyncStoreManagementService),s(1,a.IUserDataSyncStoreService),s(2,a.IUserDataSyncResourceEnablementService),s(3,a.IUserDataSyncService),s(4,a.IUserDataSyncLogService),s(5,c.IUserDataSyncAccountService),s(6,l.ITelemetryService),s(7,f.IUserDataSyncMachinesService),s(8,h.IStorageService),s(9,d.IEnvironmentService)],w),t.UserDataAutoSyncService=w;class E extends o.Disposable{constructor(e,t,i,r,s,a,c,l){super(),this.lastSyncUrl=e,this.interval=t,this.userDataSyncStoreManagementService=i,this.userDataSyncStoreService=r,this.userDataSyncService=s,
this.userDataSyncMachinesService=a,this.logService=c,this.storageService=l,this.intervalHandler=this._register(new o.MutableDisposable),this._onDidStartSync=this._register(new n.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new n.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register(o.toDisposable(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(E.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=i.disposableTimeout(()=>this.sync(E.INTERVAL_SYNCING,!1),this.interval)}sync(e,t){const n=i.createCancelablePromise(async i=>{if(this.syncPromise)try{
this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(e){if(u.isPromiseCanceledError(e))return}return this.doSync(e,t,i)});return this.syncPromise=n,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var e;return void 0!==this.lastSyncUrl&&!v.isEqual(this.lastSyncUrl,null===(e=this.userDataSyncStoreManagementService.userDataSyncStore)||void 0===e?void 0:e.url)}async hasDefaultServiceChanged(){const e=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),t=this.userDataSyncStoreManagementService.userDataSyncStore;return!(!t||!e||v.isEqual(t.defaultUrl,e.defaultUrl)&&v.isEqual(t.insidersUrl,e.insidersUrl)&&v.isEqual(t.stableUrl,e.stableUrl))}async doSync(e,t,i){let n;this.logService.info(`Auto Sync: Triggered by ${e}`),this._onDidStartSync.fire();try{if(this.syncTask=await this.userDataSyncService.createSyncTask(t),i.isCancellationRequested)return;let e=this.syncTask.manifest
;if(null===e&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new a.UserDataAutoSyncError(g.localize(0,null),a.UserDataSyncErrorCode.DefaultServiceChanged):new a.UserDataAutoSyncError(g.localize(1,null),a.UserDataSyncErrorCode.ServiceChanged):new a.UserDataAutoSyncError(g.localize(2,null),a.UserDataSyncErrorCode.TurnedOff);const n=this.storageService.get(y,0);if(n&&e&&n!==e.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new a.UserDataAutoSyncError(g.localize(3,null),a.UserDataSyncErrorCode.DefaultServiceChanged):new a.UserDataAutoSyncError(g.localize(4,null),a.UserDataSyncErrorCode.ServiceChanged):new a.UserDataAutoSyncError(g.localize(5,null),a.UserDataSyncErrorCode.SessionExpired);const r=await this.userDataSyncMachinesService.getMachines(e||void 0);if(i.isCancellationRequested)return;const s=r.find(e=>e.isCurrent)
;if(null==s?void 0:s.disabled)throw new a.UserDataAutoSyncError(g.localize(6,null),a.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),null===e&&(e=await this.userDataSyncStoreService.manifest()),e&&e.session!==n&&this.storageService.store(y,e.session,0),i.isCancellationRequested)return;s||await this.userDataSyncMachinesService.addCurrentMachine(e||void 0)}catch(e){this.logService.error(e),n=e}this._onDidFinishSync.fire(n)}register(e){return super._register(e)}}E.INTERVAL_SYNCING="Interval"})),define(t[186],i([0,1,23,2,3,22,24]),(function(e,t,i,n,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataSyncResourceEnablementService=void 0;const l="sync.enable";function u(e){return`${l}.${e}`}let h=class extends n.Disposable{constructor(e,t){super(),this.storageService=e,this.telemetryService=t,this._onDidChangeResourceEnablement=new o.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,
this._register(e.onDidChangeStorage(e=>this.onDidStorageChange(e)))}isResourceEnabled(e){return this.storageService.getBoolean(u(e),0,!0)}setResourceEnablement(e,t){if(this.isResourceEnabled(e)!==t){const i=u(e);this.telemetryService.publicLog2(i,{enabled:t}),this.storageService.store(i,t,0)}}onDidStorageChange(e){if(0===e.scope){const t=i.ALL_SYNC_RESOURCES.filter(t=>u(t)===e.key)[0];if(t)return void this._onDidChangeResourceEnablement.fire([t,this.isResourceEnabled(t)])}}};h=r([s(0,a.IStorageService),s(1,c.ITelemetryService)],h),t.UserDataSyncResourceEnablementService=h})),define(t[187],i([0,1,23,2,5,3,176,178,177,48,24,15,22,180,10,181,29,9,20]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v,y,S,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataSyncService=void 0;function E(e){const t={};return t[i.HEADER_EXECUTION_ID]=e,t}let C=class extends n.Disposable{constructor(e,t,i,n,r,s){super(),this.userDataSyncStoreService=e,this.userDataSyncStoreManagementService=t,
this.instantiationService=i,this.logService=n,this.telemetryService=r,this.storageService=s,this._status="uninitialized",this._onDidChangeStatus=this._register(new a.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new a.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new a.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new a.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new a.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new a.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(p.SettingsSynchroniser)),
this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(l.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(v.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(u.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(c.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(a.Event.any(...this.synchronisers.map(e=>a.Event.map(e.onDidChangeStatus,()=>void 0)))(()=>this.updateStatus())),this._register(a.Event.any(...this.synchronisers.map(e=>a.Event.map(e.onDidChangeConflicts,()=>void 0)))(()=>this.updateConflicts()))),
this._lastSyncTime=this.storageService.getNumber("sync.lastSyncTime",0,void 0),this.onDidChangeLocal=a.Event.any(...this.synchronisers.map(e=>a.Event.map(e.onDidChangeLocal,()=>e.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(e){await this.checkEnablement();const t=y.generateUuid();let n;try{const i=E(t);e&&(i["Cache-Control"]="no-cache"),n=await this.userDataSyncStoreService.manifest(i)}catch(e){throw e=i.UserDataSyncError.toUserDataSyncError(e),this.telemetryService.publicLog2("sync/error",{code:e.code,resource:e.resource,executionId:t,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),e}const r=this;let s;return{manifest:n,run:()=>(s=S.createCancelablePromise(e=>r.sync(n,t,e))).finally(()=>s=void 0),async stop(){if(s)return s.cancel(),r.stop()}}}async createManualSyncTask(){await this.checkEnablement();const e=y.generateUuid(),t=E(e);let n;try{
n=await this.userDataSyncStoreService.manifest(t)}catch(t){throw t=i.UserDataSyncError.toUserDataSyncError(t),this.telemetryService.publicLog2("sync/error",{code:t.code,resource:t.resource,executionId:e,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),t}return new _(e,n,t,this.synchronisers,this.logService)}async sync(e,t,n){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),n.isCancellationRequested)return;const r=(new Date).getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),"hasConflicts"!==this.status&&this.setStatus("syncing");const s=E(t);for(const t of this.synchronisers){if(n.isCancellationRequested)return;try{await t.sync(e,s)}catch(e){this.handleSynchronizerError(e,t.resource),this._syncErrors.push([t.resource,i.UserDataSyncError.toUserDataSyncError(e)])}}this.logService.info(`Sync done. Took ${(new Date).getTime()-r}ms`),this.updateLastSyncTime()}catch(e){
throw e=i.UserDataSyncError.toUserDataSyncError(e),this.telemetryService.publicLog2("sync/error",{code:e.code,resource:e.resource,executionId:t,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),e}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if("idle"!==this.status)for(const e of this.synchronisers)try{"idle"!==e.status&&await e.stop()}catch(e){this.logService.error(e)}}async replace(e){await this.checkEnablement();for(const t of this.synchronisers)if(await t.replace(e))return}async accept(e,t,i,n){await this.checkEnablement();const r=this.getSynchroniser(e);await r.accept(t,i),n&&await r.apply(!1,E(y.generateUuid()))}async resolveContent(e){for(const t of this.synchronisers){const i=await t.resolveContent(e);if(i)return i}return null}getRemoteSyncResourceHandles(e){return this.getSynchroniser(e).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(e){return this.getSynchroniser(e).getLocalSyncResourceHandles()}
getAssociatedResources(e,t){return this.getSynchroniser(e).getAssociatedResources(t)}getMachineId(e,t){return this.getSynchroniser(e).getMachineId(t)}async hasLocalData(){const e=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const t of e)if(await t.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(e){this.logService.error(e)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove("sync.lastSyncTime",0);for(const e of this.synchronisers)try{await e.resetLocal()}catch(t){this.logService.error(`${e.resource}: ${h.toErrorMessage(t)}`),this.logService.error(t)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){
for(const e of this.synchronisers)if(await e.hasPreviouslySynced())return!0;return!1}setStatus(e){const t=this._status;this._status!==e&&(this._status=e,this._onDidChangeStatus.fire(e),"hasConflicts"===t&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const e=this.computeStatus();this.setStatus(e)}updateConflicts(){const e=this.computeConflicts();f.equals(this._conflicts,e,([e,t],[i,n])=>e==e&&f.equals(t,n,(e,t)=>m.isEqual(e.previewResource,t.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(e))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(e=>"hasConflicts"===e.status)?"hasConflicts":this.synchronisers.some(e=>"syncing"===e.status)?"syncing":"idle":"uninitialized"}updateLastSyncTime(){"idle"===this.status&&(this._lastSyncTime=(new Date).getTime(),this.storageService.store("sync.lastSyncTime",this._lastSyncTime,0),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}
handleSynchronizerError(e,t){if(e instanceof i.UserDataSyncError)switch(e.code){case i.UserDataSyncErrorCode.TooLarge:throw new i.UserDataSyncError(e.message,e.code,t);case i.UserDataSyncErrorCode.TooManyRequests:case i.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case i.UserDataSyncErrorCode.LocalTooManyRequests:case i.UserDataSyncErrorCode.Gone:case i.UserDataSyncErrorCode.UpgradeRequired:case i.UserDataSyncErrorCode.IncompatibleRemoteContent:case i.UserDataSyncErrorCode.IncompatibleLocalContent:throw e}this.logService.error(e),this.logService.error(`${t}: ${h.toErrorMessage(e)}`)}computeConflicts(){return this.synchronisers.filter(e=>"hasConflicts"===e.status).map(e=>[e.resource,e.conflicts.map(b)])}getSynchroniser(e){return this.synchronisers.find(t=>t.resource===e)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}}
;C=r([s(0,i.IUserDataSyncStoreService),s(1,i.IUserDataSyncStoreManagementService),s(2,o.IInstantiationService),s(3,i.IUserDataSyncLogService),s(4,d.ITelemetryService),s(5,g.IStorageService)],C),t.UserDataSyncService=C;class _ extends n.Disposable{constructor(e,t,i,n,r){super(),this.id=e,this.manifest=t,this.syncHeaders=i,this.synchronisers=n,this.logService=r,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new a.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(e=>"hasConflicts"===e.status)?"hasConflicts":this.synchronisers.some(e=>"syncing"===e.status)?"syncing":"idle"}async preview(){if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=S.createCancelablePromise(e=>this.getPreviews(e))),this.previews||(this.previews=await this.previewsPromise),this.previews}async accept(e,t){return this.performAction(e,i=>i.accept(e,t))}async merge(e){
return e?this.performAction(e,t=>t.merge(e)):this.mergeAll()}async discard(e){return this.performAction(e,t=>t.discard(e))}async discardConflicts(){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const e=[];for(const[,t]of this.previews)for(const i of t.resourcePreviews)"conflict"===i.mergeState&&e.push(i.previewResource);for(const t of e)await this.discard(t);return this.previews}async apply(){if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const e=[];for(const[t,i]of this.previews){this.synchronizingResources.push([t,i.resourcePreviews.map(e=>e.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const n=this.synchronisers.find(e=>e.resource===t)
;for(const e of i.resourcePreviews)0===e.localChange&&0===e.remoteChange||"preview"!==e.mergeState||await n.merge(e.previewResource);const r=await n.apply(!1,this.syncHeaders);r&&e.push(this.toSyncResourcePreview(n.resource,r)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(e=>e[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=e,this.previews}async pull(){if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[e,t]of this.previews){this.synchronizingResources.push([e,t.resourcePreviews.map(e=>e.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const i=this.synchronisers.find(t=>t.resource===e);for(const e of t.resourcePreviews)await i.accept(e.remoteResource);await i.apply(!0,this.syncHeaders),
this.synchronizingResources.splice(this.synchronizingResources.findIndex(t=>t[0]===e),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}async push(){if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[e,t]of this.previews){this.synchronizingResources.push([e,t.resourcePreviews.map(e=>e.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const i=this.synchronisers.find(t=>t.resource===e);for(const e of t.resourcePreviews)await i.accept(e.localResource);await i.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(t=>t[0]===e),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}async stop(){for(const e of this.synchronisers)try{await e.stop()}catch(e){w.isPromiseCanceledError(e)||this.logService.error(e)}this.reset()}
async performAction(e,t){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const i=this.previews.findIndex(([,t])=>t.resourcePreviews.some(({localResource:t,previewResource:i,remoteResource:n})=>m.isEqual(e,t)||m.isEqual(e,i)||m.isEqual(e,n)));if(-1===i)return this.previews;const[n,r]=this.previews[i],s=r.resourcePreviews.find(({localResource:t,remoteResource:i,previewResource:n})=>m.isEqual(t,e)||m.isEqual(i,e)||m.isEqual(n,e));if(!s)return this.previews;let o=this.synchronizingResources.find(e=>e[0]===n);o||(o=[n,[]],this.synchronizingResources.push(o)),o[1].some(e=>m.isEqual(e,s.localResource))||(o[1].push(s.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const a=this.synchronisers.find(e=>e.resource===this.previews[i][0]),c=await t(a);c?this.previews.splice(i,1,this.toSyncResourcePreview(a.resource,c)):this.previews.splice(i,1);const l=this.synchronizingResources.findIndex(e=>e[0]===n)
;return this.synchronizingResources[l][1].splice(o[1].findIndex(e=>m.isEqual(e,s.localResource)),1),o[1].length||(this.synchronizingResources.splice(l,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const e=[];for(const[t,i]of this.previews){this.synchronizingResources.push([t,i.resourcePreviews.map(e=>e.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const n=this.synchronisers.find(e=>e.resource===t);let r=i;for(const e of i.resourcePreviews)0===e.localChange&&0===e.remoteChange||"preview"!==e.mergeState||(r=await n.merge(e.previewResource));r&&e.push(this.toSyncResourcePreview(n.resource,r)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(e=>e[0]===t),1),
this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=e,this.previews}async getPreviews(e){const t=[];for(const i of this.synchronisers){if(e.isCancellationRequested)return[];const n=await i.preview(this.manifest,this.syncHeaders);n&&t.push(this.toSyncResourcePreview(i.resource,n))}return t}toSyncResourcePreview(e,t){return[e,{isLastSyncFromCurrentMachine:t.isLastSyncFromCurrentMachine,resourcePreviews:t.resourcePreviews.map(b)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function b(e){return{localResource:e.localResource,previewResource:e.previewResource,remoteResource:e.remoteResource,acceptedResource:e.acceptedResource,localChange:e.localChange,remoteChange:e.remoteChange,mergeState:e.mergeState}}})),define(t[188],i([0,1,2,23,43,10,27,25,37,49,8,16,22,19,29,6,3,9,18,7]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v,y,S,w,E){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.RequestsSession=t.UserDataSyncStoreService=t.UserDataSyncStoreClient=t.UserDataSyncStoreManagementService=t.AbstractUserDataSyncStoreManagementService=void 0;let C=class extends i.Disposable{constructor(e,t,i){super(),this.productService=e,this.configurationService=t,this.storageService=i,this.userDataSyncStore=this.toUserDataSyncStore(e[n.CONFIGURATION_SYNC_STORE_KEY],t.getValue(n.CONFIGURATION_SYNC_STORE_KEY))}toUserDataSyncStore(e,t){const i=Object.assign(Object.assign({},e||{}),t||{});if(i&&w.isString(i.url)&&w.isObject(i.authenticationProviders)&&Object.keys(i.authenticationProviders).every(e=>w.isArray(i.authenticationProviders[e].scopes))){const e=i,n=this.storageService.get("sync.store.url.type",0),r=(null==t?void 0:t.url)||("insiders"===n?e.insidersUrl:"stable"===n?e.stableUrl:void 0)||e.url;return{url:E.URI.parse(r),type:n,defaultType:e.url===e.insidersUrl?"insiders":e.url===e.stableUrl?"stable":void 0,defaultUrl:E.URI.parse(e.url),
stableUrl:e.stableUrl?E.URI.parse(e.stableUrl):void 0,insidersUrl:e.insidersUrl?E.URI.parse(e.insidersUrl):void 0,authenticationProviders:Object.keys(e.authenticationProviders).reduce((t,i)=>(t.push({id:i,scopes:e.authenticationProviders[i].scopes}),t),[])}}}};C=r([s(0,u.IProductService),s(1,l.IConfigurationService),s(2,g.IStorageService)],C),t.AbstractUserDataSyncStoreManagementService=C;let _=class extends C{constructor(e,t,i,r){super(e,t,i);const s=this.storageService.get("sync.previous.store",0);s&&(this.previousConfigurationSyncStore=JSON.parse(s));const o=this.productService[n.CONFIGURATION_SYNC_STORE_KEY];o?this.storageService.store("sync.previous.store",JSON.stringify(o),0):this.storageService.remove("sync.previous.store",0),this.userDataSyncStore&&r.info("Using settings sync service",this.userDataSyncStore.url.toString())}async switch(e){var t,i
;e!==(null===(t=this.userDataSyncStore)||void 0===t?void 0:t.type)&&(e===(null===(i=this.userDataSyncStore)||void 0===i?void 0:i.defaultType)?this.storageService.remove("sync.store.url.type",0):this.storageService.store("sync.store.url.type",e,0))}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};_=r([s(0,u.IProductService),s(1,l.IConfigurationService),s(2,g.IStorageService),s(3,n.IUserDataSyncLogService)],_),t.UserDataSyncStoreManagementService=_;let b=class extends i.Disposable{constructor(e,t,i,n,r,s,o){super(),this.requestService=i,this.logService=n,this.storageService=o,this._onTokenFailed=this._register(new y.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new y.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new y.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,
this.resetDonotMakeRequestsUntilPromise=void 0,this.userDataSyncStoreUrl=e?a.joinPath(e,"v1"):void 0,this.commonHeadersPromise=h.getServiceMachineId(r,s,o).then(e=>{const i={"X-Client-Name":`${t.applicationName}${v.isWeb?"-web":""}`,"X-Client-Version":t.version,"X-Machine-Id":e};return t.commit&&(i["X-Client-Commit"]=t.commit),i}),this.session=new x(100,3e5,this.requestService,this.logService),this.initDonotMakeRequestsUntil()}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(e,t){this.authToken={token:e,type:t}}initDonotMakeRequestsUntil(){const e=this.storageService.getNumber("sync.donot-make-requests-until",0);e&&Date.now()<e&&this.setDonotMakeRequestsUntil(new Date(e))}setDonotMakeRequestsUntil(e){var t;(null===(t=this._donotMakeRequestsUntil)||void 0===t?void 0:t.getTime())!==(null==e?void 0:e.getTime())&&(this._donotMakeRequestsUntil=e,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),
this._donotMakeRequestsUntil?(this.storageService.store("sync.donot-make-requests-until",this._donotMakeRequestsUntil.getTime(),0),this.resetDonotMakeRequestsUntilPromise=S.createCancelablePromise(e=>S.timeout(this._donotMakeRequestsUntil.getTime()-Date.now(),e).then(()=>this.setDonotMakeRequestsUntil(void 0)))):this.storageService.remove("sync.donot-make-requests-until",0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(e){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const t=a.joinPath(this.userDataSyncStoreUrl,"resource",e),i=await this.request({type:"GET",url:t.toString(),headers:{}},[],c.CancellationToken.None);return(await o.asJson(i)||[]).map(({url:e,created:i})=>({ref:a.relativePath(t,t.with({path:e})),created:1e3*i}))}async resolveContent(e,t){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const i=a.joinPath(this.userDataSyncStoreUrl,"resource",e,t).toString(),n={"Cache-Control":"no-cache"
},r=await this.request({type:"GET",url:i,headers:n},[],c.CancellationToken.None);return await o.asText(r)}async delete(e){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const t=a.joinPath(this.userDataSyncStoreUrl,"resource",e).toString();await this.request({type:"DELETE",url:t,headers:{}},[],c.CancellationToken.None)}async read(e,t,i={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const r=a.joinPath(this.userDataSyncStoreUrl,"resource",e,"latest").toString();(i=Object.assign({},i))["Cache-Control"]="no-cache",t&&(i["If-None-Match"]=t.ref);const s=await this.request({type:"GET",url:r,headers:i},[304],c.CancellationToken.None);if(304===s.res.statusCode)return t;const l=s.res.headers.etag;if(!l)throw new n.UserDataSyncStoreError("Server did not return the ref",n.UserDataSyncErrorCode.NoRef,s.res.headers[n.HEADER_OPERATION_ID]);return{ref:l,content:await o.asText(s)}}async write(e,t,i,r={}){
if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const s=a.joinPath(this.userDataSyncStoreUrl,"resource",e).toString();(r=Object.assign({},r))["Content-Type"]="text/plain",i&&(r["If-Match"]=i);const o=await this.request({type:"POST",url:s,data:t,headers:r},[],c.CancellationToken.None),l=o.res.headers.etag;if(!l)throw new n.UserDataSyncStoreError("Server did not return the ref",n.UserDataSyncErrorCode.NoRef,o.res.headers[n.HEADER_OPERATION_ID]);return l}async manifest(e={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const t=a.joinPath(this.userDataSyncStoreUrl,"manifest").toString();(e=Object.assign({},e))["Content-Type"]="application/json";const i=await this.request({type:"GET",url:t,headers:e},[],c.CancellationToken.None),n=await o.asJson(i),r=this.storageService.get("sync.user-session-id",0);return r&&n&&r!==n.session&&this.clearSession(),null===n&&r&&this.clearSession(),
n&&this.storageService.store("sync.user-session-id",n.session,0),n}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const e=a.joinPath(this.userDataSyncStoreUrl,"resource").toString();await this.request({type:"DELETE",url:e,headers:{"Content-Type":"text/plain"}},[],c.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove("sync.user-session-id",0),this.storageService.remove("sync.machine-session-id",0)}async request(e,t,i){var r,s,a,c,l,u,h,d,f,g;if(!this.authToken)throw new n.UserDataSyncStoreError("No Auth Token Available",n.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new n.UserDataSyncStoreError(`${e.type} request '${null===(r=e.url)||void 0===r?void 0:r.toString()}' failed because of too many requests (429).`,n.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0)
;const m=await this.commonHeadersPromise;let v;e.headers=p.assign(e.headers||{},m,{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(e.headers),this.logService.trace("Sending request to server",{url:e.url,type:e.type,headers:Object.assign(Object.assign({},e.headers),{authorization:void 0})});try{v=await this.session.request(e,i)}catch(t){throw t instanceof n.UserDataSyncStoreError||(t=new n.UserDataSyncStoreError(`Connection refused for the request '${null===(s=e.url)||void 0===s?void 0:s.toString()}'.`,n.UserDataSyncErrorCode.ConnectionRefused,void 0)),this.logService.info("Request failed",e.url),t}const y=v.res.headers[n.HEADER_OPERATION_ID],S={url:e.url,status:v.res.statusCode,"execution-id":e.headers[n.HEADER_EXECUTION_ID],"operation-id":y},w=o.isSuccess(v)||v.res.statusCode&&-1!==t.indexOf(v.res.statusCode);if(w?this.logService.trace("Request succeeded",S):this.logService.info("Request failed",S),
401===v.res.statusCode)throw this.authToken=void 0,this._onTokenFailed.fire(),new n.UserDataSyncStoreError(`Request '${null===(a=e.url)||void 0===a?void 0:a.toString()}' failed because of Unauthorized (401).`,n.UserDataSyncErrorCode.Unauthorized,y);if(this._onTokenSucceed.fire(),409===v.res.statusCode)throw new n.UserDataSyncStoreError(`${e.type} request '${null===(c=e.url)||void 0===c?void 0:c.toString()}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,n.UserDataSyncErrorCode.Conflict,y);if(410===v.res.statusCode)throw new n.UserDataSyncStoreError(`${e.type} request '${null===(l=e.url)||void 0===l?void 0:l.toString()}' failed because the requested resource is not longer available (410).`,n.UserDataSyncErrorCode.Gone,y)
;if(412===v.res.statusCode)throw new n.UserDataSyncStoreError(`${e.type} request '${null===(u=e.url)||void 0===u?void 0:u.toString()}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,n.UserDataSyncErrorCode.PreconditionFailed,y);if(413===v.res.statusCode)throw new n.UserDataSyncStoreError(`${e.type} request '${null===(h=e.url)||void 0===h?void 0:h.toString()}' failed because of too large payload (413).`,n.UserDataSyncErrorCode.TooLarge,y);if(426===v.res.statusCode)throw new n.UserDataSyncStoreError(`${e.type} request '${null===(d=e.url)||void 0===d?void 0:d.toString()}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,n.UserDataSyncErrorCode.UpgradeRequired,y);if(429===v.res.statusCode){const t=v.res.headers["retry-after"];throw t?(this.setDonotMakeRequestsUntil(new Date(Date.now()+1e3*parseInt(t))),
new n.UserDataSyncStoreError(`${e.type} request '${null===(f=e.url)||void 0===f?void 0:f.toString()}' failed because of too many requests (429).`,n.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,y)):new n.UserDataSyncStoreError(`${e.type} request '${null===(g=e.url)||void 0===g?void 0:g.toString()}' failed because of too many requests (429).`,n.UserDataSyncErrorCode.TooManyRequests,y)}if(!w)throw new n.UserDataSyncStoreError("Server returned "+v.res.statusCode,n.UserDataSyncErrorCode.Unknown,y);return v}addSessionHeaders(e){let t=this.storageService.get("sync.machine-session-id",0);void 0===t&&(t=m.generateUuid(),this.storageService.store("sync.machine-session-id",t,0)),e["X-Machine-Session-Id"]=t;const i=this.storageService.get("sync.user-session-id",0);void 0!==i&&(e["X-User-Session-Id"]=i)}};b=r([s(1,u.IProductService),s(2,o.IRequestService),s(3,n.IUserDataSyncLogService),s(4,d.IEnvironmentService),s(5,f.IFileService),s(6,g.IStorageService)],b),t.UserDataSyncStoreClient=b;let D=class extends b{
constructor(e,t,i,n,r,s,o){var a;super(null===(a=e.userDataSyncStore)||void 0===a?void 0:a.url,t,i,n,r,s,o)}};D=r([s(0,n.IUserDataSyncStoreManagementService),s(1,u.IProductService),s(2,o.IRequestService),s(3,n.IUserDataSyncLogService),s(4,d.IEnvironmentService),s(5,f.IFileService),s(6,g.IStorageService)],D),t.UserDataSyncStoreService=D;class x{constructor(e,t,i,n){this.limit=e,this.interval=t,this.requestService=i,this.logService=n,this.requests=[],this.startTime=void 0}request(e,t){if(this.isExpired()&&this.reset(),this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new n.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/6e4} minutes.`,n.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(e.url),this.requestService.request(e,t)}isExpired(){return void 0!==this.startTime&&(new Date).getTime()-this.startTime.getTime()>this.interval}reset(){
this.requests=[],this.startTime=void 0}}t.RequestsSession=x})),define(t[189],i([0,1,23,3,74,185,54,24,22,8,55]),(function(e,t,i,n,o,a,c,l,u,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataAutoSyncService=void 0;let f=class extends a.UserDataAutoSyncService{constructor(e,t,i,r,s,o,a,c,l,u,h){super(e,t,i,r,o,a,c,l,u,h),this._register(n.Event.debounce(n.Event.any(n.Event.map(s.onWindowFocus,()=>"windowFocus"),n.Event.map(s.onWindowOpen,()=>"windowOpen")),(e,t)=>e?[...e,t]:[t],1e3)(e=>this.triggerSync(e,!0,!1)))}};f=r([s(0,i.IUserDataSyncStoreManagementService),s(1,i.IUserDataSyncStoreService),s(2,i.IUserDataSyncResourceEnablementService),s(3,i.IUserDataSyncService),s(4,o.IElectronService),s(5,i.IUserDataSyncLogService),s(6,c.IUserDataSyncAccountService),s(7,l.ITelemetryService),s(8,d.IUserDataSyncMachinesService),s(9,u.IStorageService),s(10,h.IEnvironmentService)],f),t.UserDataAutoSyncService=f})),
define(t[190],i([0,1,5,123,7,6,4,10,38,28,26,62,39,159]),(function(e,t,i,n,r,s,o,a,c,l,u,h,d,f){"use strict";function g(e){return e.hasOwnProperty("folderUri")}function p(e){return m(e)||v(e)}function m(e){return e&&"object"==typeof e&&"string"==typeof e.path&&(!e.name||"string"==typeof e.name)}function v(e){return e&&"object"==typeof e&&"string"==typeof e.uri&&(!e.name||"string"==typeof e.name)}function y(e){return e instanceof r.URI}Object.defineProperty(t,"__esModule",{value:!0}),
t.toStoreData=t.restoreRecentlyOpened=t.useSlashForPath=t.rewriteWorkspaceFileForNewLocation=t.getStoredWorkspaceFolder=t.hasWorkspaceFileExtension=t.isSingleFolderWorkspaceInitializationPayload=t.isUntitledWorkspace=t.toWorkspaceIdentifier=t.isWorkspaceIdentifier=t.isSingleFolderWorkspaceIdentifier=t.isRawUriWorkspaceFolder=t.isRawFileWorkspaceFolder=t.isStoredWorkspaceFolder=t.reviveWorkspaceIdentifier=t.isRecentFile=t.isRecentFolder=t.isRecentWorkspace=t.IWorkspacesService=t.UNTITLED_WORKSPACE_NAME=t.WORKSPACE_FILTER=t.WORKSPACE_EXTENSION=void 0,t.WORKSPACE_EXTENSION="code-workspace",t.WORKSPACE_FILTER=[{name:n.localize(0,null),extensions:[t.WORKSPACE_EXTENSION]}],t.UNTITLED_WORKSPACE_NAME="workspace.json",t.IWorkspacesService=i.createDecorator("workspacesService"),t.isRecentWorkspace=function(e){return e.hasOwnProperty("workspace")},t.isRecentFolder=g,t.isRecentFile=function(e){return e.hasOwnProperty("fileUri")},t.reviveWorkspaceIdentifier=function(e){return{id:e.id,configPath:r.URI.revive(e.configPath)}
},t.isStoredWorkspaceFolder=p,t.isRawFileWorkspaceFolder=m,t.isRawUriWorkspaceFolder=v,t.isSingleFolderWorkspaceIdentifier=y,t.isWorkspaceIdentifier=function(e){const t=e;return t&&"string"==typeof t.id&&t.configPath instanceof r.URI},t.toWorkspaceIdentifier=function(e){return e.configuration?{configPath:e.configuration,id:e.id}:1===e.folders.length?e.folders[0].uri:void 0},t.isUntitledWorkspace=function(e,t){return a.extUriBiasedIgnorePathCase.isEqualOrParent(e,t.untitledWorkspacesHome)},t.isSingleFolderWorkspaceInitializationPayload=function(e){return y(e.folder)};const S="."+t.WORKSPACE_EXTENSION;t.hasWorkspaceFileExtension=function(e){return("string"==typeof e?o.extname(e):a.extname(e))===S};const w="/";function E(e,t,i,n,r=!s.isWindows){if(e.scheme!==n.scheme)return{name:i,uri:e.toString(!0)};let o=t?void 0:a.relativePath(n,e);if(void 0!==o)0===o.length?o=".":s.isWindows&&e.scheme===u.Schemas.file&&!r&&(o=o.replace(/\//g,"\\"));else if(e.scheme===u.Schemas.file)o=e.fsPath,
s.isWindows&&(o=h.normalizeDriveLetter(o),r&&(o=d.toSlashes(o)));else{if(!a.isEqualAuthority(e.authority,n.authority))return{name:i,uri:e.toString(!0)};o=e.path}return{name:i,path:o}}function C(e){return!s.isWindows||e.some(e=>m(e)&&e.path.indexOf(w)>=0)}t.getStoredWorkspaceFolder=E,t.rewriteWorkspaceFileForNewLocation=function(e,t,i,n){let u=function(e,t){let i=l.parse(t);if(!i||!Array.isArray(i.folders))throw new Error(`${e} looks like an invalid workspace file.`);i.folders=i.folders.filter(e=>p(e));return i}(t,e);const h=a.dirname(t),d=a.dirname(n),g=[],v=C(u.folders);for(const e of u.folders){const t=m(e)?a.resolvePath(h,e.path):r.URI.parse(e.uri);let n;n=!i&&(!m(e)||o.isAbsolute(e.path)),g.push(E(t,n,e.name,d,v))}const y={insertSpaces:!1,tabSize:4,eol:s.isLinux||s.isMacintosh?"\n":"\r\n"},S=c.setProperty(e,["folders"],g,y);let w=c.applyEdits(e,S);return u.remoteAuthority===f.getRemoteAuthority(n)&&(w=c.applyEdits(w,c.removeProperty(w,["remoteAuthority"],y))),w},t.useSlashForPath=C,
t.restoreRecentlyOpened=function(e,t){const i={workspaces:[],files:[]};if(e){const n=function(e,i){for(let n=0;n<e.length;n++)try{i(e[n],n)}catch(i){t.warn(`Error restoring recent entry ${JSON.stringify(e[n])}: ${i.toString()}. Skip entry.`)}},s=e;Array.isArray(s.workspaces3)&&n(s.workspaces3,(e,t)=>{const n=Array.isArray(s.workspaceLabels)&&s.workspaceLabels[t]||void 0;"object"==typeof e&&"string"==typeof e.id&&"string"==typeof e.configURIPath?i.workspaces.push({label:n,workspace:{id:e.id,configPath:r.URI.parse(e.configURIPath)}}):"string"==typeof e&&i.workspaces.push({label:n,folderUri:r.URI.parse(e)})}),Array.isArray(s.files2)&&n(s.files2,(e,t)=>{const n=Array.isArray(s.fileLabels)&&s.fileLabels[t]||void 0;"string"==typeof e&&i.files.push({label:n,fileUri:r.URI.parse(e)})})}return i},t.toStoreData=function(e){const t={workspaces3:[],files2:[]};let i=!1;const n=[];for(const r of e.workspaces)g(r)?t.workspaces3.push(r.folderUri.toString()):t.workspaces3.push({id:r.workspace.id,
configURIPath:r.workspace.configPath.toString()}),n.push(r.label||null),i=i||!!r.label;i&&(t.workspaceLabels=n),i=!1;const r=[];for(const n of e.files)t.files2.push(n.fileUri.toString()),r.push(n.label||null),i=i||!!n.label;return i&&(t.fileLabels=r),t}})),define(t[191],i([0,1,2,3,13,22,99,98,198,4,21,8,190,18,9]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeStorageService=void 0;let v=class e extends i.Disposable{constructor(e,t,i){super(),this.globalStorageDatabase=e,this.logService=t,this.environmentService=i,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.globalStorage=new l.Storage(this.globalStorageDatabase),this.periodicFlushScheduler=this._register(new m.RunOnceScheduler(()=>this.doFlushWhenIdle(),6e4)),this.runWhenIdleDisposable=void 0,this.registerListeners()}
registerListeners(){this._register(this.globalStorage.onDidChangeStorage(e=>this.handleDidChangeStorage(e,0)))}handleDidChangeStorage(e,t){this._onDidChangeStorage.fire({key:e,scope:t})}initialize(e){return this.initializePromise||(this.initializePromise=this.doInitialize(e)),this.initializePromise}async doInitialize(e){await Promise.all([this.initializeGlobalStorage(),e?this.initializeWorkspaceStorage(e):Promise.resolve()]),this.periodicFlushScheduler.schedule()}initializeGlobalStorage(){return this.globalStorage.init()}async initializeWorkspaceStorage(t){try{const i=await this.prepareWorkspaceStorageFolder(t),n=!!this.environmentService.extensionTestsLocationURI;u.mark("willInitWorkspaceStorage");try{const t=this.createWorkspaceStorage(n?c.SQLiteStorageDatabase.IN_MEMORY_PATH:h.join(i.path,e.WORKSPACE_STORAGE_NAME),i.wasCreated?l.StorageHint.STORAGE_DOES_NOT_EXIST:void 0);await t.init();const r=t.getBoolean(a.IS_NEW_KEY);void 0===r?t.set(a.IS_NEW_KEY,i.wasCreated):r&&t.set(a.IS_NEW_KEY,!1)}finally{
u.mark("didInitWorkspaceStorage")}}catch(e){this.logService.error(`[storage] initializeWorkspaceStorage(): Unable to init workspace storage due to ${e}`)}}createWorkspaceStorage(e,t){const n={logTrace:this.logService.getLevel()===o.LogLevel.Trace?e=>this.logService.trace(e):void 0,logError:e=>this.logService.error(e)};return i.dispose(this.workspaceStorage),i.dispose(this.workspaceStorageListener),this.workspaceStoragePath=e,this.workspaceStorage=new l.Storage(new c.SQLiteStorageDatabase(e,{logging:n}),{hint:t}),this.workspaceStorageListener=this.workspaceStorage.onDidChangeStorage(e=>this.handleDidChangeStorage(e,1)),this.workspaceStorage}getWorkspaceStorageFolderPath(e){return h.join(this.environmentService.workspaceStorageHome.fsPath,e.id)}async prepareWorkspaceStorageFolder(e){const t=this.getWorkspaceStorageFolderPath(e);return await d.exists(t)?{path:t,wasCreated:!1}:(await d.mkdirp(t),this.ensureWorkspaceStorageFolderMeta(e),{path:t,wasCreated:!0})}ensureWorkspaceStorageFolderMeta(t){let i=void 0
;if(g.isSingleFolderWorkspaceInitializationPayload(t)?i={folder:t.folder.toString()}:g.isWorkspaceIdentifier(t)&&(i={configuration:t.configPath}),i){const n=this.logService,r=h.join(this.getWorkspaceStorageFolderPath(t),e.WORKSPACE_META_NAME);!async function(){try{await d.exists(r)||await d.writeFile(r,JSON.stringify(i,void 0,2))}catch(e){n.error(e)}}()}}get(e,t,i){return this.getStorage(t).get(e,i)}getBoolean(e,t,i){return this.getStorage(t).getBoolean(e,i)}getNumber(e,t,i){return this.getStorage(t).getNumber(e,i)}store(e,t,i){this.getStorage(i).set(e,t)}remove(e,t){this.getStorage(t).delete(e)}getStorage(e){return p.assertIsDefined(0===e?this.globalStorage:this.workspaceStorage)}doFlushWhenIdle(){i.dispose(this.runWhenIdleDisposable),this.runWhenIdleDisposable=m.runWhenIdle(()=>{this.flush(),this.periodicFlushScheduler.schedule()})}flush(){this._onWillSaveState.fire({reason:a.WillSaveStateReason.NONE})}async close(){this.periodicFlushScheduler.dispose(),i.dispose(this.runWhenIdleDisposable),
this.runWhenIdleDisposable=void 0,this._onWillSaveState.fire({reason:a.WillSaveStateReason.SHUTDOWN}),await Promise.all([this.globalStorage.close(),this.workspaceStorage?this.workspaceStorage.close():Promise.resolve()])}async logStorage(){return a.logStorage(this.globalStorage.items,this.workspaceStorage?this.workspaceStorage.items:new Map,this.environmentService.globalStorageHome.fsPath,this.workspaceStoragePath||"")}async migrate(t){if(this.workspaceStoragePath===c.SQLiteStorageDatabase.IN_MEMORY_PATH)return;await this.getStorage(1).close();const i=await this.prepareWorkspaceStorageFolder(t),n=h.join(i.path,e.WORKSPACE_STORAGE_NAME);return await d.copy(p.assertIsDefined(this.workspaceStoragePath),n),this.createWorkspaceStorage(n).init()}isNew(e){return!0===this.getBoolean(a.IS_NEW_KEY,e)}};v.WORKSPACE_STORAGE_NAME="state.vscdb",v.WORKSPACE_META_NAME="workspace.json",v=r([s(1,o.ILogService),s(2,f.IEnvironmentService)],v),t.NativeStorageService=v})),
define(t[56],i([0,1,104,4,35,9,21,199,200]),(function(e,t,i,n,r,s,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class l extends Error{constructor(e,t){let i=t.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`}super(i),this.type=e,this.cause=t}}function u(e){if(e instanceof l)return e;let t=void 0;return/end of central directory record signature not found/.test(e.message)&&(t="CorruptZip"),new l(t,e)}function h(e,t,a,c){let u=s.createCancelablePromise(()=>Promise.resolve()),h=0;return c.onCancellationRequested(()=>{u.cancel(),e.close()}),new Promise((d,g)=>{const p=new s.Sequencer,m=t=>{t.isCancellationRequested||(h++,e.readEntry())};e.once("error",g),e.once("close",()=>u.then(()=>{c.isCancellationRequested||e.entryCount===h?d():g(new l("Incomplete",new Error(i.localize(1,null,h,e.entryCount))))},g)),e.readEntry(),e.on("entry",l=>{if(c.isCancellationRequested)return;if(!a.sourcePathRegex.test(l.fileName))return void m(c)
;const h=l.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(h)){const e=n.join(t,h);return void(u=s.createCancelablePromise(t=>o.mkdirp(e).then(()=>m(t)).then(void 0,g)))}const d=f(e,l),v=function(e){const t=e.externalFileAttributes>>16||33188;return[448,56,7].map(e=>t&e).reduce((e,t)=>e+t,61440&t)}(l);u=s.createCancelablePromise(e=>p.queue(()=>d.then(s=>(function(e,t,s,a,c,l){const u=n.dirname(t),h=n.join(a,u);if(0!==h.indexOf(a))return Promise.reject(new Error(i.localize(0,null,t)));const d=n.join(a,t);let f;return l.onCancellationRequested(()=>{f&&f.destroy()}),Promise.resolve(o.mkdirp(h)).then(()=>new Promise((t,i)=>{if(!l.isCancellationRequested)try{(f=r.createWriteStream(d,{mode:s})).once("close",()=>t()),f.once("error",i),e.once("error",i),e.pipe(f)}catch(e){i(e)}}))})(s,h,v,t,0,e).then(()=>m(e)))).then(null,g))})})}function d(e,t=!1){return new Promise((i,n)=>{a.open(e,t?{lazyEntries:!0}:void 0,(e,t)=>{e?n(u(e)):i(t)})})}function f(e,t){return new Promise((i,n)=>{e.openReadStream(t,(e,t)=>{
e?n(u(e)):i(t)})})}t.ExtractError=l,t.zip=function(e,t){return new Promise((i,n)=>{const s=new c.ZipFile;t.forEach(e=>{e.contents?s.addBuffer("string"==typeof e.contents?Buffer.from(e.contents,"utf8"):e.contents,e.path):e.localPath&&s.addFile(e.localPath,e.path)}),s.end();const o=r.createWriteStream(e);s.outputStream.pipe(o),s.outputStream.once("error",n),o.once("error",n),o.once("finish",()=>i(e))})},t.extract=function(e,t,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=d(e,!0);return i.overwrite&&(s=s.then(e=>o.rimraf(t).then(()=>e))),s.then(e=>h(e,t,{sourcePathRegex:r},n))},t.buffer=function(e,t){return function(e,t){return d(e).then(e=>new Promise((n,r)=>{e.on("entry",i=>{i.fileName===t&&f(e,i).then(e=>n(e),e=>r(e))}),e.once("close",()=>r(new Error(i.localize(2,null,t))))}))}(e,t).then(e=>new Promise((t,i)=>{const n=[];e.once("error",i),e.on("data",e=>n.push(e)),e.on("end",()=>t(Buffer.concat(n)))}))}})),define(t[192],i([0,1,56,108]),(function(e,t,i,n){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0,t.getManifest=function(e){return i.buffer(e,"extension/package.json").then(e=>{try{return JSON.parse(e.toString("utf8"))}catch(e){throw new Error(n.localize(0,null))}})}})),define(t[193],i([0,1,76,2,21,4,13,30,36,9,7,8,31,129,109,37,56,6,15,19]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v,y,S,w,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let C=class extends n.Disposable{constructor(e,t,i,n){super(),this.beforeRemovingExtension=e,this.logService=t,this.environmentService=i,this.productService=n,this._devSystemExtensionsPath=null,this.systemExtensionsPath=i.builtinExtensionsPath,this.extensionsPath=i.extensionsPath,this.uninstalledPath=a.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new h.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(e){const t=[]
;return null!==e&&0!==e||t.push(this.scanSystemExtensions().then(null,e=>Promise.reject(new l.ExtensionManagementError(this.joinErrors(e).message,"scanningSystem")))),null!==e&&1!==e||t.push(this.scanUserExtensions(!0).then(null,e=>Promise.reject(new l.ExtensionManagementError(this.joinErrors(e).message,"scanningUser")))),Promise.all(t).then(w.flatten,e=>Promise.reject(this.joinErrors(e)))}async scanUserExtensions(e){this.logService.trace("Started scanning user extensions");let[t,n]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);if(n=n.filter(e=>!t[new u.ExtensionIdentifierWithVersion(e.identifier,e.manifest.version).key()]),e){n=u.groupByExtension(n,e=>e.identifier).map(e=>e.sort((e,t)=>i.rcompare(e.manifest.version,t.manifest.version))[0])}return this.logService.trace("Scanned user extensions:",n.length),n}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(e,t,i){
const{identifier:n}=e,r=e.key(),s=a.join(this.extensionsPath,`.${r}`),c=a.join(this.extensionsPath,r);try{await o.rimraf(c)}catch(e){try{await o.rimraf(c)}catch(e){}throw new l.ExtensionManagementError(m.localize(0,null,c,n.id),"deleting")}await this.extractAtLocation(n,t,s,i);try{await this.rename(n,s,c,Date.now()+12e4),this.logService.info("Renamed to",c)}catch(e){this.logService.info("Rename failed. Deleting from extracted location",s);try{o.rimraf(s)}catch(e){}throw e}let u=null;try{u=await this.scanExtension(r,this.extensionsPath,1)}catch(e){}if(u)return u;throw new Error(m.localize(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(e,t){this.setMetadata(e,t),t.isMachineScoped=t.isMachineScoped||void 0;const i=a.join(e.location.fsPath,"package.json"),n=await o.readFile(i,"utf8"),{manifest:r}=await this.parseManifest(n);return E.assign(r,{__metadata:t}),await o.writeFile(i,JSON.stringify(r,null,"\t")),e}getUninstalledExtensions(){return this.withUninstalledExtensions(e=>e)}
async withUninstalledExtensions(e){return this.uninstalledFileLimiter.queue(async()=>{let t=null;return o.readFile(this.uninstalledPath,"utf8").then(void 0,e=>"ENOENT"===e.code?Promise.resolve("{}"):Promise.reject(e)).then(e=>{try{return JSON.parse(e)}catch(e){return{}}}).then(i=>(t=e(i),i)).then(e=>{if(0===Object.keys(e).length)return o.rimraf(this.uninstalledPath);{const t=JSON.stringify(e);return o.writeFile(this.uninstalledPath,t)}}).then(()=>t)})}async removeExtension(e,t){this.logService.trace(`Deleting ${t} extension from disk`,e.identifier.id,e.location.fsPath),await o.rimraf(e.location.fsPath),this.logService.info("Deleted from disk",e.identifier.id,e.location.fsPath)}async removeUninstalledExtension(e){await this.removeExtension(e,"uninstalled"),await this.withUninstalledExtensions(t=>delete t[new u.ExtensionIdentifierWithVersion(e.identifier,e.manifest.version).key()])}extractAtLocation(e,t,i,n){return this.logService.trace(`Started extracting the extension from ${t} to ${i}`),
o.rimraf(i).then(()=>y.extract(t,i,{sourcePath:"extension",overwrite:!0},n).then(()=>this.logService.info(`Extracted extension to ${i}:`,e.id),e=>o.rimraf(i).finally(()=>{}).then(()=>Promise.reject(new l.ExtensionManagementError(e.message,e instanceof y.ExtractError&&e.type?e.type:"extracting")))),e=>Promise.reject(new l.ExtensionManagementError(this.joinErrors(e).message,"deleting")))}rename(e,t,i,n){return o.rename(t,i).then(void 0,r=>S.isWindows&&r&&"EPERM"===r.code&&Date.now()<n?(this.logService.info(`Failed renaming ${t} to ${i} with 'EPERM' error. Trying again...`,e.id),this.rename(e,t,i,n)):Promise.reject(new l.ExtensionManagementError(r.message||m.localize(2,null,t,i),r.code||"renaming")))}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const e=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return e;const t=this.scanDevSystemExtensions(),[i,n]=await Promise.all([e,t]);return[...i,...n]}async scanExtensionsInDir(e,t){
const i=new h.Limiter(10),n=await o.readdir(e);return(await Promise.all(n.map(n=>i.queue(()=>this.scanExtension(n,e,t))))).filter(e=>e&&e.identifier)}async scanExtension(e,t,i){if(1===i&&0===e.indexOf("."))return null;const n=a.join(t,e);try{const e=await o.readdir(n),{manifest:t,metadata:r}=await this.readManifest(n),s=e.filter(e=>/^readme(\.txt|\.md|)$/i.test(e))[0],c=s?d.URI.file(a.join(n,s)):void 0,l=e.filter(e=>/^changelog(\.txt|\.md|)$/i.test(e))[0],h=l?d.URI.file(a.join(n,l)):void 0,f={type:i,identifier:{id:u.getGalleryExtensionId(t.publisher,t.name)},manifest:t,location:d.URI.file(n),readmeUrl:c,changelogUrl:h,publisherDisplayName:null,publisherId:null,isMachineScoped:!1};return r&&this.setMetadata(f,r),f}catch(e){return this.logService.trace(e),null}}async scanDefaultSystemExtensions(){const e=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",e.length),e}async scanDevSystemExtensions(){const e=this.getDevSystemExtensionsList()
;if(e.length){const t=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",t.length),t.filter(t=>e.some(e=>u.areSameExtensions(t.identifier,{id:e})))}return[]}setMetadata(e,t){e.publisherDisplayName=t.publisherDisplayName||null,e.publisherId=t.publisherId||null,e.identifier.uuid=t.id,e.isMachineScoped=!!t.isMachineScoped}async removeUninstalledExtensions(){const e=await this.getUninstalledExtensions(),t=await this.scanAllUserExtensions(),n=new Set;for(const i of t)e[new u.ExtensionIdentifierWithVersion(i.identifier,i.manifest.version).key()]||n.add(i.identifier.id.toLowerCase());const r=u.groupByExtension(t,e=>e.identifier);await Promise.all(r.map(async e=>{const t=e.sort((e,t)=>i.rcompare(e.manifest.version,t.manifest.version))[0];n.has(t.identifier.id.toLowerCase())||await this.beforeRemovingExtension(t)}));const s=t.filter(t=>e[new u.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])
;await Promise.all(s.map(e=>this.removeUninstalledExtension(e)))}async removeOutdatedExtensions(){const e=await this.scanAllUserExtensions(),t=[],n=u.groupByExtension(e,e=>e.identifier);t.push(...w.flatten(n.map(e=>e.sort((e,t)=>i.rcompare(e.manifest.version,t.manifest.version)).slice(1)))),await Promise.all(t.map(e=>this.removeExtension(e,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(e=>e.name)}joinErrors(e){const t=Array.isArray(e)?e:[e];return 1===t.length?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=a.normalize(a.join(g.getPathFromAmdModule(e,""),"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(e){
const t=[o.readFile(a.join(e,"package.json"),"utf8").then(e=>this.parseManifest(e)),o.readFile(a.join(e,"package.nls.json"),"utf8").then(void 0,e=>"ENOENT"!==e.code?Promise.reject(e):"{}").then(e=>JSON.parse(e))],[{manifest:i,metadata:n},r]=await Promise.all(t);return{manifest:p.localizeManifest(i,r),metadata:n}}parseManifest(e){return new Promise((t,i)=>{try{const i=JSON.parse(e),n=i.__metadata||null;delete i.__metadata,t({manifest:i,metadata:n})}catch(e){i(new Error(m.localize(3,null)))}})}};C=r([s(1,c.ILogService),s(2,f.IEnvironmentService),s(3,v.IProductService)],C),t.ExtensionsScanner=C})),define(t[194],i([0,1,107,4,21,19,2,15,56,30,36,8,9,3,76,7,41,6,13,141,48,24,66,40,29,68,5,26,27,192,144,193,145]),(function(e,t,i,n,o,a,c,l,u,h,d,f,g,p,m,v,y,S,w,E,C,_,b,D,x,I,P,R,k,L,O,A,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let U=class extends c.Disposable{constructor(e,t,i,n,r,s){super(),this.galleryService=t,this.logService=i,this.downloadService=n,
this.telemetryService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new p.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new p.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new p.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new p.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const o=this._register(s.createInstance(T.ExtensionsLifecycle));this.extensionsScanner=this._register(s.createInstance(A.ExtensionsScanner,e=>o.postUninstall(e))),this.manifestCache=this._register(new E.ExtensionsManifestCache(e,this)),this.extensionsDownloader=this._register(s.createInstance(O.ExtensionsDownloader)),this._register(c.toDisposable(()=>{this.installingExtensions.forEach(e=>e.cancel()),
this.uninstallingExtensions.forEach(e=>e.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}zip(e){return this.logService.trace("ExtensionManagementService#zip",e.identifier.id),this.collectFiles(e).then(e=>u.zip(n.join(D.tmpdir(),x.generateUuid()),e)).then(e=>v.URI.file(e))}unzip(e){return this.logService.trace("ExtensionManagementService#unzip",e.toString()),this.install(e).then(e=>e.identifier)}async getManifest(e){const t=await this.downloadVsix(e),i=n.resolve(t.fsPath);return L.getManifest(i)}collectFiles(e){const t=async e=>{let i=await o.readdir(e);i=i.map(t=>n.join(e,t));const r=await Promise.all(i.map(e=>o.stat(e)));let s=Promise.resolve([]);return r.forEach((e,n)=>{const r=i[n];e.isFile()&&(s=s.then(e=>[...e,r])),e.isDirectory()&&(s=s.then(e=>t(r).then(t=>[...e,...t])))}),s};return t(e.location.fsPath).then(t=>t.map(t=>({path:`extension/${n.relative(e.location.fsPath,t)}`,localPath:t})))}install(e,t){
return this.logService.trace("ExtensionManagementService#install",e.toString()),g.createCancelablePromise(r=>this.downloadVsix(e).then(e=>{const s=n.resolve(e.fsPath);return L.getManifest(s).then(e=>{const n={id:d.getGalleryExtensionId(e.publisher,e.name)};let o=1;if(e.engines&&e.engines.vscode&&!b.isEngineValid(e.engines.vscode,y.default.version))return Promise.reject(new Error(i.localize(0,null,n.id,y.default.version)));const a=new d.ExtensionIdentifierWithVersion(n,e.version);return this.getInstalled(1).then(r=>{const s=r.filter(e=>d.areSameExtensions(n,e.identifier))[0];return s?(t=t||s.isMachineScoped,o=2,a.equals(new d.ExtensionIdentifierWithVersion(s.identifier,s.manifest.version))?this.extensionsScanner.removeExtension(s,"existing").then(null,t=>Promise.reject(new Error(i.localize(1,null,e.displayName||e.name)))):m.gt(s.manifest.version,e.version)?this.uninstallExtension(s):void 0):this.unsetUninstalledAndGetLocal(a).then(t=>{
if(t)return this.extensionsScanner.removeExtension(t,"existing").then(null,t=>Promise.reject(new Error(i.localize(2,null,e.displayName||e.name))))})}).then(()=>(this.logService.info("Installing the extension:",n.id),this._onInstallExtension.fire({identifier:n,zipPath:s}),this.getGalleryMetadata(d.getGalleryExtensionId(e.publisher,e.name)).then(e=>this.installFromZipPath(a,s,t?Object.assign(Object.assign({},e),{isMachineScoped:t}):e,o,r),()=>this.installFromZipPath(a,s,t?{isMachineScoped:t}:void 0,o,r)).then(e=>(this.logService.info("Successfully installed the extension:",n.id),e),e=>(this.logService.error("Failed to install the extension:",n.id,e.message),Promise.reject(e)))))})}))}downloadVsix(e){if(e.scheme===R.Schemas.file)return Promise.resolve(e);if(!this.downloadService)throw new Error("Download service is not available");const t=n.join(D.tmpdir(),x.generateUuid());return this.downloadService.download(e,v.URI.file(t)).then(()=>v.URI.file(t))}installFromZipPath(e,t,i,n,r){
return this.toNonCancellablePromise(this.installExtension({zipPath:t,identifierWithVersion:e,metadata:i},r).then(e=>this.installDependenciesAndPackExtensions(e,void 0).then(()=>e,t=>(l.isNonEmptyArray(e.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",e.identifier.id,t.message),l.isNonEmptyArray(e.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",e.identifier.id,t.message),e))).then(i=>(this._onDidInstallExtension.fire({identifier:e.identifier,zipPath:t,local:i,operation:n}),i),i=>(this._onDidInstallExtension.fire({identifier:e.identifier,zipPath:t,operation:n,error:i}),Promise.reject(i))))}async canInstall(e){return!0}async installFromGallery(e,t){if(!this.galleryService.isEnabled())return Promise.reject(new Error(i.localize(3,null)));const n=(new Date).getTime(),r=(e,t,i)=>{this.logService.info("Extensions installed successfully:",e.identifier.id),this._onDidInstallExtension.fire({identifier:e.identifier,gallery:e,
local:i,operation:t}),this.reportTelemetry(this.getTelemetryEvent(t),d.getGalleryExtensionTelemetryData(e),(new Date).getTime()-n,void 0)},s=(e,t,i)=>{const r=i&&i.code?i.code:"unknown";this.logService.error("Failed to install extension:",e.identifier.id,i?i.message:r),this._onDidInstallExtension.fire({identifier:e.identifier,gallery:e,operation:t,error:r}),this.reportTelemetry(this.getTelemetryEvent(t),d.getGalleryExtensionTelemetryData(e),(new Date).getTime()-n,i),i instanceof Error&&(i.name=r)};try{e=await this.checkAndGetCompatibleVersion(e)}catch(t){return s(e,1,t),Promise.reject(t)}const o=new d.ExtensionIdentifierWithVersion(e.identifier,e.version).key();let a=this.installingExtensions.get(o);if(!a){this.logService.info("Installing extension:",e.identifier.id),this._onInstallExtension.fire({identifier:e.identifier,gallery:e});let i,n,c,l=1;a=g.createCancelablePromise(e=>(i=e,new Promise((e,t)=>{n=e,c=t}))),this.installingExtensions.set(o,a);try{
const a=(await this.getInstalled(1)).find(t=>d.areSameExtensions(t.identifier,e.identifier));a&&(l=2),this.downloadInstallableExtension(e,l).then(e=>(e.metadata.isMachineScoped=t||(null==a?void 0:a.isMachineScoped),this.installExtension(e,i).then(t=>this.extensionsDownloader.delete(v.URI.file(e.zipPath)).finally(()=>{}).then(()=>t)))).then(e=>this.installDependenciesAndPackExtensions(e,a).then(()=>e,t=>this.uninstall(e).then(()=>Promise.reject(t),()=>Promise.reject(t)))).then(async t=>{a&&m.neq(a.manifest.version,e.version)&&await this.setUninstalled(a),this.installingExtensions.delete(o),r(e,l,t),n(t)},t=>{this.installingExtensions.delete(o),s(e,l,t),c(t)})}catch(t){return this.installingExtensions.delete(o),s(e,l,t),Promise.reject(t)}}return a}async checkAndGetCompatibleVersion(e){if(await this.isMalicious(e))return Promise.reject(new h.ExtensionManagementError(i.localize(4,null),h.INSTALL_ERROR_MALICIOUS));const t=await this.galleryService.getCompatibleExtension(e)
;return t||Promise.reject(new h.ExtensionManagementError(i.localize(5,null,e.identifier.id,y.default.version),h.INSTALL_ERROR_INCOMPATIBLE))}reinstallFromGallery(e){return this.logService.trace("ExtensionManagementService#reinstallFromGallery",e.identifier.id),this.galleryService.isEnabled()?this.findGalleryExtension(e).then(t=>t?this.setUninstalled(e).then(()=>this.extensionsScanner.removeUninstalledExtension(e).then(()=>this.installFromGallery(t).then(),e=>Promise.reject(new Error(i.localize(7,null,C.toErrorMessage(e)))))):Promise.reject(new Error(i.localize(8,null)))):Promise.reject(new Error(i.localize(6,null)))}getTelemetryEvent(e){return 2===e?"extensionGallery:update":"extensionGallery:install"}isMalicious(e){return this.getExtensionsReport().then(t=>d.getMaliciousExtensionsSet(t).has(e.identifier.id))}downloadInstallableExtension(e,t){const i={id:e.identifier.uuid,publisherId:e.publisherId,publisherDisplayName:e.publisherDisplayName}
;return this.logService.trace("Started downloading extension:",e.identifier.id),this.extensionsDownloader.downloadExtension(e,t).then(t=>{const n=t.fsPath;return this.logService.info("Downloaded extension:",e.identifier.id,n),L.getManifest(n).then(t=>({zipPath:n,identifierWithVersion:new d.ExtensionIdentifierWithVersion(e.identifier,t.version),metadata:i}),e=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(e).message,"validating")))},e=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(e).message,"downloading")))}installExtension(e,t){return this.unsetUninstalledAndGetLocal(e.identifierWithVersion).then(i=>i||this.extractAndInstall(e,t),e=>S.isMacintosh?Promise.reject(new h.ExtensionManagementError(i.localize(9,null),"unsetUninstalled")):Promise.reject(new h.ExtensionManagementError(i.localize(10,null),"unsetUninstalled")))}unsetUninstalledAndGetLocal(e){return this.isUninstalled(e).then(t=>t?(this.logService.trace("Removing the extension from uninstalled list:",e.identifier.id),
this.unsetUninstalled(e).then(()=>(this.logService.info("Removed the extension from uninstalled list:",e.identifier.id),this.getInstalled(1))).then(t=>t.filter(t=>new d.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).equals(e))[0])):null)}async extractAndInstall({zipPath:e,identifierWithVersion:t,metadata:i},n){const{identifier:r}=t;let s=await this.extensionsScanner.extractUserExtension(t,e,n);return this.logService.info("Installation completed.",r.id),i&&(s=await this.extensionsScanner.saveMetadataForLocalExtension(s,i)),s}async installDependenciesAndPackExtensions(e,t){if(this.galleryService.isEnabled()){const i=e.manifest.extensionDependencies||[];if(e.manifest.extensionPack)for(const n of e.manifest.extensionPack)t&&t.manifest.extensionPack&&t.manifest.extensionPack.some(e=>d.areSameExtensions({id:e},{id:n}))||i.every(e=>!d.areSameExtensions({id:e},{id:n}))&&i.push(n);if(i.length)return this.getInstalled().then(e=>{const t=i.filter(t=>e.every(({identifier:e})=>!d.areSameExtensions(e,{id:t
})));if(t.length)return this.galleryService.query({names:t,pageSize:i.length},k.CancellationToken.None).then(e=>{const t=e.firstPage;return Promise.all(t.map(e=>this.installFromGallery(e))).then(void 0,e=>this.rollback(t).then(()=>Promise.reject(e),()=>Promise.reject(e)))})})}return Promise.resolve(void 0)}rollback(e){return this.getInstalled(1).then(t=>Promise.all(t.filter(t=>e.some(e=>new d.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).equals(new d.ExtensionIdentifierWithVersion(e.identifier,e.version)))).map(e=>this.uninstall(e)))).then(()=>void 0,()=>void 0)}uninstall(e){return this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id),this.toNonCancellablePromise(this.getInstalled(1).then(t=>{const n=t.filter(t=>d.areSameExtensions(t.identifier,e.identifier))[0];return n?this.checkForDependenciesAndUninstall(n,t).then(void 0,e=>Promise.reject(this.joinErrors(e))):Promise.reject(new Error(i.localize(11,null,e.manifest.displayName||e.manifest.name)))}))}
async updateMetadata(e,t){return this.logService.trace("ExtensionManagementService#updateMetadata",e.identifier.id),e=await this.extensionsScanner.saveMetadataForLocalExtension(e,Object.assign(Object.assign({},t),{isMachineScoped:e.isMachineScoped})),this.manifestCache.invalidate(),e}getGalleryMetadata(e){return this.findGalleryExtensionByName(e).then(e=>e?{id:e.identifier.uuid,publisherDisplayName:e.publisherDisplayName,publisherId:e.publisherId}:void 0)}findGalleryExtension(e){return e.identifier.uuid?this.findGalleryExtensionById(e.identifier.uuid).then(t=>t||this.findGalleryExtensionByName(e.identifier.id)):this.findGalleryExtensionByName(e.identifier.id)}findGalleryExtensionById(e){return this.galleryService.query({ids:[e],pageSize:1},k.CancellationToken.None).then(e=>e.firstPage[0])}findGalleryExtensionByName(e){return this.galleryService.query({names:[e],pageSize:1},k.CancellationToken.None).then(e=>e.firstPage[0])}joinErrors(e){const t=Array.isArray(e)?e:[e]
;return 1===t.length?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}checkForDependenciesAndUninstall(e,t){return this.preUninstallExtension(e).then(()=>{const i=this.getAllPackExtensionsToUninstall(e,t);return i.length?this.uninstallExtensions(e,i,t):this.uninstallExtensions(e,[],t)}).then(()=>this.postUninstallExtension(e),t=>(this.postUninstallExtension(e,new h.ExtensionManagementError(t instanceof Error?t.message:t,"local")),Promise.reject(t)))}async uninstallExtensions(e,t,i){const n=[e,...t];for(const t of n)this.checkForDependents(t,n,i,e);await Promise.all([this.uninstallExtension(e),...t.map(e=>this.doUninstall(e))])}checkForDependents(e,t,i,n){const r=this.getDependents(e,i);if(r.length){const i=r.filter(e=>-1===t.indexOf(e));if(i.length)throw new Error(this.getDependentsErrorMessage(e,i,n))}}getDependentsErrorMessage(e,t,n){
return n===e?1===t.length?i.localize(12,null,n.manifest.displayName||n.manifest.name,t[0].manifest.displayName||t[0].manifest.name):2===t.length?i.localize(13,null,n.manifest.displayName||n.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(14,null,n.manifest.displayName||n.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):1===t.length?i.localize(15,null,n.manifest.displayName||n.manifest.name,e.manifest.displayName||e.manifest.name,t[0].manifest.displayName||t[0].manifest.name):2===t.length?i.localize(16,null,n.manifest.displayName||n.manifest.name,e.manifest.displayName||e.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(17,null,n.manifest.displayName||n.manifest.name,e.manifest.displayName||e.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}
getAllPackExtensionsToUninstall(e,t,i=[]){if(-1!==i.indexOf(e))return[];i.push(e);const n=e.manifest.extensionPack?e.manifest.extensionPack:[];if(n.length){const e=t.filter(e=>n.some(t=>d.areSameExtensions({id:t},e.identifier))),r=[];for(const n of e)r.push(...this.getAllPackExtensionsToUninstall(n,t,i));return[...e,...r]}return[]}getDependents(e,t){return t.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(t=>d.areSameExtensions({id:t},e.identifier)))}doUninstall(e){return this.preUninstallExtension(e).then(()=>this.uninstallExtension(e)).then(()=>this.postUninstallExtension(e),t=>(this.postUninstallExtension(e,new h.ExtensionManagementError(t instanceof Error?t.message:t,"local")),Promise.reject(t)))}preUninstallExtension(e){return Promise.resolve(o.exists(e.location.fsPath)).then(e=>e?null:Promise.reject(new Error(i.localize(18,null)))).then(()=>{this.logService.info("Uninstalling extension:",e.identifier.id),this._onUninstallExtension.fire(e.identifier)})}
uninstallExtension(e){let t=this.uninstallingExtensions.get(e.identifier.id);return t||(t=g.createCancelablePromise(t=>this.extensionsScanner.scanUserExtensions(!1).then(t=>this.setUninstalled(...t.filter(t=>d.areSameExtensions(t.identifier,e.identifier)))).then(()=>{this.uninstallingExtensions.delete(e.identifier.id)})),this.uninstallingExtensions.set(e.identifier.id,t)),t}async postUninstallExtension(e,t){t?this.logService.error("Failed to uninstall extension:",e.identifier.id,t.message):(this.logService.info("Successfully uninstalled extension:",e.identifier.id),e.identifier.uuid&&await this.galleryService.reportStatistic(e.manifest.publisher,e.manifest.name,e.manifest.version,"uninstall")),this.reportTelemetry("extensionGallery:uninstall",d.getLocalExtensionTelemetryData(e),void 0,t);const i=t?t instanceof h.ExtensionManagementError?t.code:"unknown":void 0;this._onDidUninstallExtension.fire({identifier:e.identifier,error:i})}getInstalled(e=null){return this.extensionsScanner.scanExtensions(e)}
removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}isUninstalled(e){return this.filterUninstalled(e).then(e=>1===e.length)}filterUninstalled(...e){return this.extensionsScanner.withUninstalledExtensions(t=>{const i=[];for(const n of e)t[n.key()]&&i.push(n.key());return i})}setUninstalled(...e){const t=e.map(e=>new d.ExtensionIdentifierWithVersion(e.identifier,e.manifest.version));return this.extensionsScanner.withUninstalledExtensions(e=>a.assign(e,t.reduce((e,t)=>(e[t.key()]=!0,e),{})))}unsetUninstalled(e){return this.extensionsScanner.withUninstalledExtensions(t=>delete t[e.key()])}getExtensionsReport(){const e=(new Date).getTime();return(!this.reportedExtensions||e-this.lastReportTimestamp>3e5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=e),this.reportedExtensions}updateReportCache(){return this.logService.trace("ExtensionManagementService.refreshReportedCache"),
this.galleryService.getExtensionsReport().then(e=>(this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${e.length} reported extensions from service`),e),e=>(this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]))}toNonCancellablePromise(e){return new Promise((t,i)=>e.then(e=>t(e),e=>i(e)))}reportTelemetry(e,t,i,n){const r=n?n instanceof h.ExtensionManagementError?n.code:"unknown":void 0;this.telemetryService.publicLogError(e,a.assign(t,{success:!n,duration:i,errorcode:r}))}};U=r([s(0,f.IEnvironmentService),s(1,h.IExtensionGalleryService),s(2,w.ILogService),s(3,P.optional(I.IDownloadService)),s(4,_.ITelemetryService),s(5,P.IInstantiationService)],U),t.ExtensionManagementService=U})),
define(t[201],i([0,1,35,6,41,95,72,67,143,8,156,128,30,194,166,25,158,43,160,24,79,170,171,168,169,64,13,152,148,75,2,161,68,32,155,154,140,139,73,77,165,126,146,16,147,26,37,23,187,188,183,74,153,184,138,124,189,191,167,22,164,186,54,182,80,163,55]),(function(e,t,i,n,r,s,o,a,c,l,u,h,d,f,g,p,m,v,y,S,w,E,C,_,b,D,x,I,P,R,k,L,O,A,T,U,M,F,N,j,$,z,B,W,q,V,K,H,G,Y,J,X,Q,Z,ee,te,ie,ne,re,se,oe,ae,ce,le,ue,he,de){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0,t.startup=function(e){!async function(e){const t=await new Promise(e=>{D.ipcRenderer.once("vscode:electron-main->shared-process=payload",(t,i)=>e(i)),D.ipcRenderer.send("vscode:shared-process->electron-main=ready-for-payload")}),pe=await(me=t.sharedIPCHandle,function e(t){return s.serve(me).then(null,r=>!t||n.isWindows||"EADDRINUSE"!==r.code?Promise.reject(r):s.connect(me,"").then(e=>(e.dispose(),Promise.reject(new Error("There is an instance already running."))),t=>{try{i.unlinkSync(me)}catch(e){
return Promise.reject(new Error("Error deleting the shared ipc hook."))}return e(!1)}))}(!0));var me;D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await async function(e,t,i){const n=new o.ServiceCollection,s=new k.DisposableStore,pe=()=>s.dispose();process.once("exit",pe),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",pe),s.add(e);const me=new u.EnvironmentService(t.args,process.execPath),ve=new A.StaticRouter(e=>"main"===e),ye=new I.LoggerChannelClient(e.getChannel("logger",ve)),Se=new I.FollowerLogService(ye,new j.SpdLogService("sharedprocess",me.logsPath,t.logLevel));s.add(Se),Se.info("main",JSON.stringify(i));const we=new ge(e,ve);n.set(N.IMainProcessService,we);const Ee=new B.FileService(Se);n.set(W.IFileService,Ee),s.add(Ee);const Ce=new q.DiskFileSystemProvider(Se);s.add(Ce),Ee.registerProvider(V.Schemas.file,Ce);const _e=new m.ConfigurationService(me.settingsResource,Ee);s.add(_e),await _e.initialize()
;const be=new ne.NativeStorageService(new re.GlobalStorageDatabaseChannelClient(we.getChannel("storage")),Se,me);await be.initialize(),n.set(se.IStorageService,be),s.add(k.toDisposable(()=>be.flush())),n.set(ue.IStorageKeysSyncRegistryService,new J.StorageKeysSyncRegistryChannelClient(we.getChannel("storageKeysSyncRegistryService"))),n.set(l.IEnvironmentService,me),n.set(K.IProductService,Object.assign({_serviceBrand:void 0},r.default)),n.set(x.ILogService,Se),n.set(p.IConfigurationService,_e),n.set(v.IRequestService,new a.SyncDescriptor(y.RequestService)),n.set(x.ILoggerService,new a.SyncDescriptor(Q.LoggerService));const De=A.createChannelSender(we.getChannel("electron"),{context:i.windowId});n.set(X.IElectronService,De),n.set(O.IDownloadService,new a.SyncDescriptor(L.DownloadService));const xe=new c.InstantiationService(n);let Ie;xe.invokeFunction(n=>{
const c=new o.ServiceCollection,{appRoot:l,extensionsPath:u,extensionDevelopmentLocationURI:p,isBuilt:m,installSourcePath:v}=me,y=new I.FollowerLogService(ye,new j.SpdLogService("telemetry",me.logsPath,t.logLevel));y.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),y.info("===========================================================");let D=w.NullAppender;if(p||me.disableTelemetry||!r.default.enableTelemetry)Ie=w.NullTelemetryService,c.set(S.ITelemetryService,w.NullTelemetryService);else{r.default.aiConfig&&r.default.aiConfig.asimovKey&&m&&(D=new b.AppInsightsAppender(fe,null,r.default.aiConfig.asimovKey,y),s.add(k.toDisposable(()=>D.flush())));const e={appender:w.combinedAppender(D,new w.LogAppender(Se)),commonProperties:E.resolveCommonProperties(r.default.commit,r.default.version,i.machineId,r.default.msftInternalDomains,v),sendErrorTelemetry:!0,piiPaths:u?[l,u]:[l]};Ie=new _.TelemetryService(e,_e),c.set(S.ITelemetryService,Ie)}
e.registerChannel("telemetryAppender",new C.TelemetryAppenderChannel(D)),c.set(d.IExtensionManagementService,new a.SyncDescriptor(f.ExtensionManagementService)),c.set(d.IExtensionGalleryService,new a.SyncDescriptor(g.ExtensionGalleryService)),c.set(R.ILocalizationsService,new a.SyncDescriptor(P.LocalizationsService)),c.set($.IDiagnosticsService,new a.SyncDescriptor($.DiagnosticsService)),c.set(d.IExtensionTipsService,new a.SyncDescriptor(he.ExtensionTipsService)),c.set(ee.ICredentialsService,new a.SyncDescriptor(te.KeytarCredentialsService)),c.set(ce.IUserDataSyncAccountService,new a.SyncDescriptor(ce.UserDataSyncAccountService)),c.set(H.IUserDataSyncLogService,new a.SyncDescriptor(Z.UserDataSyncLogService)),c.set(H.IUserDataSyncUtilService,new J.UserDataSyncUtilServiceClient(e.getChannel("userDataSyncUtil",e=>"main"!==e.ctx))),c.set(d.IGlobalExtensionEnablementService,new a.SyncDescriptor(oe.GlobalExtensionEnablementService)),
c.set(H.IUserDataSyncStoreManagementService,new a.SyncDescriptor(Y.UserDataSyncStoreManagementService)),c.set(H.IUserDataSyncStoreService,new a.SyncDescriptor(Y.UserDataSyncStoreService)),c.set(de.IUserDataSyncMachinesService,new a.SyncDescriptor(de.UserDataSyncMachinesService)),c.set(H.IUserDataSyncBackupStoreService,new a.SyncDescriptor(le.UserDataSyncBackupStoreService)),c.set(H.IUserDataSyncResourceEnablementService,new a.SyncDescriptor(ae.UserDataSyncResourceEnablementService)),c.set(H.IUserDataSyncService,new a.SyncDescriptor(G.UserDataSyncService)),H.registerConfiguration();const x=xe.createChild(c);x.invokeFunction(t=>{const i=t.get(d.IExtensionManagementService),n=new h.ExtensionManagementChannel(i,()=>null);e.registerChannel("extensions",n);const r=t.get(R.ILocalizationsService),o=A.createChannelReceiver(r);e.registerChannel("localizations",o);const a=t.get($.IDiagnosticsService),c=new z.DiagnosticsChannel(a);e.registerChannel("diagnostics",c)
;const l=t.get(d.IExtensionTipsService),u=new h.ExtensionTipsChannel(l);e.registerChannel("extensionTipsService",u);const f=t.get(de.IUserDataSyncMachinesService),g=new J.UserDataSyncMachinesServiceChannel(f);e.registerChannel("userDataSyncMachines",g);const p=t.get(ce.IUserDataSyncAccountService),m=new J.UserDataSyncAccountServiceChannel(p);e.registerChannel("userDataSyncAccount",m);const v=t.get(H.IUserDataSyncStoreManagementService),y=new J.UserDataSyncStoreManagementServiceChannel(v);e.registerChannel("userDataSyncStoreManagement",y);const S=t.get(H.IUserDataSyncService),w=new J.UserDataSyncChannel(e,S,Se);e.registerChannel("userDataSync",w);const E=x.createInstance(ie.UserDataAutoSyncService),C=new J.UserDataAutoSyncChannel(E);e.registerChannel("userDataAutoSync",C),i.removeDeprecatedExtensions(),r.update(),s.add(k.combinedDisposable(x.createInstance(T.NodeCachedDataCleaner),x.createInstance(U.LanguagePackCachedDataCleaner),x.createInstance(M.StorageDataCleaner),x.createInstance(F.LogsDataCleaner),E)),
s.add(i)})})}(pe,t,e),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}(e)};const fe="monacoworkbench";class ge{constructor(e,t){this.server=e,this.mainRouter=t}getChannel(e){return this.server.getChannel(e,this.mainRouter)}registerChannel(e,t){this.server.registerChannel(e,t)}}}))}).call(this);
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e790b931385d72cf5669fcefc51cdf65990efa5d/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
